#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ft first
#define sd second
#define pb push_back
#define eb emplace_back

const int INF = 1e9;

struct Node{
    int a, b, op;
};

int check11(int a, int b, vector<vector<Node>> &func, vector<vector<int>> &lst){
    int ans = 0;
    for (int i = 0; i < lst.size(); i++){
        if (func[i][0].op == 1 && lst[i][0] < a && lst[i][1] < b)
            ans++;
        else if (func[i][0].op == 2 && (lst[i][0] < a || lst[i][1] < b))
            ans++;
    }
    return ans;
}

void sol1(int n, int m, int need, vector<vector<Node>> &func, vector<vector<int>> &lst){
    if (n == 1){
        vector<int> v(m);
        for (int i = 0; i < m; i++)
            v[i] = lst[i][0];
        sort(v.begin(), v.end());
        v.push_back(m);
        cout << v[need];
        return;
    }
    int a = -1, b = m, c;
    while (b - a > 1){
        c = (a + b) / 2;

        int left = -1, right = m + 1, mid;
        while (right - left > 1){
            mid = (right + left) / 2;
            if (check11(c, mid, func, lst) >= need)
                right = mid;
            else
                left = mid;
        }

        if (right == m + 1)
            a = c;
        else if (left == -1 && check11(c, right, func, lst) > need)
            b = c;
        else{
            cout << c << " " << right;
            return;
        }
    }
}

int get_pw_3(int n){
    int curr = 1;
    for (int i = 1; i <= n; i++)
        curr *= 3;
    return curr;
}

int get_symbol(int mask, int pos){
    for (; pos > 0; pos--)
        mask /= 3;
    return mask % 3;
}

int check2(int mask, vector<vector<Node>> &func, vector<vector<int>> &lst){
    int m = lst.size(), n = lst[0].size();

    if (m == 1){
        for (int i = 0; i < n; i++)
            if (get_symbol(mask, i) == 2)
                return INF;
    }

    vector<vector<int>> dp(m, vector<int> (2 * n - 1));
    for (int j = 0; j < n; j++){
        int roof = get_symbol(mask, j);
        for (int i = 0; i < m; i++)
            dp[i][j] = lst[i][j] < roof;
    }

    for (int i = 0; i < m; i++)
        for (int j = 0; j < n - 1; j++){
            int a = func[i][j].a, b = func[i][j].b, op = func[i][j].op;
            if (op == 1)
                dp[i][j + n] = (dp[i][a] & dp[i][b]);
            else
                dp[i][j + n] = (dp[i][a] | dp[i][b]);
        }
    int cnt = 0;
    for (int i = 0; i < m; i++)
        cnt += dp[i][2 * n - 2];
    return cnt;
}

void sol2(int n, int m, int need, vector<vector<Node>> &func, vector<vector<int>> &lst){
    int mx_mask = get_pw_3(n);
    for (int mask = 0; mask < mx_mask; mask++)
        if (check2(mask, func, lst) == need){
            for (int i = 0; i < n; i++)
                cout << get_symbol(mask, i) << " ";
            return;
        }
}

void sol3(int n, int m, int need, vector<vector<Node>> &func, vector<vector<int>> &lst){
    for (int i = 0; i < n; i++)
        cout << need << " ";
}

void sol4(int n, int m, int need, vector<vector<Node>> &func, vector<vector<int>> &lst){
    cout << need << " ";
    for (int i = 1; i < n; i++)
        cout << m << " ";
}

void sol5(int n, int m, int need, vector<vector<Node>> &func, vector<vector<int>> &lst){
    vector<int> pos;
    set<int> v;
    pos.push_back(2 * n - 2);
    while (!pos.empty()){
        int curr = pos.back();
        pos.pop_back();
        if (curr < n){
            v.insert(curr);
            continue;
        }
        curr -= n;
        pos.pb(func[0][curr].a);
        if (func[0][curr].op == 1)
            pos.pb(func[0][curr].b);
    }
//    for (int el : v)
//        cout << el << endl;
    bool done = false;
    for (int i = 0; i < n; i++){
        if (v.find(i) == v.end())
            cout << "0 ";
        else if (!done){
            cout << need << " ";
            done = true;
        }
        else
            cout << m << " ";
    }
}

int main(){
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int n, m, need;
    cin >> n >> m >> need;
    vector<vector<Node>> func(m, vector<Node> (n - 1));
    for (int i = 0; i < m; i++)
        for (int j = 0; j < n - 1; j++){
            cin >> func[i][j].a >> func[i][j].b >> func[i][j].op;
            func[i][j].a--;
            func[i][j].b--;
        }
    vector<vector<int>> lst(m, vector<int> (n));
    for (int i = 0; i < m; i++)
        for (int j = 0; j < n; j++)
            cin >> lst[i][j];
    if (n <= 2){
        sol1(n, m, need, func, lst);
        return 0;
    }
    if (m <= 2){
        sol2(n, m, need, func, lst);
        return 0;
    }

    bool ok = true;
    for (int i = 0; i < m && ok; i++)
        for (int j = 0; j < n && ok; j++)
            if (lst[i][j] != i)
                ok = false;
    if (ok){
        sol3(n, m, need, func, lst);
        return 0;
    }

    ok = true;
    for (int i = 0; i < m && ok; i++)
        for (int j = 0; j < n - 1 && ok; j++)
            if (func[i][j].op == 2)
                ok = false;
    if (ok){
        sol4(n, m, need, func, lst);
        return 0;
    }
    sol5(n, m, need, func, lst);
    return 0;
}