//#pragma GCC optimize("Ofast,fast-math,unroll-loops,no-stack-protector,inline")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,sse4a,avx,avx2,bmi,bmi2,abm,mmx,adx,aes,xop")

#include <bits/stdc++.h>
using namespace std;
//#define int long long

const int MAXN = 200001;

//int tree[4 * MAXN];
pair<int, int> mod[4 * MAXN];

void push(int v, int l, int r) {
  if (mod[v] == make_pair(0, 0))
    return;
  if (l + 1 == r) {
    mod[v].second = 0;
    return;
  }
  int m = (l + r) / 2;
  mod[2 * v + 1] = mod[v];
  mod[2 * v + 2] = {mod[v].first + mod[v].second * (m - l), mod[v].second};
  mod[v] = {0, 0};
}

void update(int v, int l, int r, int ql, int qr, int qa, int qb) {
  if (qr <= ql)
    return;
  if (r <= ql || qr <= l)
    return;
  push(v, l, r);
  if (ql <= l && r <= qr) {
    mod[v] = {qa, qb};
    push(v, l, r);
    return;
  }
  int m = (l + r) / 2;
  if (ql < m)
  update(2 * v + 1, l, m, ql, m, qa, qb);
  update(2 * v + 2, m, r, m, qr, qa + qb * max(0, m - ql), qb);
}

int get(int v, int l, int r, int qi) {
  push(v, l, r);
  if (l + 1 == r)
    return mod[v].first;
  int m = (l + r) / 2;
  if (qi < m)
    return get(2 * v + 1, l, m, qi);
  else
    return get(2 * v + 2, m, r, qi);
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);
  int n;
  cin >> n;
  vector<int> arr(n);
  for (int &el : arr)
    cin >> el;
  vector<int> ans(n + 1, 0);
  unordered_map<int, int> last_ind;
  vector<int> prev_ind(n);
  for (int i = 0; i < n; ++i) {
    if (last_ind.find(arr[i]) == last_ind.end()) {
      prev_ind[i] = -1;
    } else {
      prev_ind[i] = last_ind[arr[i]];
    }
    last_ind[arr[i]] = i;
  }
  vector<int> next_ind(n);
  last_ind.clear();
  for (int i = n - 1; i >= 0; --i) {
    if (last_ind.find(arr[i]) == last_ind.end()) {
      next_ind[i] = n;
    } else {
      next_ind[i] = last_ind[arr[i]];
    }
    last_ind[arr[i]] = i;
  }
  for (int i = 0; i < n; ++i) {
    int dl = i - prev_ind[i];
    int dr = next_ind[i] - i;
    if (dl < dr)
      swap(dl, dr);
    update(0, 0, n + 1, dl, dl + dr - 1, dr, -1);
    update(0, 0, n + 1, dr, dl, dr, -2);
    update(0, 0, n + 1, 1, dr, dr, -3);
  }
  for (int i = 0; i < n; ++i)
    cout << get(0, 0, n + 1, i + 1) << ' ';
  return 0;
}