#ifndef LOCAL
#pragma GCC optimize("Ofast,fast-math,unroll-loops,no-stack-protector,inline")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,sse4a,avx,avx2,bmi,bmi2,abm,mmx,adx,aes,xop"
#endif

#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 40000;
//Node tree[MAXN * 4];
int tree[MAXN * 4][4][4];
int arr[MAXN];

int getsum(int v, int L, int l, int r, int R, int vl=-1, int vr=-1, int vm=-1) {
  if (vl != -1) {
    if (r + R == vr - vm) {
      R = vr - vm;
      r = 0;
    }
    if (l + L == vm - vl) {
      L = vm - vl;
      l = 0;
    }
  }
  if (tree[2 * v + 1][L][l] == -1 || tree[2 * v + 2][r][R] == -1)
    return -1;
  return tree[2 * v + 1][L][l] + tree[2 * v + 2][r][R];
}

void combine(int v, int vl, int vr) {
  int vm = (vl + vr) / 2;
  for (int L = 0; L < 4; ++L) {
    for (int R = 0; R < 4; ++R) {
      tree[v][L][R] = -1;
      if (L + R > vr - vl)
        continue;
      if (L + R == vr - vl) {
        if (L + R >= 4 || (L != 0 && R != 0))
          continue;
        tree[v][L][R] = getsum(v, vm - vl, 0, 0, vr - vm);
        continue;
      }
      if (L > vm - vl) {
        tree[v][L][R] = getsum(v, vm - vl, 0, L - vm + vl, R, vl, vr, vm);
        continue;
      }
      if (R > vr - vm) {
        tree[v][L][R] = getsum(v, L, R - vr + vm, 0, vr - vm, vl, vr, vm);
        continue;
      }
      for (int l = 0; l < 4; ++l) {
        for (int r = 0; r + l < 4; ++r) {
          if (l + L > vm - vl || (l + L == vm - vl && l + r != 0))
            continue;
          if (r + R > vr - vm || (r + R == vr - vm && l + r != 0))
            continue;
          tree[v][L][R] = max(tree[v][L][R], getsum(v, L, l, r, R));
        }
      }
    }
  }
}

void build(int v, int l, int r) {
  if (l + 1 == r) {
    for (int L = 0; L < 4; ++L) {
      for (int R = 0; R < 4; ++R) {
        if (L + R > 1)
          tree[v][L][R] = -1;
        else if (L + R == 0)
          tree[v][L][R] = 0;
        else
          tree[v][L][R] = arr[l];
      }
    }
    return;
  }
  int m = (l + r) / 2;
  build(2 * v + 1, l, m);
  build(2 * v + 2, m, r);
  if (l == 0 && r == 3) {
    int hhh;
    hhh++;
  }
  combine(v, l, r);
}

void update(int v, int l, int r, int qi, int qx) {
  if (qi < l || r <= qi)
    return;
  if (l + 1 == r) {
    arr[qi] = qx;
//    tree[v][0][1] = qx;
//    tree[v][1][0] = qx;
    for (int L = 0; L < 4; ++L) {
      for (int R = 0; R < 4; ++R) {
        if (L + R > 1)
          tree[v][L][R] = -1;
        else if (L + R == 0)
          tree[v][L][R] = 0;
        else
          tree[v][L][R] = arr[l];
      }
    }
    return;
  }
  int m = (l + r) / 2;
  update(2 * v + 1, l, m, qi, qx);
  update(2 * v + 2, m, r, qi, qx);
  combine(v, l, r);
}

int get() {
  int ans = 0;
  for (int l = 0; l < 4; ++l) {
    for (int r = 0; l + r < 4; ++r) {
      ans = max(ans, tree[0][l][r]);
    }
  }
  return ans;
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);
  int n;
  cin >> n;
  for (int i = 0; i < n; ++i)
    cin >> arr[i];
  build(0, 0, n);
  cout << get() << '\n';
  int q;
  cin >> q;
  while (q--) {
    int ind, x;
    cin >> ind >> x;
    update(0, 0, n, ind - 1, x);
    cout << get() << '\n';
  }
  return 0;
}
