#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <set>
#include <unordered_set>
#include <unordered_map>

#define int long long int

using namespace std;

const int maxN = 5005;
int n;
int a[maxN];
int dp[maxN][maxN];
int cnt[maxN];

struct node{
    int x, add;
    node(int x = 0, int add = 0){
        this->x = x;
        this->add = add;
    }
};

struct segmentTree{
    vector<node> t;
    segmentTree(){
        t.resize(4 * (n + 1));
    }
    void push(int v){
        t[2 * v + 1].add += t[v].add;
        t[2 * v + 2].add += t[v].add;
        t[v].add = 0;
    }
    void add(int L, int R, int v = 0, int tl = 0, int tr = n + 1){
        if(R <= tl || L >= tr || tr - tl < 1)return;
        else if(L <= tl && tr <= R)t[v].add++;
        else{
            push(v);
            int mid = (tl + tr) / 2;
            add(L, R, 2 * v + 1, tl, mid);
            add(L, R, 2 * v + 2, mid, tr);
        }
    }
    int get(int ind, int v = 0, int tl = 0, int tr = n + 1){
        if(tr - tl == 1)return t[v].add + t[v].x;
        else{
            push(v);
            int mid = (tl + tr) / 2;
            if(ind >= mid)return get(ind, 2 * v + 2, mid, tr);
            else return get(ind, 2 * v + 1, tl, mid);
        }
    }
};

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    vector<int> coords(n);
    for(int i = 0; i < n; i++){
        cin >> a[i];
        coords[i] = a[i];
    }
    sort(coords.begin(), coords.end());
    coords.erase(unique(coords.begin(), coords.end()), coords.end());
    for(int i = 0; i < n; i++)a[i] = (lower_bound(coords.begin(), coords.end(), a[i]) - coords.begin());
    if(coords.size() > 50) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < maxN; j++)cnt[j] = 0;
            int ans = 0;
            for (int j = i; j < n; j++) {
                cnt[a[j]]++;
                if (cnt[a[j]] == 1)ans++;
                dp[i][j] = ans;
            }
        }
        for (int d = 1; d <= n; d++) {
            int summ = 0;
            for (int i = 0; i <= n - d; i++) {
                summ += dp[i][i + d - 1];
            }
            cout << summ << " ";
        }
    }else{
        unordered_map<int, vector<int>> ind;
        for(int i = 0; i < n; i++){
            if(ind[a[i]].empty())ind[a[i]].push_back(-1);
            ind[a[i]].push_back(i);
        }
        segmentTree t;
        for(auto i : ind){
            for(int j = 1; j < i.second.size(); j++){
                int start = i.second[j - 1] + 1;
                for(int k = start; k <= i.second[j]; k++){
                    t.add(i.second[j] - k + 1, n - k + 1);
                }
            }
        }
        for(int i = 1; i <= n; i++)cout << t.get(i) << " ";
    }
    return 0;
}