#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <set>
#include <unordered_set>
#include <unordered_map>

using namespace std;

int n, m, s;
vector<vector<int>> a;

struct node{
    int a, b, op;
    node(int a = 0, int b = 0, int op = 0){
        this->a = a;
        this->b = b;
        this->op = op;
    }
};

struct prog{
    vector<node> p;
    prog(vector<node> & a){
        this->p = a;
    }
};

vector<prog> pr;

bool checkPr(int i, vector<vector<bool>> & mp){
    vector<bool> val(2 * n);
    for(int j = 0; j < n; j++)val[j] = mp[i][j];
    for(int j = 0; j < pr[i].p.size(); j++){
        if(pr[i].p[j].op == 1)val[n + j] = val[pr[i].p[j].a] & val[pr[i].p[j].b];
        if(pr[i].p[j].op == 2)val[n + j] = val[pr[i].p[j].a] | val[pr[i].p[j].b];
    }
    return val[2 * n - 2];
}

bool check(vector<vector<bool>> & mp){
    int ans = 0;
    for(int i = 0; i < m; i++)ans += checkPr(i, mp);
    return ans == s;
}

signed main(){
    cin >> n >> m >> s;
    a.resize(m, vector<int>(n));
    for(int i = 0; i < m; i++){
        for(int j = 0; j < n; j++)cin >> a[i][j];
    }
    for(int i = 0; i < m; i++){
        vector<node> p;
        for(int j = 1; j < n; j++){
            int x, y, op; cin >> x >> y >> op; x--; y--;
            p.push_back(node(x, y, op));
        }
        pr.push_back(prog(p));
    }
    vector<vector<bool>> mp(m, vector<bool>(n));
    if(n == 1){
        for(int z1 = 0; z1 <= m; z1++){
            for(int i = 0; i < m; i++)mp[i][0] = (bool)(a[i][0] < z1);
            if(check(mp)){
                cout << z1 << "\n";
                return 0;
            }
        }
    }else{
        for(int z1 = 0; z1 <= m; z1++){
            for(int z2 = 0; z2 <= m; z2++) {
                for(int i = 0; i < m; i++){
                    mp[i][0] = (bool)(a[i][0] < z1);
                    mp[i][1] = (bool)(a[i][1] < z2);
                }
                if (check(mp)) {
                    cout << z1 << " " << z2 << "\n";
                    return 0;
                }
            }
        }
    }
    assert(n == 1);
    return 0;
}