#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif

#include <bits/stdc++.h>

using namespace std;

void entry(int test_id);

int main() {
    int test_cnt = 1;
    if (DEV) {
        test_cnt = 100;
        freopen("input.txt", "r", stdin);
    } else {
        ios::sync_with_stdio(false);
        cin.tie(nullptr);
    }

    for (int i = 0; i < test_cnt; ++i) {
        entry(i);

        while (DEV) {
            int ch = fgetc(stdin);
            if (ch == -1) {
                return 0;
            }
            if (!isspace(ch)) {
                ungetc(ch, stdin);
                break;
            }
        }
    }
}

template<typename T>
bool relmax(T &pl, T const val) {
    if (pl < val) {
        pl = val;
        return true;
    }
    return false;
}

template<typename T>
bool relmin(T &pl, T const val) {
    if (pl > val) {
        pl = val;
        return true;
    }
    return false;
}

using ll = long long;

using ld = __float128;

struct Op {
    int p1;
    int p2;
    bool kind; // false = AND, true = OR
};

void entry(int test_id) {
    (void) test_id;
    int n, m, s;
    cin >> n  >> m >> s;
    vector<vector<Op>> P(m, vector<Op>(n-1));
    for (int i = 0; i <m; ++i) {
        for (int j = 0; j < n-1; ++j) {
            int a,b,op;
            cin >> a >> b >> op;
            P[i][j].p1 = a-1;
            P[i][j].p2 = b-1;
            P[i][j].kind = (op == 2);
        }
    }
    vector<vector<int>> tab(m, vector<int>(n));
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> tab[i][j];
        }
    }

    vector<int> z(n);

    auto eval = [&](int i) -> bool {
        vector<bool> val(2*n-1);
        for (int j =0; j < n; ++j) {
            val[j] = tab[i][j] < z[j];
        }
        for (int j = 0; j < n-1; ++j) {
            bool lhs = val[P[i][j].p1];
            bool rhs = val[P[i][j].p2];
            bool t;
            if (P[i][j].kind) {
                t = lhs || rhs;
            } else {
                t = lhs && rhs;
            }
            val[n+j] = t;
        }
        return val.back();
    };

    int rem = s;

    for (int j = 0; j < n; ++j) {
        while (rem > 0 && z[j] < m) {
            int i;
            for (i = 0; i < n; ++i) {
                if (tab[i][j] == z[j]) {
                    break;
                }
            }
            bool res1 = eval(i);
            ++z[j];
            bool res2 = eval(i);
            if (res2 && !res1){
                if (DEV) {
                    cout << "now " << i << " is true\n";
                }
                --rem;
            }
        }
    }

    for (int x : z) {
        cout << x << " ";
    }
 }