#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#pragma GCC optimize("Ofast")
#endif

#include <bits/stdc++.h>

using namespace std;

void entry(int test_id);

int main() {
    int test_cnt = 1;
    if (DEV) {
        test_cnt = 100;
        freopen("input.txt", "r", stdin);
    } else {
        ios::sync_with_stdio(false);
        cin.tie(nullptr);
    }

    for (int i = 0; i < test_cnt; ++i) {
        entry(i);

        while (DEV) {
            int ch = fgetc(stdin);
            if (ch == -1) {
                return 0;
            }
            if (!isspace(ch)) {
                ungetc(ch, stdin);
                break;
            }
        }
    }
}

template<typename T>
bool relmax(T &pl, T const val) {
    if (pl < val) {
        pl = val;
        return true;
    }
    return false;
}

template<typename T>
bool relmin(T &pl, T const val) {
    if (pl > val) {
        pl = val;
        return true;
    }
    return false;
}

using ll = long long;

using ld = __float128;

/*const int ALLOC_MEM_SZ = 160 * 1024 * 1024;
char ALLOC_MEM[ALLOC_MEM_SZ];
int ALLOC_POS = ALLOC_MEM_SZ;

void* operator new(size_t n) {
    //void* ret = ALLOC_MEM + ALLOC_POS;
    ALLOC_POS -= n;
    return ALLOC_MEM + ALLOC_POS;
}

void  operator delete (void* p) {
    (void) p;
}*/
int n;
const int TAMB =
#if DEV
        7
#else
200
#endif
;

vector<ll> dp[4];

void calc(ll const *a, int n) {
    for (int h = 0; h < 4; ++h) {
        dp[h] = vector<ll>(n + 1);
    }
    dp[0][0] = 0;
    for (int i = 0; i < n; ++i) {
        for (int h = 0; h < 4; ++h) {
            dp[h][i + 1] = ll(-1e18);
        }
        for (int h = 0; h < 4; ++h) {
            if (h < 3) {
                relmax(dp[h + 1][i + 1], dp[h][i] + a[i]);
            }
            relmax(dp[0][i + 1], dp[h][i]);
        }
    }
}


struct Solver {
    int n;
    vector<ll> a;

    vector<ll> block_ans[3][3];
    int off;
    int cnt_blocks;

    void touch(int bid) {
        int start_pos = bid * TAMB;
        int len = min(n-start_pos, TAMB);
        ll* data = a.data() + start_pos;
        for (int ban = 0; ban < 3; ++ban) {
            calc(data+ban, len+4);
            for (int excess = 0; excess < 3; ++excess) {

                block_ans[ban][excess][bid] = (len + excess - ban >= 0 ?dp[0][len + excess - ban] : -1e9);
            }
        }
    }

    void put(int i, int x) {
        i = (i - off + n) % n;
        a[i] = x;
        touch(i / TAMB);
    }

    void init() {
        auto b = a;
        for (int i = 0; i < n; ++i) {
            a[i] = b[(i + off) % n];
        }
        // a.pop_back();
        n = a.size();
        a.push_back(-1000);
        a.push_back(-1000);
        a.push_back(-1000);
        a.push_back(-1000);
        a.push_back(-1000);
        cnt_blocks = (n - 1) / TAMB + 1;
        for (int ban_l = 0; ban_l < 3; ++ban_l) {
            for (int ban_r = 0; ban_r < 3; ++ban_r) {
                block_ans[ban_l][ban_r].resize(cnt_blocks);
            }
        }
        for (int i = 0; i < cnt_blocks; ++i) {
            touch(i);
        }

    }


    ll get() {
        ll ans[3];
        ans[0] = ans[1] = ans[2] = 0;
        for (int bid = 0; bid < cnt_blocks; ++bid) {
            ll nans[3];
            nans[0] = nans[1] = nans[2] = 0;
            for (int ot = 0; ot < 3; ++ot) {
                for (int nt = 0; nt < 3; ++nt) {
                    relmax(nans[nt], ans[ot] + block_ans[ot][nt][bid]);
                }
            }
            ans[0] = nans[0];
            ans[1] = nans[1];
            ans[2] = nans[2];
        }
        return ans[0];
    }
};

// vector<pair<int, int>> mp[10'000'001];
void entry(int test_id) {
    (void) test_id;
    cin >> n;
    vector<ll> a(n);
    for (ll &x : a) { cin >> x; }
    int q;
    cin >> q;


    Solver solve[4];
    for (int i = 0; i < 4; ++i) {
        solve[i].a = a;
        solve[i].n = n;
        solve[i].off = i;
        solve[i].init();
    }
    for (int j = 0; j <= q; ++j) {
        if (j > 0) {
            int p, v;
            cin >> p >> v;
            --p;
            for (int i = 0; i < 4; ++i) {
                solve[i].put(p, v);
            }
        }
        ll ans = -1e18;
        for (int i = 0; i < 4; ++i) {
            relmax(ans, solve[i].get());
        }
        cout << ans << "\n";

    }

}