#include <iostream>
#include <vector>
#include <math.h>
#include <algorithm>
#include <string>

using namespace std;

vector<bool> used;

bool isAddable(int n, int index) {
	int ind1, ind2, ind3;
	//three behind
	ind1 = (n + index - 1) % n;
	ind2 = (n + index - 2) % n;
	ind3 = (n + index - 3) % n;
	if (used[ind1] && used[ind2] && used[ind3])
		return false;
	//three in front
	ind1 = (index + 1) % n;
	ind2 = (index + 2) % n;
	ind3 = (index + 3) % n;
	if (used[ind1] && used[ind2] && used[ind3])
		return false;
	//two behing one in front
	ind1 = (n + index - 1) % n;
	ind2 = (n + index - 2) % n;
	ind3 = (index + 1) % n;
	if (used[ind1] && used[ind2] && used[ind3])
		return false;
	//two in front one behind
	ind1 = (index + 1) % n;
	ind2 = (index + 2) % n;
	ind3 = (n + index - 1) % n;
	if (used[ind1] && used[ind2] && used[ind3])
		return false;

	return true;
}

int main() {
	int n, q, pos, new_val;
	cin >> n;
	vector<int> coolness(n);
	vector<pair<int, int>> value_place(n);

	for (int i = 0; i < n; i++) {
		cin >> coolness[i];
		value_place[i] = { coolness[i], i };
	}
	sort(value_place.begin(), value_place.end());
	reverse(value_place.begin(), value_place.end());

	used = vector<bool>(n, false);
	long long ans = 0;
	for (int i = 0; i < n; i++) {
		if (isAddable(n, value_place[i].second)) {
			ans += value_place[i].first;
			used[value_place[i].second] = true;
		}
	}

	cout << ans << "\n";
	cin >> q;

	for (int i = 0; i < q; i++) {
		cin >> pos >> new_val;
		pos--;
		int old_val = coolness[pos];
		coolness[pos] = new_val;

		value_place = vector<pair<int, int>>(n);
		for (int j = 0; j < n; j++) {
			value_place[j] = { coolness[j], j };
		}

		if (!used[pos] && old_val >= new_val) {
			cout << ans << "\n";
		}
		else {
			sort(value_place.begin(), value_place.end());
			reverse(value_place.begin(), value_place.end());

			used = vector<bool>(n, false);

			/*for (int l = 0; l < n; l++) {
				cout << used[l] << " ";
			}
			cout << "\n";*/

			ans = 0;
			for (int k = 0; k < n; k++) {
				if (isAddable(n, value_place[k].second)) {
					ans += value_place[k].first;
					used[value_place[k].second] = true;
				}
			}
			cout << ans << "\n";
		}
	}
}