#include <iostream>
#include <vector>
#include <math.h>
#include <algorithm>
#include <string>

using namespace std;

vector<bool> used;

bool Check4Rule(int n, int index) {
	int ind1, ind2, ind3;
	ind1 = (index + 1) % n;
	ind2 = (index + 2) % n;
	ind3 = (index + 3) % n;

	if (used[index] && used[ind1] && used[ind2] && used[ind3])
		return false;
	return true;
}

int main() {
	int n, q, pos, new_val, mask;
	long long ans = 0, new_ans = 0;

	cin >> n;
	vector<int> coolness(n);
	used = vector<bool>(n, false);

	for (int i = 0; i < n; i++) {
		cin >> coolness[i];
	}

	//cout << "Mask size: " << pow(2, n) << "\n";

	if (n <= 10) {
		for (int i = 0; i < pow(2, n); i++) {
			bool add_ans = true;
			new_ans = 0;
			mask = i;
			used = vector<bool>(n, false);
			for (int j = 0; j < n; j++) {
				if (mask - ((mask >> 1) << 1)) {
					used[j] = true;
					new_ans += coolness[j];
				}
				
				mask = mask >> 1;
			}

			for (int j = 0; j < n; j++) {
				if (!Check4Rule(n, j)) {
					add_ans = false;
					break;
				}
			}

			if (add_ans) {
				ans = max(ans, new_ans);
			}
		}

		cout << ans << "\n";
		cin >> q;

		for (int i = 0; i < q; i++) {
			ans = 0;
			cin >> pos >> new_val;
			pos--;
			coolness[pos] = new_val;
			for (int i = 0; i < pow(2, n); i++) {
				bool add_ans = true;
				new_ans = 0;
				mask = i;
				used = vector<bool>(n, false);
				for (int j = 0; j < n; j++) {
					if (mask - ((mask >> 1) << 1)) {
						used[j] = true;
						new_ans += coolness[j];
					}

					mask = mask >> 1;
				}

				for (int j = 0; j < n; j++) {
					if (!Check4Rule(n, j)) {
						add_ans = false;
						break;
					}
				}

				if (add_ans) {
					ans = max(ans, new_ans);
				}
			}

			cout << ans << "\n";
		}
	}
}