#include <bits/stdc++.h>

#define f first
#define s second
#define ll long long
#define pii pair<int, int>
#define ld long double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) int(a.size())
#define eb emplace_back
#define output(a) cout << #a << " ! "; for (auto& el : a) cout << el << ' '; cout << endl;
#define sun(a) a.resize(unique(all(a)) - a.begin())
#define xmax(x,y) x = max(x, y)

using namespace std;

struct node {
    ll res[4][4] = {};
    int l = 0, r = 0;

    node() {}
};

struct tree {
    vector<node> t;
    int sz = 1;
    int N = 0;

    tree() {}

    tree(int n) {
        N = n;
        while (sz < n) {
            sz <<= 1;
        }
        t.resize(sz << 1);
        for (int v = sz; v < (sz << 1); ++v) {
            t[v].l = t[v].r = v - sz + 1;
        }
        for (int v = sz - 1; v >= 1; --v) {
            t[v].l = t[v << 1].l;
            t[v].r = t[v << 1 | 1].r;
        }
    }

    void print(int v) {
        cout << v << endl;
        for (int i = 0; i < 4; ++i) {
            for (int j = 0; j < 4; ++j) {
                cout << t[v].res[i][j] << ' ';
            }
            cout << endl;
        }
    }

    void print() {
        for (int v = 1; v < (sz << 1); ++v) {
            print(v);
        }
    }

    int len(int v) {
        return min(t[v].r, N) - t[v].l + 1;
    }

    void mrg(int v) {
        if (t[v << 1 | 1].l > N) {
            for (int i = 0; i < 4; ++i) {
                for (int j = 0; j < 4; ++j) {
                    t[v].res[i][j] = t[v << 1].res[i][j];
                }
            }
            return;
        }
        int lx = len(v << 1), rx = len(v << 1 | 1);
        for (int i = 0; i < 4; ++i) {
            for (int j = 0; j < 4; ++j) {
                t[v].res[i][j] = 0;
            }
        }
        for (int l1 = 0; l1 < 4; ++l1) {
            for (int r2 = 0; r2 < 4; ++r2) {
                for (int r1 = 0; r1 < 4; ++r1) {
                    for (int l2 = 0; l2 < 4 - r1; ++l2) {
                        if ((l1 + r1 == lx && l1 != lx) || l1 + r1 > lx) {
                            continue;
                        }
                        if ((l2 + r2 == rx && r2 != rx) || l2 + r2 > rx) {
                            continue;
                        }
                        ll cur = t[v << 1].res[l1][r1] + t[v << 1 | 1].res[l2][r2];
                        if (l1 == lx && r2 == rx) {
                            if (lx + rx > 3) {
                                continue;
                            }
                            //cout << '!' << v << ' ' << len << ' ' << l1 << ' ' << r2 << ' ' << cur << endl;
                            t[v].res[lx + rx][0] = t[v].res[0][lx + rx] = cur;
                            continue;
                        }
                        if (l1 == lx) {
                            if (l1 + l2 > 3) {
                                continue;
                            }
                            xmax(t[v].res[l1 + l2][r2], cur);
                            continue;
                        }
                        if (r2 == rx) {
                            if (r1 + r2 > 3) {
                                continue;
                            }
                            xmax(t[v].res[l1][r1 + r2], cur);
                            continue;
                        }
                        xmax(t[v].res[l1][r2], cur);
                    }
                }
            }
        }
    }

    void upd(int p, int v) {
        p += sz - 1;
        t[p].res[0][1] = v;
        t[p].res[1][0] = v;
        while (1) {
            p >>= 1;
            if (p) {
                mrg(p);
            } else {
                break;
            }
        }
    }

    ll get() {
        ll res = 0;
        for (int i = 0; i < 4; ++i) {
            for (int j = 0; j < 4 - i; ++j) {
                xmax(res, t[1].res[i][j]);
            }
        }
        return res;
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    tree t(n);
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        t.upd(i + 1, a[i]);
    }
    //t.print();

    cout << t.get() << '\n';
    int q;
    cin >> q;
    while (q--) {
        int p, v;
        cin >> p >> v;
        t.upd(p, v);
        cout << t.get() << '\n';
    }
    return 0;
}
