#include <iostream>
#include <vector>
#include <fstream>
#include <assert.h>
#include <set>
#include <map>
#include <algorithm>
#define int long long
#define ll long long
#define pi pair<int, int>
#define pll pair<ll, ll>
#define F first
#define S second

using namespace std;
const int MAXN = 507;
vector <int> del[MAXN * MAXN];
const int INF = 1000000000;

int n;

int tryIt(int a, int b) {
	int k = a * b - n;
	if (k < 1) {
		return 0;
	}
	if (a < b) {
		swap(a, b);
	}
	int ra = lower_bound(del[k].begin(), del[k].end(), a) - del[k].begin();
	int rb = lower_bound(del[k].begin(), del[k].end(), b) - del[k].begin();
	int len = del[k].size() - 1;
	if (ra <= len / 2) {
		return 0;
	}
	int la = len - ra - 1;
	return max(0ll, rb - la - 1);
}

signed main() {
	cin.sync_with_stdio(0);
	cin.tie(0);
	int x;
	cin >> n >> x;
	for (int i = 1; i < MAXN * MAXN; ++i) {
		int j;
		for (j = 1; j * j <= i; ++j) {
			if (i % j == 0) {
				del[i].push_back(j);
			}
		}
		--j;
		if (j * j == i) {
			--j;
		}
		for (; j >= 1; --j) {
			del[i].push_back(i / j);
		}
		del[i].push_back(INF);
	}

	int ans = 0;
	for (int a = 1; a < MAXN; ++a) {
		if (a == x) {
			continue;
		}
		for (int b = 1; b < MAXN; ++b) {
			if (b == x) {
				continue;
			}
			ans += tryIt(a, b);
		}
	}
	cout << ans;
	return 0;
}