#include <iostream>
#include <vector>
#include <fstream>
#include <assert.h>
#include <set>
#include <map>
#include <algorithm>
#define int long long
#define ll long long
#define pi pair<int, int>
#define pll pair<ll, ll>
#define F first
#define S second

using namespace std;
const int MAXN = 3007;
vector <int> del[MAXN * MAXN];
const int INF = 1000000000;

int n;

int tryIt(int a, int b) {
	int k = a * b - n;
	if (k < 1) {
		return 0;
	}
	if (a < b) {
		swap(a, b);
	}
	int ra = lower_bound(del[k].begin(), del[k].end(), a) - del[k].begin();
	int rb = lower_bound(del[k].begin(), del[k].end(), b) - del[k].begin();
	int len = del[k].size() - 1;
	if (ra <= len / 2) {
		return 0;
	}
	int la = len - ra - 1;
	return max(0ll, rb - la - 1);
}

int lin[MAXN * MAXN];
vector <int> primes;

signed main() {
	cin.sync_with_stdio(0);
	cin.tie(0);
	int x;
	cin >> n >> x;
	for (int i = 2; i < MAXN * MAXN; ++i) {
		if (lin[i] == 0) {
			primes.push_back(i);
			lin[i] = i;
			for (int j = i * i; j < MAXN * MAXN; j += i) {
				if (lin[j] == 0) {
					lin[j] = i;
				}
			}
		}
	}
	del[1].push_back(1);
	del[1].push_back(INF);
	for (int i = 2; i < MAXN * MAXN; ++i) {
		vector <int> primDel;
		int cur = i;
		while (cur != 1) {
			primDel.push_back(lin[cur]);
			cur /= lin[cur];
		}
		set<int> cur_del;
		cur_del.insert(1);
		for (auto p : primDel) {
			vector<int> nw;
			for (auto q : cur_del) {
				nw.push_back(p * q);
			}
			for (auto q : nw) {
				cur_del.insert(q);
			}
			nw.clear();
		}
		for (auto p : cur_del) {
			del[i].push_back(p);
		}
		del[i].push_back(INF);
		primDel.clear();
		cur_del.clear();
	}

	int ans = 0;
	for (int a = 1; a < MAXN; ++a) {
		if (a == x) {
			continue;
		}
		for (int b = 1; b < MAXN; ++b) {
			if (b == x) {
				continue;
			}
			ans += tryIt(a, b);
		}
	}
	cout << ans;
	return 0;
}