#include <iostream>
#include <vector>
#include <fstream>
#include <assert.h>
#include <set>
#include <map>
#include <algorithm>
#define int long long
#define ll long long
#define pi pair<int, int>
#define pll pair<ll, ll>
#define F first
#define S second

using namespace std;

const int MAXN = 40007;
int n;
int a[MAXN * 3];
bool used[MAXN];

bool isMaskGood() {
	for (int i = 0; i < n; ++i) {
		int k = 0;
		for (int j = 0; j < 4; ++j) {
			if (used[i + j]) {
				++k;
			}
		}
		if (k == 4) {
			return false;
		}
	}
	return true;
}

void bSolveT() {
	for (int i = n; i < n + n; ++i) {
		a[i] = a[i - n];
	}
	int ans = 0;
	for (int mask = 0; mask < (1ll << n); ++mask) {
		for (int i = 0; i < n; ++i) {
			used[i] = (mask >> i) & 1;
		}
		for (int i = n; i < n + n; ++i) {
			used[i] = used[i - n];
		}
		int cur = 0;
		if (isMaskGood()) {
			for (int i = 0; i < n; ++i) {
				if (used[i]) {
					cur += a[i];
				}
			}
		}
		ans = max(ans, cur);
	}
	cout << ans << '\n';
}

void brute() {
	bSolveT();
	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		int p, v;
		cin >> p >> v;
		a[p - 1] = v;
		bSolveT();
	}
}

int dp[MAXN * 3][16];

int maskToInt(int mask, int x) {
	int ans = 0;
	for (int i = 0; i < (1ll << 4); ++i) {
		if ((mask >> i) & 1) {
			ans += a[i + x];
		}
	}
	return ans;
}

int cntDpFrom(int x) {
	for (int i = 0; i < 3 * n; ++i) {
		for (int j = 0; j < (1 << 4); ++j) {
			dp[i][j] = 0;
		}
	}
	for (int mask = 0; mask < (1 << 4); ++mask) {
		if (mask % 2 == 1) {
			dp[x + 3][mask] = 0;
		} else
		{
			dp[x + 3][mask] = maskToInt(mask, x);
		}
	}
	for (int i = x + 3; i < x + n - 1; ++i) {
		for (int mask = 0; mask < (1 << 4); ++mask) {
			dp[i + 1][mask >> 1] = max(dp[i + 1][mask >> 1], dp[i][mask]);
			dp[i + 1][(mask >> 1) + 8] = max(dp[i + 1][(mask >> 1) + 8], dp[i][mask] + a[i + 1]);
		}
		dp[i + 1][15] = 0;
	}
	int ans = 0;
	for (int mask = 0; mask < (1 << 4); ++mask) {
		ans = max(ans, dp[x + n - 1][mask]);
	}
	return ans;
}

void solveT() {
	for (int i = n; i < 3 * n; ++i) {
		a[i] = a[i - n];
	}
	int ans = 0;
	for (int i = 0; i < 4; ++i) {
		ans = max(ans, cntDpFrom(i));
	}
	cout << ans << '\n';
}

signed main() {
	cin.sync_with_stdio(0);
	cin.tie(0);
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	//if (n <= 10) {
		//brute();
		//return 0;
	//}
	solveT();
	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		int v, p;
		cin >> p >> v;
		a[p - 1] = v;
		solveT();
	}
	return 0;
}