#include <bits/stdc++.h>


using namespace std;


#define int long long


void warp()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
}


struct node
{
    int x;
    int y;
    int sz;
    int numb;
    node* l;
    node* r;
    node()
    {
        x = 0;
        y = (rand() << 15) + rand();
        sz = 0;
        l = NULL;
        r = NULL;
        numb = 0;
    }
    node (int val)
    {
        x = val;
        y = (rand() << 15) + rand();
        sz = 1;
        l = NULL;
        r = NULL;
        numb = 1;
    }
};


typedef node* tree;


int getSz(tree root)
{
    if (!root) return 0;
    return root->sz;
}


void relax(tree root)
{
    if (root)
    {
        root->sz = 1 + getSz(root->l)+ getSz(root->r);
    }
}


tree merge(tree l, tree r)
{
    if (!l) return r;
    if (!r) return l;
    if (l->y > r->y)
    {
        l->r = merge(l->r, r);
        relax(l);
        return l;
    }
    r->l = merge(l, r->l);
    relax(r);
    return r;
}


pair<tree, tree> split(tree root, int val)
{
    if (!root) return make_pair(root, root);
    if (root->x <= val)
    {
        pair<tree, tree> res = split(root->r, val);
        root->r = res.first;
        relax(root);
        return make_pair(root, res.second);
    }
    pair<tree, tree> res = split(root->l, val);
    root->l = res.second;
    relax(root);
    return make_pair(res.first, root);
}


bool find(tree root, int val)
{
    if (!root) return false;
    if (root->x == val) return true;
    if (val > root->x) return find(root->r, val);
    return find(root->l, val);
}


tree add(tree root, tree n)
{
    if (!root) return n;
    if (n->y > root->y)
    {
        pair<tree, tree> res = split(root, n->x);
        n->l = res.first;
        n->r = res.second;
        relax(n);
        return n;
    }
    if (n->x > root->x) root->r = add(root->r, n);
    else root->l = add(root->l, n);
    relax(root);
    return root;
}


tree buff(tree root, int val)
{
    if (!root) return root;
    if (root->x == val)
    {
        root->numb++;
        relax(root);
        return root;
    }
    if (val > root->x) root->r = buff(root->r, val);
    else root->l = buff(root->l, val);
    relax(root);
    return root;
}


tree insert(tree root, int val)
{
    if (find(root, val)) return buff(root, val);
    return add(root, new node(val));
}


tree erase(tree root, int val)
{
    if (!root) return root;
    if (root->x == val)
    {
        if (root->numb == 1) return merge(root->l, root->r);
        root->numb--;
        relax(root);
        return root;
    }
    if (val > root->x) root->r = erase(root->r, val);
    else root->l = erase(root->l, val);
    relax(root);
    return root;
}


void print(tree root)
{
    if (root)
    {
        print(root->l);
        cout << root->x << " ";
        print(root->r);
    }
}


signed main()
{
    warp();
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
    }
    for (int l = 1; l <= n; l++)
    {
        int ans = 0;
        tree root = NULL;
        for (int j = 0; j < l; j++) root = insert(root, a[j]);
        ans += getSz(root);
        for (int j = l; j < n; j++)
        {
            root = erase(root, a[j - l]);
            root = insert(root, a[j]);
            ans += getSz(root);
        }
        cout << ans << " ";
    }
    cout << endl;
    return 0;
}
