#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct oper {
	int x;
	int y;
	int tp;
	oper() {}
	oper(int x, int y, int tp) : x(x), y(y), tp(tp) {}
};

bool cmp(oper& A, oper& B) {
	return A.x < B.x;
}

struct node {
	int l = -1;
	int r = -1;
	int x = 0;
	node() {}
};

node pool[1000000];
int pt = 0;

int build(int L, int R, vector<int>& a) {
	node A;
	if (L == R - 1) {
		A.x = a[L];
		pool[pt] = A;
		pt++;
		return pt - 1;
	}
	int M = (L + R) / 2;
	A.l = build(L, M, a);
	A.r = build(M, R, a);
	A.x = pool[A.l].x + pool[A.r].x;
	pool[pt] = A;
	pt++;
	return pt - 1;
}

void upd(int root, int L, int R, int ind, int x) {
	if (L == R - 1) {
		pool[root].x += x;
		return;
	}
	int M = (L + R) / 2;
	if (ind < M)
		upd(pool[root].l, L, M, ind, x);
	else
		upd(pool[root].r, M, R, ind, x);
	pool[root].x = pool[pool[root].l].x + pool[pool[root].r].x;
}

int get(int root, int L, int R, int need) {
	if (pool[root].x == need)
		return R;
	if (pool[root].x < need)
		return -1;
	if (L == R - 1)
		return -1;
	int M = (L + R) / 2;
	int left = pool[root].l, right = pool[root].r;
	if (pool[left].x <= need)
		return get(left, L, M, need);
	return get(right, M, R, need - pool[left].x);
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, m, s;
	cin >> n >> m >> s;
	vector<vector<oper> > all(m);
	for (int i = 0; i < m; i++) {
		all[i].resize(n - 1);
		for (int j = 0; j < n - 1; j++) {
			int x, y, tp;
			cin >> x >> y >> tp;
			x--; y--;
			all[i][j] = { x, y, tp };
		}
	}
	vector<vector<int> > mat(m);
	for (int i = 0; i < m; i++) {
		mat[i].resize(n);
		for (int j = 0; j < n; j++)
			cin >> mat[i][j];
	}
	if (n == 1) {
		cout << s << endl;
		return 0;
	}
	if (n == 2) {
		vector<oper> arr(m);
		for (int i = 0; i < m; i++) {
			arr[i] = all[i][0];
			if (arr[i].x == 0) {
				arr[i].x = mat[i][0];
				arr[i].y = mat[i][1];
			}
			else {
				arr[i].x = mat[i][1];
				arr[i].y = mat[i][0];
			}
		}
		sort(arr.begin(), arr.end(), cmp);
		//for (auto elem : arr)
		//	cout << elem.x << "/" << elem.y << "/" << elem.tp << endl;
		vector<int> st(m + 1);
		for (auto elem : arr) {
			if (elem.tp == 2) {
				st[elem.y + 1]++;
			}
		}
		int root = build(0, m + 1, st);
		int pt = 0;
		int ans = 0;
		for (int x = 0; x <= m; x++) {
			while (pt < n && arr[pt].x < x) {
				if (arr[pt].tp == 2) {
					upd(root, 0, m + 1, arr[pt].y + 1, -1);
					ans++;
				}
				else {
					upd(root, 0, m + 1, arr[pt].y + 1, 1);
				}
				pt++;
			}
			//cout << x << ": " << pt << endl;
			if (ans > s)
				break;
			int y = get(root, 0, m + 1, s - ans);
			if (y == -1)
				continue;
			cout << x << " " << y - 1 << endl;
			return 0;
		}
	}
}