#include <iostream>
#include <vector>
#include <algorithm>
#include <time.h>

using namespace std;

struct oper {
	int x;
	int y;
	int tp;
	oper() {}
	oper(int x, int y, int tp) : x(x), y(y), tp(tp) {}
};

bool cmp(oper& A, oper& B) {
	return A.x < B.x;
}

struct node {
	int l = -1;
	int r = -1;
	int x = 0;
	node() {}
};

node pool[1000000];
int P = 0;

int build(int L, int R, vector<int>& a) {
	node A;
	if (L == R - 1) {
		A.x = a[L];
		pool[P] = A;
		P++;
		return P - 1;
	}
	int M = (L + R) / 2;
	A.l = build(L, M, a);
	A.r = build(M, R, a);
	A.x = pool[A.l].x + pool[A.r].x;
	pool[P] = A;
	P++;
	return P - 1;
}

void upd(int root, int L, int R, int ind, int x) {
	if (L == R - 1) {
		pool[root].x += x;
		return;
	}
	int M = (L + R) / 2;
	if (ind < M)
		upd(pool[root].l, L, M, ind, x);
	else
		upd(pool[root].r, M, R, ind, x);
	pool[root].x = pool[pool[root].l].x + pool[pool[root].r].x;
}

int get(int root, int L, int R, int need) {
	//cout << L << "-" << R << " " << need << endl;
	if (pool[root].x == need)
		return R;
	if (pool[root].x < need)
		return -1;
	if (L == R - 1)
		return -1;
	int M = (L + R) / 2;
	int left = pool[root].l, right = pool[root].r;
	if (pool[left].x >= need)
		return get(left, L, M, need);
	return get(right, M, R, need - pool[left].x);
}

bool check(vector<oper> &arr, int s, int x, int y) {
	int now = 0;
	for (auto elem : arr) {
		if (elem.tp == 1) {
			if (elem.x < x && elem.y < y)
				now++;
		}
		if (elem.tp == 2) {
			if (elem.x < x || elem.y < y)
				now++;
		}
	}
	return (now == s);
}

bool check2(int n, int m, int s, vector<vector<oper> >& all, vector<vector<int> >& mat, int x, int y) {
	int now = 0;
	for (int i = 0; i < m; i++) {
		bool A, B;
		A = mat[i][0] < x;
		B = mat[i][1] < y;
		/*
		if (all[i][0].x == 1) {
			A = mat[i][0] < x;
			B = mat[i][1] < y;
		}
		else {
			A = mat[i][1] < x;
			B = mat[i][0] < y;
		}
		*/
		if (all[i][0].tp == 1) {
			if (A && B)
				now++;
		}
		else {
			if (A || B)
				now++;
		}
	}
	return (now == s);
}

pair<int, int> solve2(int n, int m, int s, vector<vector<oper> > &all, vector<vector<int> > &mat) {
	vector<oper> arr(m);
	for (int i = 0; i < m; i++) {
		arr[i] = all[i][0];
		arr[i].x = mat[i][0];
		arr[i].y = mat[i][1];
		
	}
	sort(arr.begin(), arr.end(), cmp);
	vector<int> st(m + 1);
	for (auto elem : arr) {
		if (elem.tp == 2) {
			st[elem.y + 1]++;
		}
	}
	int root = build(0, m + 1, st);
	int pt = 0;
	int ans = 0;
	//cout << "here" << endl;
	//for (auto elem : arr)
	//	cout << elem.x << "/" << elem.y << "/" << elem.tp << endl;
	for (int x = 0; x <= m; x++) {
		while (pt < m && arr[pt].x < x) {
			if (arr[pt].tp == 2) {
				upd(root, 0, m + 1, arr[pt].y + 1, -1);
				ans++;
			}
			else {
				upd(root, 0, m + 1, arr[pt].y + 1, 1);
			}
			pt++;
		}
		//cout << x << ": " << pt << endl;
		if (ans > s)
			break;
		//cout << x << ": " << s - ans << endl;
		int y = get(root, 0, m + 1, s - ans);
		if (y == -1)
			continue;
		cout << x << " " << y - 1 << endl;
		return { x, y - 1 };
	}
	
	/*
	for (int x = 0; x <= m; x++) {
		int now = 0;
		vector<int> need;
		for (auto elem : arr) {
			if (elem.x < x) {
				if (elem.tp == 2)
					now++;
				else
					need.push_back(elem.y + 1);
			}
			else {
				if (elem.tp == 2) {
					need.push_back(elem.y + 1);
				}
			}
		}
		sort(need.begin(), need.end());
		if (now > s)
			break;
		int ind = s - now;
		if (ind > need.size())
			continue;
		if (ind == 0) {
			cout << x << " " << 0 << endl;
			return { x, 0 };
		}
		if (ind == need.size()) {
			cout << x << " " << m << endl;
			return {x, m};
		}
		int L = need[ind - 1];
		int R = need[ind];
		if (L == R)
			continue;
		cout << x << " " << L << endl;
		return {x, L};
	}
	return { -1, -1 };
	*/
	
}

void gen(int &n, int &m, int &s, vector<vector<oper> >& all, vector<vector<int> >& mat) {
	cout << "TEST" << endl;
	n = rand() % 5 + 1;
	m = 1;
	s = rand() % (m + 1);
	cout << n << " " << m << " " << s << endl;
	all.resize(m);
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n - 1; j++) {
			int tp = 1 + (rand() % 2);
			if (rand() % 2) {
				all[i].push_back({ 1, 2, tp });
				cout << "1 2 " << tp << endl;
			}
			else {
				all[i].push_back({ 2, 1, tp });
				cout << "2 1 " << tp << endl;
			}
		}
	}
	vector<vector<int> > now(n);
	for (int i = 0; i < n; i++) {
		now[i].resize(m);
		for (int j = 0; j < m; j++)
			now[i][j] = j;
		random_shuffle(now[i].begin(), now[i].end());
	}
	mat.resize(m);
	for (int i = 0; i < m; i++) {
		mat[i].resize(n);
		for (int j = 0; j < n; j++) {
			cout << now[j][i] << " ";
			mat[i][j] = now[j][i];
		}
		//mat[i][0] = now1[i];
		//mat[i][1] = now2[i];
		cout << endl;
	}
}

void input(int &n, int &m, int &s, vector<vector<oper> > &all, vector<vector<int> > &mat) {
	cin >> n >> m >> s;
	all.resize(m);
	for (int i = 0; i < m; i++) {
		all[i].resize(n - 1);
		for (int j = 0; j < n - 1; j++) {
			int x, y, tp;
			cin >> x >> y >> tp;
			//x--; y--;
			all[i][j] = { x, y, tp };
		}
	}
	mat.resize(m);
	for (int i = 0; i < m; i++) {
		mat[i].resize(n);
		for (int j = 0; j < n; j++)
			cin >> mat[i][j];
	}
}

bool check3(vector<int>& now, int n, int m, int s, vector<vector<oper> >& all, vector<vector<int> >& mat) {
	//cout << "here" << endl;
	int ans = 0;
	for (int i = 0; i < m; i++) {
		vector<bool> arr;
		for (int j = 0; j < n; j++) {
			arr.push_back(mat[i][j] < now[j]);
		}
		for (int j = 0; j < n - 1; j++) {
			int ind1 = all[i][j].x, ind2 = all[i][j].y;
			bool x = arr[ind1 - 1];
			bool y = arr[ind2 - 1];
			if (all[i][j].tp == 1) {
				arr.push_back(x && y);
			}
			else {
				arr.push_back(x || y);
			}
		}
		if (arr[2 * n - 2])
			ans++;
	}
	//cout << "here2" << endl;
	return (ans == s);
}

bool gen_mask(vector<int>& now, int n, int m, int s, vector<vector<oper> >& all, vector<vector<int> >& mat) {
	if (now.size() == n) {
		bool res = check3(now, n, m, s, all, mat);
		if (res)
			return 1;
		return 0;
	}
	for (int i = 0; i <= m; i++) {
		now.push_back(i);
		bool res = gen_mask(now, n, m, s, all, mat);
		if (res)
			return 1;
		now.pop_back();
	}
	return 0;
}

void solvem(int n, int m, int s, vector<vector<oper> >& all, vector<vector<int> >& mat) {

}

int main() {
	srand(time(NULL));
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, m, s;
	vector<vector<oper> > all;
	vector<vector<int> > mat;
	vector<oper> arr;
	
	
	input(n, m, s, all, mat);
	//m = 2;
	if (m <= 2) {
		vector<int> now;
		//gen(n, m, s, all, mat);
		gen_mask(now, n, m, s, all, mat);
		for (auto elem : now)
			cout << elem << " ";
		cout << endl;
		return 0;
	}

	if (n == 1) {
		cout << s << endl;
		return 0;
	}
	auto res = solve2(n, m, s, all, mat);
	return 0;
	
	//cout << check2(n, m, s, all, mat, res.first, res.second) << endl;
	//return 0;
	
	for (int ijk = 0; ijk < 10000; ijk++) {
		gen(n, m, s, all, mat);
		
		auto res = solve2(n, m, s, all, mat);
		//bool flag = check(arr, s, res.first, res.second);
		bool flag = check2(n, m, s, all, mat, res.first, res.second);
		if (flag)
			cout << "OK" << endl;
		else {
			cout << "WA " <<  res.first << " " << res.second << endl;
			return 0;
		}
	}
	return 0;
	

	
	if (n == 2) {
		
		vector<oper> arr(m);
		for (int i = 0; i < m; i++) {
			arr[i] = all[i][0];
			if (arr[i].x == 0) {
				arr[i].x = mat[i][0];
				arr[i].y = mat[i][1];
			}
			else {
				arr[i].x = mat[i][1];
				arr[i].y = mat[i][0];
			}
		}
		auto res = solve2(n, m, s, all, mat);
		bool ch = check(arr, s, res.first, res.second);
		//if (!ch) {
		//	cout << 
		//}
	}
}