#include <bits/stdc++.h>
#ifdef DEBUG
#define __GLIBCXX_DEBUG
#endif // DEBUG

using namespace std;

typedef long long ll;
typedef long double ld;

const int maxn = 4e4 + 5;
#ifdef DEBUG
const int blsz = 3;
#else
const int blsz = 200;
#endif // DEBUG

ll a[maxn];
ll dp[4][4][maxn];

struct taker {
    int len;
    ll res[4][4];
    taker() {
        for (int i = 0; i <= 3; i++)
            for (int j = 0; j <= 3; j++)
                res[i][j] = 0;
    }
    void dobuild(int l, int r) { /// []
        if (l == r) {
            res[1][1] = a[l];
            return;
        }
        if (r == l + 1) {
            res[1][0] = a[l];
            res[0][1] = a[r];
            res[2][2] = a[l] + a[r];
            return;
        }
        for (int i = 0; i < 4; i++)
            for (int j = 0; j < 4; j++)
                fill(dp[i][j] + l, dp[i][j] + r + 1, 0);
        dp[0][0][l + 2] = a[l + 1];
        dp[0][1][l + 2] = a[l + 2];
        dp[0][2][l + 2] = a[l + 1] + a[l + 2];
        dp[1][0][l + 2] = a[l + 0];
        dp[1][1][l + 2] = a[l + 0] + a[l + 2];
        dp[2][0][l + 2] = a[l + 0] + a[l + 1];
        dp[3][3][l + 2] = a[l + 0] + a[l + 1] + a[l + 2];
        for (int i = l + 3; i <= r; i++) {
            for (int j = 0; j <= 3; j++) {
                for (int k = 0; k <= 2; k++) {
                    dp[j][k + 1][i] = max(dp[j][k + 1][i], dp[j][k][i - 1] + a[i]);
                }
                for (int k = 0; k <= 3; k++) {
                    dp[j][0][i] = max(dp[j][0][i], dp[j][k][i - 1]);
                }
            }
        }
        for (int i = 0; i <= 3; i++) {
            for (int j = 0; j <= 3; j++) {
                res[i][j] = dp[i][j][r];
            }
        }
    }
};

pair <int, int> zaps[maxn];
bool isnow[maxn];
vector <taker> cvec;
int cvpos[maxn];

void docvec() {
    //cerr << "new docvec\n";
    for (taker t : cvec) {
        /*cerr << t.len << "\n";
        for (int i = 0; i < 4; i++) {
            for (int j = 0; j < 4; j++) {
                cerr << t.res[i][j] << " ";
            }
            cerr << "\n";
        }*/
    }
    for (int i = 0; i < 4; i++) {
        for (int j = 0; j < 4; j++) {
            fill(dp[i][j], dp[i][j] + cvec.size(), 0);
            dp[i][j][0] = cvec[0].res[i][j];
        }
    }
    int slen = cvec[0].len;
    for (int i = 1; i < cvec.size(); i++) {
        for (int st = 0; st < 4; st++) {
            for (int fin = 0; fin < 4; fin++) {
                if (!cvec[i].res[st][fin] && (st || fin))
                    continue;
                if (st < cvec[i].len && fin < cvec[i].len) {
                    for (int sp = 0; sp < 4; sp++) {
                        for (int fp = 0; st + fp < 4; fp++) {
                            if (sp != slen)
                                dp[sp][fin][i] = max(dp[sp][fin][i], dp[sp][fp][i - 1] + cvec[i].res[st][fin]);
                            else if (slen + st <= 3)
                                dp[slen + st][fin][i] = max(dp[slen + st][fin][i], dp[sp][fp][i - 1] + cvec[i].res[st][fin]);
                            //if (i == 1)
                            //    cerr << "fir " << st << " " << fin << " " << sp << " " << fp << " " << dp[sp][fin][i] << "\n";
                        }
                    }
                }
                else {
                    for (int sp = 0; sp < 4; sp++) {
                        for (int fp = 0; fp + st < 4; fp++) {
                            if (sp != slen)
                                dp[sp][fp + st][i] = max(dp[sp][fp + st][i], dp[sp][fp][i - 1] + cvec[i].res[st][fin]);
                            else if (slen + st <= 3)
                                dp[slen + st][fp + st][i] = max(dp[slen + st][fp + st][i],
                                                                 dp[sp][fp][i - 1] + cvec[i].res[st][fin]);
                            //if (i == 1)
                            //    cerr << "sec " << st << " " << fin << " " << sp << " " << fp << " " << dp[sp][fp + st][i] << "\n";
                        }
                    }
                }
            }
        }
        slen += cvec[i].len;
    }
    /*cerr << "got dp\n";
    for (int i = 0; i < cvec.size(); i++) {
        for (int j = 0; j <= 3; j++) {
            for (int k = 0; k <= 3; k++) {
                cerr << dp[j][k][i] << " ";
            }
            cerr << "   ";
        }
        cerr << "\n";
    }*/
    ll cres = 0;
    for (int i = 0; i < 4; i++) {
        for (int j = 0; i + j < 4; j++) {
            //cerr << "got dp " << i << " " << j << " " << dp[i][j][cvec.size() - 1] << "\n";
            cres = max(cres, dp[i][j][cvec.size() - 1]);
        }
    }
    cout << cres << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif // DEBUG
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        cin >> zaps[i].first >> zaps[i].second;
        zaps[i].first--;
    }
    for (int blnum = 0; blnum < (q + blsz - 1) / blsz; blnum++) {
        int L = blnum * blsz, R = min(L + blsz, q); /// [)
        fill(isnow, isnow + n, false);
        for (int i = L; i < R; i++) {
            isnow[zaps[i].first] = true;
        }
        cvec.clear();
        int st = 0;
        for (int i = 0; i < n; i++) {
            if (isnow[i]) {
                if (st <= i - 1) {
                    cvec.push_back(taker());
                    cvec.back().len = i - st;
                    cvec.back().dobuild(st, i - 1);
                }
                cvpos[i] = cvec.size();
                cvec.push_back(taker());
                cvec.back().len = 1;
                cvec.back().res[1][1] = a[i];
                st = i + 1;
            }
        }
        if (st < n) {
            cvec.push_back(taker());
            cvec.back().len = n - st;
            cvec.back().dobuild(st, n - 1);
        }
        if (blnum == 0) {
            docvec();
        }
        for (int i = L; i < R; i++) {
            a[zaps[i].first] = zaps[i].second;
            cvec[cvpos[zaps[i].first]].res[1][1] = zaps[i].second;
            docvec();
        }
    }
    return 0;
}
