#include <iostream>
#include <cmath>
#include <algorithm>
#include <climits>
#include <vector>
#include <set>
#include <map>

#define ff  first
#define ss  second
#define pb  push_back
#define sz  size()

using namespace std;

typedef long long ll;
typedef pair<int, int> pr;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef long double ld;

struct alg {
    int op;
    int x1, x2;
    int ind;
};

bool comp1(alg a1, alg a2) {
    if (a1.op == a2.op) {
        return a1.x1 < a2.x1;
    }
    return a1.op > a2.op;
}

bool comp2(alg a1, alg a2) {
    if (a1.op == a2.op) {
        return a1.x1 < a2.x1;
    }
    return a1.op < a2.op;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m, s;
    cin >> n >> m >> s;
    if (n == 1) {
        vector<int> v(m);
        for (int i = 0; i < m; ++i) {
            cin >> v[i];
        }
        sort(v.begin(), v.end());
        if (s == m) {
            cout << m;
        } else
            cout << v[s];
        exit(0);
    }
    if (n == 2) {
        int cnt = 0;
        vector<alg> v;
        for (int i = 0; i < m; ++i) {
            int op, x1, x2;
            cin >> x1 >> x2 >> op;
            if (op == 2) {
                ++cnt;
            }
            v.pb({ op, x1 - 1, x2 - 1, i });
        }
        vector<int> first(m);
        vector<int> second(m);
        for (int i = 0; i < m; ++i) {
            cin >> first[i] >> second[i];
        }
        for (int i = 0; i < v.sz; ++i) {
            v[i].x1 = first[v[i].ind];
            v[i].x2 = second[v[i].ind];
        }
        if (cnt >= s) {
            sort(v.begin(), v.end(), comp1);
            if (s == cnt) {
                cout << m << ' ' << 0;
                exit(0);
            }
            cout << v[s].x1 << ' ' << 0;
            exit(0);
        }
        sort(v.begin(), v.end(), comp2);
        if (s == m) {
            cout << m << ' ' << m;
            exit(0);
        }
        cout << v[s - cnt].x1 << ' ' << m;
    }

    return 0;
}