#include <iostream>
#include <cmath>
#include <algorithm>
#include <climits>
#include <vector>
#include <set>
#include <map>

#define ff  first
#define ss  second
#define pb  push_back
#define sz  size()

using namespace std;

typedef long long ll;
typedef pair<int, int> pr;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef long double ld;

struct alg {
    int op;
    int x1, x2;
    int ind;
};

bool comp1(alg a1, alg a2) {
    if (a1.op == a2.op) {
        return a1.x1 < a2.x1;
    }
    return a1.op > a2.op;
}

bool comp2(alg a1, alg a2) {
    if (a1.op == a2.op) {
        return a1.x1 < a2.x1;
    }
    return a1.op < a2.op;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m, s;
    cin >> n >> m >> s;
    if (n == 1) {
        vector<int> v(m);
        for (int i = 0; i < m; ++i) {
            cin >> v[i];
        }
        sort(v.begin(), v.end());
        if (s == m) {
            cout << m;
        } else
            cout << v[s];
        exit(0);
    }
    if (n == 2) {
        int cnt = 0;
        vector<alg> v;
        for (int i = 0; i < m; ++i) {
            int op, x1, x2;
            cin >> x1 >> x2 >> op;
            if (op == 2) {
                ++cnt;
            }
            v.pb({ op, x1 - 1, x2 - 1, i });
        }
        vector<int> first(m);
        vector<int> second(m);
        for (int i = 0; i < m; ++i) {
            cin >> first[i] >> second[i];
        }
        for (int i = 0; i < v.sz; ++i) {
            v[i].x1 = first[v[i].ind];
            v[i].x2 = second[v[i].ind];
        }
        if (cnt >= s) {
            sort(v.begin(), v.end(), comp1);
            if (s == cnt) {
                cout << m << ' ' << 0;
                exit(0);
            }
            cout << v[s].x1 << ' ' << 0;
            exit(0);
        }
        sort(v.begin(), v.end(), comp2);
        if (s == m) {
            cout << m << ' ' << m;
            exit(0);
        }
        cout << v[s - cnt].x1 << ' ' << m;
        exit(0);
    }

    if (m == 1) {
        if (s) {
            for (int i = 0; i < n; ++i) {
                cout << m << ' ';
            }
        } else {
            for (int i = 0; i < n; ++i) {
                cout << 0 << ' ';
            }
        }
        exit(0);
    }
    if ((m == 2) && (n <= 10)) {
        vector<alg> p1;
        vector<alg> p2;
        for (int i = 0; i < n - 1; ++i) {
            int op, x1, x2;
            cin >> x1 >> x2 >> op;
            p1.pb({ op, x1 - 1, x2 - 1, i });
        }
        for (int i = 0; i < n - 1; ++i) {
            int op, x1, x2;
            cin >> x1 >> x2 >> op;
            p2.pb({ op, x1 - 1, x2 - 1, i });
        }
        if (s % 2 == 0) {
            if (s) {
                for (int i = 0; i < n; ++i) {
                    cout << m << ' ';
                }
            } else {
                for (int i = 0; i < n; ++i) {
                    cout << 0 << ' ';
                }
            }
            exit(0);
        }
        vector<int> v1(2 * n - 1);
        vector<int> v2(2 * n - 1);



        for (int i = 0; i < n; ++i) {
            fill(v1.begin(), v1.end(), 1);
            fill(v2.begin(), v2.end(), 1);
            v1[i] = 0;
            v2[i] = 0;
            for (int p = 0; p < n - 1; ++p) {
                v1[n + p] = (p1[p].op == 1) ? (v1[p1[p].x1] && v1[p1[p].x2]) : (v1[p1[p].x1] || v1[p1[p].x2]);
                v2[n + p] = (p2[p].op == 1) ? (v2[p2[p].x1] && v2[p2[p].x2]) : (v2[p2[p].x1] || v2[p2[p].x2]);
            }
            if (v1.back() != v2.back()) {
                for (int j = 0; j < i; ++j) {
                    cout << m;
                }
                cout << 0;
                for (int j = i + 1; j < n; ++j) {
                    cout << m;
                }
                exit(0);
            }
            v1[i] = (v2[i] > v1[i]) ? 1 : 0;
            v2[i] = (v2[i] > v1[i]) ? 0 : 1;
            for (int p = 0; p < n - 1; ++p) {
                v1[n + p] = (p1[p].op == 1) ? (v1[p1[p].x1] && v1[p1[p].x2]) : (v1[p1[p].x1] || v1[p1[p].x2]);
                v2[n + p] = (p2[p].op == 1) ? (v2[p2[p].x1] && v2[p2[p].x2]) : (v2[p2[p].x1] || v2[p2[p].x2]);
            }
            if (v1.back() != v2.back()) {
                for (int j = 0; j < i; ++j) {
                    cout << m;
                }
                cout << max(v1[i], v2[i]);
                for (int j = i + 1; j < n; ++j) {
                    cout << m;
                }
                exit(0);
            }
        }




        for (int i = 0; i < n; ++i) {
            fill(v1.begin(), v1.end(), 0);
            fill(v2.begin(), v2.end(), 0);
            v1[i] = 1;
            v2[i] = 1;
            for (int p = 0; p < n - 1; ++p) {
                v1[n + p] = (p1[p].op == 1) ? (v1[p1[p].x1] && v1[p1[p].x2]) : (v1[p1[p].x1] || v1[p1[p].x2]);
                v2[n + p] = (p2[p].op == 1) ? (v2[p2[p].x1] && v2[p2[p].x2]) : (v2[p2[p].x1] || v2[p2[p].x2]);
            }
            if (v1.back() != v2.back()) {
                for (int j = 0; j < i; ++j) {
                    cout << 0;
                }
                cout << m;
                for (int j = i + 1; j < n; ++j) {
                    cout << 0;
                }
                exit(0);
            }
            v1[i] = (v2[i] > v1[i]) ? 1 : 0;
            v2[i] = (v2[i] > v1[i]) ? 0 : 1;
            for (int p = 0; p < n - 1; ++p) {
                v1[n + p] = (p1[p].op == 1) ? (v1[p1[p].x1] && v1[p1[p].x2]) : (v1[p1[p].x1] || v1[p1[p].x2]);
                v2[n + p] = (p2[p].op == 1) ? (v2[p2[p].x1] && v2[p2[p].x2]) : (v2[p2[p].x1] || v2[p2[p].x2]);
            }
            if (v1.back() != v2.back()) {
                for (int j = 0; j < i; ++j) {
                    cout << 0;
                }
                cout << max(v1[i], v2[i]);
                for (int j = i + 1; j < n; ++j) {
                    cout << 0;
                }
                exit(0);
            }
        }

    }

    return 0;
}