#include <iostream>
#include <cmath>
#include <algorithm>
#include <climits>
#include <vector>
#include <set>
#include <bitset>
#include <map>

#define ff  first
#define ss  second
#define pb  push_back
#define sz  size()

using namespace std;

typedef long long ll;
typedef pair<int, int> pr;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef long double ld;

struct alg {
    int op;
    int x1, x2;
    int ind;
};

bool comp1(alg a1, alg a2) {
    if (a1.op == a2.op) {
        return a1.x1 < a2.x1;
    }
    return a1.op > a2.op;
}

bool comp2(alg a1, alg a2) {
    if (a1.op == a2.op) {
        return a1.x1 < a2.x1;
    }
    return a1.op < a2.op;
}

bool comp(pr p1, pr p2) {
    return p1.ss > p2.ss;
}

vector<set<int> > vv;
vector<vector<alg> > p;



void func(alg al, int i, int n) {
    if (al.x1 < n) {
        vv[i].insert(al.x1);
    } else {
        func(p[i][al.x1 - n], i, n);
    }
    if (al.x2 < n) {
        vv[i].insert(al.x2);
    } else {
        func(p[i][al.x2 - n], i, n);
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m, s;
    cin >> n >> m >> s;
    if (n == 1) {
        vector<int> v(m);
        for (int i = 0; i < m; ++i) {
            cin >> v[i];
        }
        sort(v.begin(), v.end());
        if (s == m) {
            cout << m;
        } else
            cout << v[s];
        exit(0);
    }
    if (n == 2) {
        int cnt = 0;
        vector<alg> v;
        for (int i = 0; i < m; ++i) {
            int op, x1, x2;
            cin >> x1 >> x2 >> op;
            if (op == 2) {
                ++cnt;
            }
            v.pb({ op, x1 - 1, x2 - 1, i });
        }
        vector<int> first(m);
        vector<int> second(m);
        for (int i = 0; i < m; ++i) {
            cin >> first[i] >> second[i];
        }
        for (int i = 0; i < v.sz; ++i) {
            v[i].x1 = first[v[i].ind];
            v[i].x2 = second[v[i].ind];
        }
        if (cnt >= s) {
            sort(v.begin(), v.end(), comp1);
            if (s == cnt) {
                cout << m << ' ' << 0;
                exit(0);
            }
            cout << v[s].x1 << ' ' << 0;
            exit(0);
        }
        sort(v.begin(), v.end(), comp2);
        if (s == m) {
            cout << m << ' ' << m;
            exit(0);
        }
        cout << v[s - cnt].x1 << ' ' << m;
        exit(0);
    }

    if (m == 1) {
        if (s) {
            for (int i = 0; i < n; ++i) {
                cout << m << ' ';
            }
        } else {
            for (int i = 0; i < n; ++i) {
                cout << 0 << ' ';
            }
        }
        exit(0);
    }
    if ((m == 2) && (n <= 10)) {
        vector<alg> p1;
        vector<alg> p2;
        for (int i = 0; i < n - 1; ++i) {
            int op, x1, x2;
            cin >> x1 >> x2 >> op;
            p1.pb({ op, x1 - 1, x2 - 1, i });
        }
        for (int i = 0; i < n - 1; ++i) {
            int op, x1, x2;
            cin >> x1 >> x2 >> op;
            p2.pb({ op, x1 - 1, x2 - 1, i });
        }
        if (s % 2 == 0) {
            if (s) {
                for (int i = 0; i < n; ++i) {
                    cout << m << ' ';
                }
            } else {
                for (int i = 0; i < n; ++i) {
                    cout << 0 << ' ';
                }
            }
            exit(0);
        }
        vector<int> v1(2 * n - 1);
        vector<int> v2(2 * n - 1);
        vector<int> first(n);
        vector<int> second(n);
        for (int i = 0; i < n; ++i) {
            cin >> first[i];
        }
        for (int i = 0; i < n; ++i) {
            cin >> second[i];
        }

        for (int i = 0; i < 59049; ++i) {
            int st = i;
            for (int j = 0; j < n; ++j) {
                int r = st % 3;
                if (!r) {
                    v1[j] = 0;
                    v2[j] = 0;
                }
                if (r == 1) {
                    v1[j] = (second[j] > first[j]) ? 1 : 0;
                    v2[j] = (second[j] > first[j]) ? 0 : 1;
                }
                if (r == 2) {
                    v1[j] = 1;
                    v2[j] = 1;
                }
                st /= 3;
            }

            for (int p = 0; p < n - 1; ++p) {
                v1[n + p] = (p1[p].op == 1) ? (v1[p1[p].x1] && v1[p1[p].x2]) : (v1[p1[p].x1] || v1[p1[p].x2]);
                v2[n + p] = (p2[p].op == 1) ? (v2[p2[p].x1] && v2[p2[p].x2]) : (v2[p2[p].x1] || v2[p2[p].x2]);
            }
            if (v1.back() != v2.back()) {
                int st = i;
                for (int j = 0; j < n; ++j) {
                    int r = st % 3;
                    if (!r) {
                        cout << 0;
                    }
                    if (r == 1) {
                        cout << max(second[j], first[j]);
                    }
                    if (r == 2) {
                        cout << m;
                    }
                    cout << ' ';
                    st /= 3;
                }
                exit(0);
            }
            
        }



    }


    //  ,   5  -   
    if (s == 0) {
        for (int i = 0; i < n; ++i) {
            cout << 0 << ' ';
        }
        exit(0);
    }
    if (s == m) {
        for (int i = 0; i < n; ++i) {
            cout << m << ' ';
        }
        exit(0);
    }
    map<int, int> mp;
    vv.resize(m);
    p.resize(m);
    vector<vector<int> > a(m, vector<int>(n));
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n - 1; ++j) {
            int op, x1, x2;
            cin >> x1 >> x2 >> op;
            p[i].pb({ op, x1 - 1, x2 - 1, j });
        }
        func(p[i].back(), i, n);
    }

    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> a[i][j];
        }
    }

    for (int i = 0; i < m; ++i) {
        for (auto it = vv[i].begin(); it != vv[i].end(); ++it) {
            ++mp[*it];
        }
    }
    set<int> needToNull;
    vector<pr> vpr;
    for (pr p : mp) {
        vpr.pb(p);
    }
    sort(vpr.begin(), vpr.end(), comp);
    int i = 0;
    for (; i < vpr.sz; ++i) {
        if (s < vpr[i].ss) {
            break;
        }
        s -= vpr[i].ss;
        needToNull.insert(vpr[i].ff);
    }
    pr need = vpr[i];
    if (s) {
        vector<int> res;
        for (int i = 0; i < m; ++i) {
            if (vv[i].find(need.ff) == vv[i].end())
                continue;
            res.pb(a[i][need.ff]);
        }
        sort(res.begin(), res.end());
        for (int i = 0; i < need.ff; ++i) {
            if (needToNull.find(i) != needToNull.end()) {
                cout << 0 << ' ';
            } else {
                cout << m << ' ';
            }
        }
        cout << res[s] << ' ';
        for (int i = need.ff + 1; i < n; ++i) {
            if (needToNull.find(i) != needToNull.end()) {
                cout << 0 << ' ';
            } else {
                cout << m << ' ';
            }
        }
    } else {
        for (int i = 0; i < n; ++i) {
            if (needToNull.find(i) != needToNull.end()) {
                cout << 0 << ' ';
            } else {
                cout << m << ' ';
            }
        }
    }


    return 0;
}
