#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <cassert>
#include <set>
#define int long long

using namespace std;

typedef long double ld;
typedef pair<int, int> pa;

int gcd(int a, int b) {
    if (b > a)
        swap(a, b);
    while (b) {
        int c = a % b;
        a = b;
        b = c;
    }
    return a;
}

const int N = 3000 * 3000;
int r[N];

void build() {
    r[1] = 1;
    vector<int> eas;
    for (int d = 2; d <= N; ++d) {
        if (r[d] == 0) {
            r[d] = d;
            eas.push_back(d);
        }
        for (int j : eas) {
            if (j > r[d])
                break;
            if (j * d > N)
                break;
            r[j * d] = j;
        }
    }
}

vector<pa> get(int mul) {
    vector<pa> nw;
    while (mul > 1) {
        if (nw.size() == 0 || nw.back().first != r[mul])
            nw.push_back({ r[mul], 1 });
        else
            nw.back().second++;
        mul /= r[mul];
    }
    //reverse(nw.begin(), nw.end());
    return nw;
}


void solve(int a, int b, vector<pa> vals, int f, int s,
    vector<pa>& ss, vector<pa>& ff) {
    if (f >= a || s >= b)
        return;
    if (vals.size() == 0) {
        if (a != b && a > s && b > f) {
            ff.push_back({ f, s });
        }
        if (a != b && a > f&& b > s)
            ff.push_back({ s, f });
        if (a > f && b > s)
            ss.push_back({ f, s });
        if (a > s && b > f)
            ss.push_back({ s, f });
        return;
    }
    int ml = 1, nw = 0, all = 1;
    for (int st = 0; st < vals.back().second; ++st)
        all *= vals.back().first;
    vector<pa> nx = vals;
    nx.pop_back();
    for (int st = 0; st <= vals.back().second; ++st) {
        if (a <= f * ml) break;
        solve(a, b, nx, f * ml, s * (all / ml), ss, ff);
        ml *= vals.back().first;
    }
}

signed main() {
    //freopen("txt.out", "w", stdout);

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, x;
    cin >> n >> x;


    build();

    int bad = 0, ans = 0;
    for (int d1 = 2; d1 <= n / 2 + 1; ++d1) {
        if (d1 == x)
            continue;
        for (int d2 = d1; d2 <= n; ++d2) {
            if (d1 == x || d2 == x)
                continue;
            int ab = d1 * d2;
            int cd = ab - n;
            if (cd <= 0)
                continue;
            
            vector<pa> nw = get(cd);
            vector<pa> ss, ff;
            solve(d1, d2, nw, 1, 1, ss, ff);
            sort(ss.begin(), ss.end());
            ss.resize(unique(ss.begin(), ss.end()) - ss.begin());
            sort(ff.begin(), ff.end());
            ff.resize(unique(ff.begin(), ff.end()) - ff.begin());

            ans += ss.size() + ff.size();
            ss.clear();
        }
    }
    cout << ans;

}