#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <cassert>
#define int long long

using namespace std;

typedef long double ld;

struct go {
    vector<vector<int>> dp;
};

const int N = 4e4 + 5;
go t[4 * N];

void merge(int v, int l, int r, int nd) {
    for (int st = 0; st <= 3; ++st) {
        for (int en = 0; en <= 3; ++en) {
            t[v].dp[st][en] = 0;
        }
    }
    int m = (l + r) / 2;
    for (int st = 0; st <= 3; ++st) {
        for (int en = 0; en <= 3; ++en) {
            for (int ST = 0; ST <= 3; ++ST) {
                for (int EN = 0; EN <= 3; ++EN) {
                    if (nd && st + EN > 3)
                        continue;
                    if (en + ST > 3)
                        continue;
                    int L = st, R = EN;
                    if (EN == r - m)
                        R = EN + en;
                    if (st == m - l)
                        L = st + ST;
                    if (L > 3 || R > 3)
                        continue;

                    t[v].dp[L][R] = max(t[v].dp[L][R],
                        t[2 * v].dp[st][en] + t[2 * v + 1].dp[ST][EN]);
                }
            }
        }
    }
}

void upd(int v, int l, int r, int ps, int x) {
    if (l + 1 == r) {
        t[v].dp[0][0] = 0;
        t[v].dp[1][1] = x;
        return;
    }
    int m = (l + r) / 2;
    if (ps < m)
        upd(2 * v, l, m, ps, x);
    else
        upd(2 * v + 1, m, r, ps, x);
    if (v == 1)
        merge(v, l, r, 1);
    else
        merge(v, l, r, 0);
}

int get() {
    int ans = 0;
    for (int st = 0; st <= 3; ++st)
        for (int en = 0; en <= 3; ++en)
            ans = max(ans, t[1].dp[st][en]);
    return ans;
}

signed main() {
    //freopen("txt.out", "w", stdout);

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    for (int i = 0; i < 4 * N; ++i)
        t[i].dp.resize(4, vector<int>(4, 0));

    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i];
        upd(1, 0, n, i, a[i]);
        //cout << get() << '\n';
    }
    int q;
    cin >> q;
    cout << get() << '\n';
    for (int i = 0; i < q; ++i) {
        int p, v;
        cin >> p >> v;
        upd(1, 0, n, p - 1, v);
        cout << get() << '\n';
    }
}