#include <bits/stdc++.h>

using namespace std;

struct Node {
    int x, prior, sz;
    Node *l, *r;
    Node() {
        l = nullptr;
        r = nullptr;
        sz = 0;
    }
    Node(int key) {
        l = nullptr;
        r = nullptr;
        x = key; prior = rand();
        sz = 1;
    }
};

typedef Node * PNode;

int get_sz(PNode root) {
    if (!root) return 0;
    return root->sz;
}

void upd(PNode & root) {
    if (!root) return;
    root->sz = 1 + get_sz(root->l) + get_sz(root->r);
    return;
}


void merge_(PNode & root, PNode left, PNode right) {
    if (!left) {
        root = right;
        return;
    }
    if (!right) {
        root = left;
        return;
    }
    if (left->prior > right->prior) {
        merge_(left->r, left->r, right);
        root = left;
    }
    else {
        merge_(right->l, left, right->r);
        root = right;
    }
    upd(root);
    return;
}

void split_kth(PNode root, PNode & left, PNode & right, int k) {
    if (!root) {
        left = nullptr;
        right = nullptr;
        return;
    }
    if (get_sz(root->l) >= k) {
        split_kth(root->l, left, root->l, k);
        right = root;
        upd(right);
    }
    else {
        split_kth(root->r, root->r, right, k - get_sz(root->l) - 1);
        left = root;
        upd(left);
    }
    return;
}

void p_b(PNode & root, int key) {
    PNode ins = new Node(key);
    merge_(root, root, ins);
}


void print(PNode root) {
    if (!root) return;
    print(root->l);
    cout << root->x << " ";
    print(root->r);
    return;
}




int main()
{
    int n, x;
    cin >> n >> x;
    long long ans = 0;
    for (int a = 1; a < n + 1; a++) {
        if (a == x) continue;
        int b = (n + a - 1) / a;
        for (; (a + b - 1) <= n; b++) {
            if (b == x) continue;
            int t = a * b - n;
            for (int c = 1; c < a && c <= t; c++) {
                if (t % c == 0) {
                    int d = t / c;
                    if (t / c < b) ans++; //  cout << a << b << c << d << endl;}
                }
            }
        }
    }
    cout << ans << endl;
    return 0;
}
