#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <queue>
#include <set>

using namespace std;

typedef int64_t ll;

const ll INF = ((ll)1 << 62);

ll sqrt(ll x) {
    ll left = 1;
    ll right = 1;
    while (right * right <= x) {
        right <<= 1;
    }
    while (right - left > 1) {
        ll mid = left + right >> 1;
        if (mid * mid <= x) {
            left = mid;
        } else {
            right = mid;
        }
    }
    if (left * left == x) {
        return left;
    }
    return 0;
}

int main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    ll n;
    cin >> n;
    for (ll i = 1; i * i <= n; ++i) {
        if (n % i != 0) {
            continue;
        }
        ll a = n / i; // x + y
        ll b = i; // x - y
        if ((a + b) & 1) {
            continue;
        }
        ll x = (a + b) / 2;
        ll y = a - x;
        if (x >= 1 && y >= 1) {
            cout << "Yes" << endl;
            cout << x << " " << y << endl;
            return 0;
        }
    }
    cout << "No" << endl;
    return 0;
}
