#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <queue>
#include <set>

using namespace std;

typedef int64_t ll;

int main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    ll n;
    cin >> n;
    vector<ll> a(n);
    vector<ll> cord(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
        cord[i] = a[i];
    }
    sort(cord.begin(), cord.end());
    cord.resize(unique(cord.begin(), cord.end()) - cord.begin());
    for (ll& i : a) {
        i = lower_bound(cord.begin(), cord.end(), i) - cord.begin();
    }
    vector<ll> next(n, n);
    for (ll i = n - 1; i >= 0; --i) {
        ll x = a[i];
        a[i] = next[x];
        next[x] = i;
    }

    vector<ll> result(n + 2);
    vector<ll> arr_d(n + 2);

    for (ll i = 0; i < n; ++i) {
        ll x = a[i] - i;
        ll y = i + 1;
        if (x > y) {
            swap(x, y);
        }
        arr_d[0] += 1;
        arr_d[x] -= 1;
        arr_d[y] -= 1;
        arr_d[x + y] += 1;
    }
    ll d = 0;
    ll res = 0;
    for (ll i = 0; i <= n; ++i) {
        result[i] = res;
        d += arr_d[i];
        res += d;
    }
    for (ll i = 1; i <= n; ++i) {
        cout << result[i] << " ";
    }
    cout << endl;
    return 0;
}
