// Мария Радионова - гений

#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <queue>
#include <set>

using namespace std;

typedef int64_t ll;

struct Result {
    ll arr[4][4];

    Result() {
        for (ll i = 0; i < 4; ++i) {
            for (ll j = 0; j < 4; ++j) {
                arr[i][j] = 0;
            }
        }
    }

    Result(vector<ll> x) {
        for (ll i = 0; i < 4; ++i) {
            for (ll j = 0; j < 4; ++j) {
                arr[i][j] = 0;
            }
        }
        arr[0][0] = x[1] + x[2];
        arr[0][1] = x[1] + x[3];
        arr[0][2] = x[2] + x[3];
        arr[0][3] = x[1] + x[2] + x[3];
        arr[1][0] = x[0] + x[2];
        arr[1][1] = x[0] + x[3];
        arr[1][2] = x[0] + x[2] + x[3];
        arr[2][0] = x[0] + x[1];
        arr[2][1] = x[0] + x[1] + x[3];
        arr[3][0] = x[0] + x[1] + x[2];
    }

    Result(Result left, Result right) {
        for (ll lf = 0; lf < 4; ++lf) {
            for (ll rg = 0; rg < 4; ++rg) {
                arr[lf][rg] = 0;
                arr[lf][rg] = max(arr[lf][rg], left.arr[lf][0] + right.arr[0][rg]);
                arr[lf][rg] = max(arr[lf][rg], left.arr[lf][0] + right.arr[1][rg]);
                arr[lf][rg] = max(arr[lf][rg], left.arr[lf][0] + right.arr[2][rg]);
                arr[lf][rg] = max(arr[lf][rg], left.arr[lf][0] + right.arr[3][rg]);
                arr[lf][rg] = max(arr[lf][rg], left.arr[lf][1] + right.arr[0][rg]);
                arr[lf][rg] = max(arr[lf][rg], left.arr[lf][1] + right.arr[1][rg]);
                arr[lf][rg] = max(arr[lf][rg], left.arr[lf][1] + right.arr[2][rg]);
                arr[lf][rg] = max(arr[lf][rg], left.arr[lf][2] + right.arr[0][rg]);
                arr[lf][rg] = max(arr[lf][rg], left.arr[lf][2] + right.arr[1][rg]);
                arr[lf][rg] = max(arr[lf][rg], left.arr[lf][3] + right.arr[0][rg]);
            }
        }
    }

    ll get() {
        ll result = 0;
        for (ll lf = 0; lf < 4; ++lf) {
            for (ll rg = 0; rg < 4; ++rg) {
                result = max(arr[lf][rg], result);
            }
        }
        return result;
    }
};

typedef struct Node* pNode;
struct Node {
    pNode child_left;
    pNode child_right;
    ll left, right;
    Result result;

    Node(ll left, ll right)
        : left(left), right(right) {
            child_left = child_right = nullptr;
            result = Result();
        }
};

pNode build(ll left, ll right, vector<ll>& a) {
    pNode root = new Node(left, right);
    if (right - left == 1) {
        ll id = left << 2;
        vector<ll> x = {a[id], a[id + 1], a[id + 2], a[id + 3]};
        root->result = Result(x);
        return root;
    }
    root->child_left = build(left, left + right >> 1, a);
    root->child_right = build(left + right >> 1, right, a);
    root->result = Result(root->child_left->result, root->child_right->result);
    return root;
}

void update(pNode root, ll id, Result result) {
    if (root->left >= id + 1 || root->right <= id) {
        return;
    }
    if (root->right - root->left == 1) {
        root->result = result;
        return;
    }
    update(root->child_left, id, result);
    update(root->child_right, id, result);
    root->result = Result(root->child_left->result, root->child_right->result);
}

int main() {
    ll n;
    cin >> n;
    vector<ll> a(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<ll> a0;
    for (ll i = 1; i < n; ++i) {
        a0.emplace_back(a[i]);
    }
    vector<ll> a1;
    for (ll i = 2; i < n; ++i) {
        a1.emplace_back(a[i]);
    }
    a1.emplace_back(a[0]);
    vector<ll> a2;
    for (ll i = 3; i < n; ++i) {
        a2.emplace_back(a[i]);
    }
    a2.emplace_back(a[0]);
    a2.emplace_back(a[1]);
    vector<ll> a3;
    for (ll i = 4; i < n; ++i) {
        a3.emplace_back(a[i]);
    }
    a3.emplace_back(a[0]);
    a3.emplace_back(a[1]);
    a3.emplace_back(a[2]);
    while (a0.size() & 3) {
        a0.emplace_back(0);
        a1.emplace_back(0);
        a2.emplace_back(0);
        a3.emplace_back(0);
    }
    ll sz = (ll)a1.size() / 4;
    pNode root0 = build(0, sz, a0);
    pNode root1 = build(0, sz, a1);
    pNode root2 = build(0, sz, a2);
    pNode root3 = build(0, sz, a3);
    cout << max(max(root0->result.get(), root1->result.get()), max(root2->result.get(), root3->result.get())) << "\n";
    ll q;
    cin >> q;
    for (ll i = 0; i < q; ++i) {
        ll id, x;
        cin >> id >> x;
        --id;
        ll local_id;
        if (id != 0) {
            local_id = id - 1;
            a0[local_id] = x;
            ll ptr = (local_id >> 2) << 2;
            update(root0, ptr >> 2, Result({a0[ptr], a0[ptr + 1], a0[ptr + 2], a0[ptr + 3]}));
        }
        if (id != 1) {
            if (id == 0) {
                local_id = n - 2;
            }
            if (id != 0) {
                local_id = id - 2;
            }
            a1[local_id] = x;
            ll ptr = (local_id >> 2) << 2;
            update(root1, ptr >> 2, Result({a1[ptr], a1[ptr + 1], a1[ptr + 2], a1[ptr + 3]}));
        }
        if (id != 2) {
            if (id == 0) {
                local_id = n - 3;
            }
            if (id == 1) {
                local_id = n - 2;
            }
            if (id > 2) {
                local_id = id - 3;
            }
            a2[local_id] = x;
            ll ptr = (local_id >> 2) << 2;
            update(root2, ptr >> 2, Result({a2[ptr], a2[ptr + 1], a2[ptr + 2], a2[ptr + 3]}));
        }
        if (id != 3) {
            if (id == 0) {
                local_id = n - 4;
            }
            if (id == 1) {
                local_id = n - 3;
            }
            if (id == 2) {
                local_id = n - 2;
            }
            if (id > 3) {
                local_id = id - 4;
            }
            a3[local_id] = x;
            ll ptr = (local_id >> 2) << 2;
            update(root3, ptr >> 2, Result({a3[ptr], a3[ptr + 1], a3[ptr + 2], a3[ptr + 3]}));
        }
        cout << max(max(root0->result.get(), root1->result.get()), max(root2->result.get(), root3->result.get())) << "\n";
    }
    return 0;
}
