#include <iostream>
#include <vector>
#include <algorithm>

#define int long long

using namespace std;

struct st{
    int n;
    vector<int> t;
    vector<int> b;
    vector<int> ad;

    void init(int _n){
        n = _n;
        t.resize(4 * n);
        b.resize(4 * n);
        ad.resize(4 * n);
    }

    void push(int v, int dl, int dr){
        b[2 * v] += b[v];
        int sup = b[v];
        b[2 * v + 1] += b[v] + ((dr - dl) / 2) * ad[v];
        sup = b[v] * ((dr - dl) / 2) * ad[v];
        ad[2 * v] += ad[v];
        ad[2 * v + 1] += ad[v];
        int c = (dr - dl);
        t[v] += (c * (b[v] + ad[v] * (c - 1))) / 2;
        b[v] = 0;
        ad[v] = 0;
    }

    void add(int v, int l, int r, int beg, int a, int dl, int dr){
        if (dl == l && dr == r){
            b[v] += beg;
            ad[v] += a;
            return;
        }
        if (l >= r){
            return;
        }
        push(v, dl, dr);
        int dm = (dl + dr) / 2;
        add(2 * v, l, min(r, dm), beg, a, dl, dm);
        add(2 * v + 1, max(l, dm), r, beg + max(0, dm - l) * a, a, dm, dr);
    }

    void add(int l, int r, int beg, int a){
        add(1, l, r, beg, a, 0, n);
    }

    int get(int v, int pos, int dl, int dr){
        if (dl == dr - 1){
            return t[v] + b[v];
        }
        int dm = (dl + dr) / 2;
        push(v, dl, dr);
        if (pos < dm){
            return get(2 * v, pos, dl, dm);
        }else{
            return get(2 * v + 1, pos, dm, dr);
        }
    }

    int get(int pos){
        return get(1, pos, 0, n);
    }

    void prt(int v, int dl, int dr){
        if (dl == dr - 1){
            cout << t[v] + b[v] << ' ';
            return;
        }
        push(v, dl, dr);
        int dm = (dl + dr) / 2;
        prt(2 * v, dl, dm);
        prt(2 * v + 1, dm, dr);
    }

    void prt(){
        prt(1, 0, n);
        cout << "\n";
    }

};

signed main()
{
    st t;
    int n;
    cin >> n;
    vector<int> a(n);
    vector<pair<int, int> > sp;
    for (int i = 0; i < n; i++){
        cin >> a[i];
        sp.push_back({a[i], i});
    }
    sort(sp.begin(), sp.end());
    a[sp[0].second] = 0;
    int now = 0;
    for (int i = 1; i < n; i++){
        if (sp[i].first != sp[i - 1].first){
            now++;
        }
        a[sp[i].second] = now;
    }
    t.init(n + 1);
    vector<vector<int> > pos(n);
    for (int i = 0; i < n; i++){
        pos[i].push_back(-1);
    }
    for (int i = 0; i < n; i++){
        pos[a[i]].push_back(i);
    }
    for (int i = 0; i < n; i++){
        pos[i].push_back(n);
    }
    for (int i = 0; i < n; i++){
        if (pos[i].size() > 2){
            t.add(1, n + 1, n, -1);
        }else{
            continue;
        }
        for (int j = 0; j < pos[i].size() - 1; j++){
            int d = pos[i][j + 1] - pos[i][j] - 1;
            t.add(1, d + 1, -d, 1);
        }
    }
    for (int i = 1; i <= n; i++){
        cout << t.get(i) << ' ';
    }
    return 0;
}
