#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int build(int n, int m, vector<vector<int> > &f, vector<vector<vector<int> > > & ask, vector<int> &z){
    vector<vector<int> > val(m, vector<int>(2 * n - 1));
    int cnt = 0;
    for (int i = 0; i < m; i++){
        for (int j = 0; j < n; j++){
            val[i][j] = f[i][j] < z[j];
        }
        for (int j = n; j < 2 * n - 1; j++){
            if (ask[i][j - n][2] == 1){
                val[i][j] = val[i][ask[i][j - n][0]] && val[i][ask[i][j - n][1]];
            }else{
                val[i][j] = val[i][ask[i][j - n][0]] || val[i][ask[i][j - n][1]];
            }
        }
        cnt += val[i][2 * n - 2];
    }
    return cnt;
}

bool cmp_ft(vector<int> & a, vector<int> & b){
    return a[0] < b[0];
}

bool cmp_sd(vector<int> & a, vector<int> & b){
    return a[1] < b[1];
}

int main()
{
    int n, m, s;
    cin >> n >> m >> s;
    vector<vector<vector<int> > > ask(m, vector<vector<int> >(n - 1, vector<int>(3)));
    bool is_and = true;
    for (int i = 0; i < m; i++){
        for (int j = 0; j < n - 1; j++){
            cin >> ask[i][j][0] >> ask[i][j][1] >> ask[i][j][2];
            ask[i][j][0]--;
            ask[i][j][1]--;
            if (ask[i][j][2] == 2){
                is_and = false;
            }
        }
    }
    vector<vector<int> > f(m, vector<int>(n));
    for (int i = 0; i < m; i++){
        for (int j = 0; j < n; j++){
            cin >> f[i][j];
        }
    }

    if (n == 1){
        vector<int> z(1);
        for (; z[0] < m; z[0]++){
            if (build(n, m, f, ask, z) == s){
                cout << z[0] << endl;
                return 0;
            }
        }
    }else if (n == 2){
        vector<int> z(2);
        vector<vector<int> > and1;
        vector<vector<int> > or1;
        for (auto i : ask){
            if (i[0][2] == 1){
                and1.push_back({i[0][0], i[0][2]});
            }else{
                or1.push_back({i[0][0], i[0][1]});
            }
        }
        sort(or1.begin(), or1.end(), cmp_ft);
        sort(and1.begin(), and1.end(), cmp_sd);
        if (or1.size() >= s){
            cout << or1[s - 1][0] << ' ' << 0 << endl;
            return 0;
        }
        cout << m << ' ' << and1[s - or1.size() - 1][1] << endl;
    }else if(m <= 2){
        vector<int> mask(n);
        while (mask != vector<int>(n, m)){
            mask[0]++;
            int now = 0;
            while (mask[now] == m + 1){
                mask[now] = 0;
                now++;
                mask[now]++;
            }
            if (build(n, m, f, ask, mask) == s){
                for (int i = 0; i < n; i++){
                    cout << mask[i] << ' ';
                }
                cout << endl;
                return 0;
            }
        }
    }else if (is_and){
        cout << s << ' ';
        for (int i = 0; i < n - 1; i++){
            cout << m << ' ';
        }
        cout << endl;
        return 0;
    }else{
        for (int i = 0; i < n; i++){
            cout << s << ' ';
        }
        cout << endl;
        return 0;
    }

    return 0;
}
