#include <iostream>
#include <vector>

#define int long long

using namespace std;

void prt(vector<int> & a){
    for (auto i : a){
        cout << i << ' ';
    }
    cout << "\n";
}

void prt(vector<vector<int> > & a){
    for (auto i : a){
        prt(i);
    }
    cout << "\n";
}

struct st{
    vector<vector<vector<int> > > t;
    int n;

    void init(int _n){
        n = _n;
        t.resize(4 * n, vector<vector<int> > (4, vector<int>(4, 0)));
    }

    void relax(int v, int dl, int dr){
        if (v == 3){
            int debug = 1;
        }
        for (int i = 0; i < 4; i++){
            for (int j = 0; j < 4; j++){
                if (i + j >= dr - dl){
                    if (dr - dl > 3){
                        continue;
                    }
                    int dm = (dl + dr) / 2;
                    t[v][dr - dl][dr - dl] = t[2 * v][dm - dl][dm - dl] + t[2 * v + 1][dr - dm][dr - dm];
                }else{

                    int dm = (dl + dr) / 2;
                    if (i >= dm - dl){
                        t[v][i][j] = t[2 * v][dm - dl][dm - dl] + t[2 * v + 1][i - dm + dl][j];
                        continue;
                    }
                    if (j >= dr - dm){
                        t[v][i][j] = t[2 * v][i][j - dr + dm] + t[2 * v + 1][dr - dm][dr - dm];
                        continue;
                    }
                    t[v][i][j] = 0;
                    for (int k = 0; k < 4 && k + i < dm - dl; k++){
                        for (int q = 0; q + k < 4 && q + j < dr - dm; q++){
                            int res1 = t[2 * v][i][k];
                            int res2 = t[2 * v + 1][q][j];
                            int res = res1 + res2;
                            t[v][i][j] = max(t[v][i][j], res);
                        }
                    }
                }
            }
        }
    }

    void update(int v, int pos, int val, int dl, int dr){
        if (dl == dr - 1){
            t[v][1][1] = val;
            //prt(t[v]);
            return;
        }
        int dm = (dl + dr) / 2;
        if (pos < dm){
            update(2 * v, pos, val, dl, dm);
        }else{
            update(2 * v + 1, pos, val, dm, dr);
        }
        relax(v, dl, dr);
        //prt(t[v]);
    }

    void update(int pos, int val){
        update(1, pos, val, 0, n);
    }

    int get(){
        int res = 0;
        for (int i = 0; i < 4; i++){
            for (int j = 0; j + i < 4; j++){
                res = max(res, t[1][i][j]);
            }
        }
        return res;
    }

};

signed main(){
    int n;
    cin >> n;
    vector<int> a(n);
    st t;
    t.init(n);
    for (int i = 0; i < n; i++){
        cin >> a[i];
        t.update(i, a[i]);
    }
    cout << t.get() << "\n";
    int q;
    cin >> q;
    for (int i = 0; i < q; i++){
        int pos, val;
        cin >> pos >> val;
        pos--;
        t.update(pos, val);
        cout << t.get() << "\n";
    }
    return 0;
}
