#include <iostream>
#include <vector>
#include <cmath>
#include <queue>
using namespace std;
typedef long long I;

struct node {
    I left;
    I right;
    I parent;
    I size;
    I bests[16];
};

void eval(I ind, vector<node>& tree) {
    auto nod = tree[ind];
    I lch = (nod.left != -1) ? tree[nod.left].size : 0;
    I rch = (nod.right) ? tree[nod.right].size : 0;
    tree[ind].size = lch + rch;
    for (I i = 0; i < 4; ++i) {
        for (I j = 0; j < 4; ++j) {
            I res = 0;
            I curr = i * 4 + j;
            if (lch == 0) {
                tree[ind].bests[curr] = 0;
                continue;
            }
            for (I k = 0; k < 4; ++k) {
                I s;
                if (rch != 0) {
                    s = tree[nod.left].bests[i * 4 + k] + tree[nod.right].bests[(3 - k) * 4 + j];
                } else {
                    s = tree[nod.left].bests[i * 4 + k];
                }
                res = max(res, s);
            }
            tree[ind].bests[curr] = res;
        }
    }
}

int main() {
    I n, q, nodeCount = 0, p, v;
    cin >> n;
    vector<I> as(n);
    for (I i = 0; i < n; ++i) {
        cin >> as[i];
    }

    nodeCount = 2 * n - 1;
    queue<I> toAdd;
    vector<node> tree(nodeCount);
    for (I i = nodeCount - n; i < nodeCount; ++i) {
        I val = as[i + n - nodeCount];
        node newN;
        newN.size = 1;
        newN.left = -1;
        newN.right = -1;
        newN.parent = -1;
        for (I k1 = 0; k1 < 16; ++k1) {
            if ((k1 % 4) + (k1 / 4) < 3) {
                newN.bests[k1] = val;
            } else {
                newN.bests[k1] = 0;
            }
        }
        tree[i] = newN;
        toAdd.push(i);
    }
    for (I i = nodeCount - n - 1; i >= 0; --i) {
        node newMed;
        tree[i] = newMed;
        tree[i].right = toAdd.front();
        tree[tree[i].right].parent = i;
        toAdd.pop();
        tree[i].left = toAdd.front();
        tree[tree[i].left].parent = i;
        toAdd.pop();
        toAdd.push(i);

        //cout << nodeCount << i << endl;
        eval(i, tree);
        //cout << "I" << i << " S" << tree[i].size << " C" << tree[i].left << "-" << tree[i].right << ": ";
        /*for (I k1 = 0; k1 < 16; ++k1) {
            cout << tree[i].bests[k1] << " ";
        }
        cout << endl;*/
    }
    cout << max(max(tree[0].bests[12], tree[0].bests[9]), max(tree[0].bests[6], tree[0].bests[3])) << endl;
    cin >> q;

    for (I i = 0; i < q; ++i) {
        cin >> p >> v;
        I current = n + p - 2;
        //cout << current << endl;
        for (I k1 = 0; k1 < 16; ++k1) {
            if ((k1 % 4) + (k1 / 4) < 3) {
                tree[current].bests[k1] = v;
            } else {
                tree[current].bests[k1] = 0;
            }
        }
        current = tree[current].parent;
        while (current != -1) {
            eval(current, tree);
            current = tree[current].parent;
        }
        cout << max(max(tree[0].bests[12], tree[0].bests[9]), max(tree[0].bests[6], tree[0].bests[3])) << endl;
    }

    return 0;
}