#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
#define EPS 1e-3

#define all(v) (v).begin(), (v).end()
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

struct DO {
    vector<int> t;

    int n;


    DO(int n, vector<int> a) : n(n) {
        t.resize(n * 4);
        build(1, 0, n, a);
    }

    void update(int pos, int val) {
        update(1, 0, n, pos, val);
    }

    int get(int l, int r) {
        return get(1, 0, n, l, r);
    }

private:
    void build(int v, int l, int r, vector<int> &a) {
        if (r == l + 1) {
            t[v] = a[l];
            return;
        }
        int m = (r + l) / 2;
        build(v * 2, l, m, a);
        build(v * 2 + 1, m, r, a);
        t[v] = merge(t[v * 2], t[v * 2 + 1]);
    }

    void update(int v, int l, int r, int pos, int val) {
        if (pos >= r || pos < l) {
            return;
        }
        if (l == r - 1) {
            t[v] = val;
            return;
        }
        int m = (r + l) / 2;
        update(v * 2, l, m, pos, val);
        update(v * 2 + 1, m, r, pos, val);
        t[v] = merge(t[v * 2], t[v * 2 + 1]);
    }

    int get(int v, int l, int r, int tl, int tr) {
        if (l >= tr || r <= tl) {
            return DEFAULT;
        }
        if (tl <= l && r <= tr) {
            return t[v];
        }
        int m = (r + l) / 2;
        return merge(get(v * 2, l, m, tl, tr), get(v * 2 + 1, m, r, tl, tr));
    }

    int DEFAULT = 0;

    int merge(int a, int b) {
        return a + b;
    }
};

#define MAXK 1000000
#define int long long

struct segment {
    int len;
    int v;

    segment(int len = 0, int v = 0) : len(len), v(v) {}

    double calc(int e) {
        return len * 1. / (v + e);
    }
};


bool check(int e, int t, vector<segment> segs) {
    double cur_t = 0;
    for (segment s:segs) {
        cur_t += s.calc(e);
    }
    return t > cur_t + EPS;
}

#define INF 4000000000LL

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> tmp(n);
    vector<segment> segs(n);
    for (int i = 0; i < n; ++i) {
        cin >> tmp[i];
    }
    for (int j = 0; j < n; ++j) {
        int x;
        cin >> x;
        segs[j] = segment(x, tmp[j]);
    }

    int m;
    cin >> m;
    vector<int> a(m + 1);
    vector<int> tax(m + 1);
    a[m] = INF;
    for (int i = 0; i < m - 1; ++i) {
        cin >> a[i + 1];
    }
    for (int i = 0; i < m; ++i) {
        cin >> tax[i + 1];
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int s, e;
        cin >> s >> e;
        int t = e - s;
        int l = -1;
        int r = m;
        while (r - l > 1) {
            int m = (r + l) / 2;
            if (check(a[m], t, segs)) {
                r = m;
            } else {
                l = m;
            }
        }
        cout << tax[r] << "\n";
    }

    return 0;
}