#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
#define EPS 1e-6

#define all(v) (v).begin(), (v).end()
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

struct DO {
    vector<int> t;

    int n;


    DO(int n, vector<int> a) : n(n) {
        t.resize(n * 4);
        build(1, 0, n, a);
    }

    void update(int pos, int val) {
        update(1, 0, n, pos, val);
    }

    int get(int l, int r) {
        return get(1, 0, n, l, r);
    }

private:
    void build(int v, int l, int r, vector<int> &a) {
        if (r == l + 1) {
            t[v] = a[l];
            return;
        }
        int m = (r + l) / 2;
        build(v * 2, l, m, a);
        build(v * 2 + 1, m, r, a);
        t[v] = merge(t[v * 2], t[v * 2 + 1]);
    }

    void update(int v, int l, int r, int pos, int val) {
        if (pos >= r || pos < l) {
            return;
        }
        if (l == r - 1) {
            t[v] = val;
            return;
        }
        int m = (r + l) / 2;
        update(v * 2, l, m, pos, val);
        update(v * 2 + 1, m, r, pos, val);
        t[v] = merge(t[v * 2], t[v * 2 + 1]);
    }

    int get(int v, int l, int r, int tl, int tr) {
        if (l >= tr || r <= tl) {
            return DEFAULT;
        }
        if (tl <= l && r <= tr) {
            return t[v];
        }
        int m = (r + l) / 2;
        return merge(get(v * 2, l, m, tl, tr), get(v * 2 + 1, m, r, tl, tr));
    }

    int DEFAULT = 0;

    int merge(int a, int b) {
        return a + b;
    }
};

struct command {
    int a, b, op;

    command(int a, int b, int op) : a(a), b(b), op(op) {}

    char apply(vector<char> &vec) {
        if (op == 1) {
            return vec[a - 1] && vec[b - 1];
        } else {
            return vec[a - 1] || vec[b - 1];
        }
    }
};

vector<vector<command>> programs;
vector<vector<int>> matrix;
vector<int> z;
int n, m, s;

bool calculate(int i) {
    vector<char> memory(n * 2 - 1);
    for (int j = 0; j < n; ++j) {
        memory[j] = (matrix[i][j] < z[j]);
    }
    for (int j = n; j < 2 * n - 1; ++j) {
        memory[j] = programs[i][j - n].apply(memory);
    }
    return memory[2 * n - 2];
}

int count() {
    int cnt = 0;
    for (int i = 0; i < m; ++i) {
        cnt += calculate(i);
    }
    return cnt;
}


bool check() {
    return count() == s;
}

void gen(int x) {
    if (x == n) {
        if (check()) {
            for (int i = 0; i < n; ++i) {
                cout << z[i] << " ";
            }
            exit(0);
        }
        return;
    } else {
        for (int i = m; i >= 0; --i) {
            z[x] = i;
            gen(x + 1);
        }
    }
}

void solve1() {
    z[0] = m;
    int cnt = count();
    if (cnt == s) {
        for (int i = 0; i < n; ++i) {
            cout << z[i] << " ";
        }
        exit(0);
    }
    if (s == 0) {
        cout << 0 << " " << 0;
    }
    if (cnt > s) {
        cnt = 0;
        vector<int> line(m);
        for (int i = 0; i < m; ++i) {
            line[matrix[i][0]] = i;
        }
        for (z[0] = 1; z[0] <= m; ++z[0]) {
            cnt += calculate(line[z[0] - 1]);
            if (cnt == s) {
                for (int i = 0; i < n; ++i) {
                    cout << z[i] << " ";
                }
                exit(0);
            }

        }
    } else {
        vector<int> line(m);
        for (int i = 0; i < m; ++i) {
            line[matrix[i][1]] = i;
        }
        for (z[1] = 1; z[1] <= m; ++z[1]) {
            cnt += calculate(line[z[1] - 1]);
            if (check()) {
                for (int i = 0; i < n; ++i) {
                    cout << z[i] << " ";
                }
                exit(0);
            }

        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> s;
    programs.resize(m);
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n - 1; ++j) {
            int a, b, op;
            cin >> a >> b >> op;
            programs[i].emplace_back(a, b, op);
        }
    }
    matrix.resize(m, vector<int>(n));
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> matrix[i][j];
        }
    }
    z.resize(n);
    if (n <= 10 && m <= 2) {
        gen(0);
    } else if (n == 2) {
        solve1();
    } else {
        for (int i = 0; i < n - 1; ++i) {
            cout << m << " ";
        }
        cout << s;
    }
    return 0;
}