#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define all(v) (v).begin(), (v).end()
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

struct DO {
    vector<int> t;

    int n;


    DO(int n, vector<int> a) : n(n) {
        t.resize(n * 4);
        build(1, 0, n, a);
    }

    void update(int pos, int val) {
        update(1, 0, n, pos, val);
    }

    int get(int l, int r) {
        return get(1, 0, n, l, r);
    }

private:
    void build(int v, int l, int r, vector<int> &a) {
        if (r == l + 1) {
            t[v] = a[l];
            return;
        }
        int m = (r + l) / 2;
        build(v * 2, l, m, a);
        build(v * 2 + 1, m, r, a);
        t[v] = merge(t[v * 2], t[v * 2 + 1]);
    }

    void update(int v, int l, int r, int pos, int val) {
        if (pos >= r || pos < l) {
            return;
        }
        if (l == r - 1) {
            t[v] = val;
            return;
        }
        int m = (r + l) / 2;
        update(v * 2, l, m, pos, val);
        update(v * 2 + 1, m, r, pos, val);
        t[v] = merge(t[v * 2], t[v * 2 + 1]);
    }

    int get(int v, int l, int r, int tl, int tr) {
        if (l >= tr || r <= tl) {
            return DEFAULT;
        }
        if (tl <= l && r <= tr) {
            return t[v];
        }
        int m = (r + l) / 2;
        return merge(get(v * 2, l, m, tl, tr), get(v * 2 + 1, m, r, tl, tr));
    }

    int DEFAULT = 0;

    int merge(int a, int b) {
        return a + b;
    }
};

#define INF 1000000000000000000
#define int long long
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector<int> a(n);
    int sum = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        sum += a[i];
    }
    int diff = INF;
    int res = -1;
    int s = 0;
    for (int i = 0; i < n; ++i) {
        s += a[i];
        int d = abs(s - (sum - s));
        if (d < diff) {
            diff = d;
            res = i;
        }
    }
    cout << res + 1;

    return 0;
}