#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define all(v) (v).begin(), (v).end()
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

struct DO {
    vector<int> t;

    int n;


    DO(int n, vector<int> a) : n(n) {
        t.resize(n * 4);
        build(1, 0, n, a);
    }

    void update(int pos, int val) {
        update(1, 0, n, pos, val);
    }

    int get(int l, int r) {
        return get(1, 0, n, l, r);
    }

private:
    void build(int v, int l, int r, vector<int> &a) {
        if (r == l + 1) {
            t[v] = a[l];
            return;
        }
        int m = (r + l) / 2;
        build(v * 2, l, m, a);
        build(v * 2 + 1, m, r, a);
        t[v] = merge(t[v * 2], t[v * 2 + 1]);
    }

    void update(int v, int l, int r, int pos, int val) {
        if (pos >= r || pos < l) {
            return;
        }
        if (l == r - 1) {
            t[v] = val;
            return;
        }
        int m = (r + l) / 2;
        update(v * 2, l, m, pos, val);
        update(v * 2 + 1, m, r, pos, val);
        t[v] = merge(t[v * 2], t[v * 2 + 1]);
    }

    int get(int v, int l, int r, int tl, int tr) {
        if (l >= tr || r <= tl) {
            return DEFAULT;
        }
        if (tl <= l && r <= tr) {
            return t[v];
        }
        int m = (r + l) / 2;
        return merge(get(v * 2, l, m, tl, tr), get(v * 2 + 1, m, r, tl, tr));
    }

    int DEFAULT = 0;

    int merge(int a, int b) {
        return a + b;
    }
};


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, x;
    cin >> n >> x;
    int ans = 0;
    for (int a = 2; a < 3000; ++a) {
        if (a == x) {
            continue;
        }
        for (int b = 2; b < 3000; ++b) {
            if (b == x) {
                continue;
            }
            if (a + b - 1 > n) {
                continue;
            }
            if (a * b < n) {
                continue;
            }
            int d = a * b - n;
            for (int i = 1; i * i <=d; ++i) {
                if (d % i == 0) {
                    int op = d / i;
                    if (i < a && op < b) {
                        ans++;
                    }
                    if (op < a && i < b && i != op) {
                        ans++;
                    }
                }
            }
        }
    }
    cout << ans;

    return 0;
}