#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define all(v) (v).begin(), (v).end()
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

struct DO {
    vector<int> t;

    int n;


    DO(int n, vector<int> a) : n(n) {
        t.resize(n * 4);
        build(1, 0, n, a);
    }

    void update(int pos, int val) {
        update(1, 0, n, pos, val);
    }

    int get(int l, int r) {
        return get(1, 0, n, l, r);
    }

private:
    void build(int v, int l, int r, vector<int> &a) {
        if (r == l + 1) {
            t[v] = a[l];
            return;
        }
        int m = (r + l) / 2;
        build(v * 2, l, m, a);
        build(v * 2 + 1, m, r, a);
        t[v] = merge(t[v * 2], t[v * 2 + 1]);
    }

    void update(int v, int l, int r, int pos, int val) {
        if (pos >= r || pos < l) {
            return;
        }
        if (l == r - 1) {
            t[v] = val;
            return;
        }
        int m = (r + l) / 2;
        update(v * 2, l, m, pos, val);
        update(v * 2 + 1, m, r, pos, val);
        t[v] = merge(t[v * 2], t[v * 2 + 1]);
    }

    int get(int v, int l, int r, int tl, int tr) {
        if (l >= tr || r <= tl) {
            return DEFAULT;
        }
        if (tl <= l && r <= tr) {
            return t[v];
        }
        int m = (r + l) / 2;
        return merge(get(v * 2, l, m, tl, tr), get(v * 2 + 1, m, r, tl, tr));
    }

    int DEFAULT = 0;

    int merge(int a, int b) {
        return a + b;
    }
};

#define INF 1000000000000000000
#define int long long

int gcd(int a, int b, int &x, int &y) {
    if (a == 0) {
        x = 0;
        y = 1;
        return b;
    } else {
        int k = b / a;
        int xs = 0;
        int ys = 0;
        int g = gcd(b - k * a, a, xs, ys);
        x = -k * xs + ys;
        y = xs;
        return g;
    }
}


int solve(int a, int b, int c) {
    int x = 0;
    int y = 0;
    int g = __gcd(a, b);
    if (c % g != 0) {
        return 0;
    }
    a /= g;
    b /= g;
    c /= g;
    g = gcd(a, b, x, y);
    x *= c;
    y *= c;
    int l = a * b / g;

    int dx = -l / a;
    int dy = l / b;

    int cnt = y / dy;
    x -= dx * cnt;
    y -= dy * cnt;
    while (y <= 0) {
        y += dy;
        x += dx;
    }
    if (x <= 0) {
        return 0;
    }
    return (x - dx - 1) / (-dx);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<pair<int, int>> dp(n);
    dp[0] = {0, 0};
    for (int i = 1; i < n; ++i) {
        int sum = dp[i - 1].second;
        int ds = a[i] - sum - 1;
        int dt = ds / a[i - 1];
        ds = dt * a[i - 1];
        dp[i] = {dp[i - 1].first + dt, dp[i - 1].second + ds};
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int x;
        cin >> x;

        int l = 0;
        int r = n;
        while (r - l > 1) {
            int m = (r + l) / 2;
            if (a[m] > x) {
                r = m;
            } else {
                l = m;
            }
        }
        int ind = l;


        int sum = dp[ind].second;
        int ds = x - sum - 1;
        int dt = ds / a[ind];
        ds = dt * a[ind];
        cout << dp[ind].first + dt << " " << dp[ind].second + ds << "\n";
    }

    return 0;
}