#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define all(v) (v).begin(), (v).end()
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

struct DO {
    vector<int> t;

    int n;


    DO(int n, vector<int> a) : n(n) {
        t.resize(n * 4);
        build(1, 0, n, a);
    }

    void update(int pos, int val) {
        update(1, 0, n, pos, val);
    }

    int get(int l, int r) {
        return get(1, 0, n, l, r);
    }

private:
    void build(int v, int l, int r, vector<int> &a) {
        if (r == l + 1) {
            t[v] = a[l];
            return;
        }
        int m = (r + l) / 2;
        build(v * 2, l, m, a);
        build(v * 2 + 1, m, r, a);
        t[v] = merge(t[v * 2], t[v * 2 + 1]);
    }

    void update(int v, int l, int r, int pos, int val) {
        if (pos >= r || pos < l) {
            return;
        }
        if (l == r - 1) {
            t[v] = val;
            return;
        }
        int m = (r + l) / 2;
        update(v * 2, l, m, pos, val);
        update(v * 2 + 1, m, r, pos, val);
        t[v] = merge(t[v * 2], t[v * 2 + 1]);
    }

    int get(int v, int l, int r, int tl, int tr) {
        if (l >= tr || r <= tl) {
            return DEFAULT;
        }
        if (tl <= l && r <= tr) {
            return t[v];
        }
        int m = (r + l) / 2;
        return merge(get(v * 2, l, m, tl, tr), get(v * 2 + 1, m, r, tl, tr));
    }

    int DEFAULT = 0;

    int merge(int a, int b) {
        return a + b;
    }
};

#define int long long

#define DP_SECOND 4
int n;
int *a;
int ***dp;
vector<pair<int, int>> good = {
        {0, 0},
        {0, 1},
        {0, 2},
        {0, 3},
        {1, 0},
        {1, 1},
        {1, 2},
        {2, 0},
        {2, 1},
        {3, 0}
};

int solve() {
    for (int i = 0; i < DP_SECOND; ++i) {
        for (int j = 0; j < DP_SECOND; ++j) {
            dp[0][i][j] = 0;
        }
    }
    for (int i = 1; i <= n; ++i) {
        for (int s = 0; s < DP_SECOND; ++s) {
            for (int p = 0; p < DP_SECOND; ++p) {
                dp[i][s][p] = 0;
                bool b2 = (i < DP_SECOND && p + s >= i && !(p >= i && s >= i));
                if (b2) {
                    dp[i][s][p] = 0;
                    continue;
                }
                if (i <= p) {
                    if (s == 0) {
                        dp[i][s][p] = 0;
                    } else {
                        dp[i][s][p] = dp[i - 1][s][p - 1] + a[i - 1];
                    }
                } else {
                    if (s == 0) {
                        for (int j = 0; j < DP_SECOND; ++j) {
                            dp[i][s][p] = max(dp[i][s][p], dp[i - 1][j][p]);
                        }
                    } else {
                        dp[i][s][p] = max(dp[i][s][p], dp[i - 1][s - 1][p] + a[i - 1]);
                    }
                }
            }
        }
    }
    int ans = 0;
    for (auto e:good) {
        ans = max(ans, dp[n][e.first][e.second]);
    }
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    a = new int[n];
    dp = new int **[n + 1];
    for (int i = 0; i < n; ++i) {
        dp[i] = new int *[DP_SECOND];
        for (int j = 0; j < DP_SECOND; ++j) {
            dp[i][j] = new int[DP_SECOND];
        }
    }
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    cout << solve() << "\n";
    int q;
    cin >> q;
    for (int j = 0; j < q; ++j) {
        int p, v;
        cin >> p >> v;
        a[p - 1] = v;
        cout << solve() << "\n";

    }
    return 0;
}