#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

vector <vector <int>> samples;

bool check_ind(int a, int b, int c, int d)
{
	vector <int> seq = { a, b, c, d };
	sort(seq.begin(), seq.end());

	for (int i = 0; i < samples.size(); ++i)
		if (seq == samples[i])
			return true;
	return false;
}

ll get_ans(const vector <ll>& a)
{
	ll ans = 0;
	for (int i = 0; i < a.size(); ++i)
	{
		for (int j = 0; j < a.size(); ++j)
		{
			if (j == i)
				continue;

			for (int ii = 0; ii < a.size(); ++ii)
			{
				if (ii == i || ii == j)
					continue;

				for (int jj = 0; jj < a.size(); ++jj)
				{
					if (jj == i || jj == j || jj == ii)
						continue;

					if (check_ind(i, j, ii, jj))
						continue;

					ans = max(ans, a[i] + a[j] + a[ii] + a[jj]);
				}
			}
		}
	}

	return ans;
}

int main()
{
	int n = 0;
	cin >> n;

	vector <ll> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];

	samples.resize(n);
	for (int st = 0; st < n; ++st)
	{
		samples[st].resize(4);
		for (int i = 0; i < 4; ++i)
			samples[st][i] = (st + i) % n;
	}

	cout << get_ans(a) << '\n';
	
	int q = 0;
	cin >> q;

	while (q--)
	{
		int p = 0, v = 0;
		cin >> p >> v;
		a[p - 1] = v;
		cout << get_ans(a) << '\n';
	}

	return 0;
}