#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

bool check(const vector <bool>& a)
{
	for (int i = 0; i < a.size(); ++i)
	{
		bool inc = true;
		if (!a[i])
			continue;

		for (int j = 0; j < 4; ++j)
			if (!a[(i + j) % a.size()])
				inc = false;

		if (inc)
			return false;
	}

	return true;
}

void rec(const vector <ll>& a, vector <bool>& state, int pos, ll val, ll& ans)
{
	if (pos == a.size())
	{
		if (check(state))
			ans = max(ans, val);
	}
	else
	{
		rec(a, state, pos + 1, val, ans);
		state[pos] = true;
		rec(a, state, pos + 1, val + a[pos], ans);
		state[pos] = false;
	}
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n = 0;
	cin >> n;

	vector <ll> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];

	ll ans = 0;
	vector <bool> state(n, false);
	rec(a, state, 0, 0, ans);
	cout << ans << '\n';
	ans = 0;

	int q = 0;
	cin >> q;

	while (q--)
	{
		int p = 0, v = 0;
		cin >> p >> v;
		a[p - 1] = v;

		rec(a, state, 0, 0, ans);
		cout << ans << '\n';
		ans = 0;
	}

	return 0;
}