#include <bits/stdc++.h>

using namespace std;

#define DEBUGf

const int MAXN = 40;

bool good(int a, int b) {
    a = a * 8 + b;
    if ((a & 60) == 60)
        return false;
    if ((a & 30) == 30)
        return false;
    if ((a & 15) == 15)
        return false;
    return true;
}

bool valid(int i, int a, int b) {
    if (i == 2)
        return a == b;
    if (i == 3)
        return (a & 3) == (b>>1);
    if (i == 4)
        return (a & 1) == (b>>2);
    return true;
}

void solver(vector<long long> &v, vector<vector<long long>> &hhru) {
    int n = v.size();
    vector<vector<vector<long long>>> dp(n, vector<vector<long long>>(8, vector<long long>(8)));
    for (int i = 0; i < 8; ++i) {
        if (i & 4)
            dp[2][i][i] += v[0];
        if (i & 2)
            dp[2][i][i] += v[1];
        if (i & 1)
            dp[2][i][i] += v[2];
    }
    for (int i = 2; i < n - 1; ++i) {
        for (int fmask = 0; fmask < 8; ++fmask) {
            for (int mask = 0; mask < 8; ++mask) {
                if (!valid(i, fmask, mask))
                    continue;
                dp[i + 1][fmask][(mask & 3) * 2] = max(dp[i + 1][fmask][(mask & 3) * 2], dp[i][fmask][mask]);
                if (mask != 7)
                    dp[i + 1][fmask][((mask & 3) * 2 + 1)] = max(dp[i + 1][fmask][((mask & 3) * 2 + 1)],
                    dp[i][fmask][mask] + v[i + 1]);
            }
        }
    }
    for (int i = 0; i < 8; ++i)
        for (int j = 0; j < 8; ++j)
            hhru[i][j] = dp[n - 1][i][j];
}

bool gooderrr(int mask, int n) {
    vector<int> v(n + 3);
    for (int i = 0; i < n; ++i)
        if (mask & (1 << i))
            v[i] = 1;
    v[n] = v[0];
    v[n + 1] = v[1];
    v[n + 2] = v[2];
    for (int i = 0; i < n; ++i)
        if (v[i] && v[i + 1] && v[i + 2] && v[i + 3])
            return false;
    return true;
}

void match(vector<vector<long long>> &dp1, vector<vector<long long>> &dp2, vector<vector<long long>> &dp3) {
    if (dp2.size() == 0) {
        dp1 = dp3;
        return;
    }
    if (dp3.size()  == 0) {
        dp1 = dp2;
        return;
    }
    dp1.assign(8, vector<long long>(8));
    for (int i = 0; i < 8; ++i)
        for (int j = 0; j < 8; ++j)
            for (int k = 0; k < 8; ++k)
                for (int l = 0; l < 8; ++l)
                    if (good(j, k))
                        dp1[i][l] = max(dp1[i][l], dp2[i][j] + dp3[k][l]);
}

void get_res(vector<vector<long long>>& dp) {
    long long ans = 0;
    for (int i = 0; i < 8; ++i)
        for (int j = 0; j < 8; ++j)
            if (good(i, j))
                ans = max(ans, dp[j][i]);
    cout << ans << '\n';
}

void solve() {
    int n;
    cin >> n;
    if (n < 6) {
        vector<long long> v(n);
        for (int i = 0; i < n; ++i)
            cin >> v[i];
        int q;
        cin >> q;
        for (int i = -1; i < q; ++i) {
            if (i != -1) {
                int a, b;
                cin >> a >> b;
                v[a - 1] = b;
            }
            long long ans = 0;
            for (int mask = 0; mask < (1 << n); ++mask) {
                if (gooderrr(mask, n)) {
                    long long cur = 0;
                    for (int j = 0; j < n; ++j)
                    if (mask & (1 << j))
                        cur += v[j];
                    ans = max(cur, ans);
                }
            }
            cout << ans << endl;
        }
        return;
    }
    vector<vector<long long>> mass;
    vector<long long> v(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }
    for (int i = 0; i < n; ++i) {
        if (i % MAXN == 0)
            mass.push_back({});
        mass.back().push_back(v[i]);
    }
    if (mass.size() != 1 && mass.back().size() < MAXN) {
        for (auto x : mass.back())
            mass[mass.size() - 2].push_back(x);
        mass.pop_back();
    }
    vector<vector<vector<long long>>> dp(mass.size(), vector<vector<long long>>(8, vector<long long>(8)));
    for (int i = 0; i < mass.size(); ++i)
        solver(mass[i], dp[i]);
    int sz = 1;
    while (sz < mass.size())
        sz += sz;
    sz += sz;
    vector<vector<vector<long long>>> seg(sz);
    for (int i = 0; i < mass.size(); ++i)
        seg[i + sz / 2] = dp[i];
    for (int i = sz / 2 - 1; i > 0; --i)
        match(seg[i], seg[i + i], seg[i + i + 1]);
    get_res(seg[1]);
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        long long a, b;
        cin >> a >> b;
        --a;
        int uk = 0;
        while (mass[uk].size() <= a) {
            a -= mass[uk].size();
            ++uk;
        }
        mass[uk][a] = b;
        solver(mass[uk], seg[sz / 2 + uk]);
        int yy = uk + sz / 2;
        while (yy > 1) {
            yy /= 2;
            match(seg[yy], seg[yy + yy], seg[yy + yy + 1]);
        }
        get_res(seg[1]);
    }
}

int main() {
    #ifdef DEBUG
        freopen("Dtest.cpp", "r", stdin);
    #else
        cin.tie(nullptr);
        cout.tie(nullptr);
        ios_base::sync_with_stdio(false);
    #endif // DEBUG
    solve();
    return 0;
}

