#include <iostream>
#include <vector>

using namespace std;

int binarySearch(double x, vector<double>& vec) {
    int left = -1, right = vec.size();
    while (right - left > 1) {
        int mid = (left + right) / 2;
        if (vec[mid] > x) {
            right = mid;
        } else {
            left = mid;
        }
    }
    return left;
}

int main() {
    int n;
    cin >> n;
    vector<double> vel(n);
    vector<double> len(n);
    double help = 0.0;
    for (int i = 0; i < n; i++) {
        cin >> vel[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> len[i];
        help += (len[i] / vel[i]);
    }
    int m;
    cin >> m;
    vector<double> banVel(m - 1);
    for (int i = 0; i < m - 1; i++) {
        cin >> banVel[i];
    }
    vector<double> money(m);
    for (int i = 0; i < m; i++) {
        cin >> money[i];
    }
    int q;
    cin >> q;
    vector<int> ans;
    for (int i = 0; i < q; i++) {
        double tin, tout;
        cin >> tin >> tout;
        double time;
        time = tout - tin;
        if (time >= help) {
            ans.push_back(0);
            continue;
        }
        double left = 0.0, right = 10000000.0;
        for (int i = 0; i < 100; i++) {
            double mid = (right + left) / 2;
            double res = 0.0;
            for (int j = 0; j < n; j++) {
                res += len[j] / (vel[j] + mid);
            }
            if (res <= time) {
                right = mid;
            } else {
                left = mid;
            }
        }
        if (banVel.size() == 0) {
            ans.push_back(money[0]);
        } else if (right < banVel[0]) {
            ans.push_back(money[0]);
        } else if (right > banVel[banVel.size() - 1]) {
            ans.push_back(money[m - 1]);
        } else {
            int k = binarySearch(right, banVel);
            ans.push_back(money[k + 1]);
        }
    }
    for (auto x: ans) {
        cout << x << endl;
    }
}
