#include <iostream>
#include <vector>
#include <set>

using namespace std;

const int MAXN = 2 * 1e5;
int n;
vector<int> vec;

pair<int, set<int> > t[4 * MAXN];

void build(int v, int tl, int tr) {
    if (tl == tr) {
        set<int> need;
        need.insert(vec[tl]);
        t[v] = {1, need};
    } else {
        int tm = (tl + tr) / 2;
        build(v * 2, tl, tm);
        build(v * 2 + 1, tm + 1, tr);
        set<int> need;
        for (auto x: t[v * 2].second) {
            need.insert(x);
        }
        for (auto x: t[v * 2 + 1].second) {
            need.insert(x);
        }
        t[v] = {need.size(), need};
    }
}

pair<int, set<int> > diff(int v, int tl, int tr, int l, int r) {
    if (l > r) {
        set<int> need;
        return {0, need};
    }
    if (tl == l && tr == r) {
        return t[v];
    }
    int tm = (tr + tl) / 2;
    set<int> ans;
    set<int> one = diff(v * 2, tl, tm, l, min(r, tm)).second;
    set<int> two = diff(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r).second;
    for (auto x: one) {
        ans.insert(x);
    }
    for (auto x: two) {
        ans.insert(x);
    }
    return {ans.size(), ans};
}

int main() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        int temp;
        cin >> temp;
        vec.push_back(temp);
    }
    build(1, 0, n - 1);
    for (int i = 1; i <= n; i++) {
        int sum = 0;
        for (int j = 0; j < n - i + 1; j++) {
            sum += diff(1, 0, n - 1, j, j + i - 1).first;
        }
        cout << sum << ' ';
    }
}
