#define _USE_MATH_DEFINES
#pragma GCC optimize("O3")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <numeric>
#include <algorithm>
#include <cassert>
#include <ctime>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
using namespace std;
#define kekek ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define int long long

struct node {
    int k, b;
    node() {
        k = b = 0;
    }
};

struct segtree {
    int n;
    vector<node> tr;

    segtree(int sz) {   //  .   
        n = sz;
        tr.resize(4 * n + 5);
    }

    void push(int v, int left_sz) {
        tr[2 * v].k += tr[v].k;
        tr[2 * v].b += tr[v].b;
        tr[2 * v + 1].k += tr[v].k;
        tr[2 * v + 1].b += tr[v].b + tr[v].k * left_sz;
        tr[v].k = tr[v].b = 0;
    }

    void upd(int v, int l, int r, int ql, int qr, int k, int b) {       
        if (l > qr || ql > r) return;
        if (ql <= l && qr >= r) {
            tr[v].b += b;
            tr[v].k += k;
            return;
        }

        int m = (l + r) / 2, left_sz = max(m - ql + 1, 0ll);
        upd(2 * v, l, m, ql, qr, k, b);
        upd(2 * v + 1, m + 1, r, ql, qr, k, b + k * left_sz);
    }

    void info(int v, int l, int r) {
        if (l == r) {
            if (l == 0) return;
            cout << tr[v].b << " ";
            return;
        }
        
        int m = (l + r) / 2, left_sz = max(m - l + 1, 0ll);
        push(v, left_sz);
        info(2 * v, l, m);
        info(2 * v + 1, m + 1, r);
    }
};

signed main() {
    kekek;
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto& i : a) {
        cin >> i;
    }
    unordered_map<int, int> last;
    vector<int> left(n);
    for (int i = 0; i < n; i++) {
        if (last.find(a[i]) == last.end()) {
            left[i] = -1;
        } else {
            left[i] = last[a[i]];
        }
        last[a[i]] = i;
    }
    
    segtree kek(n + 1);
    for (int i = 0; i < n; i++) {
        int distL = i - left[i], distR = n - i;
        if (distL > distR) {
            swap(distL, distR);
        }

        if (distL >= 2) {
            kek.upd(1, 0, n, 1, distL - 1, 1, 1);
        }
        kek.upd(1, 0, n, distL, distR, 0, distL);
        if (distL >=  2) {
            kek.upd(1, 0, n, distR + 1, distL + distR - 1, -1, distL - 1);
        }

        //cout << "info(" << i << ") :";
        //kek.info(1, 0, n);
        //cout << '\n';
    }

    kek.info(1, 0, n);

    return 0;
}