#define _USE_MATH_DEFINES
#pragma GCC optimize("O3")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <numeric>
#include <algorithm>
#include <random>
#include <cassert>
#include <ctime>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
using namespace std;
#define kekek ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define int long long

random_device rd;

struct node {
    int k, b;
    node() {
        k = b = 0;
    }
};

struct segtree {
    int n;
    vector<node> tr;
    vector<int> ans;

    segtree(int sz) {   //  .   
        n = sz;
        tr.resize(4 * n + 5);
        ans.reserve(n);
    }

    void push(int v, int left_sz) {
        tr[2 * v].k += tr[v].k;
        tr[2 * v].b += tr[v].b;
        tr[2 * v + 1].k += tr[v].k;
        tr[2 * v + 1].b += tr[v].b + tr[v].k * left_sz;
        tr[v].k = tr[v].b = 0;
    }

    void upd(int v, int l, int r, int ql, int qr, int k, int b) {       
        if (l > qr || ql > r) return;
        if (ql <= l && qr >= r) {
            tr[v].b += b;
            tr[v].k += k;
            return;
        }

        int m = (l + r) / 2, left_sz = max(m - ql + 1, 0ll);
        upd(2 * v, l, m, ql, qr, k, b);
        upd(2 * v + 1, m + 1, r, ql, qr, k, b + k * left_sz);
    }

    void info(int v, int l, int r) {
        if (l == r) {
            ans.push_back(tr[v].b);
            return;
        }
        
        int m = (l + r) / 2, left_sz = max(m - l + 1, 0ll);
        push(v, left_sz);
        info(2 * v, l, m);
        info(2 * v + 1, m + 1, r);
    }
};

struct stupid_segtree {
    int n;
    vector<node> tr;
    vector<int> ans;

    stupid_segtree(int sz) {   //  .   
        n = sz;
        tr.resize(n + 5);
        ans.resize(n + 1);
    }

    void upd(int v, int l, int r, int ql, int qr, int k, int b) {
        for (int i = ql; i <= qr; i++) {
            tr[i].b += b;
            b += k;
        }
    }

    void info(int v, int l, int r) {
        for (int i = 0; i <= n; i++) {
            ans[i] = tr[i].b;
        }
    }
};

vector<int> smart(vector<int> a) {
    int n = a.size();
    unordered_map<int, int> last;
    vector<int> left(n);
    for (int i = 0; i < n; i++) {
        if (last.find(a[i]) == last.end()) {
            left[i] = -1;
        } else {
            left[i] = last[a[i]];
        }
        last[a[i]] = i;
    }

    segtree kek(n + 1);
    for (int i = 0; i < n; i++) {
        int distL = i - left[i], distR = n - i;
        if (distL > distR) {
            swap(distL, distR);
        }

        if (distL >= 2) {
            kek.upd(1, 0, n, 1, distL - 1, 1, 1);
        }
        kek.upd(1, 0, n, distL, distR, 0, distL);
        if (distL >= 2) {
            kek.upd(1, 0, n, distR + 1, distL + distR - 1, -1, distL - 1);
        }

        //cout << "info(" << i << ") :";
        //kek.info(1, 0, n);
        //cout << '\n';
    }

    kek.info(1, 0, n);
    return kek.ans;
}

vector<int> stupid(vector<int> a) {
    int n = a.size();
    unordered_map<int, int> last;
    vector<int> left(n);
    for (int i = 0; i < n; i++) {
        if (last.find(a[i]) == last.end()) {
            left[i] = -1;
        } else {
            left[i] = last[a[i]];
        }
        last[a[i]] = i;
    }

    stupid_segtree kek(n + 1);
    for (int i = 0; i < n; i++) {
        int distL = i - left[i], distR = n - i;
        if (distL > distR) {
            swap(distL, distR);
        }

        if (distL >= 2) {
            kek.upd(1, 0, n, 1, distL - 1, 1, 1);
        }
        kek.upd(1, 0, n, distL, distR, 0, distL);
        if (distL >= 2) {
            kek.upd(1, 0, n, distR + 1, distL + distR - 1, -1, distL - 1);
        }

        //cout << "info(" << i << ") :";
        //kek.info(1, 0, n);
        //cout << '\n';
    }

    kek.info(1, 0, n);
    return kek.ans;
}

/*vector<int> stupid(vector<int> a) {
    int n = a.size();
    vector<int> ans(n + 1, 0);

    for (int i = 0; i < n; i++) {
        unordered_set<int> kkk;
        for (int j = i; j < n; j++) {
            kkk.insert(a[j]);
            ans[j - i + 1] += kkk.size();
        }
    }
    return ans;
}*/

const int maxc = 20;
vector<int> best(maxc);
void stress() {
    int n = rd() % maxc + 1;
    vector<int> a(n);

    for (auto& i : a) i = rd() % maxc + 1;
    auto f = stupid(a), s = smart(a);
    if (f != s) {
        if (best.size() > a.size()) {
            a.swap(best);
            cout << best.size() << '\n';
        }
        /*
        cout << "Test\n" << n << '\n';
        for (auto i : a) {
            cout << i << " ";
        }
        cout << "\nright: ";
        for (auto i : f) {
            cout << i << " ";
        }
        cout << "\nwrong: ";
        for (auto i : s) {
            cout << i << " ";
        }
        cout << "\n\n";
        system("pause");
        */
    }
}

signed main() {
    kekek;

    if (1) {
        int n;
        cin >> n;
        vector<int> a(n);
        for (auto& i : a) {
            cin >> i;
        }
        auto ans = stupid(a);
        for (int i = 1; i <= n; i++) {
            cout << ans[i] << " ";
        }
        
        //cout << "\nsmart: ";
        //ans = smart(a);
        //for (int i = 1; i <= n; i++) {
        //    cout << ans[i] << " ";
        //}
    } else {
        for (int i = 0; i <= 100000; i++) {
            //if (i % 10 == 0) cout << i << '\n';
            stress();
        }
    }

    return 0;
}