#include <iostream>
#include <bitset>
#include <cstdlib>
#include <ctime>
#include <algorithm>
#include <vector>
#include <deque>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <set>
#include <iomanip>
#include <complex>

#define fast ios_base::sync_with_stdio(0), cin.tie(), cout.tie()
#define endl '\n'
#define ll long long
#define int ll

using namespace std;
struct segmentTree
{
    int nMax;
    vector<int> st, promise;
    segmentTree(){}
    segmentTree(int n)
    {
        nMax = 1<<(int)(log2(1.*n-1)+1);
        st.resize(2*nMax);
        promise.resize(2*nMax);
    }
    void push(int v)
    {
        st[v] += promise[v];
        if(v < nMax){
            promise[2*v] += promise[v];
            promise[2*v+1] += promise[v];
        }
        promise[v] = 0;
    }
    void upd(int lt, int rt, int lq, int rq, int val, int v)
    {
        if(lt >= rq || rt <= lq){
            return;
        }
        if(lt >= lq && rt <= rq){
            promise[v] += val;
            return;
        }
        int mid = (lt+rt)/2;
        upd(lt,mid,lq,rq,val,2*v);
        upd(mid,rt,lq,rq,val,2*v+1);
    }
    int get(int lt, int rt, int pos, int v)
    {
        push(v);
        if(lt + 1 == rt){
            return st[v];
        }
        int mid = (lt+rt)/2;
        if(pos < mid){
            return get(lt,mid,pos,2*v);
        }
        else{
            return get(mid,rt,pos,2*v+1);
        }
    }
};

signed main() {
    fast;
    //freopen("input.txt", "r", stdin);
    int n;
    cin >> n;
    vector<int> arr(n);
    for(int i = 0; i  <n;i++){
        cin >> arr[i];
    }
    unordered_map<int,int> ord;
    vector<int> cp = arr;
    sort(cp.begin(),cp.end());
    for(int i = 0; i < n;i++){
        ord[cp[i]] = i;
    }
    for(int i = 0; i < n;i++){
        arr[i] = ord[arr[i]]+1;
    }
    vector<int> l(n), r(n);
    vector<int> last1(n+1,-1),last2(n+1,n);
    for(int i = 0; i < n;i++){
        l[i] = last1[arr[i]]+1;
        last1[arr[i]] = i;
    }

    for(int i = n-1; i >= 0;i--){
        r[i] = last2[arr[i]]-1;
        last2[arr[i]] = i;
    }
    segmentTree rootF(n+1), rootM(n+1), rootP(n+1), cnt(n+1);
    for(int i = 0; i < n;i++){
        int L = max(0LL,l[i]);
        int R = min(n-1,r[i]);
        int a = i - L+1;
        int b = R-i+1;
        int mn = min(a,b);
        int mx = max(a,b);
        rootF.upd(0,rootF.nMax,1,mn+1,1,1);
        rootM.upd(0,rootM.nMax,mn+1,mx,mn,1);
        rootP.upd(0,rootP.nMax,mx,a+b-1,a+b,1);
        cnt.upd(0,rootP.nMax,mx,a+b-1,1,1);
    }
    vector<int> answer(n+1);
    for(int i = 1; i <= n;i++){
        //cout << "! " << i << endl;
        //cout << i*rootF.get(0,rootF.nMax,i,1) << endl;
        //cout <<  rootM.get(0,rootM.nMax,i,1) << endl;
        //cout << rootP.get(0,rootP.nMax,i,1) - i*cnt.get(0,rootP.nMax,i,1) << endl;
        answer[i] += i*rootF.get(0,rootF.nMax,i,1);
        answer[i] += rootM.get(0,rootM.nMax,i,1);
        answer[i] += rootP.get(0,rootP.nMax,i,1) - i*cnt.get(0,rootP.nMax,i,1);
    }
    for(int i = 1; i <= n;i++){
        cout << answer[i] << " " ;
    }
    cout << endl;
    return 0;
}
