#include <iostream>
#include <bitset>
#include <cstdlib>
#include <ctime>
#include <algorithm>
#include <vector>
#include <deque>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <set>
#include <iomanip>
#include <complex>

#define fast ios_base::sync_with_stdio(0), cin.tie(), cout.tie()
#define endl '\n'
#define ll long long
#define int ll

using namespace std;
const int INF = 1e18;
struct vertex
{
    int dp[5][5], pref[5][5];
    vertex(){
        for(int i = 0; i < 5;i++){
            for(int j = 0; j < 5;j++){
                dp[i][j] = pref[i][j] = INF;
            }
        }
    }
};
struct segmentTree
{
    int nMax;
    vector<vertex> st;
    segmentTree(){}
    segmentTree(int n)
    {
        nMax = 1<<(int)(log2(1.*n-1)+1);
        st.resize(2*nMax);
    }
    void upd(int v, int lt, int rt)
    {
        if(v >= nMax){
            return;
        }
        int mid = (lt+rt)/2;
        int cntL = mid-lt;
        int cntR = rt-mid;
        for(int i = 0; i <= 3;i++){
            for(int j = 0; j <= 3;j++){
                st[v].dp[i][j] = INF;
            }
        }
        for(int i = 0; i < 4;i++){
            for(int j = 0; j < 4;j++){
                for(int k = 0; k < 4;k++){
                    if(v == 1 && i + j > 3){
                        continue;
                    }
                    for(int m = 0; m < 4;m++){
                        if(k + m > 3){
                            continue;
                        }
                        st[v].dp[i][j] = min(st[v].dp[i][j], st[2*v].dp[i][k] + st[2*v+1].dp[m][j]);
                    }
                }
            }
        }
        for(int j = 0; j <= 3;j++){
            for(int i = 0; i <= 3;i++){
                if(i){
                    st[v].pref[i][j] = st[v].pref[i-1][j];
                }
                st[v].pref[i][j] = min(st[v].dp[i][j],st[v].pref[i-1][j]);
            }
        }
    }
    void upd(int lt, int rt, int pos, int val, int v)
    {
        if(lt + 1 == rt){
            st[v].dp[0][0] = val;
            for(int j = 1; j < 4;j++){
                for(int i = 1; i < 4;i++){
                    st[v].dp[i][j]  =st[v].dp[j][i] = 0;
                }
            }
            for(int i = 0; i < 4;i++){
                st[v].dp[i][0] = st[v].dp[0][i] = val;
            }
            st[v].dp[3][3] = 0;
            for(int j = 0; j <= 3;j++){
                for(int i = 0; i <= 3;i++){
                    if(i){
                        st[v].pref[i][j] = st[v].pref[i-1][j];
                    }
                    st[v].pref[i][j] = min(st[v].dp[i][j],st[v].pref[i-1][j]);
                }
            }
            return;
        }
        int mid = (lt+rt)/2;
        if(pos < mid){
            upd(lt,mid,pos,val,2*v);
        }
        else{
            upd(mid,rt,pos,val,2*v+1);
        }
        upd(v,lt,rt);
    }
    int get()
    {
        int answer = INF;
        for(int i = 0; i < 4;i++){
            for(int j = 0; j < 4;j++){
                if(i+j > 3){
                    continue;
                }
                answer = min(answer,st[1].dp[i][j]);
            }
        }
        return answer;
    }
};
signed main() {
    fast;
    //freopen("input.txt", "r", stdin);
    int n;
    cin >> n;
    vector<int> a(n);
    for(int i = 0; i < n;i++){
        cin >> a[i];
    }
    int q;
    cin >> q;
    vector<pair<int,int>> Q(q);
    for(int i = 0; i < q;i++){
        cin >> Q[i].first >> Q[i].second;
    }
    if(n < 15){
        auto solve = [&]()
        {
            int sum = 0;
            for(int i = 0; i < n;i++) {
                sum += a[i];
            }
            int LW = sum;
            for(int i = 1; i < 1<<n;i++){
                int res = 0;
                vector<int> ban;
                for(int j = 0; j < n;j++){
                    if(i&(1<<j)){
                        ban.push_back(j);
                        res += a[j];
                    }
                }
                ban.push_back(ban.front()+n);
                for(int j = 1; j < ban.size();j++){
                    if(abs(ban[j]-ban[j-1]) > 4){
                        res = sum;
                    }
                }

                LW = min(LW,res);
            }
            return sum-LW;
        };
        vector<int> answer(Q.size()+1);
        answer[0] = solve();
        for(int i = 1; i < answer.size();i++){
            a[Q[i-1].first-1] = Q[i-1].second;
            answer[i] = solve();
        }
        for(auto to:answer){
            cout << to << endl;
        }
        exit(0);
    }
    int sum = 0;
    for(int i = 0; i < n;i++){
        sum += a[i];
    }
    segmentTree kek(n);
    for(int i = 0; i < n;i++){
        kek.upd(0,kek.nMax,i,a[i],1);
    }
    vector<int> answer(q+1,sum);
    answer[0] -= kek.get();
    for(int i = 1; i < answer.size();i++){
        sum -= a[Q[i-1].first-1];
        a[Q[i-1].first-1] = Q[i-1].second;
        sum += a[Q[i-1].first-1];
        kek.upd(0,kek.nMax,Q[i-1].first-1,Q[i-1].second,1);
        answer[i] = sum - kek.get();
    }
    for(auto to:answer){
        cout << to << endl;
    }
    return 0;
}
