#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <vector>
#include <random>
#include <cmath>
#include <ctime>
#include <queue>
#include <map>
#include <set>
using namespace std;

#pragma target("sse,sse2,sse3,ssse3,sse4,avx,avx2,tune=native")
#pragma optimize("unroll-loops")
//#pragma optimize("Ofast,no-stack-protector")

const int_fast64_t INF = 1000000000000000000;

vector<int_fast64_t> tr;

void upd(int l, int r, int x, int_fast64_t y, int it){
    if(r<=x||x<l)
        return;
    if(l+1==r){
        tr[it] = y;
        return;
    }
    int m = (l+r)/2;
    upd(l, m, x, y, 2*it);
    upd(m, r, x, y, 2*it+1);
    tr[it] = max(tr[2*it], tr[2*it+1]);
}

int_fast64_t get(int l, int r, int x, int y, int it){
    if(r<=x||y<=l)
        return 0;
    if(x<=l&&r<=y)
        return tr[it];
    int m = (l+r)/2;
    return max(get(l, m, x, y, 2*it), get(m, r, x, y, 2*it+1));
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    tr.resize(4*n);
    vector<int_fast64_t> a(n);
    for(int i = 0; i<n; i++){
        cin >> a[i];
        if(i)
            upd(0, n, i-1, a[i]-a[i-1], 1);
    }
    upd(0, n, n-1, INF, 1);
    int q;
    cin >> q;
    for(int i = 0; i<q; i++){
        int_fast64_t b;
        cin >> b;
        if(n==1||b<a[1]){
            cout << b << ' ' << b << '\n';
            continue;
        }
        int_fast64_t ans = a[1]-1, sm = a[1]-1;
        /// O(log(n)^2)
        //if(q>5){
            int mn = 0;
            while(true){
                int l = mn, r = n;
                while(r-l>1){
                    int m = (l+r)/2;
                    if(a[m]<sm)
                        l = m;
                    else
                        r = m;
                }
                mn = l;
                l = mn, r = n;
                //cout << '[' << l << ';' << r << ']' << endl;
                while(r-l>1){
                    int m = (l+r)/2;
                    //cout << l << ':' << r << ' ' << m << '=' << get(0, n, mn, m+1, 1) << endl;
                    if(get(0, n, mn, m+1, 1)>sm)
                        r = m;
                    else
                        l = m;
                }
                int j = r;
                //cout << j << ':';
                if(r==n||sm+a[j]>b)
                    break;
                int_fast64_t jij = (min(b, ((j+1==n)?INF:(a[j+1]-1)))-sm)/a[j];
                if(jij==0)
                    break;
                sm += jij*a[j];
                ans += jij;
                mn = j;
            }
        /*}
        else{
            for(int j = 1; j<n; j++){
                /// O(n)
                int_fast64_t jij = (min(b, ((j+1==n)?INF:(a[j+1]-1)))-sm)/a[j];
                sm += jij*a[j];
                ans += jij;
                /// O(b)
                /*while(true){
                    if(sm+a[j]>b)
                        break;
                    if(j+1<n&&sm+a[j]>=a[j+1])
                        break;
                    ans++;
                    sm += a[j];
                }*/
            //}
        //}
        cout << sm << ' ' << ans << '\n';
    }

    return 0;
}
/*
4
1 5 10 50
3
2
8
50

6
1 2 4 8 16 32
2
14
15

3
1 3 4
4
10
100
1000
10000
*/
