#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<ll> lvec;
typedef pair<ll, ll> lpair;
typedef long double ldouble;

#ifdef LOCAL
#define TEST "D"

#else

#endif

struct node {
    ll left, right, val = 0, add = 0;
    node *l = nullptr, *r = nullptr;

    node(ll left, ll right) : left(left), right(right) {
        if (right - left == 1) return;
        l = new node(left, (left + right) / 2);
        r = new node((left + right) / 2, right);
    }

    void push() {
        val += add;
        if (l != nullptr) {
            l->add += add;
            r->add += add;
        }
        add = 0;
    }

    ll get(ll i) {
        push();
        if (right - left == 1) return val;
        if (i < r->left) return l->get(i);
        else return r->get(i);
    }

    void upd(ll i, ll x) {
        push();
        if (i < left || right <= i) return;
        if (right - left == 1) {
            val = x;
            return;
        }
        l->upd(i, x);
        r->upd(i, x);
    }

    void update(ll reqleft, ll reqright, ll delta) {
        if (reqright <= left || right <= reqleft) return;
        push();
        if (reqleft <= left && right <= reqright) {
            add += delta;
            push();
            return;;
        }
        l->update(reqleft, reqright, delta);
        r->update(reqleft, reqright, delta);
    }
};

void calc(ll i, node *dp, lvec &a, ll mini) {
    ll ans = dp->get(i - 1);
    if (i > mini + 1) ans = max(ans, a[i - 2] + dp->get(i - 2));
    if (i > mini + 2) ans = max(ans, a[i - 2] + a[i - 3] + dp->get(i - 3));
    if (i > mini + 3) ans = max(ans, a[i - 2] + a[i - 3] + a[i - 4] + dp->get(i - 4));
    dp->upd(i, ans);
}

int main() {
#ifdef TEST
    cerr << "Test " << TEST << "\n";
#endif
#ifdef  LOCAL
    cerr << "LOCAL\n";
#ifdef TEST
    char in_file[100] = "in_";
    strcat(in_file, TEST);
    cerr << "Input file : " << in_file << "\n";
    if (!freopen(in_file, "r", stdin)) cerr << "No input found\n";
    if (!freopen("out", "w", stdout)) cerr << "Output failed\n";
#endif
#endif
    ll n;
    cin >> n;
    node *dp1 = new node(0, n + 10), *dp2 = new node(0, n + 10),
            *dp3 = new node(0, n + 10), *dp4 = new node(0, n + 10);
    lvec a(n);
    for (auto &el : a) cin >> el;
    for (ll i = 0; i < 5; i++) a.push_back(a[i]);
    for (ll i = 3; i < n + 2; i++) calc(i, dp1, a, 1);
    for (ll i = 4; i < n + 3; i++) calc(i, dp2, a, 2);
    for (ll i = 5; i < n + 4; i++) calc(i, dp3, a, 3);
    for (ll i = 6; i < n + 5; i++) calc(i, dp4, a, 4);
    //cout << dp1[n + 1] << " " << dp2[n + 2] << " " << dp3[n + 3] << " " << dp4[n + 4] << "\n";
    cout << max({dp1->get(n + 1), dp2->get(n + 2), dp3->get(n + 3), dp4->get(n + 4)}) << "\n";
    ll q;
    cin >> q;
    while (q--) {
        ll p, v;
        cin >> p >> v;
        a[--p] = v;
        if (p < 5) a[p + n] = v;
        ll delta1 = 0;
        if (p + 9 < n + 2) {
            delta1 -= dp1->get(p + 9);
        }
        for (ll i = max(3LL, p); i < min(n + 2, p + 10); i++) calc(i, dp1, a, 1);
        if (p + 9 < n + 2) {
            delta1 += dp1->get(p + 9);
        }
        dp1->update(p + 10, n + 2, delta1);
        for (ll i = max(4LL, p); i < n + 3; i++) calc(i, dp2, a, 2);
        for (ll i = max(5LL, p); i < n + 4; i++) calc(i, dp3, a, 3);
        for (ll i = max(6ll, p); i < n + 5; i++) calc(i, dp4, a, 4);
        //cout << dp1[n + 1] << " " << dp2[n + 2] << " " << dp3[n + 3] << " " << dp4[n + 4] << "\n";
        cout << max({dp1->get(n + 1), dp2->get(n + 2), dp3->get(n + 3), dp4->get(n + 4)}) << "\n";
    }
    return 0;
}