//#pragma GCC optimize ("unroll_loops,fast_math")
//#pragma GCC target ("avx,avx2")

#include <iostream>
#include <vector>
#include <cmath>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <algorithm>

#define ll long long
#define sz(v) (int)v.size()
#define forn(i, n) for (int i = 0; i < n; ++i)
#define forln(i, l, n) for (int i = l; i < n; ++i)
#define cinv(v) for (auto& x: v) cin >> x
#define fr first
#define se second
#define all(v) v.begin(), v.end()
#define pb push_back
#define pii pair<int, int>
#define pll pair<ld, ld>
#define ld long double
#define hm unordered_map
#define int ll

using namespace std;

const ll inf = (ll)2e9;
const ll N = (int)2e5 + 10;
//const ll N = (int)10;

random_device rd;
mt19937 rnd(rd());

vector<vector<int>> event (N);

struct Tree {
    vector<int> t, assign;
    int size = 1, capacity;

    Tree (const vector<int>& v) {
        while ((1<<size) < sz(v)) ++size;
        ++size;
        size = 1<<size;
        capacity = size>>1;
        t = vector<int> (size);
        assign = vector<int> (size);
        forn (i, sz(v)) t[i + capacity] = v[i];
        for (int i = capacity - 1; i > 0; --i) t[i] = t[i * 2] + t[i * 2 + 1];
    }

    void render (int cur, int left, int right) {
        int cnt = (right - left + 1) / 2;
        t[cur] = t[cur * 2] + assign[cur * 2] * cnt + t[cur * 2 + 1] + assign[cur * 2 + 1] * cnt;
    }

    void push (int cur) {
        assign[cur * 2] += assign[cur];
        assign[cur * 2 + 1] += assign[cur];
        assign[cur] = 0;
    }

    int get (int cur, int left, int right, int l, int r) {
        if (cur >= size) return 0;
        else if (left > r || right < l) return 0;
        else if (l <= left && r >= right) return t[cur] + assign[cur] * (-left + right + 1);
        else {
            push (cur);
            int ans = get (cur * 2, left, (left + right) / 2, l, r) +
                        get (cur * 2 + 1, (left + right) / 2 + 1, right, l, r);
            render (cur, left, right);
            return ans;
        }
    }

    int get (int l, int r) {
        return get (1, 0, capacity - 1, l, r);
    }

    void add (int cur, int left, int right, int l, int r, int x) {
        if (cur >= size) return;
        else if (left > r || right < l) return;
        else if (l <= left && r >= right) assign[cur] += x;
        else {
            push (cur);
            add (cur * 2, left, (left + right) / 2, l, r, x),
                        add (cur * 2 + 1, (left + right) / 2 + 1, right, l, r, x);
            render (cur, left, right);
        }
    }

    void add (int l, int r, int x) {
        return add (1, 0, capacity - 1, l, r, x);
    }

};

ll kek (vector<int>& goo, int d) {
    ll res = 0, ans = 0;
    int cnt[N];
    for (auto& x: cnt) x = 0;
    forn (i, d) {
        if (cnt[goo[i]] == 0) ++res;
        ++cnt[goo[i]];
    }
    ans += res;
    forln (i, 1, sz (goo)) {
        if (i + d - 1 >= sz (goo)) break;
        int x = goo[i - 1];
        if (cnt[x] == 1) --res;
        --cnt[x];
        if (cnt[goo[i + d - 1]] == 0) ++res;
        ++cnt[goo[i + d - 1]];
        ans += res;
    }
    return ans;
}

signed main () {
    ios_base::sync_with_stdio (false);
    cout.tie(nullptr);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<int> goo (n);
    cinv (goo);
    auto moo = goo;
    sort (all (moo));
    moo.resize (unique(all(moo)) - moo.begin());
    for (auto& x: goo) x = lower_bound(all (moo), x) - moo.begin();
    vector<ll> ans (n);

    hm<int, int> prev;
    forn (i, n) {
        if (prev.count (goo[i])) {
            int d = i - prev[goo[i]] + 1;
            event[d].pb (i);
        } prev[goo[i]] = i;
    }

    vector<int> tmp (n, 1);
    Tree soo(tmp);
    tmp.assign(n, 0);
    Tree dop (tmp);
    ans[0] = n;
    int kol = 0, prev_kol = 0;
    forln (i, 2, n + 1) {
        soo.add (0, n - 1, 1);
        for (auto& x: event[i]) {
            int k = x - i + 1;
            soo.add (k, k, -1);
//            ++kol;
            dop.add(k, k, 1);
        }
        ans[i - 1] = soo.get (0, n - i) - dop.get(n - i + 1, n - 1);
//        prev_kol = kol;
    }
    for (auto& x: ans) cout << x << ' ';




}
/*
5
1 3 2 1 2

 */