#pragma optimize GCC("Ofast,unroll-loops,no-stack-protector,fast-math")
#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define pll pair<ll, ll>

ll const N = 1e5 + 1, M1 = 1e9 + 7, M2 = 228228227;
ld const EPS = 1e-10;

ll segment_tree[4 * N], modification[4 * N], start_arr[N];

ll Recalc(ll a, ll b) {
    return a + b;
}

void Build(ll v, ll l, ll r) {
    if (r - l == 1) {
        segment_tree[v] = start_arr[l];
        return;
    }

    ll m = (l + r) / 2;
    Build(v * 2, l, m);
    Build(v * 2 + 1, m, r);
    segment_tree[v] = Recalc(segment_tree[v * 2], segment_tree[v * 2 + 1]);
}

void Push(ll v, ll l, ll r) {
    if (modification[v] && v * 2 + 1 < 4 * N) {
        modification[v * 2] += modification[v];
        modification[v * 2 + 1] += modification[v];

        ll m = (l + r) / 2;
        segment_tree[v * 2] += modification[v] * (m - l);
        segment_tree[v * 2  + 1] += modification[v] * (r - m);
        modification[v] = 0;
    }
}

void Update(ll v, ll l, ll r, ll ql, ll qr, ll val) {
    if (l >= qr || r <= ql) {
        return;
    }

    if (l >= ql && r <= qr) {
        modification[v] += val;
        segment_tree[v] += (r - l) * val;
        return;
    }

    Push(v, l, r);
    ll m = (l + r) / 2;
    Update(v * 2, l, m, ql, qr, val);
    Update(v * 2 + 1, m, r, ql, qr, val);
    segment_tree[v] = Recalc(segment_tree[v * 2], segment_tree[v * 2 + 1]);
}

ll Get(ll v, ll l, ll r, ll ql, ll qr) {
    if (l >= qr || r <= ql) {
        return 0;
    }

    if (l >= ql && r <= qr) {
        return segment_tree[v];
    }

    Push(v, l, r);
    ll m = (l + r) / 2;
    ll ans = Recalc(Get(v * 2, l, m, ql, qr), Get(v * 2 + 1, m, r, ql, qr));
    return ans;
}

struct Node {
    ll sz, x, pr;
    Node* left = nullptr;
    Node* right = nullptr;
    Node() {}
    Node(ll _x) {
        x = _x;
        sz = 1;
        pr = rand();
    }
};

/*ll GetSz(Node* tree) {
    return (tree == nullptr ? 0 : tree->sz);
}

void UpdDekart(Node* tree) {
    tree->sz = GetSz(tree->left) + GetSz(tree->right) + 1;
}

Node* Merge(Node* left, Node* right) {
    if (left == nullptr) {
        return right;
    }
    if (right == nullptr) {
        return left;
    }

    if (left->pr > right->pr) {
        left->right = Merge(left->right, right);
        UpdDekart(left);
        return left;
    }
    else {
        right->left = Merge(left, right->left);
        UpdDekart(right);
        return right;
    }
}

pair<Node*, Node*> Split(Node* tree, ll x) {
    if (tree == nullptr) {
        return {tree, tree};
    }

    if (GetSz(tree->left) == x - 1) {
        auto tmp = tree->right;
        tree->right = nullptr;
        UpdDekart(tree);
        UpdDekart(tmp);
        return {tree, tmp};
    }
    else if (GetSz(tree->left) > x - 1) {
        auto tmp = Split(tree->left, x);
        tree->left = tmp.second;
        UpdDekart(tree);
        UpdDekart(tmp.first);
        return {tmp.first, tree};
    }
    else {
        auto tmp = Split(tree->right, x - GetSz(tree->left) - 1);
        tree->right = tmp.first;
        UpdDekart(tree);
        UpdDekart(tmp.second);
        return {tree, tmp.second};
    }
}

Node* Ins(Node* tree, ll x, ll pos) {
    Node* node = new Node(x);
    auto tmp = Split(tree, pos - 1);
    Node* mrg1 = Merge(node, tmp.second);
}

pair<ll, Node*> GetNum(Node* tree, ll pos) {
    auto tmp1 = Split(tree, pos - 1);
    auto tmp2 = Split(tmp1.second, 1);
    ll ans = (tmp2.first == nullptr ? -1 : tmp2.second->x);
    Node* return_tree = Merge(tmp1.first, Merge(tmp2.first, tmp2.second));
    return {ans, return_tree};
}*/

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    srand(time(NULL));

    ll n, x;
    cin >> n >> x;
    ll limit = (n % 2 ? (n + 1) * (n + 1) / 4 : (n / 2) * (n / 2 + 1));

    ll ans = 0;
    for (int s = n + 1; s <= limit; ++s) {
        for (int i = 2; i * i <= s; ++i) {
            if (i == x || s / i == x || s % i) {
                continue;
            }

            ll r = s - n;
            for (int k = 1; k * k <= r; ++k) {
                if (k == i) {
                    break;
                }
                if (r / k >= s / i || r % k) {
                    continue;
                }
                if (i != s / i) {
                    if (k != r / k) {
                        ans += 2;
                        if (r / k < i && k < s / i) {
                            ans += 2;
                        }
                    }
                    else {
                        ans += 2;
                    }
                }
                else {
                    if (k != r / k) {
                        ans += 2;
                    }
                    else {
                        ans += 1;
                    }
                }
            }
        }
    }

    cout << ans;

    return 0;
}
