#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

struct solver {
    vector<ll> dda;
    void init(int n) {
        dda.assign(n + 2, 0);
    }
    void plus_progression(int l, int r, ll x0, ll d) {
        //cout << "plus " << l << ' ' << r << ' ' << x0 << ' ' << d << endl;
        if (l > r) return;
        ll e = x0 + d * (r - l);
        dda[l] += x0;
        dda[l + 1] += d - x0;
        dda[r + 1] -= e + d;
        dda[r + 2] += e;
    }
    vector<ll> restore() {
        int n = (int)dda.size() - 2;
        vector<ll> da(n + 1);
        da[0] = dda[0];
        for (int i = 1; i <= n; i++) {
            da[i] = da[i - 1] + dda[i];
        }
        vector<ll> a(n);
        a[0] = da[0];
        for (int i = 1; i < n; i++) {
            a[i] = a[i - 1] + da[i];
        }
        return a;
    }
};

int main()
{
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    vector<int> all;
    for (int i = 0; i < n; i++) all.push_back(a[i]);
    sort(all.begin(), all.end());
    for (int i = 0; i < n; i++) {
        a[i] = lower_bound(all.begin(), all.end(), a[i]) - all.begin();
    }
    vector<int> last(n, -1);
    vector<int> pr(n, -1);
    for (int i = 0; i < n; i++) {
        pr[i] = last[a[i]];
        last[a[i]] = i;
    }
    //vector<long long> ans(n + 1);
    solver s;
    s.init(n + 1);
    for (int i = 0; i < n; i++) {
        int p = pr[i];
        int x1 = 0;
        int x2 = i - p;
        int x3 = n - i;
        int x4 = min(n, n - p);
        if (x2 <= x3) {
            s.plus_progression(x1, x2 - 1, 0, 1);
            s.plus_progression(x2, x3 - 1, i - p, 0);
            s.plus_progression(x3, x4, i - p, -1);
        }
        else {
            s.plus_progression(x1, x3 - 1, 0, 1);
            s.plus_progression(x3, x2 - 1, n - i, 0);
            s.plus_progression(x2, x4, n - i, -1);
        }
        /*for (int d = 1; d <= n; d++) {
            int x = min(i, n - d);
            int y = max(p, i - d);
            ans[d] += max(0, x - y);
        }*/
    }
    auto ans = s.restore();
    for (int i = 1; i <= n; i++) {
        cout << ans[i] << ' ';
    }
    cout << endl;
}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
