#include <iostream>
#include <fstream>
#include <vector>
#include <array>
#include <algorithm>
#pragma GCC optimize("Ofast")

using namespace std;

struct tree {
    vector<pair<int, int> > from;
    vector<int> to;
    vector<int> tp;
    vector<int> cur;

    void init(vector<array<int, 3> >& e) {
        int n = (int)e.size() + 1;
        from.assign(2 * n - 1, make_pair(-1, -1));
        to.assign(2 * n - 1, -1);
        tp.assign(2 * n - 1, -1);
        cur.assign(2 * n - 1, -1);
        for (int i = 0; i < n - 1; i++) {
            from[i + n] = { e[i][0], e[i][1] };
            to[e[i][0]] = to[e[i][1]] = i + n;
            tp[i + n] = e[i][2];
        }
    }

    void recalc(int i) {
        int l = from[i].first, r = from[i].second;
        if (tp[i] == 1) {
            if (cur[l] == 0 || cur[r] == 0) cur[i] = 0;
            else if (cur[l] == 1 && cur[r] == 1) cur[i] = 1;
        }
        else {
            if (cur[l] == 0 && cur[r] == 0) cur[i] = 0;
            else if (cur[l] == 1 || cur[r] == 1) cur[i] = 1;
        }
    }

    void update(int i, int val) {
        cur[i] = val;
        i = to[i];
        while (i != -1) {
            int old = cur[i];
            recalc(i);
            if (cur[i] == old) break;
            i = to[i];
        }
    }

    int get() {
        return cur.back();
    }

    void print() {
        for (int i : cur) {
            cout << i << ' ';
        }
        cout << endl;
    }
};

//int apply(vector<int>& a, vector<array<int, 3> >& ops) {
//    int n = (int)a.size();
//    vector<int> cur(2 * n - 1);
//    for (int i = 0; i < 2 * n - 1; i++) {
//        if (i < n) cur[i] = a[i];
//        else if (ops[i - n][2] == 1) cur[i] = cur[ops[i - n][0]] & cur[ops[i - n][1]];
//        else if (ops[i - n][2] == 2) cur[i] = cur[ops[i - n][0]] | cur[ops[i - n][1]];
//    }
//    return cur.back();
//}

int main()
{
    ios::sync_with_stdio(0);
    //ifstream cin("input.txt");
    int n, m, s;
    cin >> n >> m >> s;
    vector<vector<array<int, 3> > > a(m, vector<array<int, 3> >(n - 1));
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n - 1; j++) {
            int ax, bx, op;
            cin >> ax >> bx >> op;
            a[i][j] = { ax - 1, bx - 1, op };
        }
    }
    vector<vector<int> > mat(m, vector<int>(n));
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) cin >> mat[i][j];
    }
    vector<int> ans(n, -1);
    vector<tree> cur(m);
    for (int i = 0; i < m; i++) {
        cur[i].init(a[i]);
    }
    for (int pos = 0; pos < n; pos++) {
        /*cout << "pos = " << pos << endl;
        for (int i = 0; i < m; i++) {
            cur[i].print();
        }*/
        vector<array<int, 2> > val(m);
        for (int i = 0; i < m; i++) {
            for (int z = 0; z < 2; z++) {
                int res = cur[i].get();
                if (res == -1) res = z;
                val[i][z] = res;
                /*vector<int> cur(n);
                for (int j = 0; j < n; j++) {
                    if (j < pos) cur[j] = mat[i][j] < ans[j];
                    else if (j > pos) cur[j] = z;
                    else cur[j] = z;
                }
                val[i][z] = apply(cur, a[i]);*/
            }
        }
        int def = 0;
        for (int i = 0; i < m; i++) {
            if (val[i][0] == 1) def++;
        }
        if (def == s) {
            ans[pos] = 0;
            for (int i = 0; i < m; i++) {
                cur[i].update(pos, 0);
            }
            continue;
        }
        vector<int> ord(m);
        for (int i = 0; i < m; i++) {
            ord[mat[i][pos]] = i;
        }
        for (int ind = 0; ind < m; ind++) {
            int i = ord[ind];
            if (val[i][0] == 0 && val[i][1] == 1) {
                def++;
            }
            if (def == s) {
                ans[pos] = ind + 1;
                for (int i = 0; i < m; i++) {
                    cur[i].update(pos, mat[i][pos] < ans[pos]);
                }
                break;
            }
        }
    }
    for (int i = 0; i < n; i++) {
        cout << ans[i] << ' ';
    }
    cout << endl;
}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
