#include <iostream>
#include <fstream>
#include <vector>
#include <array>
#include <algorithm>
#pragma GCC optimize("Ofast")

using namespace std;
using ll = long long;

const int c = 4;

struct stree {
    vector<array<array<ll, c>, c> > t;
    vector<pair<int, int> > lr;
    vector<int> lens;
    vector<ll> full;
    //int sz = 0;

    void recalc(int v) {
        int len1 = lens[2 * v], len2 = lens[2 * v + 1];
        lens[v] = len1 + len2;
        for (int c1 = 0; c1 < c; c1++) for (int c2 = 0; c2 < c; c2++) t[v][c1][c2] = 0;
        for (int c1 = 0; c1 < min(c, len1); c1++) {
            for (int c2 = 0; c2 < min(c, len2); c2++) {
                for (int cx1 = 0; cx1 < c; cx1++) {
                    for (int cx2 = 0; cx2 < c; cx2++) {
                        if (cx1 + cx2 >= c) break;
                        t[v][c1][c2] = max(t[v][c1][c2], t[2 * v][c1][cx1] + t[2 * v + 1][cx2][c2]);
                    }
                }
            }
        }
        for (int c1 = 0; c1 < c; c1++) {
            for (int c2 = 0; c2 < c; c2++) {
                /*if (len1 + c1 >= c) continue;
                if (c2 + len2 >= c) continue;*/
                if (c1 + c2 < len2 && len1 + c1 < c) {
                    t[v][len1 + c1][c2] = max(t[v][len1 + c1][c2], full[2 * v] + t[2 * v + 1][c1][c2]);
                }
                if (c1 + c2 < len1 && len2 + c2 < c) {
                    t[v][c1][c2 + len2] = max(t[v][c1][c2 + len2], t[2 * v][c1][c2] + full[2 * v + 1]);
                }
            }
        }
        if (len1 + len2 < c) {
            full[v] = full[2 * v] + full[2 * v + 1];
        }
    }
    //void build_rec(int v, int vl, int vr, vector<ll>& a) {
    //    //lr[v] = { vl, vr };
    //    if (vr - vl == 1) {
    //        //t[v][1][1] = a[v - (int)t.size() / 2];
    //        full[v] = a[v - (int)t.size() / 2];
    //        return;
    //    }
    //    int vm = (vl + vr) / 2;
    //    build_rec(2 * v, vl, vm, a);
    //    build_rec(2 * v + 1, vm, vr, a);
    //    recalc(v);
    //}
    void print() {
        for (int i = 1; i < (int)t.size(); i++) {
            cout << "v = " << i << endl;
            for (int c1 = 0; c1 < c; c1++) {
                for (int c2 = 0; c2 < c; c2++) {
                    cout << t[i][c1][c2] << ' ';
                }
                cout << endl;
            }
            cout << endl;
        }
    }

    void init(vector<ll>& a) {
        int n = (int)a.size();
        int sz = n;
        int _n = 1;
        while (_n < n) _n *= 2;
        n = _n;
        a.resize(n);
        t.resize(2 * n), full.resize(2 * n), lens.resize(2 * n);
        for (int i = 2 * n - 1; i >= 1; i--) {
            if (i >= n) {
                full[i] = a[i - n];
                lens[i] = (i - n < sz);
            }
            else {
                recalc(i);
            }
        }
    }
    void update(int i, ll x) {
        int v = i + (int)t.size() / 2;
        full[v] = x;
        while (v > 1) {
            v /= 2;
            recalc(v);
        }
    }
    ll get() {
        ll mx = 0;
        for (int c1 = 0; c1 < c; c1++) {
            for (int c2 = 0; c2 < c; c2++) {
                if (c1 + c2 >= c) continue;
                //cout << c1 << ' ' << c2 << ' ' << t[1][c1][c2] << endl;
                mx = max(mx, t[1][c1][c2]);
            }
        }
        return mx;
    }
};

int main()
{
    ios::sync_with_stdio(0);
    int n;
    cin >> n;
    stree t;
    vector<ll> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    t.init(a);
    //t.print();
    cout << t.get() << endl;
    int q;
    cin >> q;
    for (int z = 0; z < q; z++) {
        int pos;
        ll val;
        cin >> pos >> val;
        pos--;
        t.update(pos, val);
        //t.print();
        cout << t.get() << '\n';
    }
}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
