#pragma region Include
#include<iostream>
#include<vector>
using namespace std;
#pragma endregion
#pragma region IO
template<typename T>
istream& operator >> (istream& in, vector<T>& v)
{
	for (int i = 0; i < v.size(); i++)
		in >> v[i];
	return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> v)
{
	for (int i = 0; i < v.size(); i++)
		out << v[i] << ' ';

	if (!v.empty())
		out << '\n';

	return out;
}

template<typename T>
ostream& operator << (ostream& out, vector<vector<T>> v)
{
	for (int i = 0; i < v.size(); i++)
	{
		for (int j = 0; j < v[i].size(); j++)
			out << v[i][j] << ' ';

		out << '\n';
	}

	return out;
}
#pragma endregion

pair<long long, long long> solve_a(long long n)
{
	long long pow2 = 0;
	if (n == 0)
		return { 1, 1 };

	while (!(n & 1))
	{
		++pow2;
		n >>= 1;
	}

	if ((pow2 & 1) || n == 1)
		return { -1, -1 };
	else
		return { ((n + 1) / 2) * (1ll << (pow2 / 2)), ((n - 1) / 2) * (1ll << (pow2 / 2)) };
}

pair<long long, long long> solve_b(long long n)
{
	for (long long i = 1; i < 2e4; i++)
		for (long long j = i; j < 2e4; j++)
			if (j * j - i * i == n)
				return { j, i };
	return { -1, -1 };
}

int main()
{

	long long n;
	while(cin >> n)
	{
		long long pow2 = 0;
		if (n == 0)
		{
			cout << "Yes\n1 1\n";
			continue;
		}
		
		while (!(n & 1))
		{
			++pow2;
			n >>= 1;
		}

		if ((pow2 & 1) || n == 1)
		{
			bool flag = true;
			for (long long i1 = 0; i1 <= pow2; i1++)
			{
				long long d1 = i1;
				long long d2 = pow2 - i1;
				d1 = 1ll << d1;
				d2 = 1ll << d2;
				if (((d1 + d2) & 1) || d2 - d1 < 0 || ((d2 - d1) & 1) || d2 == d1)
					continue;
				flag = false;
				cout << "Yes\n" << (d1 + d2) / 2 << ' ' << (d2 - d1) / 2 << '\n';
				break;
			}

			if (flag)
				cout << "No\n";
		}
		else
		{
			cout << "Yes\n" << ((n + 1) / 2) * (1ll << (pow2 / 2)) << ' ' << ((n - 1) / 2) * (1ll << (pow2 / 2)) << '\n';
		}
	}
}