#pragma region Include
#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<algorithm>
#include<assert.h>
using namespace std;
#pragma endregion
#pragma region IO
template<typename T>
istream& operator >> (istream& in, vector<T>& v)
{
	for (int i = 0; i < v.size(); i++)
		in >> v[i];
	return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> v)
{
	for (int i = 0; i < v.size(); i++)
		out << v[i] << ' ';

	if (!v.empty())
		out << '\n';

	return out;
}

template<typename T>
ostream& operator << (ostream& out, vector<vector<T>> v)
{
	for (int i = 0; i < v.size(); i++)
	{
		for (int j = 0; j < v[i].size(); j++)
			out << v[i][j] << ' ';

		out << '\n';
	}

	return out;
}
#pragma endregion

const long double EPS = 1e-8;
long long check_n = 0;
void ans(long long a, long long b)
{
	if (!(a * a - b * b == check_n))
		cout << "No\n";
	else
		cout << "Yes\n" << a << ' ' << b << '\n';
}

long long get_odd(long long a)
{
	return 2 * a + 1;
}

bool is_sq(long long n)
{
	long long sq = sqrt((long double)n) + EPS;
	if (sq * sq == n)
		return true;
	return false;
}

bool check_ans(long long a, long long b)
{
	if (a * a - b * b == check_n)
	{
		ans(a, b);
		return true;
	}

	return false;
}

int main()
{
	//long long x;
	//cin >> x;
	//for (long long i = 1; ; i += 2)
	//{
	//	cout << (i * i) % x << '\n';
	//	if (i != 1 && (i * i) % x == 1)
	//	{
	//		cout << "cycle: " << i;
	//		break;
	//	}
	//}

	long long n;
	while (cin >> n)
	{
		check_n = n;
		if (n == 0)
		{
			ans(1, 1);
			continue;
		}

		if (n == 1)
		{
			cout << "No\n";
			continue;
		}

		long long pow2 = 0;

		while (!(n & 1))
		{
			++pow2;
			n >>= 1;
		}

		if (pow2 % 2 == 0)
		{
			if (n > 1)
			{
				ans((1ll << (pow2 / 2)) * (n + 1) / 2, (1ll << (pow2 / 2)) * (n - 1) / 2);
			}
			else
			{
				bool flag = true;
				for (int i = 0; i <= pow2; i++)
				{
					long long d1 = 1ll << i, d2 = 1ll << (pow2 - i);
					if ((d1 + d2) % 2 == 0 && d2 - d1 > 0)
					{
						ans((d1 + d2) / 2, (d2 - d1) / 2);
						flag = false;
						break;
					}
				}
				if (flag)
					cout << "No\n";
			}
		}
		else
		{
			if (n == 1)
			{
				bool flag = true;
				for (int i = 0; i <= pow2; i++)
				{
					long long d1 = 1ll << i, d2 = 1ll << (pow2 - i);
					if ((d1 + d2) % 2 == 0 && d2 - d1 > 0)
					{
						ans((d1 + d2) / 2, (d2 - d1) / 2);
						flag = false;
						break;
					}
				}
				if (flag)
					cout << "No\n";
			}
			else
			{
				bool flag = true;
				for (long long j = 0; j <= pow2; j++)
				{
					long long j2 = pow2 - j;
					if (n - 2 * j > 0)
					{
						long long sq_1 = n - 2 * j;
						long long sq_2 = n + 2 * j2;
						if (check_ans(sq_2, sq_1))
						{
							flag = false;
							break;
						}

						sq_2 = n - 2 * j2;
						if (sq_2 > 0 && check_ans(max(sq_1, sq_2), min(sq_1, sq_2)))
						{
							flag = false;
							break;
						}
					}

					long long sq_1 = n + 2 * j;
					long long sq_2 = n + 2 * j2;
					if (check_ans(max(sq_1, sq_2), min(sq_1, sq_2)))
					{
						flag = false;
						break;
					}

					sq_2 = n - 2 * j2;

					if (sq_2 > 0 && check_ans(sq_1, sq_2))
					{
						flag = false;
						break;
					}
				}

				if (flag)
					cout << "No\n";
			}
		}
	}
}