#pragma region Include
#include<iostream>
#include<vector>
#include<assert.h>
using namespace std;
#pragma endregion
#pragma region IO
template<typename T>
istream& operator >> (istream& in, vector<T>& v)
{
	for (int i = 0; i < v.size(); i++)
		in >> v[i];
	return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> v)
{
	for (int i = 0; i < v.size(); i++)
		out << v[i] << ' ';

	if (!v.empty())
		out << '\n';

	return out;
}

template<typename T>
ostream& operator << (ostream& out, vector<vector<T>> v)
{
	for (int i = 0; i < v.size(); i++)
	{
		for (int j = 0; j < v[i].size(); j++)
			out << v[i][j] << ' ';

		out << '\n';
	}

	return out;
}
#pragma endregion

const long double EPS = 1e-6, EPS_ANS = 1e-5, llINF = 1e18;

int main()
{
	int n;
	cin >> n;

	vector<long long> len(n), vel(n);
	cin >> vel >> len;

	int m;
	cin >> m;
	vector<long long> a(m - 1), f(m);
	cin >> a >> f;
	a.insert(a.begin(), 0);
	a.push_back(llINF);
	f.insert(f.begin(), 0);

	int q;
	cin >> q;

	while (q--)
	{
		int qr_a, qr_b;
		cin >> qr_a >> qr_b;
		long long t_spent = qr_b - qr_a;

		long double l = 0, r;
		if (m > 1)
			r = a.back() + 1;
		else
			r = 1;

		for (int bin_it_cnt = 0; bin_it_cnt < 100; bin_it_cnt++)
		{
			long double mid = (l + r) / 2;
			long double t = 0;
			for (int i = 0; i < n; i++)
				t += (long double)len[i] / (vel[i] + mid);

			if (t + EPS < t_spent)
				r = mid;
			else
				l = mid;
		}

		int ans_l = 0, ans_r = m, ans_m;
		while (ans_l + 1 < ans_r)
		{
			ans_m = (ans_l + ans_r) / 2;

			if (a[ans_m] + EPS_ANS > l)
				ans_r = ans_m;
			else
				ans_l = ans_m;
		}

		if (l < EPS_ANS)
			cout << 0 << '\n';
		else
			cout << f[ans_r] << '\n';
	}
}