#pragma region Include
#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<assert.h>
using namespace std;
#pragma endregion
#pragma region IO
template<typename T>
istream& operator >> (istream& in, vector<T>& v)
{
	for (int i = 0; i < v.size(); i++)
		in >> v[i];
	return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> v)
{
	for (int i = 0; i < v.size(); i++)
		out << v[i] << ' ';

	if (!v.empty())
		out << '\n';

	return out;
}

template<typename T>
ostream& operator << (ostream& out, vector<vector<T>> v)
{
	for (int i = 0; i < v.size(); i++)
	{
		for (int j = 0; j < v[i].size(); j++)
			out << v[i][j] << ' ';

		out << '\n';
	}

	return out;
}
#pragma endregion

int main()
{
	int n;
	cin >> n;
	map<int, int> pos;
	vector<long long> cnt(n + 1);
	vector<int> v(n);

	for (int i = 0, x; i < n; i++)
	{
		cin >> x;
		v[i] = x;
		if (pos.count(x))
			++cnt[i - pos[x] - 1];
		else
			++cnt[i];
		pos[x] = i;
	}

	vector<int> suf_dif(n + 1);

	set<int> st_tmp;
	for (int i = n - 1; i >= 0; i--)
	{
		st_tmp.insert(v[i]);
		suf_dif[n - i] = st_tmp.size();
	}

	long long cur_ans = 0;

	for (int i = n - 1; i >= 0; i--)
		cnt[i] += cnt[i + 1];

	for (int i = 1; i <= n; i++)
	{
		cur_ans += cnt[i - 1];
		cur_ans -= suf_dif[i - 1];
		cout << cur_ans << ' ';
	}
}