#pragma region Include
#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<algorithm>
#include<cmath>
#include<assert.h>
using namespace std;
#pragma endregion
#pragma region IO
template<typename T>
istream& operator >> (istream& in, vector<T>& v)
{
	for (int i = 0; i < v.size(); i++)
		in >> v[i];
	return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> v)
{
	for (int i = 0; i < v.size(); i++)
		out << v[i] << ' ';

	if (!v.empty())
		out << '\n';

	return out;
}

template<typename T>
ostream& operator << (ostream& out, vector<vector<T>> v)
{
	for (int i = 0; i < v.size(); i++)
	{
		for (int j = 0; j < v[i].size(); j++)
			out << v[i][j] << ' ';

		out << '\n';
	}

	return out;
}
#pragma endregion

const long long llINF = 2e18;

int main()
{
	int n;
	cin >> n;

	vector<long long> a(n);
	cin >> a;

	vector<pair<long long, long long>> diff_ord(n - 1);

	for (int i = 0; i + 1 < n; i++)
		diff_ord[i] = { a[i + 1] - a[i], a[i] };

	diff_ord.push_back({ llINF, a.back() });
	sort(diff_ord.begin(), diff_ord.end());
	
	vector<long long> suf_min(n);

	suf_min.back() = diff_ord.back().second;

	for (int i = n - 2; i >= 0; i--)
		suf_min[i] = min(suf_min[i + 1], diff_ord[i].second);

	vector<long long> dp;
	dp.push_back(0);

	for (int i = 1; ; i++)
	{
		pair<long long, long long> p = { dp[i - 1] + 1, 0ll };
		int ind = upper_bound(diff_ord.begin(), diff_ord.end(), p) - diff_ord.begin();
		if (ind == n - 1)
			break;
		dp.push_back(dp[i - 1] + suf_min[ind]);
	}

	int q;
	cin >> q;
	long long b;
	while (cin >> b)
	{
		int ind = upper_bound(dp.begin(), dp.end(), b) - dp.begin();
		if (ind == n)
			cout << dp.back() + ((b - dp.back()) / a.back()) * a.back() << ' ' << n + (b - dp.back()) / a.back() << '\n';
		else
			cout << dp[ind - 1] << ' ' << ind - 1 << '\n';
	}
}