#pragma region Include
#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<algorithm>
#include<cmath>
#include<assert.h>
using namespace std;
#pragma endregion
#pragma region IO
template<typename T>
istream& operator >> (istream& in, vector<T>& v)
{
	for (int i = 0; i < v.size(); i++)
		in >> v[i];
	return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> v)
{
	for (int i = 0; i < v.size(); i++)
		out << v[i] << ' ';

	if (!v.empty())
		out << '\n';

	return out;
}

template<typename T>
ostream& operator << (ostream& out, vector<vector<T>> v)
{
	for (int i = 0; i < v.size(); i++)
	{
		for (int j = 0; j < v[i].size(); j++)
			out << v[i][j] << ' ';

		out << '\n';
	}

	return out;
}
#pragma endregion

const long long llINF = 2e18;

int main()
{
	int n;
	cin >> n;

	vector<long long> a(n);
	cin >> a;

	vector<pair<long long, long long>> diff_ord(n - 1);

	for (int i = 0; i + 1 < n; i++)
		diff_ord[i] = { a[i + 1] - a[i], a[i] };

	diff_ord.push_back({ llINF, a.back() });
	sort(diff_ord.begin(), diff_ord.end());
	
	vector<long long> suf_min(n);

	suf_min.back() = diff_ord.back().second;

	for (int i = n - 2; i >= 0; i--)
		suf_min[i] = min(suf_min[i + 1], diff_ord[i].second);

	vector<pair<long long, int>> dp;
	vector<long long> dp_cnt;
	dp.push_back({ 0, -1 });
	dp_cnt.push_back(0);

	for (int i = 1; ; i++)
	{
		pair<long long, long long> p = { dp[i - 1].first + 1, 0ll };
		int ind = upper_bound(diff_ord.begin(), diff_ord.end(), p) - diff_ord.begin();
		dp.push_back({ dp[i - 1].first + suf_min[ind] * (diff_ord[ind].first / suf_min[ind]), ind });
		dp_cnt.push_back(dp_cnt.back() + diff_ord[ind].first / suf_min[ind]);
		if (ind == n - 1)
			break;
	}

	dp.back().first = llINF;

	int q;
	cin >> q;
	long long b;
	while (cin >> b)
	{
		pair<long long, int> p = { b, 0 };
		auto ind = lower_bound(dp.begin(), dp.end(), p) - dp.begin();
		long long ans = dp_cnt[ind - 1], ans_sum = 0;
		b -= dp[ind - 1].first;
		ans_sum += dp[ind - 1].first;
		assert(b >= 0);

		ans += b / suf_min[dp[ind].second];
		ans_sum += (b / suf_min[dp[ind].second]) * suf_min[dp[ind].second];

		cout << ans_sum << ' ' << ans << '\n';

		while (ans_sum > 0)
		{
			ans_sum -= *--upper_bound(a.begin(), a.end(), ans_sum);
			--ans;
		}

		assert(ans == 0);
	}
}