#pragma region Include
#include<iostream>
#include<fstream>
#include<vector>
#include<map>
#include<set>
#include<algorithm>
#include<cmath>
#include<assert.h>
#include<random>
using namespace std;
#pragma endregion
#pragma region IO
template<typename T>
istream& operator >> (istream& in, vector<T>& v)
{
	for (int i = 0; i < v.size(); i++)
		in >> v[i];
	return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> v)
{
	for (int i = 0; i < v.size(); i++)
		out << v[i] << ' ';

	if (!v.empty())
		out << '\n';

	return out;
}

template<typename T>
ostream& operator << (ostream& out, vector<vector<T>> v)
{
	for (int i = 0; i < v.size(); i++)
	{
		for (int j = 0; j < v[i].size(); j++)
			out << v[i][j] << ' ';

		out << '\n';
	}

	return out;
}
#pragma endregion

const long long llINF = 2e18;

int main()
{
	int n;
	cin >> n;

	vector<long long> a(n);
	cin >> a;

	vector<long long> dp(n + 1), dp_cnt(n + 1);

	for (int i = 1; i < n; i++)
	{
		long long x = a[i] - dp[i - 1] - 1;
		dp_cnt[i] = x / a[i - 1];
		dp[i] = dp[i - 1] + x - x % a[i - 1];
	}

	dp[n] = llINF;
	dp_cnt[n] = llINF;

	for (int i = 1; i < n; i++)
		dp_cnt[i] += dp_cnt[i - 1];

	int q;
	long long b;
	cin >> q;

	while (cin >> b)
	{
		int ind = upper_bound(dp.begin(), dp.end(), b) - dp.begin();
		long long ans_sum = 0, ans = 0;
		ans_sum = dp[ind - 1];
		ans = dp_cnt[ind - 1];
		b -= ans_sum;

		ans += b / a[ind - 1];
		ans_sum += b - b % a[ind - 1];
		cout << ans_sum << ' ' << ans << '\n';
	}
}