#pragma region Include
#include<iostream>
#include<fstream>
#include<vector>
#include<map>
#include<set>
#include<algorithm>
#include<cmath>
#include<assert.h>
#include<random>
using namespace std;
#pragma endregion
#pragma region IO
template<typename T>
istream& operator >> (istream& in, vector<T>& v)
{
	for (int i = 0; i < v.size(); i++)
		in >> v[i];
	return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> v)
{
	for (int i = 0; i < v.size(); i++)
		out << v[i] << ' ';

	if (!v.empty())
		out << '\n';

	return out;
}

template<typename T>
ostream& operator << (ostream& out, vector<vector<T>> v)
{
	for (int i = 0; i < v.size(); i++)
	{
		for (int j = 0; j < v[i].size(); j++)
			out << v[i][j] << ' ';

		out << '\n';
	}

	return out;
}
#pragma endregion

long long calc_dp(vector<long long> const& a)
{
	vector<vector<long long>> dp(a.size(), vector<long long>(4, -1));
	dp[0][0] = 0;

	for (int i = 1; i < a.size(); i++)
	{
		dp[i][0] = *max_element(dp[i - 1].begin(), dp[i - 1].end());
		for (int j = 1; j < 4; j++)
			if (dp[i - 1][j - 1] >= 0)
				dp[i][j] = dp[i - 1][j - 1] + a[i];
	}

	return *max_element(dp.back().begin(), dp.back().end());
}

long long calc_dp_rt(vector<long long>& a)
{
	vector<long long> ans;
	for (int i = 0; i < 4; i++)
	{
		ans.push_back(calc_dp(a));
		rotate(a.begin(), a.begin() + 1, a.end());
	}

	rotate(a.begin(), a.end() - 4, a.end());
	return *max_element(ans.begin(), ans.end());
}

int main()
{
	int n;
	cin >> n;

	vector<long long> a(n);
	cin >> a;

	cout << calc_dp_rt(a) << '\n';
	int q, pos, n_x;
	cin >> q;

	while (cin >> pos >> n_x)
	{
		a[pos - 1] = n_x;
		cout << calc_dp_rt(a) << '\n';
	}
}