#include<iostream>
#include<iomanip>
#include<vector>
using namespace std;
#define int long long
const int K = 400;
vector<vector<vector<int>>> D(K + 2, vector<vector<int>> (4, vector<int> (4)));
const int maxn = 40000;
vector<int> dp(maxn);
vector<int> mx(maxn);
int merge(int n) {
    vector<vector<int>> an(4, vector<int> (4, 0));
    vector<vector<int>> an2(4, vector<int> (4, 0));
    for(int i = 0; i < n; ++i) {
        for(int p1 = 0; p1 < 4; ++p1) {
            for(int p2 = 0; p2 < 4; ++p2) {
                an2[p1][p2] = 0;
            }
        }
        for(int p1 = 0; p1 < 4; ++p1) {
            for(int p2 = 0; p2 < 4; ++p2) {
                for(int q1 = 0; q1 < 4; ++q1) {
                    if(p2 + q1 > 3) {
                        continue;
                    }
                    for(int q2 = 0; q2 < 4; ++q2) {
                        an2[p1][q2] = max(an2[p1][q2], an[p1][p2] + D[i][q1][q2]);
                    }
                }
            }
        }
        for(int p1 = 0; p1 < 4; ++p1) {
            for(int p2 = 0; p2 < 4; ++p2) {
                an[p1][p2] = an2[p1][p2];
            }
        }
    }
    int ans = 0;
    for(int p1 = 0; p1 < 4; ++p1) {
        for(int p2 = 0; p2 < 4; ++p2) {
            if(p1 + p2 > 3) {
                continue;
            }
            ans = max(ans, an[p1][p2]);
        }
    }
    return ans;
}
void count(int pos, vector<int> &a) {
    int n = a.size();
    for(int p2 = 0; p2 <= 3; ++p2) {
        int l = 0;
        int r = n - p2;
        for(int i = l + 1; i < r; ++i) {
            dp[i] = 0;
            mx[i] = 0;
        }
        for(int i = r - 1; i >= l + 1; --i) {
            int sum = 0;
            for(int k = 0; k < 3 && i + k < r; ++k) {
                sum += a[i + k];
                if(i + k + 2 >= r) {
                    dp[i] = max(dp[i], sum);
                }
                else {
                    dp[i] = max(dp[i], sum + mx[i + k + 2]);
                }
            }
            if(i == r - 1) {
                mx[i] = dp[i];
            }
            else {
                mx[i] = max(mx[i + 1], dp[i]);
            }
        }
        for(int p1 = 0; p1 < 4; ++p1) {
            D[pos][p1][p2] = mx[p1 + 1];
            for(int i = 0; i < p1; ++i) {
                D[pos][p1][p2] += a[i];
            }
            for(int i = 0; i < p2; ++i) {
                D[pos][p1][p2] += a[n - i - 1];
            }
        }
    }
}
int f(vector<int> &a) {
    int n = a.size();
    for(int i = 0; i < n; ++i) {
        dp[i] = 0;
        mx[i] = 0;
    }
    for(int i = n - 1; i >= 1; --i) {
        int sum = 0;
        for(int k = 0; k <= 2  && i + k < n; ++k) {
            sum += a[i + k];
            if(i + k + 2 >= n) {
                dp[i] = max(dp[i], sum);
            }
            else {
                dp[i] = max(dp[i], sum + mx[i + k + 2]);
            }
        }
        if(i == n - 1) {
            mx[i] = dp[i];
        }
        else {
            mx[i] = max(mx[i + 1], dp[i]);
        }
    }
    int ans = 0;
    for(int i = 0; i < n; ++i) {
        ans = max(ans, dp[i]);
    }
    return ans;
}
signed main() {
    int n;
    cin >> n;
    vector<int> a(n);
    for(int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<int> z1(n), z2(n), z3(n);
    for(int i = 0; i < n; ++i) {
        z1[i] = a[(i + 1)%n];
        z2[i] = a[(i + 2)%n];
        z3[i] = a[(i + 3)%n];
    }
    if(n <= 3) {
        int sum = 0;
        for(int i = 0; i < n; ++i) {
            sum += a[i];
        }
        cout << sum << "\n";
        int q;
        cin >> q;
        for(int i = 0; i < q; ++i) {
            int pos, p;
            cin >> pos >> p;
            --pos;
            sum -= a[pos];
            sum += p;
            a[pos] = p;
            cout << sum << "\n";
        }
        return 0;
    }
    int q;
    cin >> q;
    if(n <= 1000 || q <= 1000) {
        cout << max(max(f(a), f(z1)), max(f(z2), f(z3))) << "\n";
        for(int i = 0; i < q; ++i) {
            int pos, p;
            cin >> pos >> p;
            --pos;
            a[pos] = p;
            z1[(pos - 1 + n)%n] = p;
            z2[(pos - 2 + n)%n] = p;
            z3[(pos - 3 + n)%n] = p;
            cout << max(max(f(a), f(z1)), max(f(z2), f(z3))) << "\n";
        }
        return 0;
    }
    vector<vector<int>> sp(n/K + 1);
    int c = 0;
    for(int i = 0; i < n; i += K) {
        if(i + 2*K > n) {
            for(int j = i; j < n; ++j) {
                sp[c].push_back(a[j]);
            }
            i = 100000;
        }
        else {
            for(int j = i; j < i + K; ++j) {
                sp[c].push_back(a[j]);
            }
        }
        ++c;
    }
    for(int i = 0; i < c; ++i) {
        count(i, sp[i]);
    }
    cout << merge(c) << "\n";
    for(int _ = 0; _ < q; ++_) {
        int pos, p;
        cin >> pos >> p;
        --pos;
        for(int i = 0; i < c; ++i) {
            if(pos < sp[i].size()) {
                sp[i][pos] = p;
                count(i, sp[i]);
                i = 1000000;
                break;
            }
            else {
                pos -= sp[i].size();
            }
        }
        cout << merge(c);
    }
    return 0;
}
