#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vector<ld> speeds(n);
    for (int i = 0; i < n; i++)
        cin >> speeds[i];

    vector<ld> lengths(n);
    for (int i = 0; i < n; i++)
        cin >> lengths[i];

    int m;
    cin >> m;

    vector<ld> limits(m);
    limits[0] = 0;
    for (int i = 0; i < m - 1; i++)
        cin >> limits[i + 1];

    vector<ll> fines(m);
    for (int i = 0; i < m; i++)
        cin >> fines[i];

    int q;
    cin >> q;

    vector<ld> times(q);
    for (int i = 0; i < q; i++)
    {
        ll x, y;
        cin >> x >> y;
        times[i] = y - x;
    }

    for (int i = 0; i < q; i++)
    {
        ld l = 0;
        ld r = 1e12;
        for (int iter = 0; iter < 77; iter++)
        {
            ld m = (l + r) / 2.0;

            ld time = 0;
            for (int j = 0; j < n; j++)
                time += lengths[j] / (speeds[j] + m);

            if (time > times[i] + 1e-6)
                l = m;
            else
                r = m;
        }

        if (l <= 1e-6)
            cout << "0" << endl;
        else
        {
            int x = upper_bound(limits.begin(), limits.end(), l) - limits.begin() - 1;
            cout << fines[x] << endl;
        }

    }

    return 0;
}