#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

struct op
{
    int a, b, op;
};

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m, s;
    cin >> n >> m >> s;

    vector<vector<op>> ops(m, vector<op>(n - 1));
    for (int i = 0; i < m; i++)
    {
        for (int j = 0; j < n - 1; j++)
        {
            cin >> ops[i][j].a >> ops[i][j].b >> ops[i][j].op;
            ops[i][j].a--;
            ops[i][j].b--;
        }
    }

    vector<vector<int>> matrix(m, vector<int>(n));
    for (int i = 0; i < m; i++)
        for (int j = 0; j < n; j++)
            cin >> matrix[i][j];

    int l = -1;
    int r = m * n + 1;
    while (r - l > 1)
    {
        int M = (l + r) / 2;

        vector<int> limits(n, 0);
        for (int i = 0; i < M / m; i++)
            limits[i] = m;
        if (M != m * n)
            limits[M / m] = M % m;

        int cnt = 0;
        for (int i = 0; i < m; i++)
        {
            vector<bool> program(2 * n - 1, false);
            for (int j = 0; j < n; j++)
                program[j] = matrix[i][j] < limits[j];
            for (int j = n; j < 2 * n - 1; j++)
            {
                if (ops[i][j - n].op == 1)
                    program[j] = program[ops[i][j - n].a] && program[ops[i][j - n].b];
                else
                    program[j] = program[ops[i][j - n].a] || program[ops[i][j - n].b];
            }

            if (program[2 * n - 2])
                cnt++;
        }

        if (cnt >= s)
            r = M;
        else
            l = M;
    }

    int ans = l + 1;
    vector<int> limits(n, 0);
    for (int i = 0; i < ans / m; i++)
        limits[i] = m;
    if (ans != m * n)
        limits[ans / m] = ans % m;

    for (int x : limits)
        cout << x << " ";

    return 0;
}