#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>
#include <cstring>
#include <random>
#include <cstdlib>
#include <queue>
#include <deque>

#ifdef __LOCAL
#define DBG(X) cout << #X << "=" << (X) << '\n';
#define SAY(X) cout << (X) << '\n';
#else
#define DBG(X) 42
#define SAY(X) 43
#endif

using namespace std;
using ll = long long int;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

void fast_IO() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}

template<typename T>
ostream& operator<<(ostream& os, const vector<T>& vec) {
	for(auto& el: vec) os << el << ' ';
	return os;
}

template<typename T, typename S>
ostream& operator<<(ostream& os, const pair<S, T>& pr) {
	os << '[' << pr.first << ' ' << pr.second << ']';
	return os;
}

void solve() {
	ll n; cin >> n;
	if(n <= 10) {
		for(ll i = 1; i <= 1000; ++i) {
			for(ll j = 1; j <= 1000; ++j) {
				if(n == i * i - j * j) {
					cout << "Yes\n";
					cout << i << ' ' << j << '\n';
					return;
				}
			}
		}

		cout << "No\n";
		return;
	}

	ll d;
	if(n & 1) {
		d = 1;
	} else {
		d = 2;
	}

	ll d2 = n / d;
	if((d+d2)&1) {
		cout << "No\n";
		return;
	} else {
		ll x = (d + d2) / 2;
		ll y = (d2 - d) / 2;

		cout << "Yes\n";
		cout << x << ' ' << y << '\n';
	}
}

int main() {
	fast_IO();
	solve();

	return 0;
}