#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>
#include <cstring>
#include <random>
#include <cstdlib>
#include <queue>
#include <deque>

#ifdef __LOCAL
#define DBG(X) cout << #X << "=" << (X) << '\n';
#define SAY(X) cout << (X) << '\n';
#else
#define DBG(X) 42
#define SAY(X) 43
#endif

using namespace std;
using ll = long long int;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
const int NIL = -1;

void fast_IO() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}

template<typename T>
ostream& operator<<(ostream& os, const vector<T>& vec) {
	for(auto& el: vec) os << el << ' ';
	return os;
}

template<typename T, typename S>
ostream& operator<<(ostream& os, const pair<S, T>& pr) {
	os << '[' << pr.first << ' ' << pr.second << ']';
	return os;
}

const int MAXN = (int)1e5 + 7;
const double EPS = 2e-5;
ll v[MAXN], L[MAXN], a[MAXN], f[MAXN];
int n, m, q;

int check(int pos, ll tau) {
	if(pos == m - 1) return 1;
	ll x = (pos == NIL ? 0. : a[pos]);
	double mintime = 0.;
	for(int i = 0; i < n; ++i) {
		mintime += ((double)L[i]) / ((double)(v[i] + x));
	}

	return mintime <= (double)tau + EPS;
}

void solve() {
	cin >> n;
	for(int i = 0; i < n; ++i) cin >> v[i];
	for(int i = 0; i < n; ++i) cin >> L[i];
	cin >> m;
	for(int i = 0; i < m - 1; ++i) cin >> a[i];
	for(int i = 0; i < m; ++i) cin >> f[i];
	cin >> q;
	while(q--) {
		ll s, t; cin >> s >> t;
		ll tau = t - s;
		if(check(NIL, tau)) {
			cout << "0\n";
			continue;
		}

		int low = NIL, high = m - 1;
		while(high - low > 1) {
			int mid = (low+high)/2;
			if(check(mid, tau)) {
				high = mid;
			} else {
				low = mid;
			}
		}

		cout << f[high] << '\n';
	}
}

int main() {
	fast_IO();
	solve();

	return 0;
}