
#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>
#include <cstring>
#include <random>
#include <cstdlib>
#include <queue>
#include <deque>

#ifdef __LOCAL
#define DBG(X) cout << #X << "=" << (X) << '\n';
#define SAY(X) cout << (X) << '\n';
#else
#define DBG(X) 42
#define SAY(X) 43
#endif

using namespace std;
using ll = long long int;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

void fast_IO() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}

template<typename T>
ostream& operator<<(ostream& os, const vector<T>& vec) {
	for(auto& el: vec) os << el << ' ';
	return os;
}

template<typename T, typename S>
ostream& operator<<(ostream& os, const pair<S, T>& pr) {
	os << '[' << pr.first << ' ' << pr.second << ']';
	return os;
}

const int MAXN = (int)2e5 + 7;
int a[MAXN], n;
int nxt[MAXN], lst[MAXN], S[MAXN];
vector<int> ord;

void solve() {
	cin >> n;
	ord.resize(n);
	for(int i = 0; i < n; ++i) {
		cin >> a[i];
		ord[i] = a[i];
	}

	sort(ord.begin(), ord.end());
	ord.erase(unique(ord.begin(), ord.end()), ord.end());
	DBG(ord);

	for(int i = 0; i < n; ++i) {
		a[i] = lower_bound(ord.begin(), ord.end(), a[i]) - ord.begin();
	}

	for(int val = 0; val < MAXN; ++val) {
		lst[val] = n;
	}

	for(int i = n - 1; i >= 0; --i) {
		int v = a[i];
		nxt[i] = lst[v];
		lst[v] = i;
	}

	for(int i = 0; i < n; ++i) {
		for(int d = 1; d <= n; ++d) {
			int cnt = min(i, nxt[i] - d) - max(i - d + 1, 0) + 1;
			if(cnt < 0) cnt = 0;
			S[d] += cnt;
			//cout << "@ " << i << ' ' << d << ' ' << cnt << '\n';
		}
	}

	for(int i = 1; i <= n; ++i) cout << S[i] << ' ';
	cout << '\n';
}

int main() {
	fast_IO();
	solve();

	return 0;
}