#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>
#include <cstring>
#include <random>
#include <cstdlib>
#include <queue>
#include <deque>

#ifdef __LOCAL
#define DBG(X) cout << "[DBG] " #X << "=" << (X) << '\n';
#define SAY(X) cout << (X) << '\n';
#else
#define DBG(X) 42
#define SAY(X) 43
#endif

using namespace std;
using ll = long long int;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
const int NIL = -1;

void fast_IO() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}

template<typename T>
ostream& operator<<(ostream& os, const vector<T>& vec) {
	for(auto& el: vec) os << el << ' ';
	return os;
}

template<typename T, typename S>
ostream& operator<<(ostream& os, const pair<S, T>& pr) {
	os << '[' << pr.first << ' ' << pr.second << ']';
	return os;
}

const int MAXN  = (int)3e5 + 7;
const int T_AND = 1;
const int T_OR  = 2;

struct Op {
	int type, left, right;
};
vector<Op> ops[MAXN];
vector<int> A[MAXN];
int n, m, s;
int answ[MAXN];

int calc(int r) {
	vector<int> t(2*n-1, NIL);
	for(int j = 0; j < n; ++j) t[j] = A[r][j] < answ[j];
	for(int j = n; j < 2*n-1; ++j) {
		auto& op = ops[r][j - n];
		if(op.type == T_AND) {
			t[j] = t[op.left]&t[op.right];
		} else {
			t[j] = t[op.left]|t[op.right];
		}
	}

	DBG(t);
	return t.back();
}

int brute(int pos) {
	if(pos==n) {
		int cnt = 0;
		for(int r = 0; r < m; ++r) {
			cnt += calc(r);
		}

		return cnt==s;
	} else {
		int& i = answ[pos];
		for(i = 0; i <= m; ++i) {
			int rez = brute(pos + 1);
			if(rez) return rez;
		}
		return 0;
	}
}

void solve() {
	cin >> n >> m >> s;
	for(int r = 0; r < m; ++r) {
		ops[r].resize(n - 1);
		for(auto& el: ops[r]) {
			cin >> el.left >> el.right >> el.type;
			--el.left, --el.right;
		}
	}
	for(int r = 0; r < m; ++r) {
		A[r].resize(n);
		for(auto& el: A[r]) cin >> el;
	}

	int is_subtask4 = 1;
	int is_subtask5 = 1;
	for(int r = 0; r < m; ++r) {
		for(int j = 0; j < n; ++j) {
			if(A[r][j]!=r) {
				is_subtask4 = 0;
				break;
			}
		}

		if(is_subtask4==0) break;
	}

	for(int r = 0; r < m; ++r) {
		for(auto& op: ops[r]) {
			if(op.type!=T_AND) {
				is_subtask5 = 0;
				break;
			}
		}

		if(is_subtask5==0) break;
	}

	if(n <= 10 && m <= 2) {
		int rez = brute(0); DBG(rez);
		for(int i = 0; i < n; ++i) cout << answ[i] << ' ';
		cout << '\n';
		return;
	}

	if(is_subtask4) {
		for(int i = 0; i < n; ++i) cout << s << ' ';
		cout << '\n';
		return;
	}

	if(is_subtask5) {
		for(int i = 0; i < n; ++i) cout << (i==0? s : m)  << ' ';
		cout << '\n';
		return;
	}

	assert(false);
}

int main() {
	fast_IO();
	solve();

	return 0;
}