#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>
#include <cstring>
#include <random>
#include <cstdlib>
#include <queue>
#include <deque>

#ifdef __LOCAL
#define DBG(X) cout << #X << "=" << (X) << '\n';
#define SAY(X) cout << (X) << '\n';
#else
#define DBG(X) 42
#define SAY(X) 43
#endif

using namespace std;
using ll = long long int;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
const int NIL = -1;
const ll LL_INF = (ll)2e18;

void fast_IO() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}

template<typename T>
ostream& operator<<(ostream& os, const vector<T>& vec) {
	for(auto& el: vec) os << el << ' ';
	return os;
}

template<typename T, typename S>
ostream& operator<<(ostream& os, const pair<S, T>& pr) {
	os << '[' << pr.first << ' ' << pr.second << ']';
	return os;
}

const int MAXN = (int)2e5 + 77;
ll a[MAXN], pref[MAXN];
int n;

void solve() {
	cin >> n; for(int i = 0; i < n; ++i) cin >> a[i];
	for(int i = 1; i <= n; ++i) pref[i] = pref[i - 1] + a[i - 1];
	int answ = NIL;
	ll best = LL_INF;
	for(int k = 1; k < n; ++k) {
		ll a = pref[k];
		ll b = pref[n] - pref[k];
		if(abs(a - b) < best) {
			best = abs(a - b);
			answ = k;
		}
	}

	cout << answ << '\n';
}

int main() {
	fast_IO();
	solve();

	return 0;
}