#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>
#include <cstring>
#include <random>
#include <cstdlib>
#include <queue>
#include <deque>

#ifdef __LOCAL
#define DBG(X) cout << #X << "=" << (X) << '\n';
#define SAY(X) cout << (X) << '\n';
#else
#define DBG(X) 42
#define SAY(X) 43
#endif

using namespace std;
using ll = long long int;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

void fast_IO() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}

template<typename T>
ostream& operator<<(ostream& os, const vector<T>& vec) {
	for(auto& el: vec) os << el << ' ';
	return os;
}

template<typename T, typename S>
ostream& operator<<(ostream& os, const pair<S, T>& pr) {
	os << '[' << pr.first << ' ' << pr.second << ']';
	return os;
}

const int MAXN = 507;
vector<int> divs[MAXN * MAXN];

int count(int k, int L, int R) {
	/*int rez = 0;
	for(auto& el: divs[k]) {
		rez += (el >= L && el <= R);
	}
	return rez;*/

	auto& v = divs[k];
	int posL = lower_bound(v.begin(), v.end(), L) - v.begin();
	int posR = upper_bound(v.begin(), v.end(), R) - v.begin();
	return posR - posL;
}

void solve() {
	for(int i = 1; i < MAXN; ++i) {
		for(int j = i; j < MAXN * MAXN; j += i) {
			divs[j].push_back(i);
		}
	}

	int n, x; cin >> n >> x;
	ll answ = 0;

	for(int a = 1; a <= n; ++a) {
		if(a == x) continue;
		for(int b = 1; b <= n; ++b) {
			if(b == x) continue;
			int k = a * b - n;
			if(k <= 0) continue;
			/*for(ll c = 1; c <= k; ++c) {
				if(k % c == 0) {
					ll d = k / c;
					if(c < a && d < b) ++answ;
				}
			}*/
			int L = k / b + 1;
			int R = a - 1;
			if(L <= R) answ += count(k, L, R);
		}
	}

	cout << answ << '\n';
}

int main() {
	fast_IO();
	solve();

	return 0;
}