#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector")

#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>
#include <cstring>
#include <random>
#include <cstdlib>
#include <queue>
#include <deque>

#ifdef __LOCAL
#define DBG(X) cout << #X << "=" << (X) << '\n';
#define SAY(X) cout << (X) << '\n';
#else
#define DBG(X) 42
#define SAY(X) 43
#endif

using namespace std;
using ll = long long int;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

void fast_IO() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}

template<typename T>
ostream& operator<<(ostream& os, const vector<T>& vec) {
	for(auto& el: vec) os << el << ' ';
	return os;
}

template<typename T, typename S>
ostream& operator<<(ostream& os, const pair<S, T>& pr) {
	os << '[' << pr.first << ' ' << pr.second << ']';
	return os;
}

const int MAXN = 3007;
using num = int;
//vector<int> divs[MAXN * MAXN];
num* divs[MAXN * MAXN];
int cnt[MAXN * MAXN];
int fnd[MAXN * MAXN];

void build() {
	for(int i = 1; i < MAXN; ++i) {
		for(int j = i; j < MAXN * MAXN; j += i) {
			++cnt[j];
		}
	}

	for(int i = 1; i < MAXN * MAXN; ++i) {
		if(fnd[i]==0||cnt[i]==0) {
			divs[i] = nullptr;
			continue;
		}

		divs[i] = new num[cnt[i]];
		cnt[i] = 0;
	}

	for(int i = 1; i < MAXN; ++i) {
		for(int j = i; j < MAXN * MAXN; j += i) {
			if(divs[j]==nullptr) continue;
			divs[j][cnt[j]++] = i;
		}
	}
}

int count(int k, int L, int R) {
	/*int rez = 0;
	for(auto& el: divs[k]) {
		rez += (el >= L && el <= R);
	}
	return rez;*/

	num* fst = divs[k];
	num* lst = divs[k] + cnt[k];
	int posL = lower_bound(fst, lst, L) - fst;
	int posR = upper_bound(fst, lst, R) - fst;
	return posR - posL;
}

void solve() {
	int n, x; cin >> n >> x;
	ll answ = 0;

	int total = 0;
	for(int a = 1; a <= n; ++a) {
		if(a == x) continue;
		for(int b = 1; b <= n && a + b <= n + 17; ++b) {
			if(b == x) continue;
			int k = a * b - n;
			if(k <= 0) continue;
			++fnd[k];
			if(fnd[k] == 1) ++total;
		}
	}
	DBG(total);
	build();

	for(int a = 1; a <= n; ++a) {
		if(a == x) continue;
		for(int b = 1; b <= n && a + b <= n + 17; ++b) {
			if(b == x) continue;
			int k = a * b - n;
			if(k <= 0) continue;
			/*for(ll c = 1; c <= k; ++c) {
				if(k % c == 0) {
					ll d = k / c;
					if(c < a && d < b) ++answ;
				}
			}*/
			int L = k / b + 1;
			int R = a - 1;
			if(L <= R) answ += count(k, L, R);
		}
	}

	cout << answ << '\n';
}

int main() {
	fast_IO();
	solve();

	return 0;
}