#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>
#include <cstring>
#include <random>
#include <cstdlib>
#include <queue>
#include <deque>

#ifdef __LOCAL
#define DBG(X) cout << #X << "=" << (X) << '\n';
#define SAY(X) cout << (X) << '\n';
#else
#define DBG(X) 42
#define SAY(X) 43
#endif

using namespace std;
using ll = long long int;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
const ll LL_INF = (ll)2e18;

void fast_IO() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}

template<typename T>
ostream& operator<<(ostream& os, const vector<T>& vec) {
	for(auto& el: vec) os << el << ' ';
	return os;
}

template<typename T, typename S>
ostream& operator<<(ostream& os, const pair<S, T>& pr) {
	os << '[' << pr.first << ' ' << pr.second << ']';
	return os;
}

const int MAXN = (int)2e5 + 77;
ll a[MAXN];
int n, q;

void solve() {
	cin >> n; for(int i = 0; i < n; ++i) cin >> a[i];
	a[n] = LL_INF;
	cin >> q;
	while(q--) {
		ll b; cin >> b;
		ll cur = 0, cnt = 0;
		for(int i = 0; i < n; ++i) {
			/*while(cur + a[i] <= b && cur + a[i] < a[i + 1]) {
				cur += a[i];
				++cnt;
			}*/

			ll diff = min(b - cur, a[i + 1] - 1 - cur);
			if(diff < 0) diff = 0;
			diff /= a[i];

			cur += a[i] * diff;
			cnt += diff;
		}

		cout << cur << ' ' << cnt << '\n';
	}
}

int main() {
	fast_IO();
	solve();

	return 0;
}