#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>
#include <cstring>
#include <random>
#include <cstdlib>
#include <queue>
#include <deque>

#ifdef __LOCAL
#define DBG(X) cout << #X << "=" << (X) << '\n';
#define SAY(X) cout << (X) << '\n';
#else
#define DBG(X) 42
#define SAY(X) 43
#endif

using namespace std;
using ll = long long int;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
const ll LL_INF = (ll)2e18;
const int NIL   = -1;

void fast_IO() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}

template<typename T>
ostream& operator<<(ostream& os, const vector<T>& vec) {
	for(auto& el: vec) os << el << ' ';
	return os;
}

template<typename T, typename S>
ostream& operator<<(ostream& os, const pair<S, T>& pr) {
	os << '[' << pr.first << ' ' << pr.second << ']';
	return os;
}

const int MAXN = (int)2e5 + 77;
ll a[MAXN], answ_cur[MAXN], answ_cnt[MAXN];
int n, q;

struct Query {
	ll b = 0;
	int idx = NIL;
	bool operator<(const Query& other) const {
		return b < other.b;
	}
};

void solve() {
	cin >> n; for(int i = 0; i < n; ++i) cin >> a[i];
	a[n] = LL_INF;
	cin >> q; vector<Query> Q(q);
	for(int i = 0; i < q; ++i) {
		cin >> Q[i].b;
		Q[i].idx = i;
	}
	sort(Q.begin(), Q.end());
	reverse(Q.begin(), Q.end());
	ll cur = 0, cnt = 0;
	for(int i = 0; i < n; ++i) {
		ll diff = a[i + 1] - 1 - cur;
		if(diff < 0) diff = 0;
		diff /= a[i];

		while(!Q.empty()) {
			if(cur + diff * a[i] >= Q.back().b) {
				ll diff2 = Q.back().b - cur;
				if(diff2 < 0) diff2 = 0;
				diff2 /= a[i];

				int id = Q.back().idx;
				answ_cur[id] = cur + min(diff, diff2) * a[i];
				answ_cnt[id] = cnt + min(diff, diff2);
				Q.pop_back();
			} else {
				break;
			}
		}

		cur += diff * a[i];
		cnt += diff;
	}

	for(int i = 0; i < q; ++i) {
		cout << answ_cur[i] << ' ' << answ_cnt[i] << '\n';
	}
}

int main() {
	fast_IO();
	solve();

	return 0;
}