#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>
#include <cstring>
#include <random>
#include <cstdlib>
#include <queue>
#include <deque>

#ifdef __LOCAL
#define DBG(X) cout << #X << "=" << (X) << '\n';
#define SAY(X) cout << (X) << '\n';
#else
#define DBG(X) 42
#define SAY(X) 43
#endif

#define len(X) ((int)(X).size())

using namespace std;
using ll = long long int;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

void fast_IO() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}

template<typename T>
ostream& operator<<(ostream& os, const vector<T>& vec) {
	for(auto& el: vec) os << el << ' ';
	return os;
}

template<typename T, typename S>
ostream& operator<<(ostream& os, const pair<S, T>& pr) {
	os << '[' << pr.first << ' ' << pr.second << ']';
	return os;
}

ll calc(const vector<ll>& a) {
	int sz = len(a);
	vector<ll> dp(sz + 1, 0);
	for(int i = 1; i <= sz; ++i) {
		dp[i] = dp[i - 1];
		ll sum = 0;
		for(int t = 1; t <= 3 && t <= i; ++t) {
			sum += a[i - t];
			dp[i] = max(dp[i], dp[max(0, i - t - 1)] + sum);
		}
	}

	DBG(a); DBG(dp);
	return dp.back();
}

ll find(const vector<ll>& a) {
	int sz = len(a);
	ll rez = 0;
	for(int i = 0; i < 4; ++i) {
		vector<ll> b;
		for(int j = i + 1; j < sz; ++j) {
			b.push_back(a[j]);
		}
		for(int j = 0; j < i; ++j) {
			b.push_back(a[j]);
		}
		rez = max(rez, calc(b));
	}

	return rez;
}

void solve() {
	int n; cin >> n;
	vector<ll> a(n); for(auto& el: a) cin >> el;
	int q; cin >> q;
	cout << find(a) << '\n';
	while(q--) {
		int pos, val; cin >> pos >> val; --pos;
		a[pos] = val;
		cout << find(a) << '\n';
	}
}

int main() {
	fast_IO();
	solve();

	return 0;
}