#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,avx,avx2,abm,mmx")
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
#define all(x) (x).begin(), (x).end()
template <typename T1, typename T2> inline void chkmin(T1 & x, const T2 & y) {if (y < x) x = y;};
template <typename T1, typename T2> inline void chkmax(T1 & x, const T2 & y) {if (x < y) x = y;};
#define int ll
const int MAXN = 2e5 + 10;

int n;
int a[MAXN];

void read() {
	cin >> n;
	for (int i = 1; i <= n; i++)
		cin >> a[i];
}

struct event{
	int type, pos, x, d;
	event() {}
	event(int t, int a, int b, int c) {
		type = t, pos = a, x = b, d = c;
	}
};

bool operator<(const event & a, const event & b) {
	return a.pos < b.pos;
}

vector<event> have;

void add_event(int pos, int x, int d, int len) {
	if (len <= 0) return;
	have.push_back({1, pos, x, d});
	have.push_back({2, pos + len, x + d * len, d});
}

void add(int len, int pos) {
	int Len = n - pos + 1;
	int l = min(len, Len);
	int r = max(len, Len);
	if (l - 1 > 0)
	add_event(1, 1, 1, l - 1);
	if (r - l + 1 > 0)
	add_event(l, l, 0, r - l + 1);
	if (l - 1 > 0)
	add_event(r + 1, l - 1, -1, l - 1);
}

void build() {
	map<int, int> last;
	for (int i = 1; i <= n; i++) {
		int len = i - last[a[i]];
		add(len, i);
		last[a[i]] = i;
	}
	sort(all(have));
}

ll ans[MAXN];

void calc() {	
	int now_x = 0, now_d = 0;
	int pos = 0;
	for (int i = 1; i <= n; i++) {
		while (pos < have.size() && have[pos].pos < i) pos++;
		while (pos < have.size() && have[pos].pos == i) {
			if (have[pos].type == 1) {
				now_x += have[pos].x;
				now_d += have[pos].d;
			}
			else {
				now_x -= have[pos].x;
				now_d -= have[pos].d;
			}
			pos++;
		}
		ans[i] = now_x;
		now_x += now_d;
	}
}

void run() {
	build();
	calc();
}

void write() {
	for (int i = 1; i <= n; i++)
		cout << ans[i] << " ";
	cout << endl;
}

signed main() {
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0), cout.setf(ios::fixed), cout.precision(20);
	read();
	run();
	write();
	return 0;
}

