#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,avx,avx2,abm,mmx")
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
#define all(x) (x).begin(), (x).end()
template <typename T1, typename T2> inline void chkmin(T1 & x, const T2 & y) {if (y < x) x = y;};
template <typename T1, typename T2> inline void chkmax(T1 & x, const T2 & y) {if (x < y) x = y;};

struct program{
	int a, b, op;
	program() {}
};
	
int n, m, s;
vector<vector<int> > a;
vector<vector<program> > have;

void read() {
	cin >> m >> n >> s;
	have.resize(n);
	for (int i = 0; i < n; i++) {
		have[i].resize(m - 1);
		for (auto &j : have[i])
			cin >> j.a >> j.b >> j.op, j.a--, j.b--;
	}
	a.resize(n, vector<int> (m, 0));
	for (auto &i : a)
		for (auto &j : i)
			cin >> j;
}

vector<int> ans;

bool check(int pos, vector<int> & z) {
	vector<bool> now;
	for (int i = 0; i < m; i++)
		now.push_back(a[pos][i] < z[i]);
	for (auto i : have[pos]) {
		if (i.op == 1) {
			now.push_back(now[i.a] && now[i.b]);
		}
		else {
			now.push_back(now[i.a] || now[i.b]);
		}
	}
	return now.back();
}

bool check(vector<int> z) {
	int ans = 0;
	for (int i = 0; i < n; i++)
		ans += check(i, z);
	return ans == s;
}

bool check(int pos, int x, int y) {
	if (have[pos][0].op == 1) {
		return a[pos][0] < x && a[pos][1] < y;
	}
	else {
		return a[pos][0] < x || a[pos][1] < y;
	}
}

bool check(int x, int y) {
	int ans = 0;
	for (int i = 0; i < n; i++) {
		ans += check(i, x, y);
	}
	return ans == s;
}

bool check_group_1() {
	return m <= 2 && n <= 1000;
}

void solve_group_1() {
	if (m == 1) {
		for (int x = 0; x <= n; x++) {
			if (check({x})) {
				ans = {x};
				return;
			}
		}
	}
	else {
		for (int x = 0; x <= n; x++) {
			for (int y = 0; y <= n; y++) {
				if (check(x, y)) {
					ans = {x, y};
					return;
				}
			}
		}
	}
	assert(false);
}

bool check_group_3() {
	return n <= 2 && m <= 10;
}

bool now[20];
int top = 0;

bool check_mask(int pos, int mask) {
	for (top = 0; top < m; top++) {
		now[top] = a[pos][top] < ((mask >> top) & 1) + 1;
	}
	for (; top < 2 * m - 1; top++) {
		if (have[pos][top - m].op == 1) {
			now[top] = now[have[pos][top - m].a] && now[have[pos][top - m].b];
		}
		else {
			now[top] = now[have[pos][top - m].a] || now[have[pos][top - m].b];
		}
	}
	return now[top - 1];
}

bool check_mask(int mask) {
	int ans = 0;
	for (int i = 0; i < n; i++)
		ans += check_mask(i, mask);
	return ans == s;
}

void solve_group_3() {
	vector<int> ans;
	for (int mask = 0; mask < (1 << m); mask++) {
		if (check_mask(mask)) {
			for (int i = 0; i < m; i++) {
				ans.push_back(((mask >> i) & 1) + 1);
			}
			return;
		}
	}
	assert(false);
}

bool check_group_4() {
	for (int i = 0; i < n; i++) {
		int x = a[i][0];
		for (int j = 1; j < m; j++) {
			if (a[i][j] != x)
				return false;
		}
	}
	return true;
}

void solve_group_4() {
	ans.resize(m, s);
}

bool check_group_5() {
	for (auto i : have) {
		for (auto j : i) {
			if (j.op == 2) return false;
		}
	}
	return true;
}

void solve_group_5() {
	ans.resize(m, n);
	ans[0] = s;
}

void run() {
	if (check_group_1())
		solve_group_1();
	else if (check_group_3()) 
		solve_group_3();
	else if (check_group_4())
		solve_group_4();
	else if (check_group_5())
		solve_group_5();
}

void write() {
	for (auto i : ans)
		cout << i << " ";
	cout << endl; 
}

signed main() {
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0), cout.setf(ios::fixed), cout.precision(20);
	read();
	run();
	write();
	return 0;
}

