#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,avx,avx2,abm,mmx")
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
#define all(x) (x).begin(), (x).end()
template <typename T1, typename T2> inline void chkmin(T1 & x, const T2 & y) {if (y < x) x = y;};
template <typename T1, typename T2> inline void chkmax(T1 & x, const T2 & y) {if (x < y) x = y;};

struct program{
	int a, b, op;
	program() {}
};
	
int n, m, s;
vector<vector<int> > a;
vector<vector<program> > have;

void read() {
	cin >> m >> n >> s;
	if (m == 1)  {
		cout << s << endl;
		exit(0);
	}
	have.resize(n);
	for (int i = 0; i < n; i++) {
		have[i].resize(m - 1);
		for (auto &j : have[i])
			cin >> j.a >> j.b >> j.op, j.a--, j.b--;
	}
	a.resize(n, vector<int> (m, 0));
	for (auto &i : a)
		for (auto &j : i)
			cin >> j;
}

vector<vector<int> > p;
vector<vector<int> > cnt[2], type;

void build() {
	p.assign(n, vector<int> (2 * m - 1, 0));
	cnt[0].assign(n, vector<int> (2 * m - 1, 0));
	cnt[1].assign(n, vector<int> (2 * m - 1, 0));
	type.assign(n, vector<int> (2 * m - 1, 0));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m - 1; j++) {
			int a = have[i][j].a;
			int b = have[i][j].b;
			int op = have[i][j].op;
			p[i][a] = j + m;
			p[i][b] = j + m;
			type[i][j + m] = op;
		}
	}
}

void upd(int x, int y, int val) {
	cnt[val][x][p[x][y]]++;
	int pos = p[x][y];
	while (pos != 2 * m - 2) {
		//cout << "x = " << x <<  " pos = " << pos << " type = " << type[x][pos] << endl;
		int last = pos;
		if (type[x][pos] == 1) {
			if (cnt[0][x][pos] != 0) {
				cnt[0][x][p[x][pos]]++;
				pos = p[x][pos];
			}
			if (cnt[1][x][pos] == 2) {
				cnt[1][x][p[x][pos]]++;
				pos = p[x][pos];
			}
		}
		else {
			if (cnt[1][x][pos] != 0) {
				cnt[1][x][p[x][pos]]++;
				pos = p[x][pos];
			}
			if (cnt[0][x][pos] == 2) {
				cnt[0][x][p[x][pos]]++;
				pos = p[x][pos];
			}
		}
		if (pos == last)
			return;
	} 
}

bool check_life(int x) {
	if (type[x][2 * m - 2] == 1) {
		return cnt[1][x][2 * m - 2] == 2;
	}
	else {
		return cnt[1][x][2 * m - 2] >= 1;
	}
}

bool check_del(int x) {
	if (type[x][2 * m - 2] == 1) {
		return cnt[0][x][2 * m - 2] >= 1;
	}
	else {
		return cnt[0][x][2 * m - 2] == 2;
	}
}

vector<int> ans;

void recalc(int pos, vector<int> & now) {
	if (now.size() == s) {
		ans.push_back(n);
		return;
	}
	sort(all(now), [&] (int i, int j) {return a[i][pos] < a[j][pos];});
	ans.push_back(0);
	vector<int> Now;

	int it = 0;
	for (int i = 0; i < now.size() && Now.size() < s; i++) {
		upd(now[i], pos, 1);
		if (check_life(now[i]))
			s--;
		else
			Now.push_back(now[i]);
		ans[ans.size() - 1] = a[now[i]][pos] + 1;
		it = i;
	} 
	
	for (int i = it + 1; i < now.size(); i++) {
		upd(now[i], pos, 0);
		if (!check_del(now[i]))
			Now.push_back(now[i]);
	}

	now = Now;
}

void run() {
	build();
	vector<int> now(n);
	iota(all(now), 0);
	for (int i = 0; i < m; i++) {
		//cout << "puhh1" << endl;
		recalc(i, now);
		cout << endl;
		//cout << "puhh2" << endl;
	}
}

void write() {
	for (auto i : ans)
		cout << i << " ";
	cout << endl; 
}

signed main() {
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0), cout.setf(ios::fixed), cout.precision(20);
	read();
	run();
	write();
	return 0;
}

