//#pragma GCC optimize("O3,unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,avx,avx2,abm,mmx")
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
#define all(x) (x).begin(), (x).end()
template <typename T1, typename T2> inline void chkmin(T1 & x, const T2 & y) {if (y < x) x = y;};
template <typename T1, typename T2> inline void chkmax(T1 & x, const T2 & y) {if (x < y) x = y;};
#define int ll

struct node{
	int ans;
	vector<vector<int> > fans;
	int sz;
	node() {
		ans = 0;
		fans.assign(4, vector<int> (4, 0));
		sz = 0;
	}
	node(int x) {
		ans = x;
		fans.assign(4, vector<int> (4, 0));
		fans[1][1] = x;
		sz = 1;
	}
};

node merge(const node & a, const node & b) {
	if (a.sz == 0) return b;
	if (b.sz == 0) return a;
	node ans;
	ans.sz = a.sz + b.sz;
	if (a.sz <= 7 || b.sz <= 7) {
		for (int La = 0; La <= 3; La++) {
			for (int Ra = 0; Ra <= 3; Ra++) {
				if (a.sz == La && a.sz != Ra) continue;
				if (a.sz == Ra && a.sz != La) continue;
				if (La + Ra >= a.sz && La != a.sz) continue;

				for (int Lb = 0; Lb + Ra <= 3; Lb++) {
					for (int Rb = 0; Rb <= 3; Rb++) {
						if (b.sz == Lb && b.sz != Rb) continue;
						if (b.sz == Rb && b.sz != Lb) continue;
						if (Lb + Rb >= b.sz && Lb != b.sz) continue;
				
						int l = La;
						int r = Rb;
						if (a.sz == La) {
							if (b.sz == Rb) {
								l = a.sz + b.sz;
							}
							else {
								l = a.sz + Lb;
							}
						}
						if (b.sz == Rb) {
							if (a.sz == La) {
								r = a.sz + b.sz; 
							}
							else {
								r = b.sz + Ra;
							}
						}
						if (max(l, r) > 3 || max(l, r) > ans.sz) continue;
						chkmax(ans.fans[l][r], a.fans[La][Ra] + b.fans[Lb][Rb]);
						chkmax(ans.ans, a.fans[La][Ra] + b.fans[Lb][Rb]);
					}
				}
			}
		}
	}
	else {
		vector<int> bestA(4, 0), bestB(4, 0);
		for (int Ra = 0; Ra <= 3; Ra++) {
			for (int La = 0; La <= 3; La++) {
				if (a.fans[La][Ra] > a.fans[bestA[Ra]][La])
					bestA[Ra] = La;
			}
		}
		for (int Lb = 0; Lb <= 3; Lb++) {
			for (int Rb = 0; Rb <= 3; Rb++) {
				if (b.fans[Lb][Rb] > b.fans[Lb][bestB[Lb]])
					bestB[Lb] = Rb;
			}
		}
		for (int Ra = 0; Ra <= 3; Ra++) {
			for (int Lb = 0; Lb + Ra <= 3; Lb++) {
				int l = bestA[Ra];
				int r = bestB[Lb];
				int fans = a.fans[l][Ra] + b.fans[Lb][r];
				chkmax(ans.fans[l][r], fans);
				chkmax(ans.ans, fans);
			}
		}
	}
	return ans;
}


const int MAXN = 4e4 + 10;

//node tree[4 * MAXN];
//int pos[MAXN];
//int n;

struct segment_tree{
	vector<node> tree;
	int n;
	vector<int> pos;

	void build(int v, int tl, int tr, vector<int> & a) {
		if (tl == tr - 1) {
			pos[tl] = v;
			tree[v] = node(a[tl]);
			return;
		}
		int tm = (tl + tr) / 2;
		build(v * 2, tl, tm, a);
		build(v * 2 + 1, tm, tr, a);
		tree[v] = merge(tree[v * 2], tree[v * 2 + 1]);
	}

	segment_tree() {}
	segment_tree(vector<int> a) {
		n = a.size();
		tree.resize(4 * n);
		pos.resize(n);
		build(1, 0, n, a);
	}

	node get(int v, int tl, int tr, int l, int r) {
		if (tl >= r || tr <= l) {
			return node();
		}
		if (tl >= l && tr <= r) {
			return tree[v];
		}
		int tm = (tl + tr) / 2;
		return merge(get(v * 2, tl, tm, l, r), get(v * 2 + 1, tm, tr, l, r));
	}

	int get(int l, int r) {
		return get(1, 0, n, l, r + 1).ans;
	}

	void upd(int p, int val) {
		int v = pos[p];
		tree[v] = node(val);
		v /= 2;
		while (v) {
			tree[v] = merge(tree[v * 2], tree[v * 2 + 1]);
			v /= 2;
		}
	}
};

int n;
vector<int> a;

void read() {
	cin >> n;
	a.resize(n);
	for (auto &i : a)
		cin >> i;
}

segment_tree tree;

int get() {
	int ans = 0;
	for (int i = 0; i < 4; i++) {
		chkmax(ans, tree.get(i + 1, i + n - 1));
	}
	return ans;
}

void upd() {
	int pos, val;
	cin >> pos >> val;
	pos--;
	tree.upd(pos, val);
	if (pos < 4)
		tree.upd(pos + n, val);
}

vector<int> ans;

void run() {
	for (int i = 0; i < 4; i++)
		a.push_back(a[i]);
	tree = segment_tree(a);
	ans.push_back(get());
	int q;
	cin >> q;
	while (q--) {
		upd();
		ans.push_back(get());
	}
}

void write() {
	for (auto i : ans)
		cout << i << "\n";
}

signed main() {
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0), cout.setf(ios::fixed), cout.precision(20);
	read();
	run();
	write();
	return 0;
}

