#include <iostream>
#include <algorithm>
#include <cmath>

using namespace std;

int v[11], l[11];
int a[100005], f[100005];

double get_time(long long dv, int n) {
	double x = 0;
	for (int i = 0; i < n; ++i)
		x += l[i] * 1.0 / (dv + v[i]);
	return x;
}

int solve(double t, int n, int m) {
	if (get_time(0, n) <= t)
		return 0;
	long long l, r;
	l = 0;
	r = 2e9;
	while (r - l > 1) {
		long long c = (l + r) / 2;
		if (get_time(c, n) <= t)
			r = c;
		else
			l = c;
	}
	if (get_time(l, n) <= t)
		r = l;
	int x = lower_bound(a, a + m - 1, r) - a;
	return f[x];
}

int main() {
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i)
		cin >> v[i];
	for (int i = 0; i < n; ++i)
		cin >> l[i];
	int m;
	cin >> m;
	for (int i = 0; i < m - 1; ++i)
		cin >> a[i];
	for (int i = 0; i < m; ++i)
		cin >> f[i];
	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		int s, t;
		cin >> s >> t;
		t -= s;
		cout << solve(t, n, m) << '\n';
	}
	return 0;
}
