#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <map>

using namespace std;

long long tree[160005][4][4];
long long a[40004];

void recalc(int v, int L, int R) {
	if (R - L == 1) {
		tree[v][0][0] = 0;
		tree[v][1][1] = a[L];
	}
	if (R - L == 2) {
		tree[v][0][0] = 0;
		tree[v][0][1] = a[R - 1];
		tree[v][1][0] = a[L];
		tree[v][2][2] = a[L] + a[R - 1];
	}
	if (R - L == 3) {
		tree[v][0][0] = a[L + 1];
		tree[v][0][1] = a[R - 1];
		tree[v][0][2] = a[R - 1] + a[R - 2];
		tree[v][1][0] = a[L];
		tree[v][1][1] = a[L] + a[R - 1];
		tree[v][2][0] = a[L] + a[L + 1];
		tree[v][3][3] = a[L] + a[L + 1] + a[L + 2];
	}
}

void build(int v, int L, int R) {
	if (R - L < 4) {
		recalc(v, L, R);
		return;
	}
	int M = (L + R) / 2;
	build(2 * v + 1, L, M);
	build(2 * v + 2, M, R);
	for (int l1 = 0; l1 < 4; ++l1) {
		for (int r1 = 0; r1 < 4; ++r1) {
			for (int l2 = 0; l2 < 4 - r1; ++l2) {
				for (int r2 = 0; r2 < 4; ++r2) {
					int l3, r3;
					l3 = l1; r3 = r2;
					if (M - L == 1 && l1 == 1)
						l3 = l1 + l2;
					if (M - L == 2 && l1 == 2)
						l3 = l1 + l2;
					if (R - M == 1 && r2 == 1)
						r3 = r1 + r2;
					if (R - M == 2 && r2 == 2)
						r3 = r1 + r2;
					tree[v][l3][r3] = max(tree[v][l3][r3], tree[2 * v + 1][l1][r1] + tree[2 * v + 2][l2][r2]);
				}
			}
		}
	}
}

void upd(int v, int L, int R, int x) {
	if (x < L || x >= R)
		return;
	if (R - L < 4) {
		recalc(v, L, R);
		return;
	}
	int M = (L + R) / 2;
	upd(2 * v + 1, L, M, x);
	upd(2 * v + 2, M, R, x);
	for (int l = 0; l < 4; ++l)
		for (int r = 0; r < 4; ++r)
			if (tree[v][l][r] >= 0)
				tree[v][l][r] = 0;
	for (int l1 = 0; l1 < 4; ++l1) {
		for (int r1 = 0; r1 < 4; ++r1) {
			for (int l2 = 0; l2 < 4 - r1; ++l2) {
				for (int r2 = 0; r2 < 4; ++r2) {
					int l3, r3;
					l3 = l1; r3 = r2;
					if (M - L == 1 && l1 == 1)
						l3 = l1 + l2;
					if (M - L == 2 && l1 == 2)
						l3 = l1 + l2;
					if (R - M == 1 && r2 == 1)
						r3 = r1 + r2;
					if (R - M == 2 && r2 == 2)
						r3 = r1 + r2;
					tree[v][l3][r3] = max(tree[v][l3][r3], tree[2 * v + 1][l1][r1] + tree[2 * v + 2][l2][r2]);
				}
			}
		}
	}
}

long long get() {
	long long ans = 0;
	for (int l = 0; l < 4; ++l)
		for (int r = 0; r < 4 - l; ++r)
			ans = max(ans, tree[0][l][r]);
	return ans;
}

int main() {
	int n;
	cin >> n;
	for (int i = 0; i <= 4 * n; ++i)
		for (int l = 0; l < 4; ++l)
			for (int r = 0; r < 4; ++r)
				tree[i][l][r] = -1e18;
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	build(0, 0, n);
	cout << get() << '\n';
	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		long long x, y;
		cin >> x >> y;
		a[x - 1] = y;
		upd(0, 0, n, x - 1);
		cout << get() << '\n';
	}
	return 0;
}
