#include <bits/stdc++.h>
//#define int long long

using namespace std;

struct seg_tree {
    vector<vector<vector<int>>> tree;
    void update(int v, int l, int r) {
        for (int i = 0; i < 4; ++i)
            for (int j = 0; j < 4; ++j)
                tree[v][i][j] = 0;
        int mid = (l + r) / 2;
        int len = r - l, lenl = mid - l, lenr = r - mid;
        if (v == 3)
            cout << "";
        if (len < 4)
            tree[v][len][len] = max(tree[v][len][len], tree[2 * v][lenl][lenl] + tree[2 * v + 1][lenr][lenr]);
        for (int c2 = 0; lenl + c2 < 4; ++c2)
            for (int cr = 0; cr < 4; ++cr)
                if (c2 + cr < lenr)
                    tree[v][lenl + c2][cr] = max(tree[v][lenl + c2][cr], tree[2 * v][lenl][lenl] + tree[2 * v + 1][c2][cr]);
        for (int c1 = 0; c1 + lenr < 4; ++c1)
            for (int cl = 0; cl < 4; ++cl)
                if (cl + c1 < lenl)
                    tree[v][cl][lenr + c1] = max(tree[v][cl][lenr + c1], tree[2 * v][cl][c1] + tree[2 * v + 1][lenr][lenr]);
        for (int c1 = 0; c1 < 4; ++c1)
        for (int c2 = 0; c1 + c2 < 4; ++c2)
        for (int cl = 0; cl < 4; ++cl)
        for (int cr = 0; cr < 4; ++cr)
            if (cl + c1 < lenl && c2 + cr < lenr)
                tree[v][cl][cr] = max(tree[v][cl][cr], tree[2 * v][cl][c1] + tree[2 * v + 1][c2][cr]);
    }
    void build(int v, int l, int r, const vector<int>& arr) {
        if (l + 1 == r) {
            tree[v][0][0] = 0;
            tree[v][1][1] = arr[l];
            return;
        }
        int mid = (l + r) / 2;
        build(2 * v, l, mid, arr);
        build(2 * v + 1, mid, r, arr);
        update(v, l, r);
    }
    seg_tree(int n, const vector<int>& arr) : tree(4 * n, vector<vector<int>>(4, vector<int>(4))) {
        build(1, 0, n, arr);
    }
    void change(int v, int l, int r, int pos, int val) {
        if (l + 1 == r) {
            tree[v][1][1] = val;
            return;
        }
        int mid = (l + r) / 2;
        if (pos < mid)
            change(2 * v, l, mid, pos, val);
        else
            change(2 * v + 1, mid, r, pos, val);
        update(v, l, r);
    }
    int get(int n) {
        int len = n - 1;
        int ans = 0;
        if (len < 4)
            ans = tree[1][len][len];
        for (int cnt1 = 0; cnt1 < 4; ++cnt1)
            for (int cnt2 = 0; cnt1 + cnt2 < min(4, len); ++cnt2)
                ans = max(ans, tree[1][cnt1][cnt2]);
        return ans;
    }
};

int32_t main() {
    int n;
    cin >> n;
    vector<int> arr(n);
    for (int i = 0; i < n; ++i)
        cin >> arr[i];
    seg_tree tree(n, arr);
    cout << tree.get(n) << "\n";
    int q;
    cin >> q;
    for (int t = 0; t < q; ++t) {
        int pos, val;
        cin >> pos >> val;
        --pos;
        tree.change(1, 0, n, pos, val);
        cout << tree.get(n) << "\n";
    }
    return 0;
}
