#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>

using namespace std;

const double EPS = 1e-6;

void Print(const vector<int> &a)
{
    for (int i = 0; i < a.size(); i++)
    {
        cout << a[i] << " ";
    }
    cout << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    freopen("input.txt", "r", stdin);
    int n;
    cin >> n;
    vector<int> v(n);
    for (int i = 0; i < n; i++)
        cin >> v[i];
    vector<int> s(n);
    for (int i = 0; i < n; i++)
        cin >> s[i];
    int m;
    cin >> m;
    vector<int> a(m);
    a[0] = 0;
    for (int i = 1; i < m; i++)
        cin >> a[i];
    vector<int> f(m);
    for (int i = 0; i < m; i++)
        cin >> f[i];
    int q;
    cin >> q;
    for (int k = 0; k < q; k++)
    {
        int S, F;
        cin >> S >> F;
        int t = F - S;
        int left = 0, right = m;
        bool bPure = false;
        {
            double qt = 0;
            for (int i = 0; i < n; i++)
            {
                qt += 1.0 * s[i] / v[i];
            }
            if (t >= qt)
            {
                bPure = true;
            }
        }
        if (!bPure)
        {
            while (left + 1 < right)
            {
                int mid = (left + right) / 2;
                int d = a[mid];
                double qt = 0;
                for (int i = 0; i < n; i++)
                {
                    qt += 1.0 * s[i] / (v[i] + d);
                }
                if (t >= qt)
                {
                    right = mid;
                }
                else
                {
                    left = mid;
                }
            }
            cout << f[left] << endl;
        }
        else
        {
            cout << 0 << endl;
        }
    }
}
