#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <cmath>

using namespace std;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector <int> a(n);
    for (auto& u : a)
        cin >> u;
    map <int, vector <int>> digits;
    for (int i = 0; i < n; i++) {
        if (digits[a[i]].empty()) {
            digits[a[i]].emplace_back(-1);
        }
        digits[a[i]].emplace_back(i);
    }
    for (auto& u : digits) {
        u.second.emplace_back(n);
    }
    vector <pair <int, int>> delta;
    for (auto& u : digits) {
        auto tmp = u.second;
        for (int i = 1; i < tmp.size() - 1; i++) {
            delta.emplace_back(1, 1);
            delta.emplace_back(min(tmp[i] - tmp[i - 1], n - tmp[i]) + 1, -1);
            delta.emplace_back(max(tmp[i] - tmp[i - 1], n - tmp[i]) + 1, -1);
            delta.emplace_back(n - tmp[i - 1] + 1, 1);
        }
    }
    sort(delta.begin(), delta.end());
    long long pos = 0, income = 0;
    long long cur_ans = 0;
    for (int i = 1; i <= n; i++) {
        while (pos < delta.size() && delta[pos].first <= i) {
            income += delta[pos++].second;
        }
        cur_ans += income;
        cout << cur_ans << ' ';
    }
}

/*
#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <cmath>

using namespace std;

int main() {
    int n;
    cin >> n;
    vector <int> a(n), all;
    for (auto& u : a) {
        cin >> u;
        all.emplace_back(u);
    }
    sort(all.begin(), all.end());
    all.resize(unique(all.begin(), all.end()) - all.begin());
    for (auto& u : a)
        u = lower_bound(all.begin(), all.end(), u) - all.begin();
    vector <long long> ans(n);
    vector <int> cnt(all.size(), 0);
    int cur_cnt = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i; j < n; j++) {
            if (!cnt[a[j]]) {
                cnt[a[j]] = 1;
                cur_cnt++;
            }
            ans[j - i] += cur_cnt;
        }
        cnt.resize(0);
        cnt.resize(all.size(), 0);
        cur_cnt = 0;
    }
    for (auto& u : ans)
        cout << u << ' ';
}
*/