#include <iostream>
#include <algorithm>
#include <vector>
#include <cassert>
#include <map>

using namespace std;

#define AND 1
#define OR 2

vector <int> fenv;

int get(int v) {
    int ans = 0;
    for (int i = v; i > 0; i -= i & (-i))
        ans += fenv[i];
    return ans;
}

void upd(int v, int delta) {
    for (int i = v; i < fenv.size(); i += i & (-i)) {
        fenv[i] += delta;
    }
}

int main() {
    int n, m, s;
    cin >> n >> m >> s;
    if (n == 1) {
        cout << s;
        return 0;
    }
    vector <pair <int, int>> query(m);
    fenv.resize(m + 1);
    vector <int> type(m);
    for (int i = 0; i < m; i++) {
        cin >> query[i].first >> query[i].second, query[i].first--, query[i].second--;
        cin >> type[i];
    }
    vector <pair <int, int>> a(m);
    for (auto& u : a)
        cin >> u.first >> u.second;
    vector <pair <int, int>> first(m);
    for (int i = 0; i < m; i++) {
        first[i] = { a[i].first, i };
        if (type[i] == OR)
            upd(i + 1, 1);
    }
    sort(first.begin(), first.end());
    int in_ans = 0;
    for (int i = -1; i < m; i++) {
        assert(m < 5);
        if (i != -1) {
            if (type[first[i].second] == OR) {
                upd(first[i].second + 1, -1);
                in_ans++;
            }
            else {
                upd(first[i].second + 1, 1);
            }
        }
        int L = 0, R = m + 1;
        while (L + 1 < R) {
            int M = (L + R) / 2;
            if (get(M) + in_ans <= s)
                L = M;
            else
                R = M;
        }
        if (get(L) + in_ans == s) {
            cout << i + 1 << ' ' << L;
            return 0;
        }
    }
}