#include <iostream>
#include <algorithm>
#include <vector>
#include <cassert>
#include <map>

using namespace std;

#define AND 1
#define OR 2

struct Query {
    int a, b, type;
    Query(int a = 0, int b = 0, int type = 0) : a(a), b(b), type(type) {}
};

int count(vector <vector <int>>& a, vector <vector <Query>> &q, vector <int> &z) {
    int ans = 0;
    for (int i = 0; i < q.size(); i++) {
        vector <bool> val(a[i].size() + q[i].size(), 0);
        for (int j = 0; j < a[i].size(); j++) {
            val[i] = a[i][j] < z[j];
        }
        for (int j = 0; j < q[i].size(); j++) {
            if (q[i][j].type == OR) {
                val[a[i].size() + j] = val[q[i][j].a] || val[q[i][j].b];
            }
            else {
                val[a[i].size() + j] = val[q[i][j].a] && val[q[i][j].b];
            }
        }
        if (val.back())
            ans++;
    }
    return ans;
}

vector <int> fenv;

int get(int v) {
    int ans = 0;
    for (int i = v; i > 0; i -= i & (-i))
        ans += fenv[i];
    return ans;
}

void upd(int v, int delta) {
    for (int i = v; i < fenv.size(); i += i & (-i)) {
        fenv[i] += delta;
    }
}

int main() {
    int n, m, s;
    cin >> n >> m >> s;
    if (n == 1) {
        cout << s;
        return 0;
    }
    if (n == 2) {
        vector <pair <int, int>> query(m);
        fenv.resize(m + 1);
        vector <int> type(m);
        for (int i = 0; i < m; i++) {
            cin >> query[i].first >> query[i].second, query[i].first--, query[i].second--;
            cin >> type[i];
        }
        vector <pair <int, int>> a(m);
        for (auto& u : a)
            cin >> u.first >> u.second;
        vector <pair <int, int>> first(m);
        for (int i = 0; i < m; i++) {
            first[i] = { a[i].first, i };
            if (type[i] == OR)
                upd(a[i].second + 1, 1);
        }
        sort(first.begin(), first.end());
        int in_ans = 0;
        for (int i = -1; i < m; i++) {
            if (i != -1) {
                if (type[first[i].second] == OR) {
                    upd(a[first[i].second].second + 1, -1);
                    in_ans++;
                }
                else {
                    upd(a[first[i].second].second + 1, 1);
                }
            }
            int L = 0, R = m + 1;
            while (L + 1 < R) {
                int M = (L + R) / 2;
                if (get(M) + in_ans <= s)
                    L = M;
                else
                    R = M;
            }
            if (get(L) + in_ans == s) {
                cout << i + 1 << ' ' << L;
                return 0;
            }
        }
    }
    if (m == 1) {
        for (int i = 0; i < n; i++) {
            cout << s << ' ';
        }
        return 0;
    }
    if (n < 11 && m == 2) {
        vector <vector <Query>> q(m, vector <Query>(n - 1));
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n - 1; j++) {
                cin >> q[i][j].a >> q[i][j].b >> q[i][j].type, q[i][j].a--, q[i][j].b--;
            }
        }
        vector <vector <int>> a(m, vector <int>(n));
        for (auto& u : a)
            for (auto& w : u)
                cin >> w;
        int max_mask = 1;
        for (int i = 0; i < n; i++) {
            max_mask *= 3;
        }
        for (int mask = 0; mask < max_mask; mask++) {
            vector <int> z(n, 0);
            int pos = 0, tmp = mask;
            while (tmp > 0) {
                z[pos++] = tmp % 3;
                tmp /= 3;
            }
            if (count(a, q, z) == s) {
                for (auto u : z)
                    cout << u << ' ';
                return 0;
            }
        }
    }
    for (int i = 0; i < n - 1; i++) {
        cout << m << ' ';
    }
    cout << s;
}