#include <iostream>
#include <algorithm>
#include <vector>
#include <cassert>
#include <map>
#include <deque>

using namespace std;

const long long INF = 1'000'000'000'000'000;

long long get_cost(vector <int> &a) {
    vector <vector <long long>> dp(a.size(), { 0, -INF, -INF, -INF });
    dp[0][1] = a[0];
    for (int i = 1; i < a.size(); i++) {
        dp[i][0] = *max_element(dp[i - 1].begin(), dp[i - 1].end());
        for (int j = 1; j < 4; j++) {
            dp[i][j] = dp[i - 1][j - 1] + a[i];
        }
    }
    return *max_element(dp.back().begin(), dp.back().end());
}

long long count(vector <int> a) {
    long long ans = 0;
    for (int i = 0; i < 4; i++) {
        auto tmp = a[0];
        a.erase(a.begin());
        ans = max(ans, get_cost(a));
        a.push_back(tmp);
    }
    return ans;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector <int> a(n);
    for (auto& u : a)
        cin >> u;
    cout << count(a) << '\n';
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int p, v;
        cin >> p >> v, p--;
        a[p] = v;
        cout << count(a) << '\n';
    }
}