#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <iomanip>

typedef long long int64;
typedef long double ld;

using namespace std;

const double EPS = 1e-6;

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	cout << fixed << setprecision(10);

	int n;
	cin >> n;
	vector <int64> v(n), len(n);
	for (int i = 0; i < n; i++) {
		cin >> v[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> len[i];
	}
	int m;
	cin >> m;
	vector <int64> a(m - 1), f(m);
	for (int i = 0; i < m - 1; i++) {
		cin >> a[i];
	}
	for (int i = 0; i < m; i++) {
		cin >> f[i];
	}
	vector <double> times;
	for (int i = 0; i < m - 1; i++) {
		double res = 0;
		for (int j = 0; j < n; j++) {
			int64 max_v = v[j] + a[i];
			res += (double)len[j] / (double)max_v;
		}
		times.push_back(res);
	}
	double min_time = 0;
	for (int i = 0; i < n; i++) {
		min_time += (double)len[i] / (double)v[i];
	}
	times.push_back(min_time);
	sort(times.begin(), times.end());
	int q;
	cin >> q;
	for (int tt = 0; tt < q; tt++) {
		int64 s, t;
		cin >> s >> t;
		int64 del = t - s;
		int res = (int)(lower_bound(times.begin(), times.end(), (double)del + EPS) - times.begin());
		if (res == m) {
			cout << "0\n";
		} else {
			cout << f[m - 1 - res] << '\n';
		}
	}
}
/*
3
10 20 30
400 500 600
6
1 5 10 12 16
100 300 600 800 1000 1500
3
10 100
20 70
45 100
*/
