#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <iomanip>

typedef long long int64;
typedef long double ld;
#define int int64

using namespace std;

struct One {
	int x;
	int type;
	int start;
	bool up;
	One(int x = -1, int type = -1, int start = -1, bool up = false) :
		x(x), type(type), start(start), up(up)
	{}
};

struct tOne {
	int x;
	int type;
	int y;
	tOne(int x = -1, int type = -1, int y = -1) :
		x(x), type(type), y(y)
	{}
};

int Compress(vector <int64>& a) {
	vector <int64> b = a;
	sort(b.begin(), b.end());
	b.resize(unique(b.begin(), b.end()) - b.begin());
	for (auto& i : a) {
		i = (int)(lower_bound(b.begin(), b.end(), i) - b.begin());
	}
	return (int)b.size();
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	cout << fixed << setprecision(10);

	int n;
	cin >> n;
	vector <int64> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	int m = Compress(a);
	vector <vector <int>> poses(m);
	//	for (int i = 0; i < m; i++) {
	//		poses[i].push_back(0);
	//	}
	for (int i = 0; i < n; i++) {
		poses[a[i]].push_back(i + 1);
	}
	for (int i = 0; i < m; i++) {
		poses[i].push_back(n + 1);
	}
	vector <pair <int, int>> up, down;
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < (int)poses[i].size() - 1; j++) {
			int left = poses[i][j];
			int right = poses[i][j + 1] - poses[i][j];
			if (left == right) {
				up.push_back({ 1, left });
			}
			else if (left < right) {
				up.push_back({ 1, right });
				down.push_back({ left + 1, right });
			}
			else {
				up.push_back({ 1, left });
				down.push_back({ right + 1, left });
			}
		}
	}
	vector <One> E;
	for (auto i : up) {
		E.push_back(One(i.first, 1, i.second, true));
		E.push_back(One(i.second, 2, i.first, true));
	}
	for (auto i : down) {
		E.push_back(One(i.first, 1, i.second, false));
		E.push_back(One(i.second, 2, i.first, false));
	}
	sort(E.begin(), E.end(), [](One& a, One& b) {
		return a.x < b.x;
		});
	vector <int> res(n, 0);
	int num_up = 0, num_down = 0;
	int64 cur_up = 0, cur_down = 0;
	int j = 0;
	for (int i = 1; i <= n; i++) {
		cur_up += num_up;
		cur_down += num_down;
		int d_up = 0, d_down = 0;
		while (j < (int)E.size() && E[j].x == i) {
			if (E[j].up) {
				if (E[j].type == 1) {
					num_up++;
					cur_up++;
				}
				else {
					num_up--;
					d_up += E[j].x - E[j].start + 1;
				}
			}
			else {
				if (E[j].type == 1) {
					num_down++;
					cur_down++;
				}
				else {
					num_down--;
					d_down += E[j].x - E[j].start + 1;
				}
			}
			j++;
		}
		res[i - 1] += cur_up;
		res[i - 1] -= cur_down;
		cur_up -= d_up;
		cur_down -= d_down;
	}
//	for (auto i : res) {
//		cout << i << ' ';
//	}
//	cout << '\n';
	vector <pair <int, int>> ev;
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < (int)poses[i].size() - 1; j++) {
			int left = poses[i][j];
			int right = poses[i][j + 1] - poses[i][j];
			int k = poses[i][j + 1] - 1;
			if (left == right || right == 1 || left == 1) {
				continue;
			}
			if (left < right) {
				ev.push_back({ right + 1, k });
			}
			else {
				ev.push_back({ left + 1, k });
			}
		}
	}
	vector <tOne> tE;
	for (auto i : ev) {
		tE.push_back(tOne(i.first, 1, i.second));
		tE.push_back(tOne(i.second, 2, i.first));
	}
	sort(tE.begin(), tE.end(), [](tOne& a, tOne& b) {
		return a.x < b.x;
		});
	int64 cur = 0;
	int open = 0;
	j = 0;
	for (int i = 1; i <= n; i++) {
		cur -= open;
		int64 d = 0;
		while (j < (int)tE.size() && tE[j].x == i) {
			if (tE[j].type == 1) {
				open++;
				cur += tE[j].y - tE[j].x + 1;
			}
			else {
				d++;
				open--;
			}
			j++;
		}
		res[i - 1] += cur;
		cur -= d;
	}
	for (auto i : res) {
		cout << i << ' ';
	}
	cout << '\n';
}
/*
5
1 3 2 1 2

3
10 10 10
*/
