#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <iomanip>

typedef long long int64;
typedef long double ld;

using namespace std;

struct query {
	int a;
	int b;
	int op;
	query(int a = -1, int b = -1, int op = -1) :
		a(a), b(b), op(op)
	{}
};

int n, m, s;
vector <vector <query>> q;
vector <vector <int>> table;

void fill(vector <vector <int>>& val, int pos, int num) {
	if (pos == n - 1) {
		return;
	}
	int a = q[num][pos].a, b = q[num][pos].b, op = q[num][pos].op;
	if (val[num][a] != -1 && val[num][b] != -1) {
		if (op == 1) {
			val[num][n + pos] = (val[num][a] & val[num][b]);
		}
		else {
			val[num][n + pos] = (val[num][a] | val[num][b]);
		}
	}
	else {
		fill(val, pos + 1, num);
		if (op == 1) {
			val[num][n + pos] = (val[num][a] & val[num][b]);
		}
		else {
			val[num][n + pos] = (val[num][a] | val[num][b]);
		}
	}
}

pair <bool, vector <int>> get_ans(vector <int> z, int pos) {
	if (pos == n) {
		vector <vector <int>> val(m, vector <int>(2 * n, -1));
		for (int i = 0; i < m; i++) {
			for (int j = 0; j < n; j++) {
				val[i][j] = (table[i][j] < z[j] ? 1 : 0);
			}
			fill(val, 0, i);
		}
		int cnt = 0;
		for (int i = 0; i < m; i++) {
			cnt += max(0, val[i].back());
		}
		return { cnt == s, z };
	}
	for (z[0] = 0; z[0] <= m; z[0]++) {
		pair <bool, vector <int>> cur = get_ans(z, pos + 1);
		if (cur.first) {
			return cur;
		}
	}
	return { false, z };
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	cout << fixed << setprecision(10);

	cin >> n >> m >> s;
	q.resize(m, vector <query>(n - 1));
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n - 1; j++) {
			int a, b, op;
			cin >> a >> b >> op;
			q[i][j] = query(a, b, op);
		}
	}
	table.resize(m, vector <int>(n));
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n; j++) {
			cin >> table[i][j];
		}
	}
	for (int i = 0; i < n; i++) {
		cout << m - 1 << ' ';
	}
	cout << '\n';
	/*
	vector <int> z(n, 0);
	vector <int> res = get_ans(z, 0).second;
	for (auto i : res) {
		cout << i << ' ';
	}
	cout << '\n'*/
}
