#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <iomanip>

typedef long long int64;
typedef long double ld;

using namespace std;

bool check2(vector <int64>& a, int n, vector <int64>& E, int q) {
	if (n != 60) {
		return false;
	}
	if (q > 5) {
		return false;
	}
	for (int i = 0; i < n; i++) {
		if ((1LL << i) != a[i]) {
			return false;
		}
	}
	return true;
}

bool check13(vector <int64>& a, int n, vector <int64>& E, int q) {
	int64 m = *max_element(E.begin(), E.end());
	if (m > 200000) {
		return false;
	}
	if (q > 5) {
		return false;
	}
	return true;
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	cout << fixed << setprecision(10);

	int n;
	cin >> n;
	vector <int64> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	int q;
	cin >> q;
	vector <int64> E(q);
	for (int i = 0; i < q; i++) {
		cin >> E[i];
	}
	if (check2(a, n, E, q)) {
		for (auto i : E) {
			i++;
			int64 res = 1;
			int64 cnt = 0;
			while (res * 2 <= i) {
				res *= 2;
				cnt++;
			}
			cout << res - 1 << ' ' << cnt << '\n';
		}
		return 0;
	}
	if (check13(a, n, E, q)) {
		int m = *max_element(E.begin(), E.end());
		vector <int64> dp(m + 1, 0);
		dp[1] = 1;
		for (int i = 2; i <= m; i++) {
			int j = (int)(upper_bound(a.begin(), a.end(), i) - a.begin());
			j--;
			dp[i] = 1 + dp[i - a[j]];
		}
		for (auto i : E) {
			int64 res = *max_element(dp.begin(), dp.begin() + i + 1);
			int pos = 0;
			for (int j = 0; j <= i; j++) {
				if (dp[j] == res) {
					pos = j;
					break;
				}
			}
			cout << pos << ' ' << res << '\n';
		}
		return 0;
	}
}
/*
4
1 5 10 50
3
2
8
50
*/