#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <iomanip>

typedef long long int64;
typedef long double ld;

using namespace std;

vector <int64> a;
map <int64, int64> dp;

int64 get_dp(int64 pos) {
	if (pos == 0) {
		return 0;
	}
	if (dp[pos] != 0) {
		return dp[pos];
	}
	int i = (int)(upper_bound(a.begin(), a.end(), pos) - a.begin());
	i--;
	if (i == 0) {
		dp[pos] = pos;
		return dp[pos];
	}
	dp[pos] = pos / a[i] + get_dp(pos % a[i]);
	return dp[pos];
}

bool check13(vector <int64>& a, int n, vector <int64>& E, int q) {
	int64 m = *max_element(E.begin(), E.end());
	if (m > 200000) {
		return false;
	}
	if (q > 5) {
		return false;
	}
	return true;
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	cout << fixed << setprecision(10);

	int n;
	cin >> n;
	a.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	int q;
	cin >> q;
	vector <int64> E(q);
	for (int i = 0; i < q; i++) {
		cin >> E[i];
	}
	if (check13(a, n, E, q)) {
		int m = *max_element(E.begin(), E.end());
		vector <int64> dp(m + 1, 0);
		dp[1] = 1;
		for (int i = 2; i <= m; i++) {
			int j = (int)(upper_bound(a.begin(), a.end(), i) - a.begin());
			j--;
			dp[i] = 1 + dp[i - a[j]];
		}
		for (auto i : E) {
			int64 res = *max_element(dp.begin(), dp.begin() + i + 1);
			int pos = 0;
			for (int j = 0; j <= i; j++) {
				if (dp[j] == res) {
					pos = j;
					break;
				}
			}
			cout << pos << ' ' << res << '\n';
		}
		return 0;
	}
	for (int i = 0; i < q; i++) {
		int64 b = E[i];
		int j = (int)(upper_bound(a.begin(), a.end(), b + 1) - a.begin());
		j--;
		if (j == 0) {
			cout << b << ' ' << b << '\n';
			continue;
		}
		cout << a[j] - 1 << ' ' << get_dp(a[j] - 1) << '\n';
	}
}
/*

test:
4
1 5 10 50
3
2
8
50

right answer is:
2 2
4 4
49 9

*/
/*

test:
12
1 4 8 13 21 34 50 134 169 179 221 40000
10
80000
50
51
133
169
12398
8
6
80
32423

right answer is:
79900 188
20 5
20 5
120 7
120 7
12275 62
7 4
3 3
70 6
32386 153

*/