#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <iomanip>

typedef long long int64;
typedef long double ld;
const int64 INF64 = 1'000'000'000'000'000'001;

using namespace std;

int64 solve(vector <int64>& a, int n) {
	vector <vector <pair <int64, int64>>> dp(n, vector <pair <int64, int64>>(4, { -INF64, -INF64 }));
	dp[0][0] = { a[0], 0 };
	for (int i = 1; i < n; i++) {
		if (i == n - 1) {
			for (int j = 1; j <= 3; j++) {
				int k = i - j + 1;
				if (k < 0) {
					continue;
				}
				int64 sum = 0;
				for (int tmp = k; tmp <= i; tmp++) {
					sum += a[tmp];
				}
				if (k == 0) {
					if (j == 3) {
						dp[i][j].first = sum;
					} else {
						dp[i][j].first = sum;
						dp[i][j].second = sum;
					}
				} else {
					if (j == 3) {
						dp[i][j].second = dp[k - 1][0].second;
					} else {
						dp[i][j].first = dp[i][j].second = sum;
						dp[i][j].first += dp[k - 1][0].first;
						dp[i][j].second += dp[k - 1][0].second;
					}
				}
			}
			int64 Max;
			Max = dp[i - 1][0].first;
			for (int j = 0; j <= 3; j++) {
				Max = max(Max, dp[i - 1][j].first);
			}
			dp[i][0].first = Max;
			Max = dp[i - 1][0].second;
			for (int j = 0; j <= 3; j++) {
				Max = max(Max, dp[i - 1][j].second);
			}
			dp[i][0].second = Max;
			continue;
		}
		for (int j = 1; j <= 3; j++) {
			int k = i - j + 1;
			if (k < 0) {
				continue;
			}
			int64 sum = 0;
			for (int tmp = k; tmp <= i; tmp++) {
				sum += a[tmp];
			}
			if (k == 0) {
				dp[i][j].first = sum;
			} else {
				dp[i][j].first = dp[i][j].second = sum;
				dp[i][j].first += dp[k - 1][0].first;
				dp[i][j].second += dp[k - 1][0].second;
			}
		}
		int64 Max;
		Max = dp[i - 1][0].first;
		for (int j = 0; j <= 3; j++) {
			Max = max(Max, dp[i - 1][j].first);
		}
		dp[i][0].first = Max;
		Max = dp[i - 1][0].second;
		for (int j = 0; j <= 3; j++) {
			Max = max(Max, dp[i - 1][j].second);
		}
		dp[i][0].second = Max;
	}
	/*
	cout << "\n\n\n";
	for (int j = 0; j <= 3; j++) {
		for (int i = 0; i < n; i++) {
			cout << dp[i][j].first << ' ';
		}
		cout << '\n';
	}
	cout << "\n";
	for (int j = 0; j <= 3; j++) {
		for (int i = 0; i < n; i++) {
			cout << dp[i][j].second << ' ';
		}
		cout << '\n';
	}
	cout << "\n\n\n";
	*/
	int64 res = dp.back()[0].first;
	for (auto i : dp.back()) {
		res = max(res, max(i.first, i.second));
	}
	return res;
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	cout << fixed << setprecision(10);

	int n;
	cin >> n;
	vector <int64> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	int q;
	cin >> q;
	cout << solve(a, n) << '\n';
	for (int tt = 0; tt < q; tt++) {
		int p, v;
		cin >> p >> v;
		p--;
		a[p] = v;
		cout << solve(a, n) << '\n';
	}
}
/*
6
1 2 3 4 5 6
2
6 0
2 5
*/