#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <iomanip>

typedef long long int64;
typedef long double ld;
const int64 INF64 = 1'000'000'000'000'000'001;

using namespace std;

void swappy(vector <int64>& a, int n) {
	int fir = a[0];
	for (int i = 0; i < n - 1; i++) {
		swap(a[i], a[i + 1]);
	}
	a.back() = fir;
}

int64 solve(vector <int64> a, int n) {
	if (n <= 3) {
		int64 sum = 0;
		for (auto i : a) {
			sum += i;
		}
		return sum;
	}
	int64 res = -INF64;
	for (int start = 0; start <= 3; start++) {
		vector <vector <int64>> dp(n, vector <int64>(4, -INF64));
		dp[0][0] = 0;
		for (int i = 1; i < n; i++) {
			for (int j = 1; j <= 3; j++) {
				int k = i - j + 1;
				if (k <= 0) {
					continue;
				}
				dp[i][j] = dp[k - 1][0];
				for (int tmp = k; tmp <= i; tmp++) {
					dp[i][j] += a[tmp];
				}
			}
			dp[i][0] = dp[i - 1][0];
			for (int j = 1; j <= 3; j++) {
				dp[i][0] = max(dp[i][0], dp[i - 1][j]);
			}
		}
		res = max(res, dp.back()[0]);
		for (int i = 1; i <= 3; i++) {
			res = max(res, dp.back()[i]);
		}
		swappy(a, n);
	}
	return res;
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	cout << fixed << setprecision(10);

	int n;
	cin >> n;
	vector <int64> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	int q;
	cin >> q;
	cout << solve(a, n) << '\n';
	for (int tt = 0; tt < q; tt++) {
		int p, v;
		cin >> p >> v;
		p--;
		a[p] = v;
		cout << solve(a, n) << '\n';
	}
}
/*
6
1 2 3 4 5 6
2
6 0
2 5
*/