#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second
#define pb push_back
#define mp make_pair
#define all(x) x.size(), x.begin()
#define sz(x) int(x.size())
#define int long long
#ifndef MY
    #define endl '\n'
#endif // MY

ostream& operator << (ostream& out, const vector < int > lst) {
    for (auto x : lst) {
        out << x << ' ';
    }
    out << endl;
    return out;
}

const int P = 4;

struct Node {
    int res, len, l, r;
    int dp[P][P];
    Node() {
        l = 0, r = 0;
        res = 0, len = 1;
        for (int i = 0; i < P; i++) {
            for (int j = 0; j < P; j++) {
                dp[i][j] = 0;
            }
        }
    }
};

const int N = 2e5;
Node lst[P][N];
int inp[P][N];
int oh[N];
int deg = 1, n;
int dp[N];

int cnt(int t, int l, int r) {
    if (r < l) {
        return 0;
    }
    fill(dp + l, dp + r + 1, 0);
    for(int i = l; i <= r; i++) {
        dp[i] = inp[t][i];
        for (int j = 0; j < P && i - j >= l - 1; j++) {
            int sum = 0;
            if (i - j - 1 >= l) {
                sum = dp[i - j - 1];
            }
            for (int k = i; k > i - j; k--) {
                sum += inp[t][k];
            }
            dp[i] = max(dp[i], sum);
        }
    }
    return dp[r];
}

Node merge(int t, const Node& a, const Node& b) {
    Node res;
    res.l = a.l, res.r = b.r;
    res.len = a.len + b.len;
    if (res.len <= 2 * P) {
        if (res.len < 2 * P) {
            res.res = cnt(t, res.l, res.r);
            return res;
        }
//        if(a.res == 15 && b.res == 1) {
//            cout << "!!";
//        }
        for (int i = 0; i < P; i++) {
            for (int j = 0; j < P; j++) {
                res.dp[i][j] = cnt(t, res.l + i + 1, res.r - j - 1);
                for (int k = 0; k < i; k++) {
                    res.dp[i][j] += inp[t][res.l + k];
                }
                for (int k = 0; k < j; k++) {
                    res.dp[i][j] += inp[t][res.r - k];
                }
                res.res = max(res.res, res.dp[i][j]);
            }
        }
        return res;
    }
    for (int l = 0; l < P; l++) {
        for (int r = 0; r < P; r++) {
            for (int i = 0; i < P; i++) {
                for (int j = 0; j < P; j++) {
                    if (i + j >= P) {
                        break;
                    }
                    res.dp[l][r] = max(res.dp[l][r], a.dp[l][i] + b.dp[j][r]);
                }
            }
            res.res = max(res.res, res.dp[l][r]);
        }
    }
    return res;
}

void update(int t, int in, int x) {
    inp[t][in] = x;
    lst[t][in + deg].res = x;
    for (int i = (in + deg) / 2; i > 0; i /= 2) {
        lst[t][i] = merge(t, lst[t][i * 2], lst[t][i * 2 + 1]);
    }
}

int ind(int t, int in) {
    if (in < t)
        return in + n - (t + 1);
    if (in > t)
        return in - (t + 1);
    return -1;
}

void upd(int in, int x) {
    for (int t = 0; t < P; t++) {
        if (ind(t, in) != -1) {
            update(t, ind(t, in), x);
        }
    }
}

void build() {
    while (n > deg) {
        deg *= 2;
    }
    for (int t = 0; t < P; t++) {
        for (int i = deg; i < deg * 2; i++) {
            lst[t][i].l = lst[t][i].r = i - deg;
        }
        for (int i = deg - 1; i > 0; i--) {
            lst[t][i].l = lst[t][i * 2].l;
            lst[t][i].r = lst[t][i * 2 + 1].r;
            lst[t][i].len = lst[t][i].r - lst[t][i].l + 1;
        }
    }
    for (int i = 0; i < n; i++) {
        upd(i, oh[i]);
    }
}

signed main() {
#ifdef MY
    freopen("f.in", "r", stdin);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> oh[i];
    }
    build();
    int q;
    cin >> q;
    for (int i = 0; i <= q; i++) {
        if (i) {
            int j, x;
            cin >> j >> x;
            upd(j - 1, x);
        }
        int ans = 0;
        int ans1 = 0;
        for (int t = 0; t < P; t++) {
            ans = max(ans, lst[t][1].res);
            //ans1 = max(ans1, cnt(t, 0, n - 1));
        }
        cout << ans << endl;
        //assert(ans <= ans1);
    }
    return 0;
}
