//#pragma GCC optimize("Ofast,unroll-loops,fast-math,inline,no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")

#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

vector<vector<vector<vector<pair<int, pair<int, int>>>>>> g;
vector<vector<vector<int>>> used, tin;
int cur_time = 0;

void dfs(int i, int j, int k) {
	used[i][j][k] = 1;
	for (auto e : g[i][j][k]) {
		if (!used[e.first][e.second.first][e.second.second]) {
			dfs(e.first, e.second.first, e.second.second);
		}
	}
	tin[i][j][k] = cur_time++;
}

void addEdge(int a, int b, int c, int d, int e, int f) {
	g[a][b][c].push_back({d, {e, f}});
}

struct operation {
	int a, b, op;
	operation() {}
	operation(int a, int b, int op) : a(a), b(b), op(op) {}
};

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, m;
	cin >> n >> m;
	int t;
	cin >> t;
	g.resize(m, vector<vector<vector<pair<int, pair<int, int>>>>> (2 * n - 1 + 60,  vector<vector<pair<int, pair<int, int>>>> (2)));
	vector<vector<int>> arr(m, vector<int> (n));
	used.resize(m, vector<vector<int>> (2 * n - 1 + 60, vector<int> (2)));
	tin.resize(m, vector<vector<int>> (2 * n - 1 + 60, vector<int> (2)));
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n - 1; j++) {
			int a, b, op;
			cin >> a >> b >> op;
			a--;
			b--;
			if (op == 1) {
				addEdge(i, a, 0, i, n + j, 0);
				addEdge(i, b, 0, i, n + j, 0);
				addEdge(i, n + j, 1, i, a, 1);
				addEdge(i, n + j, 1, i, b, 1);
			} else {
				addEdge(i, a, 1, i, n + j, 1);
				addEdge(i, b, 1, i, n + j, 1);
				addEdge(i, n + j, 0, i, a, 0);
				addEdge(i, n + j, 0, i, b, 0);
			}
		}
	}
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n; j++) {
			cin >> arr[i][j];
		}
	}
	for (int j = 0; j < n; j++) {
		vector<pair<int, int>> inds;
		inds.reserve(m);
		for (int i = 0; i < m; i++) {
			inds.push_back({arr[i][j], i});
		}
		sort(inds.begin(), inds.end());
		for (int i = 0; i < m - 1; i++) {
			addEdge(inds[i].second, j, 0, inds[i + 1].second, j, 0);
			addEdge(inds[i + 1].second, j, 1, inds[i].second, j, 1);
		}
	}
	addEdge(0, 2 * n - 2, 0, 0, 2 * n, 0);
	addEdge(0, 2 * n, 1, 0, 2 * n - 2, 1);
	addEdge(0, 2 * n - 2, 1, 0, 2 * n, 1);
	addEdge(0, 2 * n, 0, 0, 2 * n - 2, 0);
	for (int i = 2 * n - 1; i < (int) g[0].size(); i++) {
		if (i != 2 * n) {
			addEdge(0, i, 1, 0, i, 0);
			addEdge(0, i, 1, 0, i, 0);
		}
	}
	for (int i = 1; i < m; i++) {
		int c = 2 * n - 2;
		int cm = t;
		while (c + 1 < (int) g[0].size()) {
			// new_c = c & dig
			addEdge(i, c, 0, i, c + 3, 0);
			addEdge(i - 1, c + 2, 0, i, c + 3, 0);
			addEdge(i, c + 3, 1, i, c, 1);
			addEdge(i, c + 3, 1, i - 1, c + 2, 1);
			// help = c | dig
			addEdge(i, c, 1, i, c + 1, 1);
			addEdge(i - 1, c + 2, 1, i, c + 1, 1);
			addEdge(i, c + 1, 0,i, c, 0);
			addEdge(i, c + 1, 0, i - 1, c + 2, 0);
			// new_dig = not new_c & help
			addEdge(i, c + 3, 1, i, c + 2, 0);
			addEdge(i, c + 2, 1, i, c + 3, 0);
			addEdge(i, c + 1, 0, i, c + 2, 0);
			addEdge(i, c + 2, 1, i, c + 1, 1);
			// check m
			if (i == m - 1) {
				if (cm % 2 == 0) {
					addEdge(i, c + 2, 1, i, c + 2, 0);
					addEdge(i, c + 2, 1, i, c + 2, 0);
				} else {
					addEdge(i, c + 2, 0, i, c + 2, 1);
					addEdge(i, c + 2, 0, i, c + 2, 1);
				}
			}
			c += 3;
		}
		addEdge(i, c, 1, i, c, 0);
		addEdge(i, c, 1, i, c, 0);
	}
	for (int i = 0; i < (int) g.size(); i++) {
		for (int j = 0; j < (int) g[i].size(); j++) {
			for (int k = 0; k < 2; k++) {
				if (!used[i][j][k]) {
					dfs(i, j, k);
				}
			}
		}
	}
	vector<vector<int>> ans(m, vector<int> (n));
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n; j++) {
			if (tin[i][j][0] < tin[i][j][1]) {
				ans[i][j] = 0;
			} else {
				ans[i][j] = 1;
			}
		}
	}
	for (int i = 0; i < n; i++) {
		int anss = 0;
		for (int j = 0; j < m; j++) {
			anss += ans[j][i];
		}
		cout << anss << " ";
	}
	cout << endl;
}

