#define _GLIBCXX_DEBUG
//#pragma GCC optimize("Ofast,unroll-loops,fast-math,inline,no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")

#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

#define int long long

int n;
vector<int> arr;
vector<vector<vector<int>>> tree;

vector<vector<int>> combine(const vector<vector<int>> &a, const vector<vector<int>> &b) {
	vector<vector<int>> ans(4, vector<int> (4, -1));
	for (int i = 0; i < 4; i++) {
		for (int j = 0; j < 4; j++) {
			if (a[i][j] != -1) {
				for (int k = 0; k < 4; k++) {
					if (b[j][k] != -1) {
						ans[i][k] = max(ans[i][k], a[i][j] + b[j][k]);
					}
				}
			}
		}
	}
	return ans;
}

void build(int v, int l, int r) {
	if (l + 1 == r) {
		tree[v].resize(4, vector<int> (4, -1));
		for (int i = 0; i < 4; i++) {
			tree[v][i][0] =0 ;
		}
		for (int i = 0; i < 3; i++) {
			tree[v][i][i + 1] = arr[l];
		}
	} else {
		int m = l + (r - l) / 2;
		build(2 * v + 1, l, m);
		build(2 * v + 2, m, r);
		tree[v] = combine(tree[2 * v + 1], tree[2 * v + 2]);
	}
}

void update(int v, int l, int r, int qind, int qval) {
	if (qind < l || qind >= r) {
		return;
	}
	if (l + 1 == r) {
		tree[v].resize(4, vector<int> (4, -1));
		for (int i = 0; i < 4; i++) {
			tree[v][i][0] = 0;
		}
		for (int i = 0; i < 3; i++) {
			tree[v][i][i + 1] = qval;
		}
	} else {
		int m = l + (r - l) / 2;
		update(2 * v + 1, l, m, qind, qval);
		update(2 * v + 2, m, r, qind, qval);
		tree[v] = combine(tree[2 * v + 1], tree[2 * v + 2]);
	}
}

vector<vector<int>> get(int v, int l, int r, int ql, int qr) {
	if (qr <= l || ql >= r) {
		return vector<vector<int>> (4, vector<int> (4));
	}
	if (ql <= l && r <= qr) {
		return tree[v];
	}
	int m = l + (r - l) / 2;
	auto a = get(2 *v + 1, l, m, ql, qr);
	auto b = get(2 * v + 2, m, r, ql, qr);
	return combine(a, b);
}

int get() {
	int max_ans = -1;
	for (int st = 0; st < 4; st++) {
		auto a = get(0, 0, n, st + 1, n);
		auto b = get(0, 0, n, 0, st);
		auto c = combine(a, b);
		for (int i = 0; i < 4; i++) {
			max_ans = max(max_ans, c[0][i]);
		}
	}
	return max_ans;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	arr.resize(n);
	tree.resize(4 * n);
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
	}
	build(0, 0, n);
	cout << get() << endl;
	int q;
	cin >> q;
	while (q--) {
		int ind, val;
		cin >> ind >> val;
		update(0, 0, n, ind - 1, val);
		cout << get() << endl;
	}
}
