#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <algorithm>
#include "math.h"
#include "assert.h"
using namespace std;

#define ll long long
#define ull unsigned ll
#define sz(x) (ll)(x).size()
#define all(x) (x).begin(), (x).end()
#define vec vector
#define x first
#define y second
#define pb push_back
#define eb emplace_back

#pragma GCC optimize("unroll-loops")

template<class T>
inline ostream &operator<<(ostream &out, const vec<T> &v)
{
    if(v.empty())
        return out;
    out << *v.begin();
    for(auto it = ++v.begin(); it != v.end(); ++it)
        out << ' ' << *it;
    return out;
}

template<class T>
inline istream &operator>>(istream &in, vec<T> &v)
{
    for(auto it = v.begin(); it != v.end(); ++it)
        in >> *it;
    return in;
}

template<class T1, class T2>
inline ostream &operator<<(ostream &out, const pair<T1, T2> &p)
{
    return out << p.x << ' ' << p.y;
}

template<class T1, class T2>
inline istream &operator>>(istream &in, pair<T1, T2> &p)
{
    return in >> p.x >> p.y;
}

//===================================================================================
//===================================================================================

pair<ll, ll> solve(ll n)
{
    set<ll> factor = {1, n};
    if(n % 2 == 0)
    {
        factor.insert(2);
        factor.insert(n / 2);
    }
    for(ll i = 3; i * i <= n; i += 2)
    {
        if(n % i == 0)
        {
            factor.insert(i);
            factor.insert(n / i);
        }
    }

    set<ll>::iterator l, r;
    l = next(factor.begin(), (sz(factor)-1) / 2);
    r = sz(factor) % 2 ? l : next(l);
    for(; r != factor.end(); --l, ++r)
    {
        if((*l % 2) == (*r % 2))
        {
            ll a = (*l + *r) / 2;
            ll b = *r - a;
            if(a > 0 && b > 0)
                return {a, b};
        }
    }
    return {-1, -1};
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);


    ll n;
    cin >> n;
    auto ans = solve(n);
    if(ans.x > 0 && ans.y > 0)
        cout << "Yes\n" << ans << endl;
    else
        cout << "No" << endl;
}