#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <algorithm>
#include "math.h"
#include "assert.h"
using namespace std;

#define ll long long
#define ull unsigned ll
#define sz(x) (ll)(x).size()
#define all(x) (x).begin(), (x).end()
#define vec vector
#define x first
#define y second
#define pb push_back
#define eb emplace_back

#pragma GCC optimize("unroll-loops")

template<class T>
inline ostream &operator<<(ostream &out, const vec<T> &v)
{
    if(v.empty())
        return out;
    out << *v.begin();
    for(auto it = ++v.begin(); it != v.end(); ++it)
        out << ' ' << *it;
    return out;
}

template<class T>
inline istream &operator>>(istream &in, vec<T> &v)
{
    for(auto it = v.begin(); it != v.end(); ++it)
        in >> *it;
    return in;
}

template<class T1, class T2>
inline ostream &operator<<(ostream &out, const pair<T1, T2> &p)
{
    return out << p.x << ' ' << p.y;
}

template<class T1, class T2>
inline istream &operator>>(istream &in, pair<T1, T2> &p)
{
    return in >> p.x >> p.y;
}

//===================================================================================
//===================================================================================

pair<ll, ll> solve(const ll n)
{
    vec<ll> factor1 = {1}, factor2 = {n};
    ll nn = n;
    for(ll i = 2; i <= nn; ++i)
    {
        while(nn % i == 0)
        {
            factor1.pb(factor1.back() % i ? i : i * factor1.back());
            nn /= i;
            factor2.pb(nn);
        }
    }
    reverse(all(factor2));

    vec<ll>::iterator l, r;
    l = prev(factor1.end());
    r = factor2.begin();
    for(; r != factor2.end(); --l, ++r)
    {
        if((*l % 2) == (*r % 2))
        {
            ll a = (*l + *r) / 2;
            ll b = *r - a;
            if(a > 0 && b > 0)
                return {a, b};
        }
    }
    return {-1, -1};
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);


    ll n;
    cin >> n;
    if(n == 0)
    {
        cout << "Yes\n1 1" << endl;
        return 0;
    }
    auto ans = solve(n);
    if(ans.x > 0 && ans.y > 0)
        cout << "Yes\n" << ans << endl;
    else
        cout << "No" << endl;
}