#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <algorithm>
#include "math.h"
#include "assert.h"
#include <cstdlib>
using namespace std;

#define ll long long
#define ld long double
#define ull unsigned ll
#define sz(x) (ll)(x).size()
#define all(x) (x).begin(), (x).end()
#define vec vector
#define x first
#define y second
#define pb push_back
#define eb emplace_back

#pragma GCC optimize("unroll-loops")

template<class T>
inline ostream &operator<<(ostream &out, const vec<T> &v)
{
    if(v.empty())
        return out;
    out << *v.begin();
    for(auto it = ++v.begin(); it != v.end(); ++it)
        out << ' ' << *it;
    return out;
}

template<class T>
inline istream &operator>>(istream &in, vec<T> &v)
{
    for(auto it = v.begin(); it != v.end(); ++it)
        in >> *it;
    return in;
}

template<class T1, class T2>
inline ostream &operator<<(ostream &out, const pair<T1, T2> &p)
{
    return out << p.x << ' ' << p.y;
}

template<class T1, class T2>
inline istream &operator>>(istream &in, pair<T1, T2> &p)
{
    return in >> p.x >> p.y;
}

//===================================================================================
//===================================================================================

const ld EPS = 1e-5;

void solve(const vector<ll> &v, const vector<ll> &l, const vector<ll> &a, const vector<ll> &f, ll q) {
    vec<pair<ld, ll>> ans; // Time to shtraffff
    ans.reserve(sz(v) * sz(f));

    for (ll i = -1; i < sz(a); ++i)
    {
        ld time_big = 0;
        for(ll j = 0; j < sz(v); ++j)
        {
            ll speed = v[j];
            if(i != -1)
                speed += a[i];
            ld time = (ld)l[j] / speed;
            time_big += time;
        }
        if(i == -1)
            ans.eb(time_big, 0);
        else
            ans.eb(time_big, f[i]);
    }
    if(sz(v) == 1 && sz(f) != 1)
        exit(0);
    ans.eb(ans.back().x - 10 * EPS, f.back());

    for(ll idx = 0; idx < q; ++idx)
    {
        ll s, t;
        cin >> s >> t;
        ll time = t - s;
        auto it = upper_bound(ans.rbegin(), ans.rend(), (pair<ld, ll>){time, -1});
        if(it != ans.rbegin() && it->x - time > EPS)
            --it;
        if(it == ans.rend())
            --it;
        if(it != ans.rbegin() && abs(prev(it)->x - time) <= EPS)
            --it;
        cout << it->y << '\n';
    }
}

int main()
{
    cout.precision(20);
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll n;
    cin >> n;
    vector<ll> v(n), l(n);
    cin >> v >> l;
    ll m;
    cin >> m;
    vector<ll> a(m - 1), f(m);
    cin >> a >> f;
    ll q;
    cin >> q;
    solve(v, l, a, f, q);
}