#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
using namespace std;

#define ll long long
#define ld long double
#define ull unsigned ll
#define sz(x) (ll)(x).size()
#define all(x) (x).begin(), (x).end()
#define vec vector
#define x first
#define y second
#define pb push_back
#define eb emplace_back

#pragma GCC optimize("unroll-loops")

template<class T>
inline ostream &operator<<(ostream &out, const vec<T> &v)
{
    if(v.empty())
        return out;
    out << *v.begin();
    for(auto it = ++v.begin(); it != v.end(); ++it)
        out << ' ' << *it;
    return out;
}

template<class T>
inline istream &operator>>(istream &in, vec<T> &v)
{
    for(auto it = v.begin(); it != v.end(); ++it)
        in >> *it;
    return in;
}

template<class T1, class T2>
inline ostream &operator<<(ostream &out, const pair<T1, T2> &p)
{
    return out << p.x << ' ' << p.y;
}

template<class T1, class T2>
inline istream &operator>>(istream &in, pair<T1, T2> &p)
{
    return in >> p.x >> p.y;
}

//===================================================================================
//===================================================================================

vec<ll> solve(vec<ll> v)
{
    // Very slow
    vec<ll> ans(sz(v));
    for(ll d = 1; d <= sz(v); ++d)
    {
        map<ll, ll> m;
        for(ll i = 0; i < d; ++i)
            ++m[v[i]];
        ans[d - 1] = sz(m);
        for(ll i = d; i < sz(v); ++i)
        {
            if(m[v[i - d]] == 1)
                m.erase(v[i - d]);
            else
                --m[v[i - d]];
            ++m[v[i]];
            ans[d - 1] += sz(m);
        }
    }
    return ans;
}

int main()
{
    /*ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);*/

    ll n;
    cin >> n;
    vec<ll> v(n);
    cin >> v;
    cout << solve(v) << endl;
}