#include <iostream>
#include <vector>
#include <set>
#include <queue>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <climits>
using namespace std;

#define ll long long
#define ld long double
#define ull unsigned ll
#define sz(x) (ll)(x).size()
#define all(x) (x).begin(), (x).end()
#define vec vector
#define x first
#define y second
#define pb push_back
#define eb emplace_back

#pragma GCC optimize("unroll-loops")

template<class T>
inline ostream &operator<<(ostream &out, const vec<T> &v)
{
    if(v.empty())
        return out;
    out << *v.begin();
    for(auto it = ++v.begin(); it != v.end(); ++it)
        out << ' ' << *it;
    return out;
}

template<class T>
inline istream &operator>>(istream &in, vec<T> &v)
{
    for(auto it = v.begin(); it != v.end(); ++it)
        in >> *it;
    return in;
}

template<class T1, class T2>
inline ostream &operator<<(ostream &out, const pair<T1, T2> &p)
{
    return out << p.x << ' ' << p.y;
}

template<class T1, class T2>
inline istream &operator>>(istream &in, pair<T1, T2> &p)
{
    return in >> p.x >> p.y;
}

//===================================================================================
//===================================================================================

vec<ll> solve_123(const vec<ll> &v)
{
    // For groups 1-3
    vec<ll> ans(sz(v));
    for(ll d = 1; d <= sz(v); ++d)
    {
        unordered_map<ll, ll> m;
        for(ll i = 0; i < d; ++i)
            ++m[v[i]];
        ans[d - 1] = sz(m);
        for(ll i = d; i < sz(v); ++i)
        {
            if(m[v[i - d]] == 1)
                m.erase(v[i - d]);
            else
                --m[v[i - d]];
            ++m[v[i]];
            ans[d - 1] += sz(m);
        }
    }
    return ans;
}

vec<ll> solve_4(const vec<ll> &v)
{
    // For group 4
    vec<ll> ans(sz(v));
    for(ll d = 1; d <= sz(v); ++d)
    {
        vec<ll> present(5'001);
        ll cur = 0;
        for(ll i = 0; i < d; ++i)
        {
            if(!present[v[i]])
                ++cur;
            ++present[v[i]];
        }
        ans[d - 1] = cur;
        for(ll i = d; i < sz(v); ++i)
        {
            --present[v[i - d]];
            if(!present[v[i - d]])
                --cur;

            if(!present[v[i]])
                ++cur;
            ++present[v[i]];

            ans[d - 1] += cur;
        }
    }
    return ans;
}

int main()
{
    /*ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);*/

    ll n;
    cin >> n;
    vec<ll> v(n);
    ll a_max = LLONG_MIN;
    for(ll i = 0; i < n; ++i)
    {
        cin >> v[i];
        if(v[i] > a_max)
            a_max = v[i];
    }
    if(a_max <= 5000)
        cout << solve_4(v) << endl;
    else
        cout << solve_123(v) << endl;
}