#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <algorithm>
#include "math.h"
#include "assert.h"
#include <cstdlib>
using namespace std;

#define ll long long
#define ld long double
#define ull unsigned ll
#define sz(x) (ll)(x).size()
#define all(x) (x).begin(), (x).end()
#define vec vector
#define x first
#define y second
#define pb push_back
#define eb emplace_back

#pragma GCC optimize("unroll-loops")

template<class T>
inline ostream &operator<<(ostream &out, const vec<T> &v)
{
    if(v.empty())
        return out;
    out << *v.begin();
    for(auto it = ++v.begin(); it != v.end(); ++it)
        out << ' ' << *it;
    return out;
}

template<class T>
inline istream &operator>>(istream &in, vec<T> &v)
{
    for(auto it = v.begin(); it != v.end(); ++it)
        in >> *it;
    return in;
}

template<class T1, class T2>
inline ostream &operator<<(ostream &out, const pair<T1, T2> &p)
{
    return out << p.x << ' ' << p.y;
}

template<class T1, class T2>
inline istream &operator>>(istream &in, pair<T1, T2> &p)
{
    return in >> p.x >> p.y;
}

//===================================================================================
//===================================================================================

void solve(const vec<ll> &v, ll q)
{
    auto how_much_money = [&](ll n)
    {
        ll ans = 0;
        auto it = lower_bound(all(v), n);
        while(n)
        {
            if(*it > n)
                it = --upper_bound(v.begin(), it, n);
            n -= *it;
            ++ans;
        }
        return ans;
    };

    map<ll, ll> w; // i - sum, w[i] - n of money
    for(ll i = 1; i < sz(v); ++i)
    {
        w[v[i] - 1] = how_much_money(v[i] - 1);
    }

    auto get_how_much_money = [&](ll x)
    {
        if(w.find(x) == w.end())
            return w[x] = how_much_money(x);
        else
            return w[x];
    };

    while(q--)
    {
        ll x;
        cin >> x;
        ll sum = x;
        ll ans = get_how_much_money(x);

        for(ll i = --upper_bound(all(v), x + 1) - v.begin(); i >= 0; --i)
        {
            ll tmp = get_how_much_money(v[i] - 1);
            if(tmp > ans)
            {
                ans = tmp;
                sum = v[i] - 1;
            }
        }

        cout << sum << ' ' << ans << '\n';
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll n;
    cin >> n;
    vec<ll> v(n);
    cin >> v;
    ll q;
    cin >> q;
    solve(v, q);
}