#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <algorithm>
#include "math.h"
#include "assert.h"
#include <cstdlib>
#include <climits>
using namespace std;

#define ll long long
#define ld long double
#define ull unsigned ll
#define sz(x) (ll)(x).size()
#define all(x) (x).begin(), (x).end()
#define vec vector
#define x first
#define y second
#define pb push_back
#define eb emplace_back

#pragma GCC optimize("unroll-loops")

template<class T>
inline ostream &operator<<(ostream &out, const vec<T> &v)
{
    if(v.empty())
        return out;
    out << *v.begin();
    for(auto it = ++v.begin(); it != v.end(); ++it)
        out << ' ' << *it;
    return out;
}

template<class T>
inline istream &operator>>(istream &in, vec<T> &v)
{
    for(auto it = v.begin(); it != v.end(); ++it)
        in >> *it;
    return in;
}

template<class T1, class T2>
inline ostream &operator<<(ostream &out, const pair<T1, T2> &p)
{
    return out << p.x << ' ' << p.y;
}

template<class T1, class T2>
inline istream &operator>>(istream &in, pair<T1, T2> &p)
{
    return in >> p.x >> p.y;
}

//===================================================================================
//===================================================================================

vec<bool> upped;
ll ans = 0;
vec<bool> best_upped;
ll best_ans = -1;

void update_upped(const vec<ll> &colors, ll depth = 0)
{
    if(depth == 0)
    {
        upped.clear();
        upped.assign(sz(colors), 0);
        best_upped.clear();
        best_upped.assign(sz(colors), 0);
        ans = 0;
        best_ans = LLONG_MIN;
    }

    if(depth == sz(colors))
    {
        if(ans > best_ans)
        {
            best_ans = ans;
            best_upped = upped;
        }
        return;
    }

    ll ans_before = ans;
    if(depth < 3 || !upped[depth - 3] || !upped[depth - 2] || !upped[depth - 1])
    {
        if(depth != sz(colors) - 1 || !upped[0])
        {
            upped[depth] = 1;
            ans += colors[depth];
            update_upped(colors, depth + 1);
        }
    }
    upped[depth] = 0;
    ans = ans_before;
    update_upped(colors, depth + 1);
}

void solve(vec<ll> &colors, ll q)
{
    update_upped(colors);
    cout << best_ans << '\n';
    while(q--)
    {
        ll i, v;
        cin >> i >> v;
        ll old = colors[--i];
        colors[i] = v;
        if(old != v)
        {
            /*if((old < v) != best_upped[i])
                update_upped(colors);*/
            cout << best_ans << '\n';
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll n;
    cin >> n;
    vec<ll> colors(n);
    cin >> colors;
    ll q;
    cin >> q;
    solve(colors, q);
}