#include <iostream>
#include<algorithm>
#include<set>
#include<vector>
#include<map>
#include<iomanip>
#include<string>

#define ll long long int
#define eps 0.00001

using namespace std;

vector<ll> t, a;

void build(int v, int l, int r)
{
    if (l == r)
        t[v] = a[l];
    else
    {
        int m = (l + r) / 2;
        build(2 * v, l, m);
        build(2 * v + 1, m + 1, r);
        t[v] = t[2 * v] + t[2 * v + 1];
    }
}

void change(int v, int l, int r, int x)
{
    if (l == r)
        t[v] = x;
    else
    {
        int m = (l + r) / 2;
        change(2 * v, l, m, x);
        change(2 * v + 1, m + 1, r, x);
        t[v] = t[2 * v] + t[2 * v + 1];
    }
}

ll get(int v, int l, int r, int askl, int askr)
{
    if (r < askl || l > askr)
        return 0;
    if (askl <= l && askr >= r)
        return t[v];
    int m = (l + r) / 2;
    return get(2 * v, l, m, askl, askr) + get(2 * v + 1, m + 1, r, askl, askr);
}

int main()
{
    int n;
    cin >> n;
    a.resize(n);
    t.resize(4 * n + 4);
    for (ll& i : a) cin >> i;
    build(1, 0, n - 1);
    ll prmax = 0;
    int numel = 0;
    for (int i = 0; i < n - 1; i++)
    {
        ll pr = get(1, 0, n - 1, 0, i) * get(1, 0, n - 1, i + 1, n - 1);
        if (prmax < pr)
        {
            prmax = pr;
            numel = i;
        }
    }
    cout << numel + 1;
}
