#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("unswitch-loops")
#pragma GCC target("sse,sse2,ssse3,sse4,avx,avx2,popcnt")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define len(a) (int)a.size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

#ifdef LOCAL
    #define NEW_TEST cout << "-----------TEST-----------\n";
#else
    #define NEW_TEST
#endif

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;

const int MAX     = (int)(2e5) + 7;
const int INF_INT = (int)(1e9) + 7;
const ll MOD      = (ll)(1e9)  + 7;
const ll INF_LL   = (ll)(1e18) + 7;
const ld EPS = (ld)1e-6;

template<typename T> inline void info(T & v) { for (const auto & it : v) { cout << it << ' '; } cout << '\n'; }

template<typename T> inline void init(vector<T> & v, size_t size, T value = 0) { v.assign(size, value); }

template<typename T> inline bool chkmin(T & a, const T & b) { if (a > b) { a = b; return true; } return false; }

template<typename T> inline bool chkmax(T & a, const T & b) { if (a < b) { a = b; return true; } return false; }

void solve();
void boot_up() {
#ifdef LOCAL
    freopen("input.in", "r", stdin);
    freopen("output.out", "w", stdout);
#endif
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
}


int n, m, q;
vector<int> v;
vector<int> l;
vector<int> a;
vector<int> f;

signed main() {
    boot_up();

    while (cin >> n) {
        solve();
    }
}

void solve() {
    NEW_TEST;

    init(v, n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> v[i];
    }

    init(l, n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> l[i];
    }

    ld min_time = 0;
    for (int i = 1; i <= n; ++i) {
        min_time += (ld)l[i] / v[i];
    }


    cin >> m;
    
    init(a, m);
    for (int i = 1; i <= m - 1; ++i) {
        cin >> a[i];
    }
    a.emplace_back(INF_INT);

    init(f, m + 1);
    for (int i = 1; i <= m; ++i) {
        cin >> f[i];
    }


    cin >> q;
    for (int query = 0; query < q; ++query) {
        int s, t;
        cin >> s >> t;

        int curr_time = t - s;

        if (curr_time - min_time >= -EPS) {
            cout << 0 << '\n';
        }
        else {
            if (n == 1) {
                ld v = (ld)l[1] / t;
                
                for (int i = 1; i <= m; ++i) {
                    if (a[i] - v >= -EPS) {
                        cout << f[i] << '\n';
                        break;
                    }
                }
            }
        }
    }
}
