#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("unswitch-loops")
#pragma GCC target("sse,sse2,ssse3,sse4,avx,avx2,popcnt")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define int long long

#define len(a) (int)a.size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

#ifdef LOCAL
    #define NEW_TEST cout << "-----------TEST-----------\n";
#else
    #define NEW_TEST
#endif

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;

const int MAX     = (int)(2e5) + 7;
const int INF_INT = (int)(1e9) + 7;
const ll MOD      = (ll)(1e9)  + 7;
const ll INF_LL   = (ll)(1e18) + 7;

template<typename T> inline void info(T & v) { for (const auto & it : v) { cout << it << ' '; } cout << '\n'; }

template<typename T> inline void init(vector<T> & v, size_t size, T value = 0) { v.assign(size, value); }

template<typename T> inline bool chkmin(T & a, const T & b) { if (a > b) { a = b; return true; } return false; }

template<typename T> inline bool chkmax(T & a, const T & b) { if (a < b) { a = b; return true; } return false; }

void solve();
void boot_up() {
#ifdef LOCAL
    freopen("input.in", "r", stdin);
    freopen("output.out", "w", stdout);
#endif
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
}


int n;
vector<int> a;
vector<int> s;
vector<pair<int, int>> add;
gp_hash_table<int, int> last;

void add_progression(int l, int r, int start, int step);

signed main() {
    boot_up();

    while (cin >> n) {
        solve();
    }
}

void solve() {
    NEW_TEST;

    init(a, n);
    for (auto & it : a) {
        cin >> it;
        last[it] = -1;
    }


    init(s, n + 1);
    init(add, n + 1, pair<int, int>{0, 0});
    for (int i = 0; i < n; ++i) {
        int last_pos = last[a[i]] + 1;

        int min_len = i - last_pos + 1;
        int max_len = (n - 1) - last_pos + 1;

        int l = min_len;
        int r = (n - 1) - i + 1;

        if (l <= r) {
            // 1..l-1 1 + 1 * (i - 1)
            add_progression(1, l - 1, 1, 1);

            // l..r i - last_pos + 1
            add_progression(l, r, i - last_pos + 1, 0);

            // r+1..max_len max_len - (r + 1) + 1 - 1 * (i - 1)
            add_progression(r + 1, max_len, max_len - (r + 1) + 1, -1);
        }
        else {
            // 1..r-1 1 + 1 * (i - 1)
            add_progression(1, r - 1, 1, 1);

            // r..l r
            add_progression(r, l, r, 0);

            // l+1..max_len r - 1 - 1 * (i - 1)
            add_progression(l + 1, max_len, r - 1, -1);
        }

        last[a[i]] = i;
    }

    int start = 0;
    int step = 0;
    for (int i = 1; i <= n; ++i) {
        start += step;
        start += add[i].first;
        s[i] += start;
        step += add[i].second;
    }

    for (int i = 1; i <= n; ++i) {
        cout << s[i] << ' ';
    }
}

void add_progression(int l, int r, int start, int step) {
    if (l > r) {
        return;
    }

    add[l].first += start;
    add[l].second += step;

    if (r + 1 <= n) {
        add[r + 1].first -= (start + step * (r - l + 1));
        add[r + 1].second -= step;
    }
}
