#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("unswitch-loops")
#pragma GCC target("sse,sse2,ssse3,sse4,avx,avx2,popcnt")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define len(a) (int)a.size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

#ifdef LOCAL
    #define NEW_TEST cout << "-----------TEST-----------\n";
#else
    #define NEW_TEST
#endif

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;

const int MAX     = (int)(2e5) + 7;
const int INF_INT = (int)(1e9) + 7;
const ll MOD      = (ll)(1e9)  + 7;
const ll INF_LL   = (ll)(1e18) + 7;

template<typename T> inline void info(T & v) { for (const auto & it : v) { cout << it << ' '; } cout << '\n'; }

template<typename T> inline void init(vector<T> & v, size_t size, T value = 0) { v.assign(size, value); }

template<typename T> inline bool chkmin(T & a, const T & b) { if (a > b) { a = b; return true; } return false; }

template<typename T> inline bool chkmax(T & a, const T & b) { if (a < b) { a = b; return true; } return false; }

void solve();
void boot_up() {
#ifdef LOCAL
    freopen("input.in", "r", stdin);
    freopen("output.out", "w", stdout);
#endif
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
}


int n, m, s;

signed main() {
    boot_up();

    while (cin >> n >> m >> s) {
        solve();
    }
}

void solve() {
    NEW_TEST;

    double _tm = clock();
    bool flag = true;

    vector<vector<int>> a(m + 1, vector<int>(n));
    vector<vector<int>> b(m + 1, vector<int>(n));
    vector<vector<int>> op(m + 1, vector<int>(n));

    for (int i = 1; i <= m; ++i) {
        for (int j = 1; j <= n - 1; ++j) {
            cin >> a[i][j] >> b[i][j] >> op[i][j];
        }
    }

    vector<vector<int>> x(m + 1, vector<int>(n + 1));
    for (int i = 1; i <= m; ++i) {
        for (int j = 1; j <= n; ++j) {
            cin >> x[i][j];

            if (x[i][j] != i - 1) {
                flag = false;
            }
        }
    }


    vector<vector<int>> val(m + 1, vector<int>(2 * n));
    vector<int> z(n + 1);
    if (n == 1) {
        for (int z1 = 0; z1 <= m; ++z1) {
            z[1] = z1;

            for (int i = 1; i <= m; ++i) {
                for (int j = 1; j <= n; ++j) {
                    val[i][j] = (x[i][j] < z[j] ? 1 : 0);
                }
            }

            for (int i = 1; i <= m; ++i) {
                for (int p = 1; p <= n - 1; ++p) {
                    if (op[i][p] == 1) {
                        val[i][n + p] = val[i][a[i][p]] & val[i][b[i][p]];
                    }
                    else {
                        val[i][n + p] = val[i][a[i][p]] | val[i][b[i][p]];
                    }
                }
            }

            int ones = 0;
            for (int i = 1; i <= m; ++i) {
                ones += (int)(val[i][2 * n - 1] == 1);
            }

            if (s == ones) {
                cout << z1 << '\n';
                return;
            }
        }
    }
    else {
        mt19937 rnd(time(0));
        while (clock() - _tm < 0.97 * CLOCKS_PER_SEC) {
            for (int i = 1; i <= n; ++i) {
                z[i] = rnd() % (m + 1);
            }

            for (int i = 1; i <= m; ++i) {
                for (int j = 1; j <= n; ++j) {
                    val[i][j] = (x[i][j] < z[j] ? 1 : 0);
                }
            }

            for (int i = 1; i <= m; ++i) {
                for (int p = 1; p <= n - 1; ++p) {
                    if (op[i][p] == 1) {
                        val[i][n + p] = val[i][a[i][p]] & val[i][b[i][p]];
                    }
                    else {
                        val[i][n + p] = val[i][a[i][p]] | val[i][b[i][p]];
                    }
                }
            }

            int ones = 0;
            for (int i = 1; i <= m; ++i) {
                ones += (int)(val[i][2 * n - 1] == 1);
            }

            if (s == ones) {
                for (int i = 1; i <= n; ++i) {
                    cout << z[i] << ' ';
                }
                cout << '\n';
                return;
            }
        }
    }
}
