#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("unswitch-loops")
#pragma GCC target("sse,sse2,ssse3,sse4,avx,avx2,popcnt")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define int long long

#define len(a) (int)a.size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

#ifdef LOCAL
    #define NEW_TEST cout << "-----------TEST-----------\n";
#else
    #define NEW_TEST
#endif

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;

const int MAX     = (int)(2e5) + 7;
const int INF_INT = (int)(1e9) + 7;
const ll MOD      = (ll)(1e9)  + 7;
const ll INF_LL   = (ll)(1e18) + 7;

template<typename T> inline void info(T & v) { for (const auto & it : v) { cout << it << ' '; } cout << '\n'; }

template<typename T> inline void init(vector<T> & v, size_t size, T value = 0) { v.assign(size, value); }

template<typename T> inline bool chkmin(T & a, const T & b) { if (a > b) { a = b; return true; } return false; }

template<typename T> inline bool chkmax(T & a, const T & b) { if (a < b) { a = b; return true; } return false; }

void solve();
void boot_up() {
#ifdef LOCAL
    freopen("input.in", "r", stdin);
    freopen("output.out", "w", stdout);
#endif
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
}


int n, q;
vector<ll> a;

ll cnt(ll b);

signed main() {
    boot_up();

    while (cin >> n) {
        solve();
    }
}

void solve() {
    NEW_TEST;

    double _tm = clock();

    bool flag1 = true;

    vector<pair<int, int>> chto;
    vector<pair<int, int>> pref_max;

    init(a, n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];


        if (a[i] != (1LL << (i))) {
            flag1 = false;
        }
    }

    srand(time(0));
    for (int i = 0; i < n; ++i) {
        for (int j = max(1LL, a[i] - 10); j <= a[i] + 10; ++j) {
            ll now = cnt(j);
            chto.emplace_back(j, now);
        }
    }

    chto.emplace_back(INF_LL, cnt(INF_LL));
    sort(all(chto));
    chto.resize(unique(all(chto)) - chto.begin());

    init(pref_max, len(chto), pair<int, int>{0, 0});
    pref_max[0] = chto[0];
    for (int i = 1; i < len(chto); ++i) {
        if (chto[i].second > pref_max[i - 1].second) {
            pref_max[i] = chto[i];
        }
        else {
            pref_max[i] = pref_max[i - 1];
        }
    }

    cin >> q;
    for (int query = 0; query < q; ++query) {
        ll b;
        cin >> b;

        if (b > (ll)2e5) {
        ll mx_chto = 0;
        int mx_ans = 0;
        for (ll curr_b = 2; curr_b - 1 <= b; curr_b *= 2LL) {
            if (chkmax(mx_ans, cnt(curr_b - 1))) {
                mx_chto = curr_b - 1;
            }
        }

        int l = -1, r = len(pref_max) + 1;

        while (r - l > 1) {
            int m = l + (r - l) / 2;

            if (chto[m].first <= b) {
                l = m;
            }
            else {
                r = m;
            }
        }

        if (chkmax(mx_ans, pref_max[l].second)) {
            mx_chto = pref_max[l].first;
        }

        cout << mx_chto << ' ' << mx_ans << '\n';
        }
        else {

        int mx_chto = 0, mx_ans = 0;
        for (int curr_b = 1; curr_b <= b; ++curr_b) {
            if (chkmax(mx_ans, cnt(curr_b))) {
                mx_chto = curr_b;
            }
        }

        cout << mx_chto << ' ' << mx_ans << '\n';
        }
    }
}

ll cnt(ll b) {
    int ans = 0;

    while (b) {
        auto it = (int)(upper_bound(all(a), b) - a.begin()) - 1;

        ans += b / a[it];
        b %= a[it];
    }

    return ans;
}
