#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("unswitch-loops")
#pragma GCC target("sse,sse2,ssse3,sse4,avx,avx2,popcnt")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define int long long

#define len(a) (int)a.size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

#ifdef LOCAL
    #define NEW_TEST cout << "-----------TEST-----------\n";
#else
    #define NEW_TEST
#endif

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;

const int MAX     = (int)(4e4) + 7;
const ll INF_INT = (ll)(1e18) + 7;
const ll MOD      = (ll)(1e9)  + 7;
const ll INF_LL   = (ll)(1e18) + 7;

template<typename T> inline void info(T & v) { for (const auto & it : v) { cout << it << ' '; } cout << '\n'; }

template<typename T> inline void init(vector<T> & v, size_t size, T value = 0) { v.assign(size, value); }

template<typename T> inline bool chkmin(T & a, const T & b) { if (a > b) { a = b; return true; } return false; }

template<typename T> inline bool chkmax(T & a, const T & b) { if (a < b) { a = b; return true; } return false; }

void solve();
void boot_up() {
#ifdef LOCAL
    freopen("input.in", "r", stdin);
    freopen("output.out", "w", stdout);
#endif
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
}


int n, q;
vector<int> a;
ll dp[16][MAX];

ll func();
ll func1();
void show(int mask);

signed main() {
    boot_up();

    while (cin >> n) {
        solve();
    }
}

void solve() {
    NEW_TEST;

    init(a, n);
    for (auto & it : a) {
        cin >> it;
    }

    if (n <= 10) {
        cout << func() << '\n';
    }
    else {
        cout << func1() << '\n';
    }
    
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int p, v;
        cin >> p >> v;
        --p;

        a[p] = v;

        if (n <= 10) {
            cout << func() << '\n';
        }
        else {
            cout << func1() << '\n';
        }
    }
}

ll func() {
    ll ans = 0;

    for (int mask = 1; mask <= (1 << n) - 1; ++mask) {
        ll curr_ans = 0;

        string s = "";

        for (int i = 0; i < n; ++i) {
            if ((int)((mask >> i) & 1) == 1) {
                s.push_back('1');
                curr_ans += a[i];
            }
            else {
                s.push_back('0');
            }
        }

        s += s;
        bool flag = true;
        for (int i = 0; i < n; ++i) {
            if (s[i] == '1' && s[i + 1] == '1' && s[i + 2] == '1' && s[i + 3] == '1') {
                flag = false;
                break;
            }
        }

        if (flag) {
            chkmax(ans, curr_ans);
        }
    }

    return ans;
}

ll func1() {
    ll ans = 0;
    // 0...
    for (int mask = 0; mask <= 15; ++mask) {
        if (mask % 2 == 0) {
            dp[mask][3] = 0;
            for (int i = 0; i < 4; ++i) {
                if ((int)((mask >> i) & 1) == 1) {
                    dp[mask][3] += a[i];
                }
            }
        }
        else {
            dp[mask][3] = INF_INT;
        }
    }
    for (int i = 4; i < n; ++i) {
        for (int mask = 0; mask < 15; ++mask) {
            dp[mask][i] = 0;
        }
        for (int prev_mask = 0; prev_mask < 15; ++prev_mask) {
            int fst = prev_mask / 2;
            int scd = prev_mask / 2 + 8;

            if (dp[prev_mask][i - 1] != INF_INT) {
                chkmax(dp[fst][i], dp[prev_mask][i - 1]);
                if (scd != 15) chkmax(dp[scd][i], a[i] + dp[prev_mask][i - 1]);
            }
        }
    }

    for (int mask = 0; mask < 15; ++mask) {
        if (dp[mask][n - 1] != INF_INT) {
            chkmax(ans, dp[mask][n - 1]);
        }
    }
    // 10..
    for (int mask = 0; mask <= 15; ++mask) {
        if (mask % 4 == 1) {
            dp[mask][3] = 0;
            for (int i = 0; i < 4; ++i) {
                if ((int)((mask >> i) & 1) == 1) {
                    dp[mask][3] += a[i];
                }
            }
        }
        else {
            dp[mask][3] = INF_INT;
        }
    }
    for (int i = 4; i < n; ++i) {
        for (int mask = 0; mask < 15; ++mask) {
            dp[mask][i] = 0;
        }
        for (int prev_mask = 0; prev_mask < 15; ++prev_mask) {
            int fst = prev_mask / 2;
            int scd = prev_mask / 2 + 8;

            if (dp[prev_mask][i - 1] != INF_INT) {
                chkmax(dp[fst][i], dp[prev_mask][i - 1]);

                if (scd != 15 && !(i == n - 1 && scd / 2 == 8)) {
                    chkmax(dp[scd][i], a[i] + dp[prev_mask][i - 1]);
                }
            }
        }
    }
    for (int mask = 0; mask < 15; ++mask) {
        if (dp[mask][n - 1] != INF_INT) {
            chkmax(ans, dp[mask][n - 1]);
        }
    }
    // 110..
    for (int mask = 0; mask < 15; ++mask) {
        if (mask % 8 == 3) {
            dp[mask][3] = 0;
            for (int i = 0; i < 4; ++i) {
                if ((int)((mask >> i) & 1) == 1) {
                    dp[mask][3] += a[i];
                }
            }
        }
        else {
            dp[mask][3] = INF_INT;
        }
    }
    for (int i = 4; i < n; ++i) {
        for (int mask = 0; mask < 15; ++mask) {
            dp[mask][i] = 0;
        }
        for (int prev_mask = 0; prev_mask < 15; ++prev_mask) {
            int fst = prev_mask / 2;
            int scd = prev_mask / 2 + 8;

            if (dp[prev_mask][i - 1] != INF_INT) {
                chkmax(dp[fst][i], dp[prev_mask][i - 1]);

                if (scd != 15 && !(i == n - 1 && scd / 4 == 3)) {
                   chkmax(dp[scd][i], a[i] + dp[prev_mask][i - 1]);
                }
            }
        }
    }
    for (int mask = 0; mask < 15; ++mask) {
        if (dp[mask][n - 1] != INF_INT) {
            chkmax(ans, dp[mask][n - 1]);
        }
    }
    // 1110..
    for (int mask = 0; mask <= 15; ++mask) {
        if (mask == 7) {
            dp[mask][3] = a[0] + a[1] + a[2];
        }
        else {
            dp[mask][3] = INF_INT;
        }
    }
    for (int i = 4; i < n; ++i) {
        for (int mask = 0; mask < 15; ++mask) {
            dp[mask][i] = 0;
        }
        for (int prev_mask = 0; prev_mask < 15; ++prev_mask) {
            int fst = prev_mask / 2;
            int scd = prev_mask / 2 + 8;

            if (dp[prev_mask][i - 1] != INF_INT) {
                chkmax(dp[fst][i], dp[prev_mask][i - 1]);

                if (scd != 15 && i != n - 1) {
                    chkmax(dp[scd][i], a[i] + dp[prev_mask][i - 1]);
                }
            }
        }
    }
    for (int mask = 0; mask < 15; ++mask) {
        if (dp[mask][n - 1] != INF_INT) {
            chkmax(ans, dp[mask][n - 1]);
        }
    }

    assert(ans != INF_INT);
    assert(ans != 0);

    return ans;
}

void show(int mask) {
    for (int i = 3; i >= 0; --i) {
        cout << (int)((mask >> i) & 1);
    }
    cout << '\n';
}
