#include <cstring>
#include <string>
#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#define int long long

using namespace std;

struct Event {
    int t, type;
};

bool operator<(const Event &x, const Event &y)
{
    return x.t < y.t || (x.t == y.t && x.type < y.type);
}

int32_t main()
{
    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio(0);
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    vector<int> ans(n);
    vector<Event> ev;
    unordered_map<int, int> ls;
    vector<int> right(n, -1);
    for (int i = n - 1; i >= 0; --i)
    {
        if (ls[a[i]])
        {
            right[i] = ls[a[i]];
        }
        ls[a[i]] = i;
    }
    for (int i = 0; i < n; ++i)
    {
        ev.push_back({ i, 4 });
        if (right[i] != -1)
        {
            ev.push_back({right[i] - i, 0 });
            ev.push_back({right[i] - i + 1 + min(i, n - 1 - right[i]) , 1});
            ev.push_back({right[i] - i + 1 + max(i, n - 1 - right[i]) , 2});
        }
    }
    sort(ev.begin(), ev.end());
    int now = 0, incr = 0, decr = 0;
    for (Event cur : ev)
    {
        if (cur.type == 0)
        {
            ++incr;
        }
        else if (cur.type == 1)
        {
            --incr;
        }
        else if (cur.type == 2)
        {
            ++decr;
        }
        else
        {
            now += incr - decr;
            cout << (n - cur.t) * (cur.t + 1) - now << ' ';
            if (cur.t == n - 1)
                break;
        }
    }
    cout << '\n';
    return 0;
}