#define _CRT_SECURE_NO_WARNINGS
#define rep(n, i) for (int i = 0; i < n; ++i)
#define per(n, i) for (int i = n - 1; i >= 0; --i)
#define allar(a, n) a, a + n
#define allv(a) a.begin(), a.end()
#define mp make_pair
#define fastio ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

#include <algorithm>
#include <string.h>
#include <iostream>
#include <math.h>
#include <string>
#include <random>
#include <chrono>
#include <vector>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef double db;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

const db EPS = 1e-7;

const int N = (int)2e5;

struct node {
	node* l, * r;

	int val, sz, pr;

	node(int val = 0) : l(NULL), r(NULL), val(val), sz(1), pr(rand()) {}
};

int sz(node * a) {
	if (a == NULL) {
		return 0;
	}
	return a->sz;
}

void update(node * a) {
	if (a == NULL) {
		return;
	}
	a->sz = sz(a->l) + sz(a->r) + 1;
}

node* merge(node * a, node * b) {
	if (a == NULL) {
		return b;
	}
	if (b == NULL) {
		return a;
	}
	if (a->pr > b->pr) {
		a->r = merge(a->r, b);
		update(a);
		return a;
	} else {
		b->l = merge(a, b->l);
		update(b);
		return b;
	}
}

pair <node*, node*> split(node * a, int val) {
	if (a == NULL) {
		return { NULL, NULL };
	}
	if (a->val > val) {
		auto l = split(a->l, val);
		a->l = l.second;
		update(a);
		return { l.first, a };
	} else {
		auto r = split(a->r, val);
		a->r = r.first;
		update(a);
		return { a, r.second };
	}
}

pair <node*, node*> split_ind(node* a, int ind) {
	if (a == NULL) {
		return { NULL, NULL };
	}
	if (sz(a->l) >= ind) {
		auto l = split_ind(a->l, ind);
		a->l = l.second;
		update(a);
		return { l.first, a };
	} else {
		auto r = split_ind(a->r, ind - sz(a->l) - 1);
		a->r = r.first;
		update(a);
		return { a, r.second };
	}
}

int n, a[N], s[N], cnt_diff[N], b[N], b_sz, last_ind[N], dist_prev[N];
node* t;

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	scanf("%d", &n);
	rep(n, i) {
		scanf("%d", &a[i]);
		b[i] = a[i];
	}
	sort(allar(b, n));
	b_sz = unique(allar(b, n)) - b;
	rep(n, i) {
		a[i] = lower_bound(allar(b, b_sz), a[i]) - b;
	}
	fill(allar(last_ind, b_sz), -1);
	rep(n, i) {
		dist_prev[i] = i - last_ind[a[i]];
		last_ind[a[i]] = i;
	}
	set <int> cur;
	per(n, i) {
		cur.insert(a[i]);
		cnt_diff[i] = cur.size();
	}
	cur.clear();
	s[0] = n;
	rep(n, i) {
		node* cur = new node(dist_prev[i]);
		auto f = split(t, dist_prev[i]);
		t = merge(f.first, merge(cur, f.second));
	}
	for (int i = 1; i < n; ++i) {
		s[i] = s[i - 1];
		s[i] -= cnt_diff[n - i];
		auto f_ = split(t, dist_prev[i - 1]);
		auto s_ = split_ind(f_.first, sz(f_.first) - 1);
		t = merge(s_.first, f_.second);
		f_ = split(t, i);
		s[i] += sz(f_.second);
		t = merge(f_.first, f_.second);
	}
	rep(n, i) {
		printf("%d ", s[i]);
	}
	return 0;
}