#define _CRT_SECURE_NO_WARNINGS
#define rep(n, i) for (int i = 0; i < n; ++i)
#define per(n, i) for (int i = n - 1; i >= 0; --i)
#define allar(a, n) a, a + n
#define allv(a) a.begin(), a.end()
#define mp make_pair
#define fastio ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

#include <algorithm>
#include <string.h>
#include <iostream>
#include <math.h>
#include <string>
#include <random>
#include <chrono>
#include <vector>
#include <map>
#include <set>
#include <queue>

using namespace std;

typedef long long ll;
typedef double db;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

const db EPS = 1e-7;

struct edge {
	ll from, to, c, cost;

	edge(ll from = 0, ll to = 0, ll c = 0, ll cost = 0) : from(from), to(to), c(c), cost(cost) {}
};

const int N = (int)1e5;

int n, a[N], q, p[N];
ll d[N];
vector <int> G[N];
vector <edge> edge_list;
bool used[N];

void add_edge(int a, int b, int c, int cost) {
	G[a].push_back(edge_list.size());
	edge_list.push_back(edge(a, b, c, cost));
	G[b].push_back(edge_list.size());
	edge_list.push_back(edge(b, a, 0, -cost));
}

bool bfs() {
	queue <int> q;
	q.push(0);
	fill(allar(d, 2 * n + 2), 1e18);
	fill(allar(p, 2 * n + 2), -1);
	fill(allar(used, 2 * n + 2), false);
	d[0] = 0;
	used[0] = true;
	while (q.size()) {
		int v = q.front();
		q.pop();
		used[v] = false;
		for (int u : G[v]) {
			edge e = edge_list[u];
			if (e.c == 0) {
				continue;
			}
			if (d[e.to] > d[v] + e.cost) {
				d[e.to] = d[v] + e.cost;
				p[e.to] = u;
				if (!used[e.to]) {
					q.push(e.to);
					used[e.to] = true;
				}
			}
		}
	}
	return d[2 * n - 1] != 1e18;
}

ll solve() {
	ll ans = 0;
	rep(2 * n + 2, i) {
		G[i].clear();
	}
	rep(n, i) {
		add_edge(0, i + 1, 1, -a[i]);
	}
	rep(n, i) {
		rep(4, k) {
			add_edge((i + k) % n + 1, n + 1 + i, 1, 0);
		}
	}
	rep(n, i) {
		add_edge(n + 1 + i, 2 * n + 1, 3, 0);
	}
	while (bfs()) {
		int cur = 2 * n - 1;
		ll minC = 1e18;
		while (cur != 0) {
			minC = min(minC, edge_list[p[cur]].c);
			cur = edge_list[p[cur]].from;
		}
		cur = 2 * n - 1;
		while (cur != 0) {
			edge e = edge_list[p[cur]];
			ans -= 2 * e.cost * minC;
			edge_list[p[cur]].c -= minC;
			edge_list[p[cur] ^ 1].c += minC;
			cur = edge_list[p[cur]].from;
		}
	}
	return ans;
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	scanf("%d", &n);
	rep(n, i) {
		scanf("%d", &a[i]);
	}
	scanf("%d", &q);
	printf("%lld\n", solve());
	rep(q, i) {
		int p, v;
		scanf("%d%d", &p, &v);
		--p;
		a[p] = v;
		printf("%lld\n", solve());
	}
	return 0;
}