#include <iostream>
#include <vector>
#include <cmath>
#include <set>
#include <unordered_set>
#include <utility>
#include <unordered_map>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")

using namespace std;

#define ll long long
#define pb push_back
#define usi unordered_set<int>
#define Size 800228
unordered_set<int> tree[Size];
vector<int> a;

void merge(usi a, usi b, usi& c) {
	if (a.size() > b.size()) {
		swap(a, b);
	}
	c = b;
	for (int i : a) {
		if (b.find(i) == b.end()) {
			c.insert(i);
		}
	}
	return;
}

void build(int v, int l, int r) {
	if (r - l == 1) {
		tree[v] = { a[l] };
		return;
	}
	int m = (l + r) / 2;
	build(2 * v + 1, l, m);
	build(2 * v + 2, m, r);
	merge(tree[2 * v  +1], tree[2 * v  +2], tree[v]);
	return;
}

unordered_set<int> askseg(int v, int l, int r, int askl, int askr) {
	if (r <= askl || askr <= l) {
		return {};
	}
	if (askl <= l && r <= askr) {
		return tree[v];
	}
	int m = (l + r) / 2;
	unordered_set<int> a = askseg(2 * v + 1, l, m, askl, askr);
	unordered_set<int> b = askseg(2 * v + 2, m, r, askl, askr);
	unordered_set<int> c;
	merge(a, b, c);
	return c;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	a.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	vector<ll> ans(n);
	build(0, 0, n);
	for (int i = 1; i <= n; i++) {
		for (int r = i; r <= n; r++) {
			int l = r - i;
			ans[i - 1] += askseg(0, 0, n, l, r).size();
		}
	}
	for (int i : ans) {
		cout << i << " ";
	}
	return 0;
}