#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#define ll long long
#define pb push_back
#define pii pair<int, int>
#define ft first
#define sd second

using namespace std;

ll u[40005];
ll tree[160005][5][5];

ll inf = 1e17;

void build(int v, int l, int r) {
    if (l + 1 == r) {
        tree[v][1][1] = u[l];
        tree[v][0][0] = 0;
        return;
    }
    build(2 * v + 1, l, (l + r) / 2);
    build(2 * v + 2, (l + r) / 2, r);
    for (int a = 0; a <= 3; ++a) {
        for (int b = 0; b <= 3; ++b) {
            for (int c = 0; c <= 3 - b; ++c) {
                for (int d = 0; d <= 3; ++d) {
                    if (a == (l + r) / 2 - l && d == r - (l + r) / 2) {
                        tree[v][a + d][a + d] = max(tree[v][a + d][a + d], tree[2 * v + 1][a][b] + tree[2 * v + 2][c][d]);
                    } else if (a == (l + r) / 2 - l) {
                        tree[v][a + c][d] = max(tree[v][a + c][d], tree[2 * v + 1][a][b] + tree[2 * v + 2][c][d]);
                    } else if (d == r - (l + r) / 2) {
                        tree[v][a][b + d] = max(tree[v][a][b + d], tree[2 * v + 1][a][b] + tree[2 * v + 2][c][d]);
                    } else {
                        tree[v][a][d] = max(tree[v][a][d], tree[2 * v + 1][a][b] + tree[2 * v + 2][c][d]);
                    }
                }
            }
        }
    }
    /*cout << "^^ " << v << " " << l << " " << r << "\n";
    for (int a = 0; a <= 3; ++a) {
        for (int b = 0; b <= 3; ++b) {
            cout << a << " " << b << " " << tree[v][a][b] << "\n";
        }
    }
    cout << "\n\n";*/
}

void update(int v, int l, int r, int idx, int val) {
    if (l > idx || r <= idx) return;
    if (l == idx && l + 1 == r) {
        tree[v][1][1] = val;
        return;
    }
    update(2 * v + 1, l, (l + r) / 2, idx, val);
    update(2 * v + 2, (l + r) / 2, r, idx, val);
    for (int a = 0; a <= 3; ++a) {
        for (int b = 0; b <= 3; ++b) {
            tree[v][a][b] = -inf;
        }
    }
    /*cout << "(( " << v << " " << l << " " << r << "\n";
    for (int a = 0; a <= 3; ++a) {
        for (int b = 0; b <= 3; ++b) {
            cout << a << " " << b << " " << tree[v][a][b] << "\n";
        }
    }
    cout << "\n\n";*/
    for (int a = 0; a <= 3; ++a) {
        for (int b = 0; b <= 3; ++b) {
            for (int c = 0; c <= 3 - b; ++c) {
                for (int d = 0; d <= 3; ++d) {
                    if (a == (l + r) / 2 - l && d == r - (l + r) / 2) {
                        tree[v][a + d][a + d] = max(tree[v][a + d][a + d], tree[2 * v + 1][a][b] + tree[2 * v + 2][c][d]);
                    } else if (a == (l + r) / 2 - l) {
                        tree[v][a + c][d] = max(tree[v][a + c][d], tree[2 * v + 1][a][b] + tree[2 * v + 2][c][d]);
                    } else if (d == r - (l + r) / 2) {
                        tree[v][a][b + d] = max(tree[v][a][b + d], tree[2 * v + 1][a][b] + tree[2 * v + 2][c][d]);
                    } else {
                        tree[v][a][d] = max(tree[v][a][d], tree[2 * v + 1][a][b] + tree[2 * v + 2][c][d]);
                    }
                }
            }
        }
    }
    /*cout << "^^ " << v << " " << l << " " << r << "\n";
    for (int a = 0; a <= 3; ++a) {
        for (int b = 0; b <= 3; ++b) {
            cout << a << " " << b << " " << tree[v][a][b] << "\n";
        }
    }
    cout << "\n\n";*/
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> u[i];
    }
    for (int i = 0; i < 4 * n; ++i) {
        for (int a = 0; a <= 3; ++a) {
            for (int b = 0; b <= 3; ++b) {
                tree[i][a][b] = -inf;
            }
        }
    }
    build(0, 0, n);
    ll ans = 0;
    for (int a = 0; a <= 3; ++a) {
        for (int b = 0; b <= 3 - a; ++b) {
            //cout << a << " " << b << " " << tree[0][a][b] << "\n";
            ans = max(ans, tree[0][a][b]);
        }
    }
    cout << ans << "\n";
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int x, y;
        cin >> x >> y;
        update(0, 0, n, x - 1, y);
        ll ans = 0;
        for (int a = 0; a <= 3; ++a) {
            for (int b = 0; b <= 3 - a; ++b) {
                ans = max(ans, tree[0][a][b]);
                //cout << a << " " << b << " " << tree[0][a][b] << "\n";
            }
        }
        cout << ans << "\n";
    }
    return 0;
}

