#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <iomanip>
#include <string>
#include <algorithm>
#include <cstring>
#include <cassert>
#include <cmath>
#include <numeric>
#include <queue>
#include <deque>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream& out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(const T &x, ostream &out = cerr) {
	output(x.begin(), x.end(), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int N = 15;
const int mx = 1e5 + 228;
const ll INF = 1e9 + 228;
const ld EPS = 1e-7;
int n, m, q;
ll u[N], len[N], f[mx], a[mx];

ld minimal_time_with_given_overflow(ld delta) {
	ld res = 0;
	for (int i = 0; i < n; ++i) {
		res += (ld)len[i] / ((ld)u[i] + delta);
	}
	return res;
}

ll get_speed_overflow(ll t) {
	// for (int i = 0; i <= 10; ++i) {
	// 	cerr << minimal_time_with_given_overflow(i) << " ";
	// }
	// cerr << endl;
	// cerr << "t = " << t << endl;
	ll l = 0, r = INF;
	while (l < r) {
		ll mid = (l + r) >> 1;
		if (t >= minimal_time_with_given_overflow(mid)) {
			r = mid;
		} else {
			l = mid + 1;
		}
	}
	// cerr << "l = " << l << endl;
	assert(t >= minimal_time_with_given_overflow(l));
	if (l) {
		assert(t < minimal_time_with_given_overflow(l - 1));
	}
	// cerr << "speed = " << l << endl;
	return l;
}

ll money(ll speed, ll t) {
	if (t >= minimal_time_with_given_overflow(EPS)) {
		return 0;
	}
	int pos = lower_bound(a, a + m - 1, speed) - a;
	// if (pos < m - 1 && a[pos] == speed && t >= minimal_time_with_given_overflow((ld)speed + EPS)) {
	// 	pos++;
	// }
	return f[pos];
}

signed main() {
	fast_io();
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> u[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> len[i];
	}
	cin >> m;
	for (int i = 0; i < m - 1; ++i) {
		cin >> a[i];
	}
	for (int i = 0; i < m; ++i) {
		cin >> f[i];
	}
	cin >> q;
	for (int i = 0; i < q; ++i) {
		ll s, t;
		cin >> s >> t;
		ll speed_diff = get_speed_overflow(t - s);
		ll ans = money(speed_diff, t - s);
		cout << ans << "\n";
	}
}
