#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <iomanip>
#include <string>
#include <algorithm>
#include <cstring>
#include <cassert>
#include <cmath>
#include <numeric>
#include <queue>
#include <deque>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream& out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(const T &x, ostream &out = cerr) {
	output(x.begin(), x.end(), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int N = 15;
const int mx = 1e5 + 228;
const ll INF = 1e9 + 228;
const ld EPS = 1e-7;
int n, m, q;
ll u[N], len[N], f[mx], a[mx];

ld minimal_time_with_given_overflow(ld delta) {
	ld res = 0;
	for (int i = 0; i < n; ++i) {
		res += (ld)len[i] / ((ld)u[i] + delta);
	}
	return res;
}

ll solve(ll t) {
	if (t >= minimal_time_with_given_overflow(EPS)) {
		return 0;
	}
	int l = 0, r = m - 1;
	while (l < r) {
		int mid = (l + r) >> 1;
		if (t >= minimal_time_with_given_overflow((ld)a[mid] + EPS)) {
			r = mid;
		} else {
			l = mid + 1;
		}
	}
	// for (int i = 0; i < m - 1; ++i) {
	// 	if (t >= minmal_time_with_given_overflow((ld)a[i] + EPS)) {
	// 		return f[i];
	// 	}
	// }
	return f[l];
}

signed main() {
	fast_io();
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> u[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> len[i];
	}
	cin >> m;
	for (int i = 0; i < m - 1; ++i) {
		cin >> a[i];
	}
	for (int i = 0; i < m; ++i) {
		cin >> f[i];
	}
	cin >> q;
	for (int i = 0; i < q; ++i) {
		ll s, t;
		cin >> s >> t;
		ll ans = solve(t - s);
		cout << ans << "\n";
	}
}
