#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <iomanip>
#include <string>
#include <algorithm>
#include <cstring>
#include <cassert>
#include <cmath>
#include <numeric>
#include <queue>
#include <deque>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream& out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(const T &x, ostream &out = cerr) {
	output(x.begin(), x.end(), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int mx = 2e5 + 228;
int n, a[mx], l[mx];
ll C[mx], X[mx], ans[mx];
map<int, int> elem;

void add_constant(int l, int r, ll c) {
	// cerr << "add_constant " << l << " " << r << " " << c << endl;
	if (l > r) {
		return;
	}
	C[l] += c;
	C[r + 1] -= c;
}

void add_coeff(int l, int r, ll c) {
	// cerr << "add_coeff " << l << " " << r << " " << c << endl;
	if (l > r) {
		return;
	}
	X[l] += c;
	X[r + 1] -= c;
}

void scanline() {
	for (int i = 0; i < n; ++i) {
		C[i] += C[i - 1];
		X[i] += X[i - 1];
		ans[i] = (ll)i * X[i] + C[i];
	}
}

void print_ans() {
	for (int i = 0; i < n; ++i) {
		cout << ans[i] << " ";
	}
	cout << endl;
}

void handle(int a, int b) {
	// cerr << "handle " << a << " " << b << endl;
	if (a > b) {
		swap(a, b);
	}
	add_constant(0, a, 1);
	add_coeff(0, a, 1);
	add_constant(a + 1, b, a + 1);
	add_constant(b + 1, a + b, a + b + 1);
	add_coeff(b + 1, a + b, -1);
}

signed main() {
	fast_io();
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	for (int i = 0; i < n; ++i) {
		if (elem.find(a[i]) == elem.end()) {
			l[i] = -1;
		} else {
			l[i] = elem[a[i]];
		}
		elem[a[i]] = i;
	}
	for (int i = 0; i < n; ++i) {
		handle(i - l[i] - 1, n - i - 1);
	}
	scanline();
	print_ans();
}
