#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <iomanip>
#include <string>
#include <algorithm>
#include <cstring>
#include <cassert>
#include <cmath>
#include <numeric>
#include <queue>
#include <deque>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream& out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(const T &x, ostream &out = cerr) {
	output(x.begin(), x.end(), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

struct op {
	int type, a, b, res;
	op(): type(-1), a(0), b(0), res(0) {}
};

int m, n, s;
vector<vector<op> > ops;
vector<vector<int> > a;
vector<int> z;

int get_op(int line, int pos) {
	if (pos < n) {
		return (a[line][pos] < z[pos]);
	} else {
		return ops[line][pos - n].res;
	}
}

int eval(int line) {
	for (int i = 0; i < n - 1; ++i) {
		int op1 = get_op(line, ops[line][i].a);
		int op2 = get_op(line, ops[line][i].b);
		if (ops[line][i].type == 1) {
			ops[line][i].res = (op1 & op2);
		} else {
			ops[line][i].res = (op1 | op2);
		}
		// cerr << "calculate: " << ops[line][i].a << " " << ops[line][i].b << " " << ops[line][i].type << endl;
		// cerr << "ops " << line << " " << i << " = " << ops[line][i].res << endl;
	}
	int res = get_op(line, 2 * n - 2);
	// cerr << "eval " << line << " " << res << endl;
	return res;
}

int check(int x) {
	for (int i = 0; i < n; ++i) {
		z[i] = min(x, m);
		x -= z[i];
	}
	// cerr << "z" << endl;
	// output(all(z));
	int res = 0;
	for (int i = 0; i < m; ++i) {
		res += eval(i);
	}
	return res;
}

void binsearch() {
	int l = 0, r = n * (m + 1);
	while (l < r) {
		int mid = (l + r) >> 1;
		if (check(mid) >= s) {
			r = mid;
		} else {
			l = mid + 1;
		}
	}
	check(l);
}

void read() {
	cin >> n >> m >> s;
	ops.resize(m, vector<op> (n - 1));
	for (int i = 0; i < m; ++i) {
		for (int j = 0; j < n - 1; ++j) {
			cin >> ops[i][j].a >> ops[i][j].b >> ops[i][j].type;
			ops[i][j].a--;
			ops[i][j].b--;
		}
	}
	a.resize(m, vector<int> (n));
	for (int i = 0; i < m; ++i) {
		for (int j = 0; j < n; ++j) {
			cin >> a[i][j];
		}
	}
	z.resize(n);
}

signed main() {
	fast_io();
	read();
	// check(2);
	binsearch();
	output(all(z), cout);
}
