#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <iomanip>
#include <string>
#include <algorithm>
#include <cstring>
#include <cassert>
#include <cmath>
#include <numeric>
#include <queue>
#include <deque>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream& out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(const T &x, ostream &out = cerr) {
	output(x.begin(), x.end(), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int K = 3;

struct data {
	ll dp[K + 1][K + 1];
	int len;

	data() {
		len = 0;
		for (int i = 0; i <= K; ++i) {
			for (int j = 0; j <= K; ++j) {
				dp[i][j] = 0;
			}
		}
	}

	data(ll x) {
		len = 1;
		for (int i = 0; i <= K; ++i) {
			for (int j = 0; j <= K; ++j) {
				dp[i][j] = 0;
			}
		}
		dp[1][1] = x;
	}
};

data merge(data a, data b) {
	data res;
	res.len = a.len + b.len;
	for (int la = 0; la <= min(K, a.len); ++la) {
		for (int ra = 0; ra <= min(K, a.len); ++ra) {
			if (la + ra >= a.len && (la != a.len || ra != a.len)) {
				continue;
			}
			for (int lb = 0; lb <= min(K, b.len); ++lb) {
				for (int rb = 0; rb <= min(K, b.len); ++rb) {
					if (lb + rb >= b.len && (lb != b.len || rb != b.len)) {
						continue;
					}
					if (ra + lb <= K) {
						int new_l = (la == a.len ? la + lb : la);
						int new_r = (rb == b.len ? rb + ra : rb);
						chkmax(res.dp[new_l][new_r], a.dp[la][ra] + b.dp[lb][rb]);
					}
				}
			}
		}
	}
	return res;
}

struct st {
	vector<data> t;
	int n;

	st() {}

	void build(const vector<ll> &a, int v, int tl, int tr) {
		if (tl == tr) {
			t[v] = data(a[tl]);
		} else {
			int tm = (tl + tr) >> 1;
			build(a, v * 2, tl, tm);
			build(a, v * 2 + 1, tm + 1, tr);
			t[v] = merge(t[v * 2], t[v * 2 + 1]);
		}
	}

	void build(const vector<ll> &a) {
		n = a.size();
		t.resize(4 * n);
		build(a, 1, 0, n - 1);
	}

	void update(int pos, ll val, int v, int tl, int tr) {
		if (tl == tr) {
			t[v] = data(val);
		} else {
			int tm = (tl + tr) >> 1;
			if (pos <= tm) {
				update(pos, val, v * 2, tl, tm);
			} else {
				update(pos, val, v * 2 + 1, tm + 1, tr);
			}
			t[v] = merge(t[v * 2], t[v * 2 + 1]);
		}
	}

	void update(int pos, ll val) {
		update(pos, val, 1, 0, n - 1);
	}

	ll get() {
		ll ans = 0;
		for (int i = 0; i <= K; ++i) {
			for (int j = 0; j <= K; ++j) {
				if (i + j <= K) {
					chkmax(ans, t[1].dp[i][j]);
				}
			}
		}
		return ans;
	}
};

st t;
int n, q;
vector<ll> a;

signed main() {
	fast_io();
	cin >> n;
	a.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	t.build(a);
	cout << t.get() << "\n";
	cin >> q;
	for (int i = 0; i < q; ++i) {
		int pos;
		ll val;
		cin >> pos >> val;
		t.update(pos, val);
		cout << t.get() << "\n";
	}
}
