/// YUR3K ///
#include <iostream>
#include <vector>
#include <cmath>
#include <map>
#pragma GCC optimize ("O3")
#define int long long
using namespace std;

vector<vector<map<int, int>>> ft;

inline int f(int k)
{
    return k & (k+1);
}

map<int, int> operator+(map<int, int> u, map<int, int> v)
{
    auto ans = u;
    for (auto i : v)
    {
        if (ans.count(i.first) == 1)
            ans[i.first] += i.second;
        else
            ans[i.first] = i.second;
    }
    return ans;
}

map<int, int> operator-(map<int, int> u, map<int, int> v)
{
    auto ans = u;
    for (auto i : v)
    {
        ans[i.first] -= i.second;
    }
    return ans;
}

inline void gen_ft(int n, int m)
{
    ft.resize(n);
    for (int i = 0; i < n; i++)
    {
        ft[i].resize(m);
        for (int j = 0; j < m; j++)
            ft[i][j] = map<int, int>();
    }
}

void update_ft(int n, int m, int X, int Y, int val)
{
    for (int i = X; i < n; i = i|(i+1))
        for (int j = Y; j < m; j = j|(j+1))
        {
            if (ft[i][j].count(val) == 0)
                ft[i][j][val] = 0;
            ft[i][j][val]++;
        }
}


int query_ft(int X, int Y, int el)
{
    //cout << "Querying\n";
    int ans = 0;
    for (int i = X; i >= 0; i = f(i)-1)
        for (int j = Y; j >= 0; j = f(j)-1)
        {
            if (ft[i][j].count(el) == 1)
                ans += ft[i][j][el];
        }
    return ans;
}


inline void fastio()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}
signed main()
{
    fastio();

    int n, x;
    cin >> n >> x;

    gen_ft(n, n);
    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++)
        {
            update_ft(n, n, i, j, (i+1)*(j+1));
        }

    int ans = 0;
    int mirror = 0;
    for (int a = 2; a < n; a++)
    {
        if (a == x)
            continue;
        for (int b = 2; (a+b <= n+1) && (b <= a); b++)
        {
            if (b == x)
                continue;

            int poly = a*b - n;
            int this_ans = query_ft(a-2, b-2, poly);
            if (a == b)
                mirror += this_ans;
            ans += this_ans;
        }
    }

    cout << 2 * ans - mirror;

    return 0;
}
