#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <iomanip>

#define ll long long
#define ld long double

using namespace std;

struct der {
    int a, b, op;
    der() {
        a = 0;
        b = 0;
        op = 0;
    }
};


vector<vector<int>> val;
vector<int> z(2);
vector<der> g;

bool build(int s) {
    int tr = 0;
    for (int i = 0; i < g.size(); ++i) {
        if (g[i].op == 1) {
            if (val[i][g[i].a] < z[0] && val[i][g[i].b] < z[1]) {
                tr++;
            }
        }
        else {
            if (val[i][g[i].a] < z[g[i].a] || val[i][g[i].b] < z[g[i].b]) {
                tr++;
            }
        }
    }
    return tr == s;
}

int main()
{
    int n, m, s;
    cin >> n >> m >> s;
    if (n == 1) {
        cout << s;
        return 0;
    }
    if (n != 2) {
        cout << 0;
        return 0;
    }
    g.resize(m);
    for (int i = 0; i < m; ++i) {
        cin >> g[i].a >> g[i].b >> g[i].op;
        g[i].a--; g[i].b--;
    }
    val.resize(m, vector<int>(n));
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> val[i][j];
        }
    }

    for (int i = 0; i < m + 1; ++i) {
        z[0] = i;
        for (int j = 0; j < m + 1; ++j) {
            if (j == i) {
                continue;
            }
            z[1] = j;
            if (build(s)) {
                cout << z[0] << " " << z[1];
                return 0;
            }
        }
    }
}