
// Created by olymp on 16.01.2020.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <utility>
#include <cstdlib>
#include <stack>
#include <queue>
#include <deque>
#include <cmath>

const int N = 5000;
using namespace std;
using ll = long long;
using ld = long double;

vector<bool> make(const vector<bool>& a, const vector<bool> &b)
{
    vector<bool> ans(a.size());
    for (int i = 0; i < a.size(); ++i) {
        ans[i] = a[i] || b[i];
    }
    return ans;
}

int take(const vector<bool> &a)
{
    int ans = 0;
    for (int i = 0; i < a.size(); ++i) {
        if (a[i])
        {
            ++ans;
        }
    }
    return ans;
}

void build(int v, int l, int r, vector<vector<bool>>& tree, const vector<int>& a)
{
    if (r - l == 1)
    {
        tree[v][a[l]] = true;
        return;
    }
    int mid = (l + r) / 2;
    build(2 * v + 1, l, mid, tree, a);
    build(2 * v + 2, mid, r, tree, a);
    tree[v] = make(tree[2 * v + 1], tree[2 * v + 2]);
}

vector<bool> get(int v, int l, int r, int ql, int qr, vector<vector<bool>>& tree)
{
    if (ql <= l && qr >= r)
    {
        return tree[v];
    }
    if (ql >= r || qr < l) {
        vector<bool> ans(N, false);
        return ans;
    }
    int mid = (l + r / 2);
    return make(get(2 * v + 1, l, mid, ql, qr, tree), get(2 * v + 2, mid, r, ql, qr, tree));
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> v(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }
    vector<vector<bool>> tree(4 * N, vector<bool> (N, false));
    build(0, 0, n, tree, v);
    for (int i = 0; i <= n; ++i) {
        int ans = 0;
        for (int j = 0; j + i < n; ++j) {
//cout << take(get(0, 0, n, j, i + j + 1, tree)) << endl;
            ans += take(get(0, 0, n, j, j + i + 1, tree));
        }
        cout << ans << ' ';
    }
    cout << endl;
}

