#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector<vector<bool>> tree;

vector<bool> make(int a, int b)
{
    vector<bool> ans(tree[a].size());
    for (int i = 0; i < tree[a].size(); ++i) {
        ans[i] = tree[a][i] || tree[b][i];
    }
    return ans;
}

int take(int v)
{
    int ans = 0;
    for (int i = 0; i < tree[v].size(); ++i) {
        if (tree[v][i])
        {
            ++ans;
        }
    }
    return ans;
}

void build(int v, int l, int r, const vector<int> &a)
{
    if (r - l == 1)
    {
        tree[v][a[l]] = true;
        return;
    }
    int mid = (l + r) / 2;
    build(2 * v + 1, l, mid, a);
    build(2 * v + 2, mid, r, a);
    tree[v] = make(2 * v + 1, 2 * v + 2);
}

int get(int v, int l, int r, int ql, int qr)
{
    if (ql <= l && qr >= r)
    {
        return take(v);
    }
    if (ql >= r || qr < l) {
        return 0;
    }
    int mid = (l + r / 2);
    return get(2 * v + 1, l, mid, ql, qr) + get(2 * v + 2, mid, r, ql, qr);
}

int main()
{
    int n;
    cin >> n;
    vector<int> v(n);
    int mx = 0;
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
        mx = max(mx, v[i]);
    }
    tree.assign(4 * n, vector<bool>(mx + 1, false));
    build(0, 0, n, v);
    for (int i = 0; i <= n; ++i) {
        int ans = 0;
        for (int j = 0; j + i < n; ++j) {
            ans += get(0, 0, n, j, j + i + 1);
        }
        cout << ans << ' ';
    }
    cout << endl;
}

