#include <iostream>
#include <vector>

using namespace std;

vector<vector<bool>> tree;
vector<int> a;

void make(int a, int b, int c)
{
    for (int i = 0; i < tree[a].size(); ++i) {
        tree[c][i] = tree[a][i] || tree[b][i];
    }
}

int take(int v)
{
    int ans = 0;
    for (int i = 0; i < tree[v].size(); ++i) {
        if (tree[v][i])
        {
            ++ans;
        }
    }
    return ans;
}

void build(int v, int l, int r)
{
    if (r - l == 1)
    {
        tree[v][a[l]] = true;
        return;
    }
    int mid = (l + r) / 2;
    build(2 * v + 1, l, mid);
    build(2 * v + 2, mid, r);
    make(2 * v + 1, 2 * v + 2, v);
}

int get(int v, int l, int r, int ql, int qr)
{
    if (ql <= l && qr >= r)
    {
        return take(v);
    }
    if (ql >= r || qr < l) {
        return 0;
    }
    int mid = (l + r / 2);
    return get(2 * v + 1, l, mid, ql, qr) + get(2 * v + 2, mid, r, ql, qr);
}

int main()
{
    int n;
    cin >> n;
    a.resize(n);
    tree.assign(4 * n, vector<bool>(51, false));
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    build(0, 0, n);
    for (int i = 0; i < n; ++i) {
        int ans = 0;
        for (int j = 0; j + i < n; ++j) {
            ans += get(0, 0, n, j, j + i + 1);
        }
        cout << ans << ' ';
    }
    cout << endl;
}

