#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int m = 1, *tree;

void build_tree(int n)
{
    while (m < n)
        m *= 2;
    tree = new int[2*m];
    fill(tree, tree + 2 * m, 0);
}

void add(int l, int r, int k, int b)
{
    for (int i = l; i < r; ++i)
        tree[i] += k * i + b;
}

void destroy_tree()
{
    delete[] tree;
}

vector<int> solve(vector<int> a)
{
    int n = a.size(), prev[n], pos[n];
    fill(pos, pos + n, -1);
    for (int i = 0; i < n; ++i)
        prev[i] = pos[a[i]], pos[a[i]] = i;
    build_tree(n);
    /*cout << "prev: ";
    for (int i = 0; i < n; ++i)
        cout << prev[i] << ' ';
    cout << '\n';*/
    for (int i = 0; i < n; ++i)
    {
        int first_threshold = i - prev[i], second_threshold = n - i, window = first_threshold + second_threshold - 1;
        if (second_threshold < first_threshold)
            swap(first_threshold, second_threshold);
        //cout << "for i = " << i << " first_threshold = " << first_threshold << ", second_threshold = " << second_threshold << '\n';
        add(0, first_threshold, 1, 1);
        add(first_threshold, second_threshold, 0, first_threshold);
        add(second_threshold, window, -1, window);
        /*cout << "now tree: ";
        for (int i = 0; i < n; ++i)
            cout << tree[i] << ' ';
        cout << '\n';*/
    }
    vector<int> ans;
    for (int i = 0; i < n; ++i)
        ans.push_back(tree[i]);
    destroy_tree();
    return ans;
}

int main()
{
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    vector<int> all;
    for (int i = 0; i < n; ++i)
        all.push_back(a[i]);
    sort(all.begin(), all.end());
    for (int i = 0; i < n; ++i)
        a[i] = lower_bound(all.begin(), all.end(), a[i]) - all.begin();
    vector<int> x(solve(a));
    for (int y: x)
        cout << y << ' ';
    return 0;
}
