#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int m = 1, *tree_k, *tree_b, *tree;

void build_tree(int n)
{
    while (m < n)
        m *= 2;
    tree_k = new int[2*m];
    tree_b = new int[2*m];
    tree = new int[2*m];
    fill(tree, tree + 2 * m, 0);
    fill(tree_k, tree_k + 2 * m, 0);
    fill(tree_b, tree_b + 2 * m, 0);
}

void push(int id, int tl, int tr, int tm)
{
    if (id >= m)
    {
        tree[id] += tree_k[id] * (id - m) + tree_b[id];
        return void(tree_k[id] = tree_b[id] = 0);
    }
    tree_b[2*id] += tree_b[id], tree_b[2*id+1] += tree_b[id], tree_b[id] = 0;
    tree_k[2*id] += tree_k[id], tree_k[2*id+1] += tree_k[id], tree_k[id] = 0;
}

void add(int id, int l, int r, int tl, int tr, int k, int b)
{
    if (l == r)
        return;
    //cout << "add " << id << ' ' << l << ' ' << r << ' ' << tl << ' ' << tr << ' ' << k << ' ' << b << '\n';
    if (l == tl && r == tr)
    {
        tree_k[id] += k, tree_b[id] += b;
        return;
    }
    int tm = (tl + tr) / 2;
    push(id, tl, tr, tm);
    if (r <= tm)
        return add(2 * id, l, r, tl, tm, k, b);
    if (l >= tm)
        return add(2 * id + 1, l, r, tm, tr, k, b);
    add(2 * id, l, tm, tl, tm, k, b);
    add(2 * id + 1, tm, r, tm, tr, k, b);
}

int get(int id, int pos, int tl, int tr)
{
    //cout << "get " << id << ' ' << pos << ' ' << tl << ' ' << tr << '\n';
    int tm = (tl + tr) / 2;
    push(id, tl, tr, tm);
    if (tr == tl + 1 && tl == pos)
        return tree[id];
    if (pos < tm)
        return get(2 * id, pos, tl, tm);
    else
        return get(2 * id + 1, pos, tm, tr);
}

void destroy_tree()
{
    delete[] tree;
    delete[] tree_k;
    delete[] tree_b;
}

vector<int> solve(vector<int> a)
{
    int n = a.size(), prev[n], pos[n];
    fill(pos, pos + n, -1);
    for (int i = 0; i < n; ++i)
        prev[i] = pos[a[i]], pos[a[i]] = i;
    build_tree(n);
    for (int i = 0; i < n; ++i)
    {
        int first_threshold = i - prev[i], second_threshold = n - i, window = first_threshold + second_threshold - 1;
        if (second_threshold < first_threshold)
            swap(first_threshold, second_threshold);
        //cout << "--\n";
        add(1, 0, first_threshold, 0, m, 1, 1);
        //cout << "--\n";
        add(1, first_threshold, second_threshold, 0, m, 0, first_threshold);
        //cout << "--\n";
        add(1, second_threshold, window, 0, m, -1, window);
        //cout << "--\n";
    }
    vector<int> ans;
    for (int i = 0; i < n; ++i)
        ans.push_back(get(1, i, 0, m));
    destroy_tree();
    return ans;
}

int main()
{
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    vector<int> all;
    for (int i = 0; i < n; ++i)
        all.push_back(a[i]);
    sort(all.begin(), all.end());
    for (int i = 0; i < n; ++i)
        a[i] = lower_bound(all.begin(), all.end(), a[i]) - all.begin();
    vector<int> x(solve(a));
    for (int y: x)
        cout << y << ' ';
    return 0;
}
