#include <iostream>
#include <random>
#include <vector>
#include <algorithm>
#define int long long
using namespace std;
const int N = 1e6;
mt19937 g(88);

struct item
{
    int key, add = 0, mv, mv_id = 0, sz = 1, l = 0, r = 0;
    item() {}
};

item all[N];
int q = 1;

int make_item() {return q++;}
int make_item(int key)
{
    all[q].key = key, all[q].mv = key;
    return q++;
}

inline int sz(int v) {return v ? all[v].sz : 0;}
inline int max(int v) {return v ? all[v].mv : -1;}
inline int max_pos(int v) {return v ? all[v].mv_id : 0;}

inline int max(int a, int b) {return a > b ? a : b;}
inline int max(int a, int b, int c) {return max(a, max(b, c));}

void push(int id)
{
    int a = all[id].add;
    all[id].key += a, all[id].mv += a;
    if (all[id].l)
        all[all[id].l].add += a;
    if (all[id].r)
        all[all[id].r].add += a;
}

void upd(int id)
{
    all[id].sz = 1 + sz(all[id].l) + sz(all[id].r);
    all[id].mv = max(all[id].key, max(all[id].l), max(all[id].r));
    if (all[id].l && all[id].mv == all[all[id].l].mv)
        all[id].mv_id = all[all[id].l].mv_id;
    else if (all[id].key == all[id].mv)
        all[id].mv_id = sz(all[id].l);
    else
        all[id].mv_id = sz(all[id].l) + 1 + all[all[id].r].mv_id;
}

void split(int t, int key, int& l, int& r)
{
    if (!t)
        return void(l = r = 0);
    push(t);
    if (key <= sz(all[t].l))
        split(all[t].l, key, l, all[t].l), r = t;
    else
        split(all[t].r, key - sz(all[t].l) - 1, all[t].r, r), l = t;
    upd(l), upd(r);
}

inline unsigned long long gen() {return ((long long)g() << 32) + g();}

void merge(int& t, int l, int r)
{
    if (!l || !r)
        return void(t = 0);
    push(l), push(r);
    int szl = sz(l), szr = sz(r);
    if (gen() % (szl + szr) < szl)
        merge(all[l].r, all[l].r, r), t = l;
    else
        merge(all[r].l, l, all[r].l), t = r;
    upd(t);
}

void print(int t)
{
    if (!t)
        return;
    push(t);
    print(all[t].l);
    cout << all[t].key << "(" << all[t].add << ';' << all[t].mv << ';' << all[t].mv << ';' << all[t].mv_id << ") ";
    print(all[t].r);
}

signed main()
{
    /*int t = make_item();
    while (true)
    {
        string s;
        cin >> s;
        if (s == "add")
        {
            int pos, val;
            cin >> pos >> val;
            int mc = make_item(), mcc = make_item();
            split(t, pos, mc, t);
            split(t, 1, t, mcc);
            all[t].add += val;
            cout << '{' << t << ';' << all[t].add << '}';
            print(mc), cout << '\n';
            print(t), cout << '\n';
            print(mcc), cout << '\n';
            push(t);
            print(mc), cout << '\n';
            print(t), cout << '\n';
            print(mcc), cout << '\n';
            merge(t, t, mcc);
            merge(t, mc, t);
        }
        cout << "tree: ", print(t), cout << '\n';
    }*/
    int n;
    cin >> n;
    int a[n];
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    int q;
    cin >> q;
    int b[q];
    for (int i = 0; i < q; ++i)
        cin >> b[i];
    int top[n] = {0}, fp[n] = {0};
    for (int i = 1; i < n; ++i)
        top[i] = a[i] / a[i-1] - 1 + top[i-1] + (fp[i-1] < a[i] % a[i-1]),
        fp[i] = fp[i-1] + a[i-1] * (a[i] / a[i-1] - 1 + (fp[i-1] < a[i] % a[i-1]));
    /*cout << "top: ";
    for (int i = 0; i < n; ++i)
        cout << top[i] << ' ';
    cout << '\n';
    cout << "fp: ";
    for (int i = 0; i < n; ++i)
        cout << fp[i] << ' ';
    cout << '\n';*/
    for (int i = 0; i < q; ++i)
    {
        b[i]++;
        int u = upper_bound(a, a + n, b[i]) - a - 1;
        int to = b[i] / a[u] - 1 + top[u] + (fp[u] < b[i] % a[u]);
        int f = fp[u] + a[u] * (b[i] / a[u] - 1 + (fp[u] < b[i] % a[u]));
        cout << to << ' ' << f << '\n';
    }
    return 0;
}
