#include <iostream>
#include <algorithm>
#define int long long
using namespace std;
const int N = 40000;
const int inf = 100;

int n, m = 1, a[N];

struct node
{
    int dp[4][4], tl, tr, l = -1, r = -1;
    node()
    {
        for (int i = 0; i < 4; ++i)
            for (int j = 0; j < 4; ++j)
                dp[i][j] = -inf;
    }
    node(int _tl, int _tr)
    {
        node();
        tl = _tl, tr = _tr;
    }
};

node tree[4*N];
int vcnt = 1;

inline int max(int a, int b) {return a > b ? a : b;}
/*
void print_tree()
{
    cout << "tree:\n";
    for (int v = 1; v < 2 * m; ++v)
    {
        cout << "tree vertex " << v << ":\n";
        for (int i = 0; i < 4; ++i)
            for (int j = 0; j < 4; ++j)
                cout << '\t' << i << ' ' << j << '\t' << tree[v].dp[i][j] << '\n';
    }
}*/

void merge(int v)
{
    //cout << 'i';
    for (int i = 0; i < 4; ++i)
        for (int j = 0; j < 4; ++j)
            tree[v].dp[i][j] = -inf;
    //cout << "merging " << v << " from " << tree[v].l << " and " << tree[v].r << '\n';
    int sz = tree[v].tr - tree[v].tl;
    //cout << '[' << sz << ']';
    if (sz < 6)
    {
        for (int i = 0; i < 4; ++i)
        {
            for (int j = 0; j < 4; ++j)
            {
                int model[sz];
                fill(model, model + sz, 0);
                while (model[0] < 2)
                {
                    bool models = i <= sz && j <= sz;
                    if (models)
                        models &= count(model, model + i, 1) == i && count(model + sz - j, model + sz, 1) == j
                            && (i == sz || !model[i]) && (j == sz || !model[sz-1-j]);
                    if (models)
                    {
                        int th_ans = 0;
                        for (int k = 0; k < sz; ++k)
                            th_ans += model[k] * a[tree[v].tl+k];
                        tree[v].dp[i][j] = max(tree[v].dp[i][j], th_ans);
                    }
                    model[sz-1]++;
                    for (int k = sz - 1; k; --k)
                        if (model[k] == 2)
                            model[k] = 0, model[k-1]++;
                }
            }
        }
        //cout << "easy\n";
        return;
    }
    int l_ = tree[v].l, r_ = tree[v].r;
    for (int i = 0; i < 4; ++i)
        for (int j = 0; j < 4; ++j)
            for (int k = 0; k < 4; ++k)
                for (int l = 0; l < 4 - k; ++l)
                    //cout << i << ' ' << j << ' ' << k << ' ' << l << ' ' << tree[l_].dp[i][k] << " + ",
                    //cout << tree[r_].dp[l][j] << " = " << tree[l_].dp[i][k] + tree[r_].dp[l][j] << '\n',
                    tree[v].dp[i][j] = max(tree[v].dp[i][j], tree[l_].dp[i][k] + tree[r_].dp[l][j]);
    //cout << "done\n";
}

void build_tree(int v, int tl, int tr)
{
    //cout << "building " << v << " on [" << tl << ';' << tr << ")\n";
    tree[v].tl = tl, tree[v].tr = tr;
    if (tl + 1 == tr)
    {
        for (int i = 0; i < 4; ++i)
            for (int j = 0; j < 4; ++j)
                tree[v].dp[i][j] = i == 1 && j == 1 ? a[tl] : -inf;
        return;
    }
    int tm = (tl + tr) / 2;
    build_tree(tree[v].l = vcnt++, tl, tm);
    build_tree(tree[v].r = vcnt++, tm, tr);
    merge(v);
    /*cout << "node " << v << " [" << tl << ';' << tr << ") " << tree[v].l << ' ' << tree[v].r << ":\n\t";
    for (int i = 0; i < 4; ++i, cout << "\t\t")
        for (int j = 0; j < 4; ++j)
            cout << tree[v].dp[i][j] << ' ';
    cout << '\n';*/
}

void update(int v, int pos, int nv, int tl, int tr)
{
    //cout << "upd " << v << " [" << tl << ';' << tr << ") on " << pos << " with " << nv << '\n';
    if (tl == pos && tr == tl + 1)
    {
        for (int i = 0; i < 4; ++i)
            for (int j = 0; j < 4; ++j)
                tree[v].dp[i][j] = i == 1 && j == 1 ? (a[tl] = nv) : -inf;
        return;
    }
    int tm = (tl + tr) / 2;
    if (pos < tm)
        update(tree[v].l, pos, nv, tl, tm);
    else
        update(tree[v].r, pos, nv, tm, tr);
    merge(v);
}

int get()
{
    int ans = -inf;
    for (int i = 0; i < 4; ++i)
        for (int j = 0; j < 4 - i; ++j)
            ans = max(ans, tree[0].dp[i][j]);
    return ans;
}

signed main()
{
    cin >> n;
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    while (m < n)
        m *= 2;
    build_tree(0, 0, n);
    int q;
    cin >> q;
    int p[q], v[q];
    for (int i = 0; i < q; ++i)
        cin >> p[i] >> v[i];
    cout << get() << '\n';
    for (int i = 0; i < q; ++i)
    {
        update(0, --p[i], v[i], 0, n);
        cout << get() << '\n';
    }
    return 0;
}
