#include <iostream>

using namespace std;

#include <deque>
#include <vector>
#include <set>
#include <map>

double bin_search(int l, int r, int x, vector<int> intervals) {
    while (r - l > 1) {
        int m = (r + l) / 2;
        if (intervals[m] <= x) {
            l = m;
        } else {
            r = m;
        }
    }
    return l + 1;
}

double bin_search1(double l, double r, double time, vector<double> length_roads, vector<double> speed_limit, int n) {
    for (int g = 0; g < 20; g++) {
        double m = (r + l) / 2;
        double lol = 0;
        for (int i = 0; i < n; i++) {
            lol += length_roads[i] / (speed_limit[i] + m);
        }
        if (lol < time) {
            r = m;
        } else {
            l = m;
        }
    }
    return l;
}


double count_limit(double time, vector<double> roads_time, vector<double> length_roads, vector<double> speed_limit, int n) {
    double num = 0;
    for (auto c: roads_time) num += c;
    if (time >= num) {
        return 0;
    } else {
        return bin_search1(-1.0, 1000000.0, time, length_roads, speed_limit, n);
    }
}

int main() {
    int n;
    cin >> n;
    vector<double> speed_limit;
    for (int i = 0; i < n; i++) {
        double temp;
        cin >> temp;
        speed_limit.push_back(temp);
    }
    vector<double> length_roads;
    for (int i = 0; i < n; i++) {
        double temp;
        cin >> temp;
        length_roads.push_back(temp);
    }
    vector<double> roads_time;
    for (int i = 0; i < n; i++) {
        roads_time.push_back(length_roads[i] / speed_limit[i]);
    }


    int m;
    cin >> m;
    vector<int> intervals;
    for (int i = 0; i < m - 1; i++) {
        double temp;
        cin >> temp;
        intervals.push_back(temp);
    }
    vector<double > cost;
    for (int i = 0; i < m; i++) {
        double temp;
        cin >> temp;
        cost.push_back(temp);
    }
    int q;
    cin >> q;
    for (int h = 0; h < q; h++) {
        double tin, tout;
        cin >> tin >> tout;
        double time = tout - tin;
        double more_limit = count_limit(time, roads_time, length_roads, speed_limit, n);
        cout << endl;
        if (more_limit == 0) {
            cout << 0 << endl;
        } else {
            double x = bin_search(-1.0, m - 1, more_limit, intervals);
            cout << cost[x] << endl;
        }
    }
}