#include <iostream>

using namespace std;

#include <deque>
#include <vector>

long long bin_search(long long l, long long r, long long x, vector<long long> intervals) {
    while (r - l > 1) {
        long long m = (r + l) / 2;
        if (intervals[m] <= x) {
            l = m;
        } else {
            r = m;
        }
    }
    return l + 1;
}

long double bin_search1(long double  l, long double  r, long long time, vector<long double > length_roads, vector<long double > speed_limit, long long n) {
    for (int g = 0; g < 20; g++) {
        long double  m = (r + l) / 2;
        long double  lol = 0;
        for (long long i = 0; i < n; i++) {
            lol += length_roads[i] / (speed_limit[i] + m);
        }
        if (lol < time) {
            r = m;
        } else {
            l = m;
        }
    }
    return l;
}


long double  count_limit(long long time, vector<long double > roads_time, vector<long double > length_roads, vector<long double > speed_limit, long long n) {
    long double num = 0;
    for (auto c: roads_time) num += c;
    if (time >= num - 10e-6) {
        return 0;
    } else {
        return bin_search1(-1.0, 1000000.0, time, length_roads, speed_limit, n);
    }
}

signed main() {
    long long n;
    cin >> n;
    vector<long double > speed_limit;
    for (long long i = 0; i < n; i++) {
        long double  temp;
        cin >> temp;
        speed_limit.push_back(temp);
    }
    vector<long double > length_roads;
    for (long long i = 0; i < n; i++) {
        long double  temp;
        cin >> temp;
        length_roads.push_back(temp);
    }
    vector<long double > roads_time;
    for (long long i = 0; i < n; i++) {
        roads_time.push_back(length_roads[i] / speed_limit[i]);
    }


    long long m;
    cin >> m;
    vector<long long> intervals;
    for (long long i = 0; i < m - 1; i++) {
        long long temp;
        cin >> temp;
        intervals.push_back(temp);
    }
    vector<long long > cost;
    for (long long i = 0; i < m; i++) {
        long long temp;
        cin >> temp;
        cost.push_back(temp);
    }
    long long q;
    cin >> q;
    for (long long h = 0; h < q; h++) {
        long long tin, tout;
        cin >> tin >> tout;
        long long time = tout - tin;
        long double  more_limit = count_limit(time, roads_time, length_roads, speed_limit, n);
        if (more_limit == 0) {
            cout << 0 << endl;
        } else {
            long double  x = bin_search(-1.0, m - 1, more_limit, intervals);
            cout << cost[x] << endl;

        }
    }
}