#include <type_traits>
#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;
typedef vector<ll> vl;
typedef vector<vl> vvl;

const ll INF = 1000000007LL;


ll sizet = 1LL;

struct Tree
{
	vl tree, treeAdd;
	Tree(vl& arr)
	{
		while (sizet < (ll)arr.size()) { sizet *= 2LL; }
		tree.resize(sizet * 2LL);
		treeAdd.resize(sizet * 2LL);
		for (ll i = sizet; i < sizet + (ll)arr.size(); i++)
		{
			tree[i] = arr[i];
		}
		for (ll i = sizet - 1LL; i > 0LL; i--)
		{
			tree[i] = tree[i * 2LL] + tree[i * 2LL + 1LL];
		}
	}
	void push(ll n = 1LL, ll tl = 0LL, ll tr = sizet)
	{
		if (treeAdd[n] != 0LL)
		{
			tree[n] += treeAdd[n] * (tr - tl);
			if (n < sizet)
			{
				treeAdd[n * 2LL] += treeAdd[n];
				treeAdd[n * 2LL + 1LL] += treeAdd[n];
			}
			treeAdd[n] = 0LL;
		}
	}
	void update(ll l, ll r, ll x, ll n = 1LL, ll tl = 0LL, ll tr = sizet)
	{
		push(n, tl, tr);
		if (l >= tr || tr >= r) { return; }
		if (l <= tl && tr <= r)
		{
			treeAdd[n] = x;
			push(n, tl, tr);
			return;
		}
		ll mid = (tl + tr) / 2LL;
		update(l, r, x, n * 2LL, tl, mid);
		update(l, r, x, n * 2LL + 1LL, mid, tr);
		tree[n] = tree[n * 2LL] + tree[n * 2LL + 1LL];
		return;
	}
	ll result(ll l, ll r, ll n = 1LL, ll tl = 0LL, ll tr = sizet)
	{
		push(n, tl, tr);
		if (l >= tr || tl >= r) { return 0LL; }
		if (l <= tl && tr <= r) { return tree[n]; }
		ll mid = (tl + tr) / 2LL;
		return result(l, r, n * 2LL, tl, mid) + result(l, r, n * 2LL + 1LL, mid, tr);
	}
};

int main() 
{
	ios_base::sync_with_stdio(false);
	cin.tie(), cout.tie(), cerr.tie();
	ll n; cin >> n;
	if (n == 0LL)
	{
		cout << "YES" << endl;
		cout << "1 1" << endl;
		return 0LL;
	}
	for (ll i = 1LL; i * i <= n; i++)
	{
		if (n % i == 0LL)
		{
			ll i1 = i, j1 = n / i;
			if (i1 > j1) { swap(i1, j1); }
			if (j1 % 2LL == i1 % 2LL)
			{
				ll x = (j1 + i1) / 2LL;
				ll y = (j1 - i1) / 2LL;
				if (x >= y)
				{
					cout << "Yes" << endl;
					cout << x << " " << y << endl;
					return 0LL;
				}
			}
		}
	}
	cout << "No" << endl;
	return 0LL;
}