#include <type_traits>
#include <algorithm>
#include <iostream>
#include <vector>
#include <bitset>
#include <cmath>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pll;
typedef vector<ll> vl;
typedef vector<vl> vvl;

const ll INF = 1000000007LL;

const ll constant = 10000000000LL;

ll sizet = 1LL;

struct Tree
{
	vl tree, treeAdd;
	Tree(vl& arr)
	{
		while (sizet < (ll)arr.size()) { sizet *= 2LL; }
		tree.resize(sizet * 2LL);
		treeAdd.resize(sizet * 2LL);
		for (ll i = sizet; i < sizet + (ll)arr.size(); i++)
		{
			tree[i] = arr[i - sizet];
		}
		for (ll i = sizet - 1LL; i > 0LL; i--)
		{
			tree[i] = tree[i * 2LL] + tree[i * 2LL + 1LL];
		}
	}
	void push(ll n = 1LL, ll tl = 0LL, ll tr = sizet)
	{
		if (treeAdd[n] != 0LL)
		{
			tree[n] += treeAdd[n] * (tr - tl);
			if (n < sizet)
			{
				treeAdd[n * 2LL] += treeAdd[n];
				treeAdd[n * 2LL + 1LL] += treeAdd[n];
			}
			treeAdd[n] = 0LL;
		}
	}
	void update(ll l, ll r, ll x, ll n = 1LL, ll tl = 0LL, ll tr = sizet)
	{
		push(n, tl, tr);
		if (l >= tr || tl >= r) { return; }
		if (l <= tl && tr <= r)
		{
			treeAdd[n] += x;
			push(n, tl, tr);
			return;
		}
		ll mid = (tl + tr) / 2LL;
		update(l, r, x, n * 2LL, tl, mid);
		update(l, r, x, n * 2LL + 1LL, mid, tr);
		tree[n] = tree[n * 2LL] + tree[n * 2LL + 1LL];
		return;
	}
	ll result(ll l, ll r, ll n = 1LL, ll tl = 0LL, ll tr = sizet)
	{
		push(n, tl, tr);
		if (l >= tr || tl >= r) { return 0LL; }
		if (l <= tl && tr <= r) { return tree[n]; }
		ll mid = (tl + tr) / 2LL;
		return result(l, r, n * 2LL, tl, mid) + result(l, r, n * 2LL + 1LL, mid, tr);
	}
};

struct Int
{
	ll a = 0LL, b = 0LL, c = 0LL;
	Int operator+(Int other)
	{
		Int result;
		ll c1 = c + other.c;
		result.c = c1 % constant;
		c1 /= constant;
		ll b1 = b + other.b + c1;
		result.b = b1 % constant;
		b1 /= constant;
		result.a = a + other.a + b1;
		return result;
	}
	Int operator*(Int other)
	{
		Int result;
		ll c1 = c * other.c;
		result.c = c1 % constant;
		c1 /= constant;
		ll b1 = b * other.b + c1;
		result.b = b1 % constant;
		b1 /= constant;
		result.a = a * other.a + b1;
		return result;
	}
	bool operator<(Int other)
	{
		return (a < other.a || (a == other.a && (b < other.b || (b == other.b && c < other.c))));
	}
};

int main() 
{
	ios_base::sync_with_stdio(false);
	cin.tie(), cout.tie(), cerr.tie();
	ll n; cin >> n;
	vector<Int> arr(n);
	for (ll i = 0LL; i < n; i++)
	{
		ll x; cin >> x;
		arr[i].c = x;
	}
	vector<Int> suffix(n);
	suffix[n - 1LL] = arr[n - 1LL];
	for (ll i = n - 2LL; i >= 0LL; i--)
	{
		suffix[i] = suffix[i + 1LL] + arr[i];
	}
	ll iMax = 0LL;
	Int max = arr[0LL] * suffix[1LL];
	Int pref = arr[0LL];
	for (ll i = 1LL; i < n - 1LL; i++)
	{
		pref = pref + arr[i];
		if (max < pref * suffix[i + 1LL])
		{
			max = pref * suffix[i + 1LL];
			iMax = i;
		}
	}
	cout << iMax + 1LL << endl;
	return 0;
}