#include <type_traits>
#include <algorithm>
#include <iostream>
#include <vector>
#include <bitset>
#include <cmath>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pll;
typedef vector<ll> vl;
typedef vector<vl> vvl;

const ll INF = 1000000007LL;

const ll constant = 10000000000LL;

ll sizet = 1LL;

struct Tree
{
	vl tree, treeAdd;
	Tree(vl& arr)
	{
		while (sizet < (ll)arr.size()) { sizet *= 2LL; }
		tree.resize(sizet * 2LL);
		treeAdd.resize(sizet * 2LL);
		for (ll i = sizet; i < sizet + (ll)arr.size(); i++)
		{
			tree[i] = arr[i - sizet];
		}
		for (ll i = sizet - 1LL; i > 0LL; i--)
		{
			tree[i] = tree[i * 2LL] + tree[i * 2LL + 1LL];
		}
	}
	void push(ll n = 1LL, ll tl = 0LL, ll tr = sizet)
	{
		if (treeAdd[n] != 0LL)
		{
			tree[n] += treeAdd[n] * (tr - tl);
			if (n < sizet)
			{
				treeAdd[n * 2LL] += treeAdd[n];
				treeAdd[n * 2LL + 1LL] += treeAdd[n];
			}
			treeAdd[n] = 0LL;
		}
	}
	void update(ll l, ll r, ll x, ll n = 1LL, ll tl = 0LL, ll tr = sizet)
	{
		push(n, tl, tr);
		if (l >= tr || tl >= r) { return; }
		if (l <= tl && tr <= r)
		{
			treeAdd[n] += x;
			push(n, tl, tr);
			return;
		}
		ll mid = (tl + tr) / 2LL;
		update(l, r, x, n * 2LL, tl, mid);
		update(l, r, x, n * 2LL + 1LL, mid, tr);
		tree[n] = tree[n * 2LL] + tree[n * 2LL + 1LL];
		return;
	}
	ll result(ll l, ll r, ll n = 1LL, ll tl = 0LL, ll tr = sizet)
	{
		push(n, tl, tr);
		if (l >= tr || tl >= r) { return 0LL; }
		if (l <= tl && tr <= r) { return tree[n]; }
		ll mid = (tl + tr) / 2LL;
		return result(l, r, n * 2LL, tl, mid) + result(l, r, n * 2LL + 1LL, mid, tr);
	}
};

ll funk(ll a, ll b, ll c, ll d)
{
	if (a == b)
	{
		if (c == d)
		{
			return 1LL;
		}
		else
		{
			return 2LL;
		}
	}
	if (c == d)
	{
		return 2LL;
	}
	if (a > d && b > c)
	{
		return 4LL;
	}
	return 2LL;
}

int main() 
{
	ios_base::sync_with_stdio(false);
	cin.tie(), cout.tie(), cerr.tie();
	/*
	ll n; cin >> n;
	ll x; cin >> x;
	ll ans = 0LL;
	ll n1 = n + 1LL;
	if (n1 % 2LL != 0LL) { n1++; }
	for (ll a = 2LL; a <= n1 / 2LL; a++)
	{
		if (a == x) { continue; }
		ll l = a - 1LL, r = INF;
		while (r - l > 1LL)
		{
			ll mid = (l + r) / 2LL;
			if (mid * a > n) { r = mid; }
			else { l = mid; }
		}
		for (ll b = r; b <= n1; b++)
		{
			if (b == x) { continue; }
			ll cd = a * b - n;
			for (ll i = 1LL; i * i <= cd; i++)
			{
				if (cd % i == 0LL)
				{
					ll c = i, d = cd / i;
					if (a <= c) { swap(c, d); }

					if (a <= c || b <= d) { continue; }
					if (min(a, b) == 4LL)
					{
						//cout << min(a, b) << " " << max(a, b) <<
							//" " << min(c, d) << " " << max(c, d) << endl;
					}
					if (b > n1 / 2LL)
					{
						b += (a - 2LL);
					}
					ans += funk(a, b, c, d);
				}
			}
		}
	}
	cout << ans << endl;
	*/
	ll n; cin >> n;
	vl arr(n);
	for (ll& x : arr) { cin >> x; }
	ll q; cin >> q;
	vector<pll> zapros(q), trueAns(q);
	for (ll i = 0LL; i < q; i++)
	{
		cin >> zapros[i].first; zapros[i].second = i;
	}
	sort(zapros.begin(), zapros.end());
	ll prevAns = 0LL, prev = 0LL, prevCost = 0LL;
	for (ll i = 0LL; i < q; i++)
	{
		ll last = n - 1LL;
		while (last >= 0LL && arr[last] > zapros[i].first)
		{
			last--;
		}
		if (last == -1LL) { return 1LL; }
		ll arrSize = last + 1LL;
		ll ans = prevAns;
		ll trueCost = prevCost;
		if (arr.back() <= 500LL)
		{
			for (ll cost = prev + 1LL; cost <= zapros[i].first; cost++)
			{
				ll cost1 = cost;
				ll ans1 = 0LL;
				for (ll i = last; i >= 0LL; i--)
				{
					while (cost1 >= arr[i])
					{
						ans1++;
						cost1 -= arr[i];
					}
				}
				if (ans1 > ans)
				{
					ans = ans1;
					trueCost = cost;
				}
			}
		}
		else
		{
			ll cost1 = arr[last] - 1LL;
			ll ans1 = 0LL;
			for (ll i = last; i >= 0LL; i--)
			{
				while (cost1 >= arr[i])
				{
					ans1++;
					cost1 -= arr[i];
				}
			}
			if (ans1 > ans)
			{
				ans = ans1;
				trueCost = arr[last] - 1LL;
			}
		}
		prevAns = ans;
		prevCost = trueCost;
		trueAns[zapros[i].second] = { prevCost, prevAns };
		prev = zapros[i].first;
	}
	for (ll i = 0LL; i < q; i++)
	{
		cout << trueAns[i].first << " " << trueAns[i].second << endl;
	}
	return 0;
}