#include <type_traits>
#include <algorithm>
#include <iostream>
#include <vector>
#include <bitset>
#include <cmath>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pll;
typedef vector<ll> vl;
typedef vector<vl> vvl;

const ll INF = 1000000007LL;

const ll constant = 10000000000LL;

ll sizet = 1LL;

struct Tree
{
	vl tree, treeAdd;
	Tree(vl& arr)
	{
		while (sizet < (ll)arr.size()) { sizet *= 2LL; }
		tree.resize(sizet * 2LL);
		treeAdd.resize(sizet * 2LL);
		for (ll i = sizet; i < sizet + (ll)arr.size(); i++)
		{
			tree[i] = arr[i - sizet];
		}
		for (ll i = sizet - 1LL; i > 0LL; i--)
		{
			tree[i] = tree[i * 2LL] + tree[i * 2LL + 1LL];
		}
	}
	void push(ll n = 1LL, ll tl = 0LL, ll tr = sizet)
	{
		if (treeAdd[n] != 0LL)
		{
			tree[n] += treeAdd[n] * (tr - tl);
			if (n < sizet)
			{
				treeAdd[n * 2LL] += treeAdd[n];
				treeAdd[n * 2LL + 1LL] += treeAdd[n];
			}
			treeAdd[n] = 0LL;
		}
	}
	void update(ll l, ll r, ll x, ll n = 1LL, ll tl = 0LL, ll tr = sizet)
	{
		push(n, tl, tr);
		if (l >= tr || tl >= r) { return; }
		if (l <= tl && tr <= r)
		{
			treeAdd[n] += x;
			push(n, tl, tr);
			return;
		}
		ll mid = (tl + tr) / 2LL;
		update(l, r, x, n * 2LL, tl, mid);
		update(l, r, x, n * 2LL + 1LL, mid, tr);
		tree[n] = tree[n * 2LL] + tree[n * 2LL + 1LL];
		return;
	}
	ll result(ll l, ll r, ll n = 1LL, ll tl = 0LL, ll tr = sizet)
	{
		push(n, tl, tr);
		if (l >= tr || tl >= r) { return 0LL; }
		if (l <= tl && tr <= r) { return tree[n]; }
		ll mid = (tl + tr) / 2LL;
		return result(l, r, n * 2LL, tl, mid) + result(l, r, n * 2LL + 1LL, mid, tr);
	}
};

ll funk(ll a, ll b, ll c, ll d)
{
	if (a == b)
	{
		if (c == d)
		{
			return 1LL;
		}
		else
		{
			return 2LL;
		}
	}
	if (c == d)
	{
		return 2LL;
	}
	if (a > d && b > c)
	{
		return 4LL;
	}
	return 2LL;
}

ll funk(const vl& arr)
{
	ll bestAns = 0LL;
	ll n = (ll)arr.size();
	for (ll it = 0LL; it < 1024LL; it++)
	{
		bool win = true;
		for (ll i = 0LL; i < 14LL; i++)
		{
			ll i1 = i % n, i2 = (i + 1LL) % n, i3 = (i + 2LL) % n, i4 = (i + 3LL) % n;
			if ((it & (1LL << i1)) && (it & (1LL << i2)) && (it & (1LL << i3)) && (it & (1LL << i4)))
			{
				win = false;
				break;
			}
		}
		if (!win) { continue; }
		ll sum = 0LL;
		for (ll i = 0LL; i < (ll)arr.size(); i++)
		{
			if (it & (1LL << i))
			{
				sum += arr[i];
			}
		}
		if (bestAns < sum) { bestAns = sum; }
	}
	return bestAns;
}

int main() 
{
	ios_base::sync_with_stdio(false);
	cin.tie(), cout.tie(), cerr.tie();
	ll n; cin >> n;
	vl arr(n);
	for (ll& x : arr) { cin >> x; }
	cout << funk(arr) << endl;
	ll q; cin >> q;
	for (ll i = 0LL; i < q; i++)
	{
		ll p, v;
		cin >> p >> v; p--;
		arr[p] = v;
		cout << funk(arr) << endl;
	}
	return 0;
}