#include <iostream>
#include <vector>
#include <algorithm>
#include <limits>
#include <cmath>
int gcd(int a, int b)
{
	if (b > a)
		std::swap(a, b);
	if (a % b == 0)
		return b;
	while (a != 0 && b != 0)
	{
		if (a > b)
			a %= b;
		else
			b %= a;
	}
	return a + b;
}
long long int gcd(long long int a,long long int b)
{
	if (b > a)
		std::swap(a, b);
	if (a % b == 0)
		return b;
	while (a != 0 && b != 0)
	{
		if (a > b)
			a %= b;
		else
			b %= a;
	}
	return a + b;
}
std::vector<int> primeNumbers(int N)
{
	int rt = sqrt(N);
	std::vector<int> primes;
	primes.push_back(2);
	std::vector<bool> used(N + 1, false);
	for (int i = 3; i <= rt; i += 2)
	{
		if (!used[i])
		{
			used[i] = true;
			primes.push_back(i);
			for (int k = i * i; k <= N; k += i)
				used[k] = true;
		}
	}
	for (int i = rt + (1 - rt % 2); i <= N; i += 2)
		if (!used[i])
			primes.push_back(i);
	return primes;
}
std::vector<long long int> primeNumbers(long long int N)
{
	long long int rt = sqrt(N);
	std::vector<long long int> primes;
	primes.push_back(2);
	std::vector<bool> used(N + 1, false);
	for (int i = 3; i <= rt; i += 2)
	{
		if (!used[i])
		{
			used[i] = true;
			primes.push_back(i);
			for (long long int k = i * i; k <= N; k += i)
				used[k] = true;
		}
	}
	for (long long int i = rt + (1 - rt % 2); i <= N; i += 2)
		if (!used[i])
			primes.push_back(i);
	return primes;
}


void out(std::vector<int>& vec)
{
	for (auto& it : vec)
		std::cout << it << ' ';
	std::cout << std::endl;
}
void out(std::vector<long long int>& vec)
{
	for (auto& it : vec)
		std::cout << it << ' ';
	std::cout << std::endl;
}
std::vector<long long int> getSquares(long long int N)
{
	
	long long int rt = sqrt(N);
	std::vector<long long int> res(rt);
	for (int i = 1; i <= rt; ++i)
		res.push_back(i * i);
	return res;
}
bool isSq(long long int N)
{
	long long int rt = sqrt(N);
	return rt * rt == N;
}


int main()
{
	
	long long int n;
	std::cin >> n;
	if (n == 0)
	{
		std::cout << "Yes\n" << 1 << ' ' << 1;
		return 0;
	}
	long long int rt = sqrt(n);
	if (rt < 0)
		std::cout << 2;
	for (long long int i = 1; i <= rt; ++i)
	{
		long long int y = (n - (long long int)i * i) / (2l * i);
		
		if (i * (2 * y + i) == n && y > 0)
		{
			std::cout << "Yes\n" << y + i << ' ' << y;
			return 0;
		}
	}
	std::cout << "No";
	return 0;
}