#include <iostream>
#include <vector>
#include <algorithm>
#include <limits>
#include <cmath>
#include <set>
#include <map>
int gcd(int a, int b)
{
	if (b > a)
		std::swap(a, b);
	if (a % b == 0)
		return b;
	while (a != 0 && b != 0)
	{
		if (a > b)
			a %= b;
		else
			b %= a;
	}
	return a + b;
}
long long int gcd(long long int a,long long int b)
{
	if (b > a)
		std::swap(a, b);
	if (a % b == 0)
		return b;
	while (a != 0 && b != 0)
	{
		if (a > b)
			a %= b;
		else
			b %= a;
	}
	return a + b;
}
std::vector<int> primeNumbers(int N)
{
	int rt = sqrt(N);
	std::vector<int> primes;
	primes.push_back(2);
	std::vector<bool> used(N + 1, false);
	for (int i = 3; i <= rt; i += 2)
	{
		if (!used[i])
		{
			used[i] = true;
			primes.push_back(i);
			for (int k = i * i; k <= N; k += i)
				used[k] = true;
		}
	}
	for (int i = rt + (1 - rt % 2); i <= N; i += 2)
		if (!used[i])
			primes.push_back(i);
	return primes;
}
std::vector<long long int> primeNumbers(long long int N)
{
	long long int rt = sqrt(N);
	std::vector<long long int> primes;
	primes.push_back(2);
	std::vector<bool> used(N + 1, false);
	for (int i = 3; i <= rt; i += 2)
	{
		if (!used[i])
		{
			used[i] = true;
			primes.push_back(i);
			for (long long int k = i * i; k <= N; k += i)
				used[k] = true;
		}
	}
	for (long long int i = rt + (1 - rt % 2); i <= N; i += 2)
		if (!used[i])
			primes.push_back(i);
	return primes;
}


void out(std::vector<int>& vec)
{
	for (auto& it : vec)
		std::cout << it << ' ';
	std::cout << std::endl;
}
void out(std::vector<long long int>& vec)
{
	for (auto& it : vec)
		std::cout << it << ' ';
	std::cout << std::endl;
}
std::vector<long long int> getSquares(long long int N)
{
	
	long long int rt = sqrt(N);
	std::vector<long long int> res(rt);
	for (int i = 1; i <= rt; ++i)
		res.push_back(i * i);
	return res;
}
bool isSq(long long int N)
{
	long long int rt = sqrt(N);
	return rt * rt == N;
}


/*int variaty(int d, std::vector<int>& types)
{
	if (d == 1)
		return types.size();
	int sum = 0;
	int current = 0;
	std::multiset<int> types_in_seq;
	for (int i = 0; i < d; ++i)
	{
		if (types_in_seq.find(types[i]) == types_in_seq.end())
		{

			++current;
		}
		types_in_seq.insert(types[i]);
	}
	int right = d;
	int left = 1;
	sum = current;
	while (right < types.size())
	{

		if (types_in_seq.find(types[right]) == types_in_seq.end())
		{
			++current;

		}
		types_in_seq.insert(types[right]);
		auto lit = types_in_seq.find(types[left - 1]);
		lit = types_in_seq.erase(lit);
		if (lit == types_in_seq.end() || *lit != types[left - 1])
		{
			--current;
		}
		sum += current;
		++left;
		++right;
	}
	return sum;
}*/
void out(std::map<int, int>& map)
{
	for (auto& it : map)
	{
		std::cout << it.first << ": " << it.second << '\n';
	}

}

/*int variaty(int d, std::vector<std::pair<int, std::map<int, int>::iterator>>& types, std::map<int, int>& uses)
{
	//std::cout << "\n\n\n";
	if (d == 1)
		return types.size();
	int sum = 0;
	int current = 0;
	for (int i = 0; i < d; ++i)
	{
		auto it = types[i].second;
		if (it->second == 0)
			++current;
		++it->second;

	}
	//out(uses);
	int right = d;
	int left = 1;
	sum = current;
	while (right < types.size())
	{
		auto rit = types[right].second;
		if (rit->second == 0)
		{
			++current;
		}
		++rit->second;
		
		auto lit = types[left - 1].second;
		--lit->second;
		if (lit->second == 0)
			--current;
		//std::cout << "\nLeft: " << left << " Right: " << right << '\n';
		//out(uses);
		sum += current;
		++left;
		++right;
	}
	while (left <= types.size())
	{
		(*types[left - 1].second).second = 0;
		++left;
	}
	return sum;
}*/

int max(int a, int b)
{
	return a > b ? a : b;
}
int main()
{
	
	std::cout.sync_with_stdio(false);

	//int n = 5000;
	int n;
	std::cin >> n;
	
	std::vector<int> types(n);
	std::vector<int> divs(n);
	int d2_sum = 0;
	for (int i = 0; i < n; ++i)
	{
		std::cin >> types[i];
		if (i > 0)
		{
			if (types[i - 1] != types[i])
			{
				divs[i - 1] = 2;
				d2_sum += 2;
			}
			else
			{
				divs[i - 1] = 1;
				d2_sum += 1;
			}
		}

	}

	std::cout << n << ' ';
	if (n == 1)
		return 0;
	std::cout << d2_sum << ' ';
	std::vector<int> buff(divs.size());
	std::vector<int>* divs_p = &divs;
	std::vector<int>* buff_p = &buff;
	for (int i = 2; i < n; ++i)
	{
		int sum = 0;
		for (int j = 1; j < n - i + 1; ++j)
		{
			//(*buff_p)[j - 1] = next((*divs_p)[j - 1], (*divs_p)[j]) +
			//	(types[j - 1] != types[j - 1 + i]);
			if ((*divs_p)[j - 1] == (*divs_p)[j])
				(*buff_p)[j - 1] = (*divs_p)[j - 1] + (types[j - 1] != types[j - 1 + i] && (*divs_p)[j - 1] == i);
			else
				(*buff_p)[j - 1] = max((*divs_p)[j - 1], (*divs_p)[j]);
			sum += (*buff_p)[j - 1];
		}
		std::cout << sum << ' ';
		std::swap(divs_p, buff_p);
	}

	/*std::vector<std::pair<int, std::map<int, int>::iterator>> types(n);
	std::map<int, int> uses;
	for (int i = 0; i < n; ++i)
	{
		std::cin >> types[i].first;
		//types[i].first = 1;
		std::map<int, int>::iterator it = uses.find(types[i].first);
		if (it == uses.end())
		{
			it = uses.insert(std::make_pair(types[i].first, 0 )).first;
			types[i].second = it;
		}
		else
		{
			types[i].second = it;
		}
	}
	//std::cout << "Got inf\n";
	for (int i = 1; i <= n; ++i)
	{
		std::cout << variaty(i, types, uses) << ' ';
	}*/



	return 0;
}