#include <iostream>
#include <vector>
#include <array>
#include <limits>

class Int128
{
public:
    Int128(long long int num)
    {
        digits[0] = num % radix;
        digits[1] = num / radix;
        size = 1 + digits[1] != 0;
    }
    void countSize()
    {
        for (int i = 0; i < 4; ++i)
        {
            if (this->digits[i] == 0)
            {
                size = i;
                return;
            }
        }
        size = 4;
    }
    Int128 operator+(Int128 a)
    {
        const Int128* bigger = this;
        const Int128* sm = &a;
        if (a.size > this->size)
            std::swap(bigger, sm);
        bool remainder = false;;
        Int128 result(0);
        for (int i = 0; i < sm->size; ++i)
        {
            long long int res = bigger->digits[i] + (long long int)sm->digits[i] + remainder;
            if (res >= radix)
            {
                remainder = true;
                res %= radix;
            }
            else
            {
                remainder = false;
            }
            result.digits[i] = res;
        }
        for (int i = sm->size; i < bigger->size; ++i)
        {
            long long int res = bigger->digits[i] + remainder;
            if (res >= radix)
            {
                remainder = true;
                res %= radix;
            }
            else
            {
                remainder = false;
            }
            result.digits[i] = res;
        }
        result.countSize();
        return result;
    }
    Int128 operator*(int x)
    {
        int remainder = 0;
        Int128 result(0);
        for (int i = 0; i < 4; ++i)
        {
            long long int res = this->digits[i] * x + remainder;
            if (res >= radix)
            {
                remainder = res / radix;
                res %= radix;
            }
            else
            {
                remainder = 0;
            }
            result.digits[i] = res;
        }
        result.countSize();
        return result;

    }
    Int128 mult(int x, int shift = 0)
    {
        int remainder = 0;
        Int128 result(0);
        for (int i = 0; i < 4 - shift; ++i)
        {
            long long int res = this->digits[i] * x + remainder;
            if (res >= radix)
            {
                remainder = res / radix;
                res %= radix;
            }
            else
            {
                remainder = 0;
            }
            result.digits[i + shift] = res;
        }
        result.countSize();
        return result;
    }
 
    Int128 operator*(const Int128& a)
    {
        
        const Int128* bigger = this;
        const Int128* sm = &a;
        if (a.size > this->size)
            std::swap(bigger, sm);
        
        if (a.size == 1)
            return *this * a.digits[0];
        if (a.size == 2)
            return *this * a.digits[0] + mult(a.digits[1], 1);
    }
    bool operator>(Int128 b)
    {
        if (this->size > b.size)
            return true;
        if (this->size < b.size)
            return false;
        if (this->size == 0)
            return false;
        for (int i = this->size - 1; i >= 0; -i)
        {
            if (this->digits[i] > b.digits[i])
                return true;
            if (this->digits[i] < b.digits[i])
                return false;
        }
        return true;
    }
private:
    std::array<int, 4> digits;
    int radix = std::numeric_limits<int>::max();
    int size;
};










bool multBigger(long long a, long long b, long long c, long long d)
{
    long long w = a + b;
    if (a > b)
        std::swap(a, b);
    if (c > d)
        std::swap(c, d);
    bool changed = false;
    if (a < c)
    {
        std::swap(a, c);
        changed = true;
    }
    long long int k = a - c;
    if (changed)
        return (w - 2 * c - k < 0);
    else
        return (w - 2 * c - k > 0);
}
int main()
{

    
    int n;
    std::cin >> n;
    long long int weight = 0;
    std::vector<int> arr(n);

    int cut = n / 2;
    long long int weight_left = 0;
    for (int i = 0; i < n; ++i)
    {
        std::cin >> arr[i];
        weight += arr[i];
        if (i <= cut)
            weight_left += arr[i];
    }
    
    bool changed = true;
    while (changed)
    {
        Int128 current = Int128(weight_left) * Int128((weight - weight_left));
        if (cut > 0 && Int128(weight_left - arr[cut]) * Int128(weight - weight_left + arr[cut]) > current)
       // if (cut > 0 && multBigger(weight_left - arr[cut], weight - weight_left + arr[cut], weight_left, weight - //weight_left))
        {
            weight_left -= arr[cut];
            --cut;
            changed = true;
           
        }
       else if (cut < n - 1 && Int128(weight_left + arr[cut + 1]) * Int128(weight - weight_left - arr[cut + 1]) > current)
        //else if (cut < n - 1 && multBigger(weight_left + arr[cut + 1], weight - weight_left - arr[cut + 1], weight_left, weight - weight_left))
        {
            weight_left += arr[cut + 1];
            ++cut;
            changed = true;
        }
        else
        {
            changed = false;
        }
    }
    std::cout << cut + 1;
    
    /*
    int last = 0;
    long long int w = arr[0];
    long long int max_p = (w) * (weight - w);
    int ind_of_max = 0;
    while (last < arr.size() - 1)
    {
        ++last;
        w += arr[last];
        long long int p = w * (weight - w);
        if (p > max_p)
        {
            max_p = p;
            ind_of_max = last;
        }
    }
    std::cout << ind_of_max + 1;*/
    return 0;
}