#include <iostream>
#include <vector>

int lower(std::vector<long long int>& vec, int b)
{
    int l = 0,  r = vec.size() - 1;
    while (l < r)
    {
        if (l == r - 1)
        {
            if (vec[r] > b)
                return l;
            return r;
        }
        int med = (l + r) / 2;
        if (vec[med] <= b)
            l = med;
        else
            r = med;
    }
}
long long int amount(int i_val, std::vector<long long int> & vals)
{
    long long int sum = vals[i_val] - 1;
    long long int res = sum / vals[i_val - 1];

    if (i_val == 1)
        return res;
    while (sum != 0)
    {
        sum %= vals[i_val - 1];
        if (sum == 0)
            break;
        --i_val;
        res += sum / vals[i_val - 1];
    }
    return res;
}
long long int amountOf(int sum, int i_val, std::vector<long long int>& vals)
{
    long long int res = sum / vals[i_val];

    if (i_val == 0)
        return res;
    while (sum != 0)
    {
        sum %= vals[i_val];
        if (sum == 0)
            break;

        --i_val;
        res += sum / vals[i_val];
    }
    return res;
}
int main()
{
    int n;
    std::cin >> n;
    std::vector<long long int> a(n);
    //    
    std::vector<std::pair<long long int, int>> amounts(n);
    int max_amounts_till = 0;
    int ind_of_max_amounts = 0;
    for (int i = 0; i < n; ++i)
    {
        std::cin >> a[i];
        if (i > 0)
        {
            int am = amount(i, a);
            if (am > max_amounts_till)
            {
                max_amounts_till = am;
                ind_of_max_amounts = i;
            }
            amounts[i] = { max_amounts_till, ind_of_max_amounts };
        }
    }
    int q;
    std::cin >> q;
    for (int i = 0; i < q; ++i)
    {
        long long int b;
        std::cin >> b;
        if (n == 1 || b < a[1])
        {
            std::cout << b << ' ' << b << '\n';
            continue;
        }
        int lower_ind = lower(a, b);
        
        int max_amount = amounts[lower_ind].first;
        int ind_of_max = amounts[lower_ind].second;
        int b_amount = amountOf(b, lower_ind, a);
        if (b_amount > max_amount)
        {
            std::cout << b << ' ' << b_amount << std::endl;
        }
        else
        {
            std::cout << a[lower_ind] - 1 << ' ' << max_amount << std::endl;
        }
    }
}