#include <iostream>
#include <vector>

int lower(std::vector<long long int>& vec, int b)
{
    int l = 0,  r = vec.size() - 1;
    while (l < r)
    {
        if (l == r - 1)
        {
            if (vec[r] > b)
                return l;
            return r;
        }
        int med = (l + r) / 2;
        if (vec[med] <= b)
            l = med;
        else
            r = med;
    }
}
long long int amount(int i_val, std::vector<long long int> & vals)
{
    long long int sum = vals[i_val] - 1;
    long long int res = sum / vals[i_val - 1];

    if (i_val == 1)
        return res;
    while (sum != 0)
    {
        sum %= vals[i_val - 1];
        if (sum == 0)
            break;
        --i_val;
        res += sum / vals[i_val - 1];
    }
    return res;
}
long long int amountOf(int sum, int i_val, std::vector<long long int>& vals)
{
    long long int res = sum / vals[i_val];

    if (i_val == 0)
        return res;
    while (sum != 0)
    {
        sum %= vals[i_val];
        if (sum == 0)
            break;

        --i_val;
        res += sum / vals[i_val];
    }
    return res;
}
std::pair<long long int, long long int> maxAmount(long long int b, std::vector<long long int>& a, std::vector < std::pair<long long int, long long int>> & amounts)
{
    int n = a.size();
    if (n == 1 || b < a[1])
    {
        return { b, b };
    }
    int lower_ind = lower(a, b);

    int max_amount = amounts[lower_ind].first;
    int sum_of_pr = amounts[lower_ind].second;

    auto after_lo = maxAmount(b % a[lower_ind], a, amounts);
    int max_cur_amount = b / a[lower_ind];
    long long int max_sum = after_lo.first + a[lower_ind] * max_cur_amount;
    long long int b_amount = after_lo.second + max_cur_amount;
    if (b_amount > max_amount)
    {
        return { max_sum, b_amount };
    }
    else
    {
        return { sum_of_pr, max_amount };
    }
}
int main()
{
    int n;
    std::cin >> n;
    std::vector<long long int> a(n);
    //    
    std::vector<std::pair<long long int, long long int>> amounts(n);
    long long int max_amounts_till = 0;
    long long int max_sum = 0;
    for (int i = 0; i < n; ++i)
    {
        std::cin >> a[i];
        if (i > 0)
        {
            int am = amount(i, a);
            if (am > max_amounts_till)
            {
                max_amounts_till = am;
                max_sum = a[i] - 1;
            }
            am = amountOf(a[i] - a[i - 1] - 1, i - 1, a);
            amounts[i] = { max_amounts_till, max_sum };
        }
    }
    int q;
    std::cin >> q;
    for (int i = 0; i < q; ++i)
    {
        long long int b;
        std::cin >> b;
        auto res = maxAmount(b, a, amounts);
        std::cout << res.first << ' ' << res.second << std::endl;
    }
}