#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

double get_time(vector<pair<int, int>>& roads, int add = 0);
int cost_of_right_answ (vector<pair<int, int>>& roads, vector<pair<int, int>>& taxes, int l, int r, int Max); // r = m-1 l = 0

int main () {
    int n = 0;
    cin >> n;
    vector<pair<int, int>> roads(n); // first maxV, second L;
    for (int i = 0; i < n; i++) cin >> roads[i].first;
    for (int i = 0; i < n; i++) cin >> roads[i].second;
    int m = 0;
    cin >> m;
    vector<pair<int, int>> taxes(m, {1000000000001, 0}); // first - min to tax, second - tax
    for (int i = 0; i < m - 1; i++) cin >> taxes[i].first;
    for (int i = 0; i < m; i++) cin >> taxes[i].second;
    int q = 0;
    cin >> q;
    vector<int> cars(q);
    for (int i = 0; i < q; i++) {
        int s = 0, t = 0;
        cin >> s >> t;
        cars[i] = t - s;
    }

    for (auto car_t: cars) {
        if (car_t >= get_time(roads)) {
            cout << "0\n";
            continue;
        }

        cout << cost_of_right_answ(roads, taxes, 0, m - 1, car_t) << endl;
    }

}

double get_time(vector<pair<int, int>>& roads, int add) {
    double answ = 0;
    for (auto elem: roads) {
        answ += float (elem.second) / (elem.first + add);
    }
    return answ;
}

int cost_of_right_answ (vector<pair<int, int>>& roads, vector<pair<int, int>>& taxes, int l, int r, int Max) {
    if (r - l <= 1) {
            for (int i = r; i >= 0; i--) {
                if (get_time(roads, taxes[i].first) > Max) return taxes[i + 1].second;
            }
            return taxes[0].second;
    }
    int c = (l + r) / 2;
    if (get_time(roads, taxes[c].first) < Max) return cost_of_right_answ(roads, taxes, l, c, Max);
    else return cost_of_right_answ(roads, taxes, c, r, Max);
}
