#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>


using namespace std;


void fast_io() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}


#define int long long


struct Adder {
    vector<int> dx;
    int n;

public:
    Adder(int _n) : n(_n), dx(_n + 1) {}

    void add(int l, int r, int x) {
        dx[l] += x;
        dx[r] -= x;
    }

    vector<int> get() {
        vector<int> res(n);

        int cur = 0;
        for (int i = 0; i < n; ++i) {
            cur += dx[i];

            res[i] = cur;
        }

        return res;
    }
};


signed main() {
    fast_io();

    int n;
    cin >> n;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    map<int, int> last;

    vector<int> nxt(n, n);

    for (int i = 0; i < n; ++i) {
        if (last.find(a[i]) == last.end()) {
            last[a[i]] = i;

            continue;
        }

        nxt[last[a[i]]] = i;

        last[a[i]] = i;
    }

    Adder all(n);

    for (int i = 0; i < n; ++i) {
        for (int r = i; r < nxt[i]; ++r) {
            all.add(r - i, r + 1, 1);
        }
    }

    for (int x : all.get()) {
        cout << x << ' ';
    }

    return 0;
}
