#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>


using namespace std;


void fast_io() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}


#define int long long


struct Adder {
    vector<int> dxx;
    int n;

public:
    Adder(int _n) : n(_n), dxx(_n + 2) {}

    void add(int l, int r, int c) {
        dxx[l] += 1;
        dxx[l + c] -= 1;

        dxx[r] -= 1;
        dxx[r + c] += 1;
    }

    vector<int> get() {
        vector<int> res(n);

        int cur = 0;
        int cdx = 0;
        for (int i = 0; i < n; ++i) {
            cdx += dxx[i];
            cur += cdx;

            res[i] = cur;
        }

        return res;
    }
};


signed main() {
    fast_io();

    int n;
    cin >> n;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    map<int, int> last;

    vector<int> nxt(n, n);

    for (int i = 0; i < n; ++i) {
        if (last.find(a[i]) == last.end()) {
            last[a[i]] = i;

            continue;
        }

        nxt[last[a[i]]] = i;

        last[a[i]] = i;
    }

    Adder all(n);

    for (int i = 0; i < n; ++i) {
        all.add(0, i + 1, nxt[i] - i);
    }

    for (int x : all.get()) {
        cout << x << ' ';
    }

    return 0;
}
