#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC optimize("no-stack-protector")
#pragma GCC target("sse4")

#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <cmath>
#include <iomanip>
#include <numeric>
#include <random>
#include <chrono>
#include <queue>
#include <unordered_map>
#include <tuple>
#include <ctime>

using namespace std;
using ll = long long;
using ld = long double;

const ld eps = 1e-9;
const ll INF = 1e15;
const ld pi = atan2(0, -1);
const ll mod = 1e9 + 7;
const ll P = 179, Q = 239;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

bool equal(ld a, ld b) {
	return abs(a - b) < eps;
}

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ll& a, ll b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}


bool maxi(ld& a, ld b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ld& a, ld b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

ll mmin(ll a, ll b) {
	if (a < b) return a;
	return b;
}

ll mmax(ll a, ll b) {
	if (a > b) return a;
	return b;
}

ll n, m, k;
vector <bool> used;
vector <ll> v, l, a, f;
vector <ll> sumlen;
vector <vector <ll>> opa;
vector <ld> base;

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cin >> n;
	v.resize(n);
	for (auto& x : v) {
		cin >> x;
	}
	l.resize(n);
	for (auto& x : l) {
		cin >> x;
	}
	sumlen.resize((1 << n));
	opa.resize(1 << n);
	base.resize(1 << n);
	for (ll mask = 0; mask < (1 << n); ++mask) {
		for (int j = 0; j < n; ++j) {
			if (mask & (1 << j)) {
				sumlen[mask] += l[j];
				opa[mask].push_back(j);
			}
			else {
				base[mask] += l[j] * 1.0l / v[j];
			}
		}
	}
	cin >> m;
	a.resize(m - 1);
	for (auto& x : a) {
		cin >> x;
	}
	f.resize(m);
	for (auto& x : f) {
		cin >> x;
	}
	ll q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		ll s, t;
		cin >> s >> t;
		ll dt = t - s;
		ld ans = INF;
		for (ll mask = 0; mask < (1 << n); ++mask) {
			ll len = sumlen[mask];
			ld init = base[mask];
			ld left = 0, r = 1e9;
			while (r - left > eps) {
				ld e = (left + r) / 2;
				ld cur = init;
				for (auto& x : opa[mask]) {
					cur += l[x] * 1.0l / (v[x] + e);
				}
				if (cur <= dt) {
					r = e;
				}
				else {
					left = e;
				}
			}
			mini(ans, left);
		//	cout << left << '\n';
		}
		bool done = false;
		if (equal(ans, 0)) {
			cout << 0 << '\n';
			done = true;
		}
		if (!done) {
			for (int j = 0; j < m - 1; ++j) {
				if (ans <= a[j]) {
					cout << f[j] << '\n';
					done = true;
					break;
				}
			}
		}
		if (!done) {
			cout << f[m - 1] << '\n';
		}
	}
	return 0;
}
/*
3
10 20 30
400 500 600
6
1 5 10 12 16
100 300 600 800 1000 1500
3
10 100
20 70
45 100
*/