#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC optimize("no-stack-protector")
#pragma GCC target("sse4")

#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <cmath>
#include <iomanip>
#include <numeric>
#include <random>
#include <chrono>
#include <queue>
#include <unordered_map>
#include <tuple>
#include <ctime>

using namespace std;
using ll = long long;
using ld = long double;

const ld eps = 1e-5;
const ll INF = 1e15;
const ld pi = atan2(0, -1);
const ll mod = 1e9 + 7;
const ll P = 179, Q = 239;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

bool equal(ld a, ld b) {
	return abs(a - b) < eps;
}

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ll& a, ll b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}


bool maxi(ld& a, ld b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ld& a, ld b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

ll mmin(ll a, ll b) {
	if (a < b) return a;
	return b;
}

ll mmax(ll a, ll b) {
	if (a > b) return a;
	return b;
}

ll n, m, k;
vector <bool> used;
vector <ll> a;
vector <ll> fen;

void upd(ll p, ll dt) {
	for (int i = p; i < n; i = i | (i + 1)) {
		fen[i] += dt;
	}
}

ll get(ll p) {
	ll ans = 0;
	for (int i = p; i >= 0; i = (i & (i + 1)) - 1) {
		ans += fen[i];
	}
	return ans;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cin >> n;
	a.resize(n);
	for (auto& x : a) {
		cin >> x;
	}
	map <ll, ll> pos;
	vector <ll> ans(n);
	fen.resize(n);
	for (int i = 0; i < n; ++i) {
		if (pos.find(a[i]) == pos.end()) {
			pos[a[i]] = i;
		}
		else {
			upd(pos[a[i]], -1);
			pos[a[i]] = i;
		}
		upd(pos[a[i]], 1);
		for (int j = 0; j <= i; ++j) {
			ans[i - j] += get(i) - get(j - 1);
		}
	}
	for (auto& x : ans) {
		cout << x << ' ';
	}
	return 0;
}
/*
5
1 3 2 1 2
*/
/*
3
10 20 30
400 500 600
6
1 5 10 12 16
100 300 600 800 1000 1500
3
10 100
20 70
45 100
*/