#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC optimize("no-stack-protector")
#pragma GCC target("sse4")

#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <cmath>
#include <iomanip>
#include <numeric>
#include <random>
#include <chrono>
#include <queue>
#include <unordered_map>
#include <tuple>
#include <ctime>

using namespace std;
using ll = long long;
using ld = long double;

const ld eps = 1e-5;
const ll INF = 1e15;
const ld pi = atan2(0, -1);
const ll mod = 1e9 + 7;
const ll P = 179, Q = 239;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

bool equal(ld a, ld b) {
	return abs(a - b) < eps;
}

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ll& a, ll b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}


bool maxi(ld& a, ld b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ld& a, ld b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

ll mmin(ll a, ll b) {
	if (a < b) return a;
	return b;
}

ll mmax(ll a, ll b) {
	if (a > b) return a;
	return b;
}

ll n, m, k;
vector <bool> used;
vector <vector <ll>> f;

struct op {
	ll a, b;
	ll t;

	op(ll a = 0, ll b = 0, ll t = 0) : a(a), b(b), t(t) {};
};

#define cerr if(0)cerr

vector <vector <ll>> flex;
vector <ll> cur;

void gen() {
	if (cur.size() == n) {
		flex.push_back(cur);
		return;
	}
	for (int i = 0; i <= m; ++i) {
		cur.push_back(i);
		gen();
		cur.pop_back();
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	ll s;
	cin >> n >> m >> s;
	gen();
	f.resize(m, vector <ll>(n));
	vector <vector <op>> bmlp(m, vector <op>(n - 1));
	for (int i = 0; i < m; ++i) {
		for (int j = 0; j < n - 1; ++j) {
			cin >> bmlp[i][j].a >> bmlp[i][j].b >> bmlp[i][j].t;
			bmlp[i][j].a--;
			bmlp[i][j].b--;
		}
	}
	for (auto& x : f) {
		for (auto& y : x) {
			cin >> y;
		}
	}
	if (m == 2) {
		for (ll ptr = 0; ptr < flex.size(); ++ptr) {
			vector <vector <ll>> cpy(m, vector <ll>(n));
			for (int j = 0; j < n; ++j) {
				for (int i = 0; i < m; ++i) {
					cpy[i][j] = f[i][j] < flex[ptr][j];
				}
			}
			cerr << "Genned\n";
			for (auto& x : cpy) {
				for (auto& y : x) {
					cerr << y << ' ';
				}
				cerr << '\n';
			}
			ll cnt = 0;
			for (int i = 0; i < m; ++i) {
				vector <ll> val(2 * n - 1);
				cerr << "Entered cycle\n";
				for (int j = 0; j < n; ++j) {
					cerr << j << '\n';
					cerr << ' ' << cpy[i][j] << '\n';
					val[j] = cpy[i][j];
				}
				cerr << "Coppied";
				for (int j = 0; j < n - 1; ++j) {
					ll a = bmlp[i][j].a, b = bmlp[i][j].b;
					ll t = bmlp[i][j].t;
					if (t == 1) {
						val[j + n] = val[a] | val[b];
					} else if (t == 2) {
						val[j + n] = val[a] & val[b];
					}
				}
				if (val.back() == 1) {
					++cnt;
				}
			}
			if (cnt == s) {
				for (auto& x : flex[ptr]) {
					cout << x << ' ';
				}
				return 0;
			}
		}
	}
	return 0;
}
/*
4 3 2
1 2 1
3 4 1
5 6 2
1 2 2
3 5 1
4 6 2
1 4 1
2 3 1
5 6 2
0 1 2 2
2 2 1 0
1 0 0 1
*/
/*
2 2 1
1 2 1
1 2 2 
0 1
1 0
*/
/*
5
1 3 2 1 2
4
1 1 1 1
*/
/*
3
10 20 30
400 500 600
6
1 5 10 12 16
100 300 600 800 1000 1500
3
10 100
20 70
45 100
*/