#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC optimize("no-stack-protector")
#pragma GCC target("sse4")

#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <cmath>
#include <iomanip>
#include <numeric>
#include <random>
#include <chrono>
#include <queue>
#include <unordered_map>
#include <tuple>
#include <ctime>

using namespace std;
using ll = int;
using ld = long double;

const ld eps = 1e-5;
const ll INF = 1e15;
const ld pi = atan2(0, -1);
const ll mod = 1e9 + 7;
const ll P = 179, Q = 239;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

bool equal(ld a, ld b) {
	return abs(a - b) < eps;
}

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ll& a, ll b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}


bool maxi(ld& a, ld b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ld& a, ld b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

ll mmin(ll a, ll b) {
	if (a < b) return a;
	return b;
}

ll mmax(ll a, ll b) {
	if (a > b) return a;
	return b;
}

ll n, m, k;
vector <bool> used;
vector <vector <ll>> f;

struct op {
	ll a, b;
	ll t;

	op(ll a = 0, ll b = 0, ll t = 0) : a(a), b(b), t(t) {};
};

#define cerr if(0)cerr

vector <vector <ll>> flex;
vector <ll> cur;
ll s;
vector <vector <op>> bmlp;

ll check(vector <ll>& cur) {
	vector <vector <ll>> cpy(m, vector <ll>(n));
	for (int j = 0; j < n; ++j) {
		for (int i = 0; i < m; ++i) {
			cpy[i][j] = int(f[i][j] < cur[j]);
		}
	}
	ll cnt = 0;
	for (int i = 0; i < m; ++i) {
		vector <ll> val(2 * n - 1);
		for (int j = 0; j < n; ++j) {
			val[j] = cpy[i][j];
		}
		for (int j = 0; j < n - 1; ++j) {
			ll a = bmlp[i][j].a, b = bmlp[i][j].b;
			ll t = bmlp[i][j].t;
			if (t == 1) {
				val[j + n] = val[a] & val[b];
			} else if (t == 2) {
				val[j + n] = val[a] | val[b];
			}
		}
		if (val.back() == 1) {
			++cnt;
		}
	}
	return cnt;
}

void gen() {
	if (cur.size() == n) {
		if (check(cur) == s) {
			for (auto& x : cur) {
				cout << int(x) << ' ';
			}
			exit(0);
		}
		return;
	}
	for (int i = 0; i <= m; ++i) {
		cur.push_back(i);
		gen();
		cur.pop_back();
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cin >> n >> m >> s;
	f.resize(m, vector <ll>(n));
	bmlp.resize(m, vector <op>(n - 1));
	for (int i = 0; i < m; ++i) {
		for (int j = 0; j < n - 1; ++j) {
			cin >> bmlp[i][j].a >> bmlp[i][j].b >> bmlp[i][j].t;
			bmlp[i][j].a--;
			bmlp[i][j].b--;
		}
	}
	for (auto& x : f) {
		for (auto& y : x) {
			cin >> y;
		}
	}
	if (n <= 2) {
		if (n == 1) {
			for (ll z1 = 0; z1 <= m; ++z1) {
				vector <ll> cur{ z1 };
				if (check(cur) == s) {
					cout << z1;
					return 0;
				}
			}
		}
		else if (n == 2) {
			for (ll z1 = 0; z1 <= m; ++z1) {
				ll l1 = -1, r1 = m + 1;
				while (r1 - l1 > 1) {
					ll z2 = (l1 + r1) / 2;
					vector <ll> cur{ z1, z2 };
					if (check(cur) > s) {
						l1 = z2;
					} else {
						r1 = z2;
					}
				}
				ll l2 = -1, r2 = m + 1;
				while (r2 - l2 > 1) {
					ll z2 = (l2 + r2) / 2;
					vector <ll> cur{ z1, z2 };
					if (check(cur) > s) {
						r2 = z2;
					} else {
						l2 = z2;
					}
				}
				vector <ll> res1{ l1, l2 };
				vector <ll> res2{ l1, r2 };
				vector <ll> res3{ r1, l2 };
				vector <ll> res4{ r1, r2 };
				if (check(res1) && l1 >= 0 && l2 >= 0) {
					cout << l1 << ' ' << l2;
					return 0;
				}
				else if (check(res2) && l1 >= 0 && r2 <= m) {
					cout << l1 << ' ' << r2;
					return 0;
				}
				else if (check(res3) && r1 <= m && l2 >= 0) {
					cout << r1 << ' ' << l2;
					return 0;
				}
				else if (check(res4) && r1 <= m && r2 <= m) {
					cout << r1 << ' ' << r2;
					return 0;
				}
				else {
					exit(1);
				}
			}
		}
	}
	else {
		gen();
	}
	exit(1);
	return 0;
}
/*
4 3 2
1 2 1
3 4 1
5 6 2
1 2 2
3 5 1
4 6 2
1 4 1
2 3 1
5 6 2
0 1 2 2
2 2 1 0
1 0 0 1
*/
/*
3 2 1
1 2 1
2 3 1
1 2 2
2 3 2
0 1 1
1 0 0
*/
/*
2 2 2
1 2 1
1 2 2
1 1
0 0
*/
/*
5
1 3 2 1 2
4
1 1 1 1
*/
/*
3
10 20 30
400 500 600
6
1 5 10 12 16
100 300 600 800 1000 1500
3
10 100
20 70
45 100
*/