#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC optimize("no-stack-protector")
#pragma GCC target("sse4")

#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <cmath>
#include <iomanip>
#include <numeric>
#include <random>
#include <chrono>
#include <queue>
#include <unordered_map>
#include <tuple>
#include <ctime>

using namespace std;
using ll = long long;
using ld = long double;

const ld eps = 1e-9;
const ll INF = 1e15;
const ld pi = atan2(0, -1);
const ll mod = 1e9 + 7;
const ll P = 179, Q = 239;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

bool equal(ld a, ld b) {
	return abs(a - b) < eps;
}

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ll& a, ll b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}


bool maxi(ld& a, ld b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ld& a, ld b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

ll mmin(ll a, ll b) {
	if (a < b) return a;
	return b;
}

ll mmax(ll a, ll b) {
	if (a > b) return a;
	return b;
}

ll n, m, k;
vector <bool> used;

struct ans {
	ll x, y;
	ll dx, dy;
	bool found;

	ans(bool found = true, ll x = 0, ll y = 0, ll dx = 0, ll dy = 0) : found(found), x(x), y(y), dx(dx), dy(dy) {};
};

ll gcd(ll a, ll b, ll& x, ll& y) {
	if (b == 0) {
		x = 1;
		y = 0;
		return a;
	}
	ll k1, k2;
	ll d = gcd(b, a % b, k1, k2);
	x = k2;
	y = k1 - a / b * k2;
	return d;
}

ans solve(ll a, ll b, ll c) {
	ll k1, k2;
	ll d = gcd(a, b, k1, k2);
	if (c % d != 0) {
		return ans(false);
	}
	a /= d;
	b /= d;
	c /= d;
	ll x0, y0;
	d = gcd(a, b, x0, y0);
	x0 *= c; y0 *= c;
	return ans(true, x0, y0, b, a);
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	ll x;
	cin >> n >> x;
	ll cnt = 0;
	for (ll c = 1; c < n; ++c) {
		for (ll a = c + 1; a <= n; ++a) {
			if (a == x) continue;
			auto ans = solve(a, c, n);
			if (ans.found) {
//				cout << "For " << a << " and " << c << " found: " << ans.x << ' ' << ans.y << ' ' << ans.dx << ' ' << ans.dy << '\n';
				ll x0 = ans.x, y0 = ans.y;
				while (y0 < 0) {
					y0 += ans.dy;
					x0 -= ans.dx;
				}
				while (y0 >= 0) {
					y0 -= ans.dy;
					x0 += ans.dx;
				}
				while (abs(y0) <= n && abs(y0) < x0 && x0 <= n) {
//					cout << a << ' ' << x0 << ' ' << c << ' ' << -y0 << '\n';
					if (x0 != x)
						++cnt;
					y0 -= ans.dy;
					x0 += ans.dx;
				}
			}
		}
	}
	cout << cnt;
	return 0;
}