#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC optimize("no-stack-protector")
#pragma GCC target("sse4")

#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <cmath>
#include <iomanip>
#include <numeric>
#include <random>
#include <chrono>
#include <queue>
#include <unordered_map>
#include <tuple>
#include <ctime>

using namespace std;
using ll = long long;
using ld = long double;

const ld eps = 1e-9;
const ll INF = 1e15;
const ld pi = atan2(0, -1);
const ll mod = 1e9 + 7;
const ll P = 179, Q = 239;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

bool equal(ld a, ld b) {
	return abs(a - b) < eps;
}

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ll& a, ll b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}


bool maxi(ld& a, ld b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ld& a, ld b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

ll mmin(ll a, ll b) {
	if (a < b) return a;
	return b;
}

ll mmax(ll a, ll b) {
	if (a > b) return a;
	return b;
}

ll n, m, k;
vector <bool> used;
vector <vector <ll>> a;
vector <vector <vector <ll>>> dp;

void recalc() {
	for (int ptr = 0; ptr < 4; ++ptr) {
		dp[ptr][1][0] = dp[ptr][1][1] = dp[ptr][1][2] = dp[ptr][1][2] = 0;
		for (int i = 2; i <= n; ++i) {
			dp[ptr][i][0] = mmax(mmax(dp[ptr][i - 1][0], dp[ptr][i - 1][1]), mmax(dp[ptr][i - 1][2], dp[ptr][i - 1][3]));
			for (int j = 1; j < 4; ++j) {
				dp[ptr][i][j] = dp[ptr][i - 1][j - 1] + a[ptr][i - 1];
			}
		}
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cin >> n;
	a.resize(4, vector <ll>(n));
	for (int i = 0; i < n; ++i) {
		cin >> a[0][i];
		a[1][(i + 1) % n] = a[0][i];
		a[2][(i + 2) % n] = a[0][i];
		a[3][(i + 3) % n] = a[0][i];
	}
/*	for (auto& x : a) {
		for (auto& y : x) {
			cout << y << ' ';
		}
		cout << '\n';
	}*/
	dp.resize(4, vector <vector <ll>>(n + 1, vector <ll>(4)));
	recalc();
	ll ans = 0;
	for (int i = 0; i < 4; ++i) {
//		cout << i << ":\n";
		for (auto& x : dp[i][n]) {
//			cout << x << ' ';
			maxi(ans, x);
		}
//		cout << '\n';
	}
	cout << ans << '\n';
	ll q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		ll p, v;
		cin >> p >> v;
		--p;
		a[0][p] = v;
		a[1][(p + 1) % n] = v;
		a[2][(p + 2) % n] = v;
		a[3][(p + 3) % n] = v;
		recalc();
		ll ans = 0;
		for (int i = 0; i < 4; ++i) {
//			cout << i << ":\n";
			for (auto& x : dp[i][n]) {
//				cout << x << ' ';
				maxi(ans, x);
			}
//			cout << '\n';
		}
		cout << ans << '\n';
	}
	return 0;
}
/*
6
1 2 3 4 5 6
2
6 0 
2 5
*/