#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <cmath>
#include <algorithm>
#include <cassert>

using namespace std;

#define ll long long
//#define int long long
#define F first
#define S second
const int inf = 1e9;
const int mod = 1e9 + 7;
const int SZ = 2e5 + 4;
const double EPS = 1e-5;

int n;
int a[SZ];

void read() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
}

struct node {
    int t = 0, add = 0;
};
int m, len;
vector<node> t;

void push(int cur) {
    t[cur].t += t[cur].add;
    if (cur < len) {
        t[cur * 2].add += t[cur].add;
        t[cur * 2 + 1].add += t[cur].add;
    }
    t[cur].add = 0;
}

void update(int cur, int l, int r, int vl = 0, int vr = len) {
    push(cur);
    if (r <= vl || vr <= l) {
        return;
    }
    if (l <= vl && vr <= r) {
        ++t[cur].add;
        push(cur);
        return;
    }
    update(cur * 2, l, r, vl, (vl + vr) / 2);
    update(cur * 2 + 1, l, r, (vl + vr) / 2, vr);
}

void push_all() {
    for (int i = 1; i < 2 * len; ++i) {
        push(i);
    }
}

void solve() {
    m = ceil(log2(n));
    len = (1 << m);
    t.resize(2 * len);

    map<int, int> x;
    vector<int> r(n, n);
    for (int i = 0; i < n; ++i) {
        if (x.count(a[i])) {
            r[x[a[i]]] = i;
        }
        x[a[i]] = i;
    }
    vector<int> ans(n + 1);
    for (int i = 0; i < n; ++i) {
        int p = r[i];
        for (int j = 0; j <= i; ++j) {
            update(1, i - j, p - j);
            push_all();
        }
    }
    push_all();
    for (int l = 0; l < n; ++l) {
        cout << t[len + l].t << " ";
    }
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    read();
    solve();

    return 0;
}
