#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <bitset>
#include <cmath>
#include <algorithm>
#include <cassert>

using namespace std;

#define ll long long
//#define int long long
#define F first
#define S second
const int inf = 1e9;
const int mod = 1e9 + 7;
const int SZ = 3e5 + 4;
const double EPS = 1e-5;

int n, m, s;
vector<vector<int>> a;

struct oper {
    int a, b, op;
};
vector<oper> x[SZ];

void read() {
    cin >> m >> n >> s;
    a.resize(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m - 1; ++j) {
            int a, b, op;
            cin >> a >> b >> op;
            --a, --b;
            x[i].push_back({ a, b, op });
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
}

void solve() {
    if (n <= 2 && m <= 10) {
        int pw = 1;
        for (int i = 0; i < m; ++i) {
            pw *= 3;
        }
        for (int p = 0; p < pw; ++p) {
            vector<int> z(m);
            int y = 1;
            for (int i = 0; i < m; ++i) {
                z[i] = p / y % 3;
                y *= 3;
            }
            int ans = 0;
            for (int i = 0; i < n; ++i) {
                vector<bool> t(m);
                for (int j = 0; j < m; ++j) {
                    t[j] = (a[i][j] < z[j]);
                }
                for (auto& q : x[i]) {
                    t.push_back(q.op == 1 ? t[q.a] && t[q.b] : t[q.a] || t[q.b]);
                }
                ans += t.back();
            }
            if (ans == s) {
                for (int i = 0; i < m; ++i) {
                    cout << z[i] << " ";
                }
                return;
            }
        }
    }
    else if (n <= 100000 && m <= 2) {
        if (n == 1) {
            cout << s;
        }
        else {
            if (s == 0) {
                cout << "0 0";
                return;
            }
            vector<pair<int, int>> y(n);
            for (int i = 0; i < n; ++i) {
                y[a[i][0]].first = i;
                y[a[i][1]].second = i;
            }
            vector<int> out(n, 0);
            vector<vector<int>> t(n, vector<int>(m, 0));
            int ans = 0;
            for (int z0 = 0; z0 <= n; ++z0) {
                if (z0 > 0) {
                    int i = y[z0 - 1].first;
                    ans -= out[i];
                    t[i][0] = 1;
                    out[i] = x[i][0].op == 1 ? t[i][0] && t[i][1] : t[i][0] || t[i][1];
                    ans += out[i];
                }
                if (z0 & 1) {
                    for (int z1 = n; z1 >= 0; ++z1) {
                        if (z1 < n) {
                            int i = y[z1].second;
                            ans -= out[i];
                            t[i][1] = 0;
                            out[i] = x[i][0].op == 1 ? t[i][0] && t[i][1] : t[i][0] || t[i][1];
                            ans += out[i];
                        }
                        if (ans == s) {
                            cout << z0 << " " << z1;
                            return;
                        }
                    }
                }
                else {
                    for (int z1 = 0; z1 <= n; ++z1) {
                        if (z1 > 0) {
                            int i = y[z1 - 1].second;
                            ans -= out[i];
                            t[i][1] = 1;
                            out[i] = x[i][0].op == 1 ? t[i][0] && t[i][1] : t[i][0] || t[i][1];
                            ans += out[i];
                        }
                        if (ans == s) {
                            cout << z0 << " " << z1;
                            return;
                        }
                    }
                }
            }
        }
    }
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    read();
    solve();

    return 0;
}
