#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <cmath>
#include <algorithm>
#include <cassert>

using namespace std;

#define ll long long
#define int long long
#define F first
#define S second
const int inf = 1e9;
const int mod = 1e9 + 7;
const int SZ = 2e5 + 4;
const double EPS = 1e-5;

int n;
int a[SZ];

void read() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        a[i + n] = a[i];
    }
}

vector<int> dp1;
vector<int> dp2;
vector<int> dp3;
vector<int> dp4;

void cnt(vector<int> &dp, int bg) {
    for (int i = bg; i < 3 * n; ++i) {
        dp[i] = (i - bg > 1 ? dp[i - 2] : 0) + a[i];
        if (i - bg >= 1) {
            dp[i] = max(dp[i], (i - bg > 2 ? dp[i - 3] : 0) + a[i - 1] + a[i]);
        }
        if (i - bg >= 2) {
            dp[i] = max(dp[i], (i - bg > 3 ? dp[i - 4] : 0) + a[i - 2] + a[i - 1] + a[i]);
        }
    }
}

int get_ans() {
    int x1 = max({ dp1[n - 1], dp1[n - 2] });
    int x2 = max({ dp2[n], dp2[n - 1] });
    int x3 = max({ dp3[n + 1], dp3[n] });
    int x4 = max({ dp4[n + 2], dp4[n + 1] });
    return max({ x1, x2, x3, x4 });
}

void solve() {
    dp1.resize(3 * n);
    dp2.resize(3 * n);
    dp3.resize(3 * n);
    dp4.resize(3 * n);
    cnt(dp1, 1);
    cnt(dp2, 2);
    cnt(dp3, 3);
    cnt(dp4, 4);
    cout << get_ans() << "\n";

    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int x, k;
        cin >> x >> k;
        --x;
        a[x] = a[x + n] = k;
        cnt(dp1, 1);
        cnt(dp2, 2);
        cnt(dp3, 3);
        cnt(dp4, 4);
        cout << get_ans() << "\n";
    }
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    read();
    solve();

    return 0;
}