#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <cmath>
#include <algorithm>
#include <cassert>

using namespace std;

#define ll long long
#define int long long
#define F first
#define S second
const int inf = 1e9;
const int mod = 1e9 + 7;
const int SZ = 5e5 + 4;
const double EPS = 1e-5;

int n;
int a[SZ];

void read() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        a[i + n] = a[i];
    }
}

vector<int> dp1, dp2, dp3, dp4;

void cnt() {
    dp1.resize(2 * n + 1);
    vector<int> mx1(2 * n + 1);
    mx1[2] = dp1[2] = a[1];
    mx1[3] = dp1[3] = a[1] + a[2];
    mx1[4] = dp1[4] = a[1] + a[2] + a[3];
    for (int i = 5; i <= 2 * n; ++i) {
        dp1[i] = max({ mx1[i - 2] + a[i - 1], mx1[i - 3] + a[i - 2] + a[i - 1], mx1[i - 4] + a[i - 3] + a[i - 2] + a[i - 1] });
        mx1[i] = max(mx1[i - 1], dp1[i]);
    }

    dp2.resize(2 * n + 1);
    vector<int> mx2(2 * n + 1);
    mx2[3] = dp2[3] = a[2];
    mx2[4] = dp2[4] = a[2] + a[3];
    mx2[5] = dp2[5] = a[2] + a[3] + a[4];
    for (int i = 6; i <= 2 * n; ++i) {
        dp2[i] = max({ mx2[i - 2] + a[i - 1], mx2[i - 3] + a[i - 2] + a[i - 1], mx2[i - 4] + a[i - 3] + a[i - 2] + a[i - 1] });
        mx2[i] = max(mx2[i - 1], dp2[i]);
    }

    dp3.resize(2 * n + 1);
    vector<int> mx3(2 * n + 1);
    mx3[4] = dp3[4] = a[3];
    mx3[5] = dp3[5] = a[3] + a[4];
    mx3[6] = dp3[6] = a[3] + a[4] + a[5];
    for (int i = 7; i <= 2 * n; ++i) {
        dp3[i] = max({ mx3[i - 2] + a[i - 1], mx3[i - 3] + a[i - 2] + a[i - 1], mx3[i - 4] + a[i - 3] + a[i - 2] + a[i - 1] });
        mx3[i] = max(mx3[i - 1], dp3[i]);
    }

    dp4.resize(2 * n + 1);
    vector<int> mx4(2 * n + 1);
    mx4[5] = dp4[5] = a[4];
    mx4[6] = dp4[6] = a[4] + a[5];
    mx4[7] = dp4[7] = a[4] + a[5] + a[6];
    for (int i = 8; i <= 2 * n; ++i) {
        dp4[i] = max({ mx4[i - 2] + a[i - 1], mx4[i - 3] + a[i - 2] + a[i - 1], mx4[i - 4] + a[i - 3] + a[i - 2] + a[i - 1] });
        mx4[i] = max(mx4[i - 1], dp4[i]);
    }
}

int get_ans() {
    int x1 = max({ dp1[n], dp1[n - 1], dp1[n - 2] });
    int x2 = max({ dp2[n + 1], dp2[n], dp2[n - 1] });
    int x3 = max({ dp3[n + 2], dp3[n + 1], dp3[n] });
    int x4 = max({ dp4[n + 3], dp4[n + 2], dp4[n + 1] });
    return max({ x1, x2, x3, x4 });
}

void solve() {
    cnt();
    cout << get_ans() << "\n";
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int x, k;
        cin >> x >> k;
        --x;
        a[x] = a[x + n] = k;
        cnt();
        cout << get_ans() << "\n";
    }
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    read();
    solve();

    return 0;
}