#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <string>
using namespace std;
#define int long long
using pii = pair<int, int>;

vector<int> z_function(string s) { 
	int n = s.size();
	vector<int> z(n);
	for (int i = 1, l = 0, r = 1; i < n; i++) {
		if (i <= r) {
			z[i] = min(r - i + 1, z[i - l]);
		}
		while (i + z[i] < n && s[i + z[i]] == s[z[i]]) {
			z[i]++;
		}
		if (i + z[i] > r) {
			l = i;
			r = i + z[i] - 1;
		}
	}
	return z;
}

vector<int> prefix_function(string s) {
	int n = s.size();
	vector<int> p(n);
	for (int i = 1; i < n; i++) {
		int j = p[i - 1];
		while (j > 0 && s[j] != s[i]) {
			j = p[j];
		}
		if (s[j] == s[i]) {
			p[i] = j + 1;
		}
	}
	return p;
}

void fast_io() {
#ifdef DEBUG
	freopen("in.in", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
}

pii get(int a) {
	if (a == 1 || a == 4 || a % 4 == 2) {
		return {0, 0};
	}
	if (a % 2 == 1) {
		int x = (a + 1) / 2;
		int y = (a - 1) / 2;
		return {x, y};
	} else {
		int x = (a / 2 + 2) / 2;
		int y = (a / 2 - 2) / 2;
		return {x, y};
	}
}

signed main() {
	//fast_io();
	int n;
	cin >> n;
	pii p = get(n);
	if (p.first == 0) {
		cout << "No\n";
	} else {
		cout << "Yes\n" << p.first << " " << p.second << "\n";
	}
	return 0;
}