#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;
using ld = long double;

const ld INF = 1e9;

int cmp(const ld& a, const ld& b)
{
	return a > b;
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n = 0, m = 0;
	cin >> n;

	vector<int> v(n);
	for (int i = 0; i < n; ++i)
		cin >> v[i];

	vector<int> l(n);
	for (int i = 0; i < n; ++i)
		cin >> l[i];

	cin >> m;

	vector<int> a(m, INF);
	for (int i = 0; i < m - 1; ++i)
		cin >> a[i];

	vector<int> f(m);
	for (int i = 0; i < m; ++i)
		cin >> f[i];

	ld ok = 0;
	for (int i = 0; i < n; ++i)
		ok += (ld)l[i] / (ld)v[i];

	vector<vector<ld>> dp(n + 1, vector<ld>(m, 0.0));
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j)
			dp[i + 1][j] = dp[i][j] + (ld)l[i] / (ld)(v[i] + a[j]);

	int q = 0;
	cin >> q;

	int start = 0, end = 0;
	for (int i = 0; i < q; ++i)
	{
		cin >> start >> end;
		ld t = end - start;

		if (t >= ok)
			cout << 0 << "\n";
		else
		{
			auto it = lower_bound(dp[n].begin(), dp[n].end(), t, cmp);
			cout << f[it - dp[n].begin()] << "\n";
		}			
	}


	return 0;
}