#include <algorithm>
#include <iostream>
#include <vector>
#include <set>

using namespace std;
const int maxElem = 51;

vector<int> st, add;

void push(int i, int l, int r)
{
	st[i] += add[i] * (r - l);
	if (l + 1 != r)
	{
		add[i * 2 + 1] += add[i];
		add[i * 2 + 2] += add[i];
	}
	add[i] = 0;
}

int get(int i, int l, int r, int ql, int qr)
{
	push(i, l, r);
	if (ql <= l && r <= qr)
		return st[i];

	if (l >= qr || r <= ql)
		return 0;

	int m = (l + r) >> 1;
	return get(i * 2 + 1, l, m, ql, qr) + get(i * 2 + 2, m, r, ql, qr);
}

void update(int i, int l, int r, int ql, int qr, int x)
{
	push(i, l, r);
	if (ql <= l && r <= qr)
	{
		add[i] += x;
		return;
	}

	if (l >= qr || r <= ql)
		return;

	int m = (l + r) >> 1;
	update(i * 2 + 1, l, m, ql, qr, x);
	update(i * 2 + 2, m, r, ql, qr, x);
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n = 0;
	cin >> n;

	vector<int> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];


	if (n > 5000)
	{
		int last[maxElem] = {};
		vector<int> prev(n, -1);
		for (int i = 0; i < n; ++i)
		{
			if (last[a[i]])
				prev[i] = i - last[a[i]] + 1;
			last[a[i]] = i + 1;
		}

		st.resize(4 * n), add.resize(4 * n);
		for (int i = 0; i < n; ++i)
			if (prev[i] != -1) update(0, 0, n, prev[i], i + 1, 1);

		set<int> s;

		int cnt = 0;
		for (int i = 0; i < n; ++i)
		{
			cnt += (n - i);
			cnt -= s.size();

			cnt -= get(0, 0, n, i, i + 1);

			s.insert(a[n - i - 1]);

			cout << cnt << " ";
		}
	}
	else
	{
		vector<int> ans(n);

		vector<int> v;
		set<int> myS;
		for (auto x : a)
			myS.insert(x);
		for (auto x : myS)
			v.push_back(x);

		for (int i = 0; i < n; ++i)
			a[i] = lower_bound(v.begin(), v.end(), a[i]) - v.begin();

		for (int i = 0; i < n; ++i)
		{
			int cnt[5002] = {};
			int c = 0;
			for (int len = 1; i + len <= n; ++len)
			{
				if (cnt[a[i + len - 1]] == 0)
					++c, cnt[a[i + len - 1]] = 1;
				ans[len - 1] += c;
			}
		}

		for (auto x : ans)
			cout << x << " ";
	}

	return 0;
}