#include <iostream>
#include <vector>

using namespace std;

struct func
{
	int op = 0, a = 0, b = 0;

	bool get(bool x, bool y) const
	{
		if (op == 1)
			return (x && y);
		else
			return (x || y);
	}

	bool get(const vector<int>& arr) const
	{
		if (op == 1)
			return (arr[a] && arr[b]);
		else
			return (arr[a] || arr[b]);
	}
};

istream& operator>>(istream& stream, func& f)
{
	stream >> f.op >> f.a >> f.b;
	--f.a, --f.b;
	return stream;
}

int count(int z0, int z1, const vector<vector<int>>& matr, const vector<vector<func>>& f)
{
	int cnt = 0;
	for (int i = 0; i < matr.size(); ++i)
		cnt += f[i][0].get((matr[i][0] < z0), (matr[i][1] < z1));

	return cnt;
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n = 0, m = 0, s = 0;
	cin >> n >> m >> s;

	vector<vector<int>> matr(m, vector<int>(n));
	vector<vector<func>> f(m, vector<func>(n - 1));

	for (int i = 0; i < m; ++i)
		for (int j = 0; j < n - 1; ++j)
			cin >> f[i][j];

	for (int i = 0; i < m; ++i)
		for (int j = 0; j < n; ++j)
			cin >> matr[i][j];

	if (n == 1)
	{
		cout << s << endl;
		return 0;
	}

	for (int z0 = 0; z0 <= m; ++z0)
	{
		int l = 0, r = m + 1;
		while (l + 1 != r)
		{
			int m = (l + r) >> 1;
			if (count(z0, m, matr, f) <= s)
				l = m;
			else
				r = m;
		}

		if (count(z0, l, matr, f) == s)
		{
			cout << z0 << " " << l << endl;
			return 0;
		}
		else if (count(z0, l + 1, matr, f) == s)
		{
			cout << z0 << " " << l + 1 << endl;
			return 0;
		}
	}

	return 0;
}