#include <iostream>
#include <random>
#include <ctime>
#include <vector>

using namespace std;

struct func
{
	int op = 0, a = 0, b = 0;

	bool get(bool x, bool y) const
	{
		if (op == 1)
			return (x && y);
		else
			return (x || y);
	}

	bool get(const vector<int>& arr) const
	{
		if (op == 1)
			return (arr[a] && arr[b]);
		else
			return (arr[a] || arr[b]);
	}
};

istream& operator>>(istream& stream, func& f)
{
	stream >> f.a >> f.b >> f.op;
	--f.a, --f.b;
	return stream;
}

int count(int z0, int z1, const vector<vector<int>>& matr, const vector<vector<func>>& f)
{
	int cnt = 0;
	for (int i = 0; i < matr.size(); ++i)
		cnt += (int)f[i][0].get((matr[i][0] < z0), (matr[i][1] < z1));

	return cnt;
}

int count(int mask, const vector<vector<int>>& matr, const vector<vector<func>>& f)
{
	int n = matr[0].size();
	int cnt = 0;
	for (int i = 0; i < matr.size(); ++i)
	{
		vector<int> arr(n * 2 - 1);
		for (int j = 0; j < n; ++j)
			arr[i] = (matr[i][j] < ((mask >> j) & 1));
		for (int j = 0; j < n - 1; ++j)
			arr[n + j] = f[i][j].get(arr);
		cnt += arr.back();
	}

	return cnt;
}

int main()
{
	srand(time(0));
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n = 0, m = 0, s = 0;
	cin >> n >> m >> s;

	vector<vector<int>> matr(m, vector<int>(n));
	vector<vector<func>> f(m, vector<func>(n - 1));

	for (int i = 0; i < m; ++i)
		for (int j = 0; j < n - 1; ++j)
			cin >> f[i][j];

	for (int i = 0; i < m; ++i)
		for (int j = 0; j < n; ++j)
			cin >> matr[i][j];

	if (m == 1)
	{
		if (s == 0)
		{
			for (int i = 0; i < n; ++i)
				cout << 0 << " ";
		}		
		else
		{
			for (int i = 0; i < n; ++i)
				cout << 1 << " ";
		}
		return 0;
	}

	if (m == 2)
	{
		for (int mask = 0; mask < (1 << n); ++mask)
		{
			if (count(mask, matr, f) == s)
			{
				for (int i = 0; i < n; ++i)
					cout << ((mask >> i) & 1) << " ";
				return 0;
			}				
		}
	}

	if (n == 1 || n > 2)
	{
		for (int i = 0; i < n; ++i)
			cout << s << " ";
		return 0;
	}

	while(true)
	{
		int z0 = rand() % (m + 1);
		int l = 0, r = m + 1;
		while (l + 1 != r)
		{
			int m = (l + r) >> 1;
			if (count(z0, m, matr, f) <= s)
				l = m;
			else
				r = m;
		}

		if (count(z0, l, matr, f) == s)
		{
			cout << z0 << " " << l << endl;
			return 0;
		}
		/*
		for (int l = 0; l <= m; ++l)
		{
			if (count(z0, l, matr, f) == s)
			{
				cout << z0 << " " << l << endl;
				return 0;
			}
		}*/
	}

	return 0;
}