#include <iostream>
#include <random>
#include <ctime>
#include <vector>

using namespace std;

struct func
{
	int op = 0, a = 0, b = 0;

	bool get(bool x, bool y) const
	{
		if (op == 1)
			return (x && y);
		else
			return (x || y);
	}

	bool get(const vector<int>& arr) const
	{
		if (op == 1)
			return (arr[a] && arr[b]);
		else
			return (arr[a] || arr[b]);
	}
};

istream& operator>>(istream& stream, func& f)
{
	stream >> f.a >> f.b >> f.op;
	--f.a, --f.b;
	return stream;
}

int count(int z0, int z1, const vector<vector<int>>& matr, const vector<vector<func>>& f)
{
	int cnt = 0;
	for (int i = 0; i < matr.size(); ++i)
		cnt += (int)f[i][0].get((matr[i][0] < z0), (matr[i][1] < z1));

	return cnt;
}

int count(const vector<int>& mask, const vector<vector<int>>& matr, const vector<vector<func>>& f)
{
	int n = matr[0].size();
	int cnt = 0;
	for (int i = 0; i < matr.size(); ++i)
	{
		vector<int> arr(n * 2 - 1);
		for (int j = 0; j < n; ++j)
			arr[j] = (matr[i][j] < mask[j]);
		for (int j = 0; j < n - 1; ++j)
			arr[n + j] = f[i][j].get(arr);
		cnt += arr.back();
	}

	return cnt;
}

void rec(const vector<vector<int>>& matr, const vector<vector<func>>& f, vector<int>& cur, int n, int m, int s)
{
	if (cur.size() == n)
	{
		if (count(cur, matr, f) == s)
		{
			for (int i = 0; i < n; ++i)
				cout << cur[i] << " ";
			exit(0);
		}
		return;
	}

	for (int i = 0; i <= m; ++i)
	{
		cur.push_back(i);
		rec(matr, f, cur, n, m, s);
		cur.pop_back();
	}
}

void rec1(const vector<vector<int>>& matr, const vector<vector<func>>& f, vector<int>& cur, int n, int m, int s)
{
	if (cur.size() == n)
	{
		if (count(cur, matr, f) == s)
		{
			for (int i = 0; i < n; ++i)
				cout << cur[i] << " ";
			exit(0);
		}
		return;
	}
	else if (cur.size() == n - 1)
	{
		int l = 0, r = m + 1;
		while (l + 1 != r)
		{
			int m = (l + r) >> 1;
			cur.push_back(m);
			if (count(cur, matr, f) <= s)
				l = m;
			else
				r = m;
		}

		if (count(cur, matr, f) == s)
		{
			for (auto x : cur)
				cout << x << " ";
			exit(0);
		}
	}

	for (int i = 0; i <= rand() % m; ++i)
	{
		cur.push_back(rand() % (m + 1));
		rec1(matr, f, cur, n, m, s);
		cur.pop_back();
	}
}

int main()
{
	srand(time(0));
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n = 0, m = 0, s = 0;
	cin >> n >> m >> s;

	vector<vector<int>> matr(m, vector<int>(n));
	vector<vector<func>> f(m, vector<func>(n - 1));

	bool onlyAnd = true;
	for (int i = 0; i < m; ++i)
	{
		for (int j = 0; j < n - 1; ++j)
		{
			cin >> f[i][j];
			if (f[i][j].op != 1)
				onlyAnd = false;
		}
	}		

	for (int i = 0; i < m; ++i)
		for (int j = 0; j < n; ++j)
			cin >> matr[i][j];

	if (onlyAnd)
	{
		cout << s << " ";
		for (int i = 1; i < n; ++i)
			cout << m << " ";
	}
	else if (m == 1)
	{
		if (s == 0)
			for (int i = 0; i < n; ++i)
				cout << 0 << " ";		
		else
			for (int i = 0; i < n; ++i)
				cout << 1 << " ";
	}
	else if (m == 2)
	{
		vector<int> cur;
		rec(matr, f, cur, n, m, s);
	}
	else if (n == 1 || n > 2)
	{
		for (int i = 0; i < n; ++i)
			cout << s << " ";
	}
	else if (n <= 2)
	{
		while (true)
		{
			int z0 = rand() % (m + 1);
			int l = 0, r = m + 1;
			while (l + 1 != r)
			{
				int m = (l + r) >> 1;
				if (count(z0, m, matr, f) <= s)
					l = m;
				else
					r = m;
			}

			if (count(z0, l, matr, f) == s)
			{
				cout << z0 << " " << l << endl;
				return 0;
			}
		}
	}
	else
	{
		vector<int> cur;
		rec1(matr, f, cur, n, m, s);
	}

	return 0;
}