#include <iostream>
#include <vector>
#include <tuple>

using namespace std;

tuple<int, int, int> gcd(int a, int b)
{
	if (b == 0)
		return { a, 1, 0 };

	auto [d, y, x] = gcd(b, a % b);
	return { d, x, y - (a / b) * x };
}

int diophCount(int a, int c, int n, int bad)
{
	auto [d, x, y] = gcd(a, c);
	if (n % d)
		return 0;

	a /= d, c /= d, n /= d;
	x *= n, y *= n;
	y = -y;

	if (x > 0)
		y -= a * (x / c), x %= c;
	else
		y -= a * (x - (c - 1) / c), x -= c * (x - (c - 1) / c);

	int cnt = 0;
	while (x > y)
	{
		if (x > 0 && y > 0 && x != bad)
			++cnt;
		x += c, y += a;
	}

	return cnt;
}

int main()
{
	int n = 0, x = 0;
	cin >> n >> x;

	int cnt = 0;
	for (int a = 2; a < n; ++a)
	{
		if (a == x)
			continue;

		for (int c = 1; c < a; ++c)
			cnt += diophCount(a, c, n, x);
	}
		
	cout << cnt << "\n";

	return 0;
}