#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;
using ll = long long;

bool check(int mask, int n)
{
	int bad = 15;
	for (int i = 0; i <= n - 4; ++i)
		if (((mask >> i) & bad) == bad)
			return false;

	if ((mask & 1) == 1 && (mask >> (n - 3)) == 7)
		return false;

	if ((mask & 3) == 3 && (mask >> (n - 2)) == 3)
		return false;

	if ((mask & 7) == 7 && (mask >> (n - 1)) == 1)
		return false;

	return true;
}

ll getSum(int mask, const vector<ll>& a)
{
	ll res = 0;
	for (int i = 0; i < a.size(); ++i)
		res += a[i] * ((mask >> i) & 1);
	return res;
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n = 0;
	cin >> n;

	vector<ll> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];

	ll maxSum = 0;
	for (int mask = 0; mask < (1 << n); ++mask)
		if (check(mask, n))
			maxSum = max(maxSum, getSum(mask, a));
	cout << maxSum << "\n";

	int q = 0;
	cin >> q;

	int ind = 0, x = 0;
	for (int i = 0; i < q; ++i)
	{
		cin >> ind >> x;
		a[ind - 1] = x;

		maxSum = 0;
		for (int mask = 0; mask < (1 << n); ++mask)
			if (check(mask, n))
				maxSum = max(maxSum, getSum(mask, a));

		cout << maxSum << "\n";
	}
	
	return 0;
}