#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;
using ll = long long;
const ll INF = 1e9;

bool check(int mask, int n)
{
	int bad = 15;
	for (int i = 0; i <= n - 4; ++i)
		if (((mask >> i)& bad) == bad)
			return false;

	if ((mask & 1) == 1 && (mask >> (n - 3)) == 7)
		return false;

	if ((mask & 3) == 3 && (mask >> (n - 2)) == 3)
		return false;

	if ((mask & 7) == 7 && (mask >> (n - 1)) == 1)
		return false;

	return true;
}

ll getSum(int mask, const vector<ll>& a, int n)
{
	ll res = 0;
	for (int i = 0; i < n; ++i)
		res += a[i] * ((mask >> i) & 1);
	return res;
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n = 0;
	cin >> n;

	vector<ll> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	
	ll maxAns = 0;
	for (int startMask = 0; startMask < 15; ++startMask)
	{
		vector<ll> dp(16, -INF), newDp(16, 0);
		dp[startMask] = 0;
		for (int i = 4; i < n + 4; ++i)
		{
			newDp.assign(16, 0);
			for (int mask = 0; mask < 15; ++mask)
			{
				int newMask = ((mask << 1) & 15);
				newDp[newMask] = max(newDp[newMask], dp[mask]);
				newDp[newMask | 1] = max(newDp[newMask | 1], dp[mask] + a[(i % n)]);
			}
			swap(dp, newDp);
		}

		maxAns = max(maxAns, dp[startMask]);
	}

	cout << maxAns << "\n";

	return 0;
}